db $42

JMP Return : JMP Main : JMP Return : JMP Return : JMP Return : JMP Return : JMP Return : JMP Main : JMP Return : JMP Return

	!RAM_CUSTBLOCK	= $7EC275	; free ram used for custom map16 changes
        !BOUNCE = $08                   ; change this if needed
        !RAM = $0660                    ; change to the RAM you used with the ground pound patch

BOUNCE:			; Code for spawning a bounce block sprite is here
	PHY		; save Y

	LDA #$0F	; Clear low nybble of these (so bounce block is positioned correctly)
	TRB $98		;
	TRB $9A		;

	LDY #$03	; find a free bounce sprite slot

GET_FREE_SLOT:
	LDA $1699,y	; check status
	BEQ GOT_ONE	; if empty, we got one
	DEY
	BPL GET_FREE_SLOT
	DEC $18CD	; decrement counter used by SMW
	BPL BOUNCE_0
	LDA #$03	; reset it if needed
	STA $18CD	;

BOUNCE_0:
	LDY $18CD	; do some stuff if a turnblock
	LDA $1699,Y	; 
	CMP #$07
	BNE NOT_TURNBLOCK

NOT_TURNBLOCK:			; quite necessary because spinning blocks use these tables
	LDY $18CD	; $18CD holds the oldest bounce sprite index, in case more than 4 are running at one time

GOT_ONE:
	LDA #$00	; bounce block properties. YXPPCCCT
	STA $1901,Y	; set to palette E, first sprite page, no x/y flip
	LDA #!BOUNCE	; Set bounce block sprite number
	STA $1699,y	; 8+ = custom
	LDA #$00	; make it run init routine
	STA $169D,Y	; 1-FF = no init routine

	LDA $9A		; X (low)
	STA $16A5,Y	; store to bounce sprite table
	LDA $9B		; X (high)
	STA $16AD,Y	;
	LDA $98		; Y (low)
	STA $16A1,Y	;
	LDA $99		; Y (high)
	STA $16A9,Y	;

	LDA $1933	; layer being processed
	LSR		; Used in bounce sprite code
	ROR		; determines which layer to write the block to after done animating
	STA $08		; store to scratch

	LDA #$00	; set x speed
	STA $16B5,Y	;
	LDA #$30	; set y speed 
	STA $16B1,Y	;
	LDA #$00	; movement table index. 0 = up, 1 = right, 2 = left, 3 = down
	ORA $08		; add in layer bit determined earlier
	STA $16C9,Y	;

	LDA #$1C	; set block to turn into = spawn block from table
	STA $16C1,Y	; 1C-FF will not use the regular table. Instead you must set it in a table later
	LDA #$08	; set time to show block
	STA $16C5,Y	;
	PHX		; get table index for custom map16 changes
	TYA		; this allows your sprite to change the block back after it finishes animating
	ASL		; could also be used to change it to something else
	TAX		;
	REP #$20	; 16 bit A
	LDA #$0132
	STA !RAM_CUSTBLOCK,x	; store to custom table. Will change to this block after the bounce sprite finishes
	SEP #$20	; 8 bit A
	PLX		
	

	; done with bounce sprite spawning

	PHK
	PER $0006	; hit sprites above block
	PEA $94F3
	JML $0286ED

	LDA #$09 	; Replace block with invisible solid block
	STA $9C	; 
	JSL $00BEB0	;
	PLY			; restore y

        JSR Coin
        RTL

Main:
        LDA !RAM
        BEQ Return
        JMP BOUNCE	; bounce if small


Return:
	RTL

Coin:
        LDX #$03                
Loop:   
        LDA $17D0,X             
        BEQ SpawnCoin           
        DEX                       
        BPL Loop           
        DEC $1865               
        BPL Loopend           
        LDA #$03                
        STA $1865               
Loopend:        LDX $1865               
SpawnCoin:      JSL IncCoin   
     
        INC $17D0,X             
        LDA $9A       ; store block y pos low byte   
        STA $17E0,X             
        LDA $9B    
        STA $17EC,X   ; store block y pos high byte     
     
        LDA $98          
        CLC                       
        ADC #$20                
        STA $17D4,X   ; store block x pos low byte + 48
        LDA $99                         
        ADC #$00
        STA $17E8,X   ; store block x pos high byte
        
        LDA #$30
        STA $17DC

        LDA $1933     ; which layer is processed          
        STA $17E4,X             
        LDA #$D0                
        STA $17D8,X             
        RTS 

IncCoin:
        INC $13CC          
     
        LDA #$01                
        STA $1DFC               ; / Play sound effect
 
        LDA $0DC0               
        BEQ Ret          
        DEC $0DC0               

Ret:
        RTL                       ; Return 