;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Asceticism Patch
; By Alexander
; See HowToReadYourMe.txt for stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Defines
; You might wanna change these
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Toggle		=	$0DA1	; Flag for the patch disabler
!LR		=	$14C1	; L/R pressed flag
!Freespace	=	$108000	; Freespace, yo

header			; USELESS
lorom			; SOME BANKS BUT NOT TOO MANY

org $05CE08		; \
STZ !Toggle		; | Disables the toggle flag, if applicable
STZ $0F40		; |
NOP #148		; / Stops points from being added after getting the goal

org $028765		; \ Prevents turn blocks from giving their usual 50 points
db $00			; /

org $00A1DA
JML Start

org !Freespace

Start:
	JSR Toggle	; Comment this line out if you don't want the patch to ever be disabled via a toggle
	LDA !Toggle	;
	BNE ToggleOff	;
	LDA #$FC	;
	STA $0F1A	;
	STA $0F19	;
	LDA $0DBF	;
	BNE Death	;
	LDA $0F34	;
	BNE Death	;
	LDA $0F35	;
	BNE Death	;
	LDA $0F36	;
	BNE Death	;
	BRA Finish
ToggleOff:
	LDA #$18	; \
	STA $0F19	; | Draws "non-ascetic" indicator onto status bar
	LDA #$17	; |
	STA $0F1A	; /
	STZ $0F34	;
	STZ $0F35	;
	STZ $0F36	;
	STZ $0DBF	;
	BRA Finish
	
Death:
	LDA #$FC	;
	STA $0F1A	;
	STA $0F19	;
	JSL $00F606	;
	STZ $0F34	;
	STZ $0F35	;
	STZ $0F36	;
	STZ $0DBF	;
	BRA Finish

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Toggle routine aka the routine that gave me nightmares
; Usage is self-explanatory if you read the comments
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Toggle:
	LDA !LR		; If L/R still pressed
	BNE Wait	;
	LDA !Toggle	; If not active
	BEQ NotActive	;
	
	LDA $17		; \
	CMP #$30	; | Check if both L and R are pressed.
	BEQ Flags	; |
	RTS		; / Return if not
	
NotActive:
	LDA $17		;
	CMP #$30	; Check if pressing both L and R
	BEQ Flags	;
	RTS
	
Flags:	
	LDA !Toggle	; \
	EOR #$01	; | Activate/deactivate patch
	STA !Toggle	; /
	INC !LR		; This flag is set when L/R is held down
	
Wait:
	LDA $17		; \
	AND #$30	; | Check to see if L/R has been released
	BNE NotYet	; / Return if not
	STZ !LR		; Clear the "L/R pressed flag"
NotYet:
	RTS

Finish:
	LDA $1426	;
	BEQ +		;
	JML $00A1DF	;
+
	JML $00A1E4	;

; RATS

db "STAR"
dw End-Start-$01
dw End-Start-$01^$FFFF

End: