;	#########################
;	#                       #
;	#  COUNTER DIGIT "FIX"  #
;	#                       #
;	#   by WhiteYoshiEgg    #
;	#                       #
;	#########################


;		This patch changes the lives and coin counter
;		so that if the value is less than 10,
;		the counter will be displayed one tile farther left,
;		removing an unnecessary space.
;		Nothing special, but might be worth "fixing" anyway.


;		DEFINITIONS
;		***********


				; \  Point to some FREE SPACE!
				;  | (Note: If your ROM is at least 1MB big
	!FreeSpace    = $1F8000	;  | and you haven't applied any other
				;  | patches before, you don't need
				; /  to change this.)

				; \  Status bar address to display lives counter
	!LivesAddr    = $0F16	;  | (no need to change this unless you
				; /  changed the counter's position)

				; \  Status bar address to display lives counter
	!CoinsAddr    = $0F12	;  | (originally $0F13, I just changed it
				; /  to save even more space)



;		ACTUAL CODE
;		***********


	header			; \  generic
	lorom			; /  patch stuff



	org $008F49		;    Hijack lives displaying routine
		JSL HijackLives	;    Jump to the custom code
		NOP #14		;    Remove the rest of the routine

	org $008F73		;    Hijack coins displaying routine
		JSL HijackCoins	;    Jump to the custom code
		NOP #13		;    Remove the rest of the routine


	org $008CB9		; \ Replace the "x" sign in the coin counter
		db $78		; / with a colon (looks better IMO)

	org $008CBF		; \ Remove the "0" after the coin counter
		db $FC		; / (it's not needed anymore since I moved the counter)




	org !FreeSpace

	db "STAR"		; \
	dw End-Start		;  | Write RAT / RATS Tag / whatever
	dw End-Start^#$FFFF	; /

	Start:
	HijackLives:
		LDA $0DBE	;    Load amount of lives
		INC A		;    Increase by one for some reason (it's like this in the original SMW's code)
		CMP #$0A	; \  If less than 10,
		BCC OneDigit	; /  only show ones digit
		JSL $00974C	; \
		TXY		;  | Otherwise, convert value to decimal
		STX !LivesAddr	;  | and store both digits
		STA !LivesAddr+1;  | to their original place
		BRA Return	; /
	OneDigit:	
		STA !LivesAddr	;    Store the ones digit to where the 10s digit normally is
		LDA #$FC	; \  Store blank tile
		STA !LivesAddr+1; /  to 10s digit
	Return:	
		RTL		;    Return



	HijackCoins:
		LDA $0DBF	;    Load amount of coins
		CMP #$0A	; \  If less than 10,
		BCC OneDigit2	; /  only show ones digit
		JSL $00974C	; \
		TXY		;  | Otherwise, convert value to decimal
		STX !CoinsAddr	;  | and store both digits
		STA !CoinsAddr+1;  | to their original place
		BRA Return2	; /
	OneDigit2:	
		STA !CoinsAddr	;    Store the ones digit to where the 10s digit normally is
		LDA #$FC	; \  Store blank tile
		STA !CoinsAddr+1; /  to 10s digit
	Return2:	
		RTL		;    Return
	End:
