;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   Creating/Eating Block   ;
;   Sprite Editing Patch    ;
;       By Luigi-San        ;
;                           ;
;  This patch changes the   ;
;     path used by the      ;
;   creating/eating block   ;
;  sprite for both the main ;
; overworld and all submaps ;
;   as well as some extra   ;
;    data related to the    ;
;          sprite.          ;
;                           ;
;   No Freespace required.  ;
; ------------------------- ;
;        How to use:        ;
;                           ;
;      Each command is      ;
; represented by one byte,  ;
; in the format XY, where Y ;
; is the direction to move  ;
; in (0=Right,1=Left,       ;
; 2=Down,3=Up), and X is    ;
; the amount of tiles to    ;
; move in that direction.   ;
; So, for example, the byte ;
; "43" means that the       ;
; sprite will go up four    ;
;         tiles.            ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        Main Data          ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $0393EF
db $80,$13,$10,$13,$10,$13,$10,$13,$60,$23,$20,$23,$B0,$22,$A1,$22,$A0,$22,$A1,$22,$C0,$13,$10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$F0,$F0,$F0,$52,$50,$33,$50,$32,$50,$33,$50,$22,$50,$33,$F0,$50,$82,$FF ; |Path For levels on main overworld

org $0393A4
db $10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$10,$13,$F0,$F0,$20,$12,$10,$12,$10,$12,$10,$12,$10,$12,$10,$12,$10,$12,$D0,$C3,$F1,$21,$22,$F1,$F1,$51,$43,$10,$13,$10,$13,$10,$13,$F0,$F0,$F0,$60,$32,$60,$32,$71,$32,$60,$32,$61,$32,$70,$33,$10,$33,$10,$33,$10,$33,$10,$33,$F0,$10,$F2,$52,$FF ; |Path For levels on submaps

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Extra Stuff         ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $03926F
db $10,$F0,$00,$00,$00 ; |Sprite X-Speed

org $039274
db $00,$00,$10,$F0,$00 ; |Sprite Y-Speed

org $039293
db $2E ; |Tile used by sprite

org $0392B9
db $04 ; |Sound effect used by sprite




