;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Custom Other Sprites, by imamelia
;;
;; This patch allows you to insert custom extended, cluster, minor extended,
;; bounce, score, smoke, and spinning coin sprites (!).  It comes with a few sample
;; subroutines for use with some of these sprites.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

!Freespace1 = $18F000
!Freespace2 = $198000

; cluster sprites, extended sprites, minor extended sprites, bounce sprites, score sprites, smoke images, spinning coin from block

org $02F815
JML ClusterSpriteHack
NOP
;LDA $1892,x
;BEQ $03       

org $029B1B
JML ExtendedSpriteHack
;LDY $9D
;BNE $08

org $028B6C
JML MinorExSpriteHack
;BEQ $06
;STX $1698

org $029052
JML BounceSpriteHack
;LDY $9D
;BNE $08

org $02ADC9
JML ScoreSpriteHack
;LDA $9D
;BEQ $03

org $0296C3
JML SmokeImageHack
;BEQ $12
;AND #$7F

org $0299F1
JML SpinningCoinHack
;LDA $9D
;BNE $13

org !Freespace1

reset bytes

db "STAR"
dw End1-Start1-$01
dw End1-Start1-$01^$FFFF

Start1:

ClusterSpriteHack:

LDA $1892,x			; cluster sprite number
BEQ .Return				;
CMP #$09				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$09				; 09 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA ClusterPtrs,y			; pointers to the cluster sprites
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

.Return				;
JML $02F81D			;
.NotCustom				;
JML $02F81A			;

ExtendedSpriteHack:

CMP #$13				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$13				; 13 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA ExtendedPtrs,y		; pointers to the extended sprites
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

JML $029B15			;
.NotCustom				;
LDY $9D				;
BNE .Return2			;
JML $029B1F			;
.Return2				;
JML $029B27			;

MinorExSpriteHack:

BEQ .Return1			;
STX $1698				;
CMP #$0C				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$0C				; 0C is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA MinorExtendedPtrs,y	; pointers to the minor extended sprites
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

.Return1				;
JML $028B74			;			;
.NotCustom				;
JML $028B71			;

BounceSpriteHack:

CMP #$08				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$08				; 08 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA BouncePtrs,y			; pointers to the bounce sprites
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

JML $02904C			;
.NotCustom				;
LDY $9D				;
BNE .Return2			;
JML $029056			;
.Return2				;
JML $02905E			;

ScoreSpriteHack:

CMP #$16				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$16				; 16 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA ScorePtrs,y			; pointers to the score sprites
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

JML $02ADC5			;
.NotCustom				;
LDY $9D				;
BNE .Return2			;
JML $02ADD0			;
.Return2				;
JML $02AE5B			;

SmokeImageHack:

BEQ .Return1			;
AND #$7F				;
CMP #$06				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$06				; 06 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA SmokePtrs,y			; pointers to the smoke images
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

.Return1				;
JML $0296D7			;
.NotCustom				;
JML $0296C7			;

SpinningCoinHack:

CMP #$02				;
BCC .NotCustom			;

PHB					;
PHK					;
PLB					;
SEC					;
SBC #$02				; 02 is the first custom one
REP #$30				; 16-bit AXY
AND.w #$00FF			; clear the high byte
ASL					; x2
TAY					; into Y
LDA SpinCoinPtrs,y		; pointers to the spinning coins
STA $08				; low and high bytes
SEP #$30				; 8-bit AXY
LDA.b #!Freespace2>>16	; bank byte
STA $0A				;
PHA					;
PLB					;
PHK					;
PEA.w .PtrRet-$01			; push a return address
JML [$0008]				;
.PtrRet				;
PLB					;

JML $0299E8			;
.NotCustom				;
LDY $9D				;
BNE .Return2			;
JML $0299F5			;
.Return2				;
JML $029A08			;

ClusterPtrs:
dw ClusterSprite09
dw ClusterSprite0A
dw ClusterSprite0B
dw ClusterSprite0C
dw ClusterSprite0D
dw ClusterSprite0E
dw ClusterSprite0F
;dw ClusterSprite10
;...
;dw ClusterSpriteFF

ExtendedPtrs:
dw ExtendedSprite13
dw ExtendedSprite14
dw ExtendedSprite15
dw ExtendedSprite16
dw ExtendedSprite17
;dw ExtendedSprite18
;...
;dw ExtendedSpriteFF

MinorExtendedPtrs:
dw MinorExSprite0C
dw MinorExSprite0D
dw MinorExSprite0E
dw MinorExSprite0F
;dw MinorExSprite10
;...
;dw MinorExSpriteFF

BouncePtrs:
dw BounceSprite08
dw BounceSprite09
dw BounceSprite0A
dw BounceSprite0B
;dw BounceSprite0C
;...
;dw BounceSpriteFF

ScorePtrs:
dw ScoreSprite16
dw ScoreSprite17
dw ScoreSprite18
dw ScoreSprite19
dw ScoreSprite1A
dw ScoreSprite1B
dw ScoreSprite1C
dw ScoreSprite1D
dw ScoreSprite1E
dw ScoreSprite1F
;dw ScoreSprite20
;...
;dw ScoreSpriteFF


SmokePtrs:
dw SmokeImage06
dw SmokeImage07
;dw SmokeImage08
;...
;dw SmokeImage7F

SpinCoinPtrs:
dw SpinningCoin02
dw SpinningCoin03
;dw SpinningCoin04
;...
;dw SpinningCoinFF

End1:

print "Freespace used by hacks and pointers: ",bytes," bytes."

org !Freespace2

reset bytes

db "STAR"
dw $7FF7
dw $8008
;dw End2-Start2-$01
;dw End2-Start2-$01^$FFFF

Start2:

incsrc otherspritecode.asm

End2:

print "Freespace used by custom code: ",bytes," bytes."
