;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Custom Fade Patch
; coded by edit1754
;
; Colors F8-FF cannot fade due to the RAM table being 16 bytes too small,
; so it is recommended to use those colors for Sprite Status Bar / Course Clear Text
; The new Sprite Status Bar v1.1.0 will use these colors by default,
; with the white and black colors moved into the second half of the palette as well
;
; To enable custom fading in your level, change $00 to $01 in your level's entry.
; Otherwise, the default fading will be used (and the regular fade fix patch applies)
;
; The table format is just a series of bytes that correspond to colors in the palette.
; The first byte represents the BG color (not color 00), and the rest represent
; colors 01-F7. F8-FF are not included for reasons previously stated.
; Transparency in palette 8 should not be used in 8BPP BGs, as it can't fade correctly.
;
; In order to set up a custom table for your level other than the one included,
; copy & paste the one included, change it to your liking, then change the
; FadeMost label to something different. Then after that, go to your level's
; entry in the LevelTable and change "FadeMost" to the label of your new table
;
; The table that is included is suitable for both Layer 3 BGs that use the status bar
; palettes, and 8BPP BGs that overwrite much of the seldom-used sprite colors
; as well as the status bar colors
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

		!FreeSpace = $1B8000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; levelnum.ips (disassembly) - credit goes to BMF for this
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ORG $05D8B9
		JSR LevelNumCode

ORG $05DC46
LevelNumCode:	LDA.b $0E  		; Load level number, 1st part of hijacked code
		STA.w $010B		; Store it in free RAM
		ASL A    		; 2nd part of hijacked code
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hijacks
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $A488
		JML PaletteDMAHack

org $AF45
		JML ColorFadeHack

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FreeSpace
reset bytes

db "STAR"
dw CodeEnd-CodeStart
dw CodeEnd-CodeStart^#$FFFF

CodeStart:

PaletteDMAHack:	LDY.w $0680
		CPY.b #$FF
		BEQ .Main
		LDX.w $A481,y
		JML $00A48E

.Main		REP #%00010000
		LDA.b #$01
		STA.w $2121
		LDX.w #$2200
		STX.w $4320
		LDX.w #$0907
		STX.w $4322
		LDA.b #$7E
		STA.w $4324
		LDX.w #$01EE
		STX.w $4325
		LDA.b #%00000100
		STA.w $420B
		SEP #%00010000
		STZ.w $0680
		JML $00A4E2

ColorFadeHack:	LDA.w $010B
		ASL #2
		TAX
		LDA.l LevelTable,x
		AND.w #$0001
		BNE .Main
		LDA.w #$01FE
		STA.w $0905
		JML $00AF4B

.Main		LDA.l LevelTable+1,x
		STA.b $8A
		LDA.l LevelTable+2,x
		STA.b $8B
		LDX.w #$01EE
		LDA.w #$00F7
		STA.b $00
.CODE_00AF53	LDY.b $00
		LDA.b [$8A],y
		AND.w #$0001
		BEQ .Skip1
		LDA.w $0905,x
		STA.b $02
		LDA.w $0703,x
		PHK
		PER.w .Ret1-1
		PEA.w $84CE
		JML $00AFC0
.Ret1     	LDA $04
		STA.w $0905,x
.Skip1		DEX #2
		DEC $00
		BNE .CODE_00AF53
		LDA [$8A]
		AND.w #$0001
		BEQ .Skip2
		LDA.w $0701
		STA $02
		LDA.w $0903
		PHK
		PER.w .Ret2-1
		PEA.w $84CE
		JML $00AFC0
.Ret2		LDA $04
		STA.w $0701
.Skip2		SEP #%00110000
		STZ.w $0A05
		LDA.b #$FF
		STA.w $0680
		JML $00AFA2


LevelTable:
L000:		db $00 : dl FadeMost		; Enable; Table Pointer
L001:		db $00 : dl FadeMost		; Enable; Table Pointer
L002:		db $00 : dl FadeMost		; Enable; Table Pointer
L003:		db $00 : dl FadeMost		; Enable; Table Pointer
L004:		db $00 : dl FadeMost		; Enable; Table Pointer
L005:		db $00 : dl FadeMost		; Enable; Table Pointer
L006:		db $00 : dl FadeMost		; Enable; Table Pointer
L007:		db $00 : dl FadeMost		; Enable; Table Pointer
L008:		db $00 : dl FadeMost		; Enable; Table Pointer
L009:		db $00 : dl FadeMost		; Enable; Table Pointer
L00A:		db $00 : dl FadeMost		; Enable; Table Pointer
L00B:		db $00 : dl FadeMost		; Enable; Table Pointer
L00C:		db $00 : dl FadeMost		; Enable; Table Pointer
L00D:		db $00 : dl FadeMost		; Enable; Table Pointer
L00E:		db $00 : dl FadeMost		; Enable; Table Pointer
L00F:		db $00 : dl FadeMost		; Enable; Table Pointer
L010:		db $00 : dl FadeMost		; Enable; Table Pointer
L011:		db $00 : dl FadeMost		; Enable; Table Pointer
L012:		db $00 : dl FadeMost		; Enable; Table Pointer
L013:		db $00 : dl FadeMost		; Enable; Table Pointer
L014:		db $00 : dl FadeMost		; Enable; Table Pointer
L015:		db $00 : dl FadeMost		; Enable; Table Pointer
L016:		db $00 : dl FadeMost		; Enable; Table Pointer
L017:		db $00 : dl FadeMost		; Enable; Table Pointer
L018:		db $00 : dl FadeMost		; Enable; Table Pointer
L019:		db $00 : dl FadeMost		; Enable; Table Pointer
L01A:		db $00 : dl FadeMost		; Enable; Table Pointer
L01B:		db $00 : dl FadeMost		; Enable; Table Pointer
L01C:		db $00 : dl FadeMost		; Enable; Table Pointer
L01D:		db $00 : dl FadeMost		; Enable; Table Pointer
L01E:		db $00 : dl FadeMost		; Enable; Table Pointer
L01F:		db $00 : dl FadeMost		; Enable; Table Pointer
L020:		db $00 : dl FadeMost		; Enable; Table Pointer
L021:		db $00 : dl FadeMost		; Enable; Table Pointer
L022:		db $00 : dl FadeMost		; Enable; Table Pointer
L023:		db $00 : dl FadeMost		; Enable; Table Pointer
L024:		db $00 : dl FadeMost		; Enable; Table Pointer
L025:		db $00 : dl FadeMost		; Enable; Table Pointer
L026:		db $00 : dl FadeMost		; Enable; Table Pointer
L027:		db $00 : dl FadeMost		; Enable; Table Pointer
L028:		db $00 : dl FadeMost		; Enable; Table Pointer
L029:		db $00 : dl FadeMost		; Enable; Table Pointer
L02A:		db $00 : dl FadeMost		; Enable; Table Pointer
L02B:		db $00 : dl FadeMost		; Enable; Table Pointer
L02C:		db $00 : dl FadeMost		; Enable; Table Pointer
L02D:		db $00 : dl FadeMost		; Enable; Table Pointer
L02E:		db $00 : dl FadeMost		; Enable; Table Pointer
L02F:		db $00 : dl FadeMost		; Enable; Table Pointer
L030:		db $00 : dl FadeMost		; Enable; Table Pointer
L031:		db $00 : dl FadeMost		; Enable; Table Pointer
L032:		db $00 : dl FadeMost		; Enable; Table Pointer
L033:		db $00 : dl FadeMost		; Enable; Table Pointer
L034:		db $00 : dl FadeMost		; Enable; Table Pointer
L035:		db $00 : dl FadeMost		; Enable; Table Pointer
L036:		db $00 : dl FadeMost		; Enable; Table Pointer
L037:		db $00 : dl FadeMost		; Enable; Table Pointer
L038:		db $00 : dl FadeMost		; Enable; Table Pointer
L039:		db $00 : dl FadeMost		; Enable; Table Pointer
L03A:		db $00 : dl FadeMost		; Enable; Table Pointer
L03B:		db $00 : dl FadeMost		; Enable; Table Pointer
L03C:		db $00 : dl FadeMost		; Enable; Table Pointer
L03D:		db $00 : dl FadeMost		; Enable; Table Pointer
L03E:		db $00 : dl FadeMost		; Enable; Table Pointer
L03F:		db $00 : dl FadeMost		; Enable; Table Pointer
L040:		db $01 : dl FadeMost		; Enable; Table Pointer
L041:		db $00 : dl FadeMost		; Enable; Table Pointer
L042:		db $00 : dl FadeMost		; Enable; Table Pointer
L043:		db $00 : dl FadeMost		; Enable; Table Pointer
L044:		db $00 : dl FadeMost		; Enable; Table Pointer
L045:		db $00 : dl FadeMost		; Enable; Table Pointer
L046:		db $00 : dl FadeMost		; Enable; Table Pointer
L047:		db $00 : dl FadeMost		; Enable; Table Pointer
L048:		db $00 : dl FadeMost		; Enable; Table Pointer
L049:		db $00 : dl FadeMost		; Enable; Table Pointer
L04A:		db $00 : dl FadeMost		; Enable; Table Pointer
L04B:		db $00 : dl FadeMost		; Enable; Table Pointer
L04C:		db $00 : dl FadeMost		; Enable; Table Pointer
L04D:		db $00 : dl FadeMost		; Enable; Table Pointer
L04E:		db $00 : dl FadeMost		; Enable; Table Pointer
L04F:		db $00 : dl FadeMost		; Enable; Table Pointer
L050:		db $00 : dl FadeMost		; Enable; Table Pointer
L051:		db $00 : dl FadeMost		; Enable; Table Pointer
L052:		db $00 : dl FadeMost		; Enable; Table Pointer
L053:		db $00 : dl FadeMost		; Enable; Table Pointer
L054:		db $00 : dl FadeMost		; Enable; Table Pointer
L055:		db $00 : dl FadeMost		; Enable; Table Pointer
L056:		db $00 : dl FadeMost		; Enable; Table Pointer
L057:		db $00 : dl FadeMost		; Enable; Table Pointer
L058:		db $00 : dl FadeMost		; Enable; Table Pointer
L059:		db $00 : dl FadeMost		; Enable; Table Pointer
L05A:		db $00 : dl FadeMost		; Enable; Table Pointer
L05B:		db $00 : dl FadeMost		; Enable; Table Pointer
L05C:		db $00 : dl FadeMost		; Enable; Table Pointer
L05D:		db $00 : dl FadeMost		; Enable; Table Pointer
L05E:		db $00 : dl FadeMost		; Enable; Table Pointer
L05F:		db $00 : dl FadeMost		; Enable; Table Pointer
L060:		db $00 : dl FadeMost		; Enable; Table Pointer
L061:		db $00 : dl FadeMost		; Enable; Table Pointer
L062:		db $00 : dl FadeMost		; Enable; Table Pointer
L063:		db $00 : dl FadeMost		; Enable; Table Pointer
L064:		db $00 : dl FadeMost		; Enable; Table Pointer
L065:		db $00 : dl FadeMost		; Enable; Table Pointer
L066:		db $00 : dl FadeMost		; Enable; Table Pointer
L067:		db $00 : dl FadeMost		; Enable; Table Pointer
L068:		db $00 : dl FadeMost		; Enable; Table Pointer
L069:		db $00 : dl FadeMost		; Enable; Table Pointer
L06A:		db $00 : dl FadeMost		; Enable; Table Pointer
L06B:		db $00 : dl FadeMost		; Enable; Table Pointer
L06C:		db $00 : dl FadeMost		; Enable; Table Pointer
L06D:		db $00 : dl FadeMost		; Enable; Table Pointer
L06E:		db $00 : dl FadeMost		; Enable; Table Pointer
L06F:		db $00 : dl FadeMost		; Enable; Table Pointer
L070:		db $00 : dl FadeMost		; Enable; Table Pointer
L071:		db $00 : dl FadeMost		; Enable; Table Pointer
L072:		db $00 : dl FadeMost		; Enable; Table Pointer
L073:		db $00 : dl FadeMost		; Enable; Table Pointer
L074:		db $00 : dl FadeMost		; Enable; Table Pointer
L075:		db $00 : dl FadeMost		; Enable; Table Pointer
L076:		db $00 : dl FadeMost		; Enable; Table Pointer
L077:		db $00 : dl FadeMost		; Enable; Table Pointer
L078:		db $00 : dl FadeMost		; Enable; Table Pointer
L079:		db $00 : dl FadeMost		; Enable; Table Pointer
L07A:		db $00 : dl FadeMost		; Enable; Table Pointer
L07B:		db $00 : dl FadeMost		; Enable; Table Pointer
L07C:		db $00 : dl FadeMost		; Enable; Table Pointer
L07D:		db $00 : dl FadeMost		; Enable; Table Pointer
L07E:		db $00 : dl FadeMost		; Enable; Table Pointer
L07F:		db $00 : dl FadeMost		; Enable; Table Pointer
L080:		db $00 : dl FadeMost		; Enable; Table Pointer
L081:		db $00 : dl FadeMost		; Enable; Table Pointer
L082:		db $00 : dl FadeMost		; Enable; Table Pointer
L083:		db $00 : dl FadeMost		; Enable; Table Pointer
L084:		db $00 : dl FadeMost		; Enable; Table Pointer
L085:		db $00 : dl FadeMost		; Enable; Table Pointer
L086:		db $00 : dl FadeMost		; Enable; Table Pointer
L087:		db $00 : dl FadeMost		; Enable; Table Pointer
L088:		db $00 : dl FadeMost		; Enable; Table Pointer
L089:		db $00 : dl FadeMost		; Enable; Table Pointer
L08A:		db $00 : dl FadeMost		; Enable; Table Pointer
L08B:		db $00 : dl FadeMost		; Enable; Table Pointer
L08C:		db $00 : dl FadeMost		; Enable; Table Pointer
L08D:		db $00 : dl FadeMost		; Enable; Table Pointer
L08E:		db $00 : dl FadeMost		; Enable; Table Pointer
L08F:		db $00 : dl FadeMost		; Enable; Table Pointer
L090:		db $00 : dl FadeMost		; Enable; Table Pointer
L091:		db $00 : dl FadeMost		; Enable; Table Pointer
L092:		db $00 : dl FadeMost		; Enable; Table Pointer
L093:		db $00 : dl FadeMost		; Enable; Table Pointer
L094:		db $00 : dl FadeMost		; Enable; Table Pointer
L095:		db $00 : dl FadeMost		; Enable; Table Pointer
L096:		db $00 : dl FadeMost		; Enable; Table Pointer
L097:		db $00 : dl FadeMost		; Enable; Table Pointer
L098:		db $00 : dl FadeMost		; Enable; Table Pointer
L099:		db $00 : dl FadeMost		; Enable; Table Pointer
L09A:		db $00 : dl FadeMost		; Enable; Table Pointer
L09B:		db $00 : dl FadeMost		; Enable; Table Pointer
L09C:		db $00 : dl FadeMost		; Enable; Table Pointer
L09D:		db $00 : dl FadeMost		; Enable; Table Pointer
L09E:		db $00 : dl FadeMost		; Enable; Table Pointer
L09F:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0A9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AD:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0AF:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0B9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BD:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0BF:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0C9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CD:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0CF:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0D9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DD:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0DF:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0E9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0EA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0EB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0EC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0ED:		db $00 : dl FadeMost		; Enable; Table Pointer
L0EE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0EF:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F0:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F1:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F2:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F3:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F4:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F5:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F6:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F7:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F8:		db $00 : dl FadeMost		; Enable; Table Pointer
L0F9:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FA:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FB:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FC:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FD:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FE:		db $00 : dl FadeMost		; Enable; Table Pointer
L0FF:		db $00 : dl FadeMost		; Enable; Table Pointer
L100:		db $00 : dl FadeMost		; Enable; Table Pointer
L101:		db $00 : dl FadeMost		; Enable; Table Pointer
L102:		db $00 : dl FadeMost		; Enable; Table Pointer
L103:		db $00 : dl FadeMost		; Enable; Table Pointer
L104:		db $01 : dl FadeMost		; Enable; Table Pointer
L105:		db $01 : dl FadeMost		; Enable; Table Pointer
L106:		db $01 : dl FadeMost		; Enable; Table Pointer
L107:		db $00 : dl FadeMost		; Enable; Table Pointer
L108:		db $00 : dl FadeMost		; Enable; Table Pointer
L109:		db $00 : dl FadeMost		; Enable; Table Pointer
L10A:		db $00 : dl FadeMost		; Enable; Table Pointer
L10B:		db $00 : dl FadeMost		; Enable; Table Pointer
L10C:		db $00 : dl FadeMost		; Enable; Table Pointer
L10D:		db $00 : dl FadeMost		; Enable; Table Pointer
L10E:		db $00 : dl FadeMost		; Enable; Table Pointer
L10F:		db $00 : dl FadeMost		; Enable; Table Pointer
L110:		db $00 : dl FadeMost		; Enable; Table Pointer
L111:		db $00 : dl FadeMost		; Enable; Table Pointer
L112:		db $00 : dl FadeMost		; Enable; Table Pointer
L113:		db $00 : dl FadeMost		; Enable; Table Pointer
L114:		db $00 : dl FadeMost		; Enable; Table Pointer
L115:		db $00 : dl FadeMost		; Enable; Table Pointer
L116:		db $00 : dl FadeMost		; Enable; Table Pointer
L117:		db $00 : dl FadeMost		; Enable; Table Pointer
L118:		db $00 : dl FadeMost		; Enable; Table Pointer
L119:		db $00 : dl FadeMost		; Enable; Table Pointer
L11A:		db $00 : dl FadeMost		; Enable; Table Pointer
L11B:		db $00 : dl FadeMost		; Enable; Table Pointer
L11C:		db $00 : dl FadeMost		; Enable; Table Pointer
L11D:		db $00 : dl FadeMost		; Enable; Table Pointer
L11E:		db $00 : dl FadeMost		; Enable; Table Pointer
L11F:		db $00 : dl FadeMost		; Enable; Table Pointer
L120:		db $00 : dl FadeMost		; Enable; Table Pointer
L121:		db $00 : dl FadeMost		; Enable; Table Pointer
L122:		db $00 : dl FadeMost		; Enable; Table Pointer
L123:		db $00 : dl FadeMost		; Enable; Table Pointer
L124:		db $00 : dl FadeMost		; Enable; Table Pointer
L125:		db $00 : dl FadeMost		; Enable; Table Pointer
L126:		db $00 : dl FadeMost		; Enable; Table Pointer
L127:		db $00 : dl FadeMost		; Enable; Table Pointer
L128:		db $00 : dl FadeMost		; Enable; Table Pointer
L129:		db $00 : dl FadeMost		; Enable; Table Pointer
L12A:		db $00 : dl FadeMost		; Enable; Table Pointer
L12B:		db $00 : dl FadeMost		; Enable; Table Pointer
L12C:		db $00 : dl FadeMost		; Enable; Table Pointer
L12D:		db $00 : dl FadeMost		; Enable; Table Pointer
L12E:		db $00 : dl FadeMost		; Enable; Table Pointer
L12F:		db $00 : dl FadeMost		; Enable; Table Pointer
L130:		db $00 : dl FadeMost		; Enable; Table Pointer
L131:		db $00 : dl FadeMost		; Enable; Table Pointer
L132:		db $00 : dl FadeMost		; Enable; Table Pointer
L133:		db $00 : dl FadeMost		; Enable; Table Pointer
L134:		db $00 : dl FadeMost		; Enable; Table Pointer
L135:		db $00 : dl FadeMost		; Enable; Table Pointer
L136:		db $00 : dl FadeMost		; Enable; Table Pointer
L137:		db $00 : dl FadeMost		; Enable; Table Pointer
L138:		db $00 : dl FadeMost		; Enable; Table Pointer
L139:		db $00 : dl FadeMost		; Enable; Table Pointer
L13A:		db $00 : dl FadeMost		; Enable; Table Pointer
L13B:		db $00 : dl FadeMost		; Enable; Table Pointer
L13C:		db $00 : dl FadeMost		; Enable; Table Pointer
L13D:		db $00 : dl FadeMost		; Enable; Table Pointer
L13E:		db $00 : dl FadeMost		; Enable; Table Pointer
L13F:		db $00 : dl FadeMost		; Enable; Table Pointer
L140:		db $00 : dl FadeMost		; Enable; Table Pointer
L141:		db $00 : dl FadeMost		; Enable; Table Pointer
L142:		db $00 : dl FadeMost		; Enable; Table Pointer
L143:		db $00 : dl FadeMost		; Enable; Table Pointer
L144:		db $00 : dl FadeMost		; Enable; Table Pointer
L145:		db $00 : dl FadeMost		; Enable; Table Pointer
L146:		db $00 : dl FadeMost		; Enable; Table Pointer
L147:		db $00 : dl FadeMost		; Enable; Table Pointer
L148:		db $00 : dl FadeMost		; Enable; Table Pointer
L149:		db $00 : dl FadeMost		; Enable; Table Pointer
L14A:		db $00 : dl FadeMost		; Enable; Table Pointer
L14B:		db $00 : dl FadeMost		; Enable; Table Pointer
L14C:		db $00 : dl FadeMost		; Enable; Table Pointer
L14D:		db $00 : dl FadeMost		; Enable; Table Pointer
L14E:		db $00 : dl FadeMost		; Enable; Table Pointer
L14F:		db $00 : dl FadeMost		; Enable; Table Pointer
L150:		db $00 : dl FadeMost		; Enable; Table Pointer
L151:		db $00 : dl FadeMost		; Enable; Table Pointer
L152:		db $00 : dl FadeMost		; Enable; Table Pointer
L153:		db $00 : dl FadeMost		; Enable; Table Pointer
L154:		db $00 : dl FadeMost		; Enable; Table Pointer
L155:		db $00 : dl FadeMost		; Enable; Table Pointer
L156:		db $00 : dl FadeMost		; Enable; Table Pointer
L157:		db $00 : dl FadeMost		; Enable; Table Pointer
L158:		db $00 : dl FadeMost		; Enable; Table Pointer
L159:		db $00 : dl FadeMost		; Enable; Table Pointer
L15A:		db $00 : dl FadeMost		; Enable; Table Pointer
L15B:		db $00 : dl FadeMost		; Enable; Table Pointer
L15C:		db $00 : dl FadeMost		; Enable; Table Pointer
L15D:		db $00 : dl FadeMost		; Enable; Table Pointer
L15E:		db $00 : dl FadeMost		; Enable; Table Pointer
L15F:		db $00 : dl FadeMost		; Enable; Table Pointer
L160:		db $00 : dl FadeMost		; Enable; Table Pointer
L161:		db $00 : dl FadeMost		; Enable; Table Pointer
L162:		db $00 : dl FadeMost		; Enable; Table Pointer
L163:		db $00 : dl FadeMost		; Enable; Table Pointer
L164:		db $00 : dl FadeMost		; Enable; Table Pointer
L165:		db $00 : dl FadeMost		; Enable; Table Pointer
L166:		db $00 : dl FadeMost		; Enable; Table Pointer
L167:		db $00 : dl FadeMost		; Enable; Table Pointer
L168:		db $00 : dl FadeMost		; Enable; Table Pointer
L169:		db $00 : dl FadeMost		; Enable; Table Pointer
L16A:		db $00 : dl FadeMost		; Enable; Table Pointer
L16B:		db $00 : dl FadeMost		; Enable; Table Pointer
L16C:		db $00 : dl FadeMost		; Enable; Table Pointer
L16D:		db $00 : dl FadeMost		; Enable; Table Pointer
L16E:		db $00 : dl FadeMost		; Enable; Table Pointer
L16F:		db $00 : dl FadeMost		; Enable; Table Pointer
L170:		db $00 : dl FadeMost		; Enable; Table Pointer
L171:		db $00 : dl FadeMost		; Enable; Table Pointer
L172:		db $00 : dl FadeMost		; Enable; Table Pointer
L173:		db $00 : dl FadeMost		; Enable; Table Pointer
L174:		db $00 : dl FadeMost		; Enable; Table Pointer
L175:		db $00 : dl FadeMost		; Enable; Table Pointer
L176:		db $00 : dl FadeMost		; Enable; Table Pointer
L177:		db $00 : dl FadeMost		; Enable; Table Pointer
L178:		db $00 : dl FadeMost		; Enable; Table Pointer
L179:		db $00 : dl FadeMost		; Enable; Table Pointer
L17A:		db $00 : dl FadeMost		; Enable; Table Pointer
L17B:		db $00 : dl FadeMost		; Enable; Table Pointer
L17C:		db $00 : dl FadeMost		; Enable; Table Pointer
L17D:		db $00 : dl FadeMost		; Enable; Table Pointer
L17E:		db $00 : dl FadeMost		; Enable; Table Pointer
L17F:		db $00 : dl FadeMost		; Enable; Table Pointer
L180:		db $00 : dl FadeMost		; Enable; Table Pointer
L181:		db $00 : dl FadeMost		; Enable; Table Pointer
L182:		db $00 : dl FadeMost		; Enable; Table Pointer
L183:		db $00 : dl FadeMost		; Enable; Table Pointer
L184:		db $00 : dl FadeMost		; Enable; Table Pointer
L185:		db $00 : dl FadeMost		; Enable; Table Pointer
L186:		db $00 : dl FadeMost		; Enable; Table Pointer
L187:		db $00 : dl FadeMost		; Enable; Table Pointer
L188:		db $00 : dl FadeMost		; Enable; Table Pointer
L189:		db $00 : dl FadeMost		; Enable; Table Pointer
L18A:		db $00 : dl FadeMost		; Enable; Table Pointer
L18B:		db $00 : dl FadeMost		; Enable; Table Pointer
L18C:		db $00 : dl FadeMost		; Enable; Table Pointer
L18D:		db $00 : dl FadeMost		; Enable; Table Pointer
L18E:		db $00 : dl FadeMost		; Enable; Table Pointer
L18F:		db $00 : dl FadeMost		; Enable; Table Pointer
L190:		db $00 : dl FadeMost		; Enable; Table Pointer
L191:		db $00 : dl FadeMost		; Enable; Table Pointer
L192:		db $00 : dl FadeMost		; Enable; Table Pointer
L193:		db $00 : dl FadeMost		; Enable; Table Pointer
L194:		db $00 : dl FadeMost		; Enable; Table Pointer
L195:		db $00 : dl FadeMost		; Enable; Table Pointer
L196:		db $00 : dl FadeMost		; Enable; Table Pointer
L197:		db $00 : dl FadeMost		; Enable; Table Pointer
L198:		db $00 : dl FadeMost		; Enable; Table Pointer
L199:		db $00 : dl FadeMost		; Enable; Table Pointer
L19A:		db $00 : dl FadeMost		; Enable; Table Pointer
L19B:		db $00 : dl FadeMost		; Enable; Table Pointer
L19C:		db $00 : dl FadeMost		; Enable; Table Pointer
L19D:		db $00 : dl FadeMost		; Enable; Table Pointer
L19E:		db $00 : dl FadeMost		; Enable; Table Pointer
L19F:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1A9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AD:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1AF:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1B9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BD:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1BF:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1C9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CD:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1CF:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1D9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DD:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1DF:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1E9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1EA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1EB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1EC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1ED:		db $00 : dl FadeMost		; Enable; Table Pointer
L1EE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1EF:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F0:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F1:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F2:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F3:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F4:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F5:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F6:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F7:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F8:		db $00 : dl FadeMost		; Enable; Table Pointer
L1F9:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FA:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FB:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FC:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FD:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FE:		db $00 : dl FadeMost		; Enable; Table Pointer
L1FF:		db $00 : dl FadeMost		; Enable; Table Pointer

FadeMost:	db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $01,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$00,$01,$01


CodeEnd:
print bytes

