;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Activate Debug Features With Flags
;;            by 
;;      wiiqwertyuiop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Defines
;;

!FreeSpace = $128000
!SlowMotionFlag	= $60		; Techinically doesn't need to be free ram. just use what ever ram you want to use here. For example if you wanted it to be slow when mario isn't small you could put $19. THIS IS TRUE FOR ALL OF THEM!
!SlowMotionSpeed = $0F
!BeatLevelFlag = $15     	
!ExitType = $01			; Exit type: 00 - level beaten regular, 01 - level beaten secret
!FreeRoamingFlag = $14AF 	; On/Off Flag
!YoshiOWColorFlag = $61 	; Set this to #$02 to increase Yoshi's OW color by one. Anything higher will make him flash all his colors until it hits zero.
!YoshiHouseWarpFlag = $62

;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Slow Motion
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro SlowMotionCode()

LDA !SlowMotionFlag	;\ Delete this if you don't want it
BNE SlowTime		;/

endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Beat Level
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro EndLevelCode()

LDA !BeatLevelFlag	;\ Delete this if you don't want it
BNE BeatLevel		;/

endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Free Roaming Mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro FreeRoamingCode()

LDA !FreeRoamingFlag	;\ And so on
BNE Roam		;/

endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Change Yoshi's OW Color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro ChangeYoshiOWColor()

LDA !YoshiOWColorFlag
BNE ChangeColor

endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Warp to Star World From Yoshi's House
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro WarpFromYoshiHouse()

LDA !YoshiHouseWarpFlag
BNE WarpNow

endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Hijacks
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $00A242
JML Slow
NOP

org $00A256
db !SlowMotionSpeed

org $00CC68
JML Free
NOP #26

org $048246
JML Yoshi
NOP

org $049132
JML Warp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Freespace + RATS Tag
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FreeSpace
!CodeSize = EndCode-OurCode
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Actual Code Below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Slow:
LDA $13D4
BEQ OurCode
JML $00A247

OurCode:

%SlowMotionCode()

%EndLevelCode()

JML $00A28A

SlowTime:
JML $00A253

BeatLevel:
LDA #!ExitType
JML $00A27A

Free:
LDA $17
AND #$20
BEQ Skip
LDA $18
CMP #$80
BNE Skip

Skip:
LDA !FreeRoamingFlag
BEQ OldCode 

LDA #$02
STA $1E01

%FreeRoamingCode()

OldCode:
LDA $1E01
JMP $00CCBB

Roam:

LDA $1E01
JMP $00CC86

Yoshi:

%ChangeYoshiOWColor()

LDA $15,x
AND #$20
JMP $048261

ChangeColor:
LDA $13
AND #$01
BNE +
DEC !YoshiOWColorFlag
+
JMP $04824D

Warp:
%WarpFromYoshiHouse()

LDA $16
AND #$20
JML $049136

WarpNow:
JML $049138
EndCode: