;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Flutter Jump
;;Original by Scepile3
;;Modification by UltimateYoshiMaster
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;		Notes from original version:		      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;*I use the RAM Addresses $0660 (For Flutter Jump Indicator. if used or not and pose to show)
;;
;;*How do you make a RATS tag? I think that's the reason for the freezing...
;;
;;*People that are good at rapidly pressing buttons may find a slight advantage...
;;
;;*There is a slight glitch...(it deals with springs...)
;;
;;
;;Original code from:
;; LR Hook - Version 1.1
;; By Smallhacker
;; 
;; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Timers, set to some other location if you are already using these locations in RAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TTFJ = $0661	;[T]ime [T]o [F]lutter [J]ump
FJR = $0662	;[F]lutter [J]ump [R]est
FC = $0663	;[F]lutter [C]arry
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $34B64 ;;change this to free space in rom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Disable L/R scrolling
org $34B64
org $00CDF6
    BRA lrSkip
org $00CE49
lrSkip:

;Hijack the status bar routine
org $008F49
        JSL NewRoutine

org $34B64
%RATS_start(0)

NewRoutine:
    LDA $77     ;(in order)Doesn't work if not in air, swimming, climbing, or on yoshi
    AND #$04	;On the ground?
    BNE Reset	;Exit
    LDA $75	;Swimming?
    BNE Reset	;Exit
    LDA $74	;Climbing?
    BNE Reset	;Exit
    LDA $187A	;On Yoshi?
    BNE Reset	;Exit
    LDA $1499     ;temperarily stops when facing screen
    BEQ NoReturn
    JMP Return
NoReturn:
	LDA TTFJ
	BEQ NoFlutter	;If the player isn't flutter jumping then don't apply its effects
		DEC FC		;boost more
		LDA FC		;load boost amount
		STA $7D		;apply boost
		DEC TTFJ	;decrement flutter jump counter
		BRA Fluttered	;don't run the resting code if we're flutter jumping
NoFlutter:
	LDA FJR		;Is there still rest time to take care of?
	BEQ NoRest	;Nope, skip
	DEC FJR		;Yes, decrement the rest timer
NoRest:
Fluttered:
	LDA $16       ;change these two lines to alter which button you want to press. controller values are in the RAM section of smwcentral.net
	CMP #$80
	BNE Return

	STZ $140D     ;remove this line if you don't want to allow mario to flutter while spin jumping (without this, mario spin flutters)
	LDA FJR		;Are we resting?
	BNE NoCheck
	LDA #$16	;How long to flutter jump
	STA TTFJ
	LDA #$F8	;Starting Y speed for flutter jump
	STA FC
	LDA #$16	;How long to rest afterwards
	STA FJR
	LDA #$09     ;What sound to play		(list of sounds at http://www.smwcentral.net/?p=thread&id=6665)
	STA $1DF9	;Sound Bank to use
NoCheck:
	BRA Return
Reset:	;Stop the flutter jump
	STZ TTFJ
	STZ FC
	BRA Return
Return:
	LDA $0DBE ;Don't mess with this part of code
	INC A
	RTL

%RATS_end(0)