;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Fog Variant 1
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Screen Designation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	LDA #$17		 	;\ Everything
	STA $212C			;| is on main screen
	LDA #$00 			;| Nothing
	STA $212D			;| is on sub screen
	LDA #$27			;| Affect layer 1,2,3
	STA $40				;/ and back enable

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Gradient		;| Get gradient pointer
	STA $4352			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$20			;\ Enable HDMA
	TSB $0D9F			;| on channel 5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Gradient:
	db $06,$F9
	db $06,$F8
	db $06,$F7
	db $06,$F6
	db $06,$F5
	db $06,$F4
	db $06,$F3
	db $06,$F2
	db $06,$F1
	db $06,$F0
	db $06,$EF
	db $06,$EE
	db $06,$ED
	db $05,$EC
	db $05,$EB
	db $05,$EA
	db $05,$E9
	db $05,$E8
	db $05,$E7
	db $05,$E6
	db $05,$E5
	db $05,$E4
	db $05,$E3
	db $05,$E2
	db $05,$E1
	db $00
%RATS_end(0)