;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Gradient Green
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Gradient		;| Get gradient pointer
	STA $4352			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$20			;\ Enable HDMA
	TSB $0D9F			;| on channel 5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Gradient:
	db $08,$43
	db $08,$44
	db $08,$45
	db $08,$46
	db $08,$47
	db $08,$48
	db $08,$49
	db $08,$4A
	db $08,$4B
	db $08,$4C
	db $08,$4D
	db $08,$4E
	db $08,$4F
	db $08,$50
	db $08,$51
	db $08,$52
	db $08,$53
	db $08,$54
	db $08,$55
	db $08,$56
	db $08,$57
	db $08,$58
	db $08,$59
	db $08,$5A
	db $08,$5B
	db $08,$5C
	db $08,$5D
	db $08,$5E
	db $08,$5F
	db $00
%RATS_end(0)