;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Gradient Red
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Gradient		;| Get gradient pointer
	STA $4352			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$20			;\ Enable HDMA
	TSB $0D9F			;| on channel 5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Gradient:
	db $08,$23
	db $08,$24
	db $08,$25
	db $08,$26
	db $08,$27
	db $08,$28
	db $08,$29
	db $08,$2A
	db $08,$2B
	db $08,$2C
	db $08,$2D
	db $08,$2E
	db $08,$2F
	db $08,$30
	db $08,$31
	db $08,$32
	db $08,$33
	db $08,$34
	db $08,$35
	db $08,$36
	db $08,$37
	db $08,$38
	db $08,$39
	db $08,$3A
	db $08,$3B
	db $08,$3C
	db $08,$3D
	db $08,$3E
	db $08,$3F
	db $00
%RATS_end(0)