;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Gradient Underwater
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Screen Designation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	LDA #$17		 	;\ Everything
	STA $212C			;| is on main screen
	LDA #$00 			;| Nothing
	STA $212D			;| is on sub screen
	LDA #$27			;| Affect layer 1,2,3
	STA $40				;/ and back enable

	STZ $0701			;\ Set BG color to
	STZ $0702			;/ black for gradient

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4350			;| $4331 = Mode 00
	LDA #Gradient		;| Get gradient pointer
	STA $4352			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$20			;\ Enable HDMA
	TSB $0D9F			;| on channel 5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Gradient:
	db $05,$9A
	db $05,$98
	db $05,$96
	db $05,$94
	db $05,$92
	db $05,$90
	db $04,$8E
	db $04,$8C
	db $04,$8A
	db $03,$88
	db $03,$86
	db $02,$84
	db $02,$82
	db $78,$E0
	db $02,$82
	db $02,$84
	db $03,$86
	db $03,$88
	db $04,$8A
	db $04,$8C
	db $04,$8E
	db $05,$90
	db $05,$92
	db $05,$94
	db $05,$96
	db $05,$98
	db $05,$9A
	db $00
%RATS_end(0)