;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Rainbow Gradient
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $01,$22
	db $01,$20
	db $01,$21
	db $01,$20
	db $01,$23
	db $02,$22
	db $02,$20
	db $01,$21
	db $01,$27
	db $03,$20
	db $01,$28
	db $01,$26
	db $03,$20
	db $01,$21
	db $01,$22
	db $01,$29
	db $03,$22
	db $01,$20
	db $01,$25
	db $01,$2D
	db $01,$21
	db $01,$20
	db $01,$21
	db $01,$20
	db $01,$21
	db $02,$25
	db $01,$20
	db $01,$23
	db $01,$29
	db $01,$2A
	db $01,$27
	db $01,$21
	db $01,$2F
	db $01,$35
	db $01,$2D
	db $01,$24
	db $02,$21
	db $02,$22
	db $01,$24
	db $01,$23
	db $01,$21
	db $01,$22
	db $01,$24
	db $01,$27
	db $01,$29
	db $02,$23
	db $01,$2E
	db $01,$3E
	db $01,$26
	db $01,$23
	db $02,$22
	db $01,$23
	db $01,$3C
	db $01,$39
	db $01,$2B
	db $01,$2A
	db $01,$2D
	db $01,$3B
	db $01,$3F
	db $01,$34
	db $01,$2D
	db $01,$2C
	db $01,$32
	db $01,$2E
	db $01,$2B
	db $01,$31
	db $01,$3D
	db $01,$37
	db $01,$35
	db $01,$37
	db $01,$36
	db $01,$38
	db $01,$37
	db $01,$36
	db $01,$3E
	db $01,$3A
	db $01,$37
	db $01,$31
	db $01,$33
	db $01,$35
	db $02,$36
	db $01,$2E
	db $01,$31
	db $01,$39
	db $01,$3F
	db $02,$3B
	db $01,$36
	db $01,$31
	db $01,$36
	db $01,$3F
	db $01,$3E
	db $01,$3F
	db $02,$30
	db $01,$37
	db $01,$3A
	db $01,$3B
	db $01,$35
	db $01,$36
	db $01,$30
	db $01,$29
	db $01,$2E
	db $01,$3D
	db $01,$37
	db $01,$32
	db $01,$3E
	db $01,$38
	db $01,$33
	db $01,$34
	db $01,$32
	db $01,$2F
	db $01,$2B
	db $01,$2D
	db $01,$3A
	db $01,$33
	db $01,$2D
	db $01,$2A
	db $01,$2D
	db $01,$30
	db $01,$3D
	db $01,$39
	db $01,$2C
	db $02,$2B
	db $01,$29
	db $01,$2B
	db $01,$29
	db $01,$30
	db $01,$3E
	db $01,$39
	db $01,$36
	db $01,$38
	db $01,$33
	db $01,$39
	db $01,$3F
	db $01,$32
	db $01,$37
	db $01,$3F
	db $01,$36
	db $01,$38
	db $01,$3E
	db $01,$38
	db $01,$30
	db $01,$37
	db $01,$3C
	db $01,$3A
	db $01,$3E
	db $02,$3F
	db $01,$3D
	db $01,$3F
	db $01,$30
	db $01,$24
	db $01,$2F
	db $01,$3B
	db $03,$3F
	db $01,$2A
	db $01,$28
	db $02,$3F
	db $01,$3D
	db $01,$3A
	db $01,$3D
	db $02,$3F
	db $01,$3C
	db $01,$35
	db $01,$33
	db $01,$29
	db $01,$37
	db $01,$35
	db $01,$2F
	db $01,$38
	db $01,$3A
	db $01,$2A
	db $01,$25
	db $01,$2D
	db $01,$32
	db $01,$2F
	db $01,$2E
	db $01,$34
	db $01,$2F
	db $01,$20
	db $01,$28
	db $02,$35
	db $01,$23
	db $01,$24
	db $01,$2E
	db $01,$23
	db $02,$20
	db $01,$23
	db $01,$2E
	db $02,$26
	db $01,$28
	db $01,$20
	db $00

Color_Green:
	db $01,$49
	db $01,$46
	db $02,$46
	db $01,$4F
	db $01,$4F
	db $01,$4E
	db $01,$49
	db $02,$47
	db $01,$4C
	db $01,$43
	db $01,$42
	db $01,$44
	db $01,$52
	db $01,$51
	db $01,$45
	db $01,$43
	db $01,$42
	db $01,$44
	db $01,$48
	db $01,$50
	db $01,$47
	db $01,$46
	db $01,$44
	db $01,$41
	db $01,$49
	db $01,$51
	db $01,$44
	db $01,$41
	db $01,$42
	db $01,$40
	db $01,$42
	db $01,$46
	db $01,$47
	db $01,$40
	db $01,$43
	db $01,$49
	db $01,$4A
	db $01,$46
	db $01,$40
	db $01,$4E
	db $01,$54
	db $01,$4C
	db $01,$43
	db $01,$40
	db $01,$40
	db $01,$40
	db $01,$40
	db $01,$42
	db $01,$41
	db $01,$40
	db $01,$41
	db $01,$41
	db $01,$40
	db $01,$42
	db $01,$40
	db $01,$40
	db $01,$48
	db $01,$58
	db $01,$41
	db $01,$40
	db $02,$40
	db $01,$40
	db $01,$56
	db $01,$4F
	db $02,$40
	db $01,$44
	db $01,$52
	db $01,$57
	db $01,$47
	db $01,$40
	db $01,$40
	db $01,$47
	db $01,$44
	db $01,$40
	db $01,$40
	db $01,$4A
	db $01,$43
	db $01,$40
	db $01,$41
	db $01,$40
	db $01,$41
	db $01,$41
	db $01,$40
	db $01,$47
	db $01,$42
	db $01,$41
	db $01,$40
	db $01,$42
	db $01,$42
	db $01,$43
	db $01,$46
	db $01,$40
	db $01,$40
	db $01,$49
	db $01,$55
	db $01,$4C
	db $01,$48
	db $01,$42
	db $01,$40
	db $01,$49
	db $01,$59
	db $01,$55
	db $01,$51
	db $01,$40
	db $01,$40
	db $01,$44
	db $02,$42
	db $01,$40
	db $01,$45
	db $01,$44
	db $01,$40
	db $01,$40
	db $01,$4C
	db $01,$46
	db $01,$40
	db $01,$49
	db $01,$43
	db $01,$40
	db $01,$42
	db $01,$42
	db $01,$41
	db $02,$40
	db $01,$49
	db $01,$43
	db $01,$40
	db $02,$40
	db $01,$41
	db $01,$4B
	db $01,$48
	db $01,$40
	db $02,$41
	db $01,$40
	db $01,$43
	db $01,$40
	db $01,$43
	db $01,$4F
	db $01,$49
	db $01,$46
	db $01,$48
	db $01,$44
	db $01,$4A
	db $01,$51
	db $01,$44
	db $01,$4A
	db $01,$53
	db $01,$4A
	db $01,$4C
	db $01,$53
	db $01,$4D
	db $01,$44
	db $01,$4D
	db $01,$52
	db $01,$51
	db $01,$55
	db $01,$57
	db $01,$59
	db $01,$58
	db $01,$5B
	db $01,$4C
	db $01,$40
	db $01,$4A
	db $01,$57
	db $02,$5D
	db $01,$5F
	db $01,$49
	db $01,$46
	db $01,$5C
	db $01,$5D
	db $01,$5B
	db $01,$59
	db $01,$5C
	db $02,$5E
	db $01,$5D
	db $01,$56
	db $01,$55
	db $01,$4B
	db $01,$5B
	db $01,$5A
	db $01,$54
	db $01,$5D
	db $01,$5F
	db $01,$4F
	db $01,$4B
	db $01,$54
	db $01,$5B
	db $01,$58
	db $01,$57
	db $01,$5D
	db $01,$58
	db $01,$49
	db $01,$50
	db $01,$5E
	db $01,$5E
	db $01,$4D
	db $01,$4F
	db $01,$5A
	db $01,$4F
	db $01,$4C
	db $01,$48
	db $01,$4D
	db $01,$5A
	db $01,$55
	db $01,$56
	db $01,$59
	db $01,$51
	db $00

Color_Blue:
	db $01,$8E
	db $01,$8B
	db $02,$8C
	db $01,$96
	db $01,$97
	db $01,$95
	db $01,$90
	db $02,$8E
	db $01,$94
	db $01,$8B
	db $01,$89
	db $01,$8B
	db $01,$98
	db $01,$98
	db $01,$8D
	db $01,$8B
	db $01,$8C
	db $01,$8F
	db $01,$92
	db $01,$9A
	db $01,$92
	db $01,$8F
	db $01,$8A
	db $01,$86
	db $01,$90
	db $01,$9A
	db $01,$8F
	db $01,$8C
	db $01,$8D
	db $01,$8C
	db $01,$8F
	db $01,$91
	db $01,$8E
	db $01,$86
	db $01,$8C
	db $01,$93
	db $01,$94
	db $01,$90
	db $01,$87
	db $01,$95
	db $01,$9B
	db $01,$93
	db $01,$89
	db $01,$87
	db $01,$88
	db $01,$89
	db $01,$88
	db $01,$8A
	db $01,$88
	db $01,$86
	db $01,$87
	db $01,$89
	db $01,$8C
	db $01,$8C
	db $01,$85
	db $01,$84
	db $01,$8E
	db $01,$9F
	db $01,$87
	db $01,$83
	db $02,$82
	db $01,$84
	db $01,$9C
	db $01,$95
	db $02,$85
	db $01,$89
	db $01,$99
	db $01,$9E
	db $01,$8F
	db $01,$88
	db $01,$86
	db $01,$8C
	db $01,$89
	db $01,$85
	db $01,$89
	db $01,$94
	db $01,$8C
	db $01,$89
	db $01,$89
	db $01,$89
	db $01,$8B
	db $01,$8C
	db $01,$8B
	db $01,$91
	db $01,$8B
	db $01,$87
	db $01,$85
	db $01,$88
	db $01,$8A
	db $01,$8B
	db $01,$8B
	db $01,$83
	db $01,$85
	db $01,$8E
	db $01,$9B
	db $01,$92
	db $01,$8E
	db $01,$87
	db $01,$84
	db $01,$8C
	db $01,$9B
	db $01,$97
	db $01,$94
	db $01,$82
	db $01,$80
	db $01,$85
	db $02,$86
	db $01,$82
	db $01,$87
	db $01,$85
	db $01,$80
	db $01,$81
	db $01,$8D
	db $01,$86
	db $01,$80
	db $01,$8C
	db $01,$85
	db $01,$81
	db $01,$82
	db $01,$81
	db $01,$80
	db $02,$80
	db $01,$8A
	db $01,$83
	db $01,$81
	db $02,$80
	db $01,$80
	db $01,$8B
	db $01,$88
	db $01,$80
	db $02,$81
	db $01,$80
	db $01,$83
	db $01,$80
	db $01,$80
	db $01,$8A
	db $01,$85
	db $01,$81
	db $01,$83
	db $01,$80
	db $01,$82
	db $01,$89
	db $01,$80
	db $01,$83
	db $01,$8B
	db $01,$80
	db $01,$81
	db $01,$88
	db $01,$84
	db $01,$80
	db $01,$80
	db $01,$83
	db $01,$80
	db $01,$83
	db $01,$84
	db $01,$85
	db $01,$85
	db $01,$8B
	db $01,$84
	db $01,$80
	db $01,$80
	db $01,$88
	db $02,$8D
	db $01,$91
	db $01,$80
	db $01,$80
	db $01,$8D
	db $01,$88
	db $01,$83
	db $01,$80
	db $01,$85
	db $02,$8D
	db $01,$88
	db $01,$82
	db $01,$86
	db $01,$80
	db $01,$87
	db $01,$83
	db $01,$80
	db $01,$88
	db $01,$8D
	db $01,$80
	db $01,$80
	db $01,$84
	db $01,$86
	db $01,$83
	db $01,$85
	db $01,$8D
	db $01,$8A
	db $01,$80
	db $01,$84
	db $01,$92
	db $01,$93
	db $01,$82
	db $01,$83
	db $01,$8D
	db $01,$82
	db $01,$80
	db $01,$80
	db $01,$84
	db $01,$90
	db $01,$8A
	db $01,$89
	db $01,$8C
	db $01,$83
	db $00
%RATS_end(0)