;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Castle
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $12,$25
	db $02,$26
	db $03,$26
	db $05,$27
	db $08,$28
	db $08,$29
	db $06,$2A
	db $02,$2B
	db $03,$2B
	db $05,$2C
	db $04,$2D
	db $04,$2E
	db $04,$2F
	db $04,$30
	db $06,$31
	db $02,$32
	db $03,$32
	db $05,$33
	db $04,$34
	db $04,$35
	db $04,$36
	db $04,$37
	db $06,$38
	db $02,$39
	db $03,$39
	db $05,$3A
	db $04,$3B
	db $04,$3C
	db $04,$3D
	db $04,$3E
	db $01,$3F
	db $01,$3E
	db $02,$3D
	db $01,$3C
	db $01,$3C
	db $02,$3B
	db $01,$3A
	db $02,$39
	db $02,$38
	db $02,$37
	db $02,$36
	db $01,$35
	db $02,$34
	db $02,$33
	db $01,$32
	db $01,$32
	db $01,$31
	db $01,$30
	db $01,$30
	db $02,$2F
	db $02,$2E
	db $02,$2D
	db $04,$2C
	db $04,$2B
	db $04,$2A
	db $04,$29
	db $04,$28
	db $01,$27
	db $03,$27
	db $02,$26
	db $02,$26
	db $17,$25
	db $00

Color_Green:
	db $12,$44
	db $02,$44
	db $03,$45
	db $05,$45
	db $08,$46
	db $08,$46
	db $06,$47
	db $02,$47
	db $03,$48
	db $05,$48
	db $04,$49
	db $04,$49
	db $04,$4A
	db $04,$4A
	db $06,$4B
	db $02,$4B
	db $03,$4C
	db $05,$4C
	db $04,$4D
	db $04,$4D
	db $04,$4D
	db $04,$4D
	db $06,$4E
	db $02,$4E
	db $03,$4F
	db $05,$4F
	db $04,$50
	db $04,$50
	db $04,$51
	db $04,$51
	db $01,$52
	db $01,$51
	db $02,$51
	db $01,$51
	db $01,$50
	db $02,$50
	db $01,$50
	db $02,$4F
	db $02,$4F
	db $02,$4E
	db $02,$4E
	db $01,$4D
	db $02,$4D
	db $02,$4C
	db $01,$4C
	db $01,$4B
	db $01,$4B
	db $01,$4B
	db $01,$4A
	db $02,$4A
	db $02,$49
	db $02,$49
	db $04,$48
	db $04,$48
	db $04,$47
	db $04,$47
	db $04,$46
	db $01,$46
	db $03,$45
	db $02,$45
	db $02,$44
	db $17,$44
	db $00

Color_Blue:
	db $14,$83
	db $08,$84
	db $08,$85
	db $08,$86
	db $08,$87
	db $08,$88
	db $01,$89
	db $10,$88
	db $10,$87
	db $10,$86
	db $10,$85
	db $15,$84
	db $05,$85
	db $05,$86
	db $08,$87
	db $08,$88
	db $01,$89
	db $05,$88
	db $05,$87
	db $06,$86
	db $05,$85
	db $05,$84
	db $19,$83
	db $00
%RATS_end(0)