;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Dark Purple
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $0A,$38
	db $03,$37
	db $03,$36
	db $03,$35
	db $03,$34
	db $03,$33
	db $04,$32
	db $03,$31
	db $03,$30
	db $03,$2F
	db $03,$2E
	db $04,$2D
	db $05,$2C
	db $05,$2B
	db $06,$2A
	db $05,$29
	db $05,$28
	db $06,$27
	db $05,$26
	db $05,$25
	db $06,$24
	db $05,$23
	db $05,$22
	db $16,$21
	db $12,$20
	db $03,$21
	db $02,$22
	db $03,$23
	db $03,$24
	db $02,$25
	db $04,$26
	db $04,$27
	db $04,$28
	db $04,$29
	db $03,$2A
	db $03,$2B
	db $02,$2C
	db $03,$2D
	db $03,$2E
	db $02,$2F
	db $04,$30
	db $03,$31
	db $03,$32
	db $03,$33
	db $03,$34
	db $03,$35
	db $03,$36
	db $02,$37
	db $03,$38
	db $09,$39
	db $00

Color_Green:
	db $09,$4F
	db $04,$4E
	db $04,$4D
	db $01,$4C
	db $03,$4C
	db $02,$4B
	db $02,$4B
	db $04,$4A
	db $08,$49
	db $08,$48
	db $08,$47
	db $08,$46
	db $05,$45
	db $03,$44
	db $02,$44
	db $06,$43
	db $05,$42
	db $05,$42
	db $16,$42
	db $05,$42
	db $05,$42
	db $06,$42
	db $08,$41
	db $1D,$40
	db $05,$41
	db $05,$42
	db $04,$43
	db $02,$43
	db $01,$44
	db $03,$44
	db $01,$44
	db $02,$45
	db $03,$45
	db $04,$46
	db $02,$47
	db $02,$47
	db $03,$48
	db $01,$48
	db $04,$49
	db $04,$4A
	db $03,$4B
	db $01,$4C
	db $02,$4C
	db $0A,$4D
	db $00

Color_Blue:
	db $09,$93
	db $04,$93
	db $04,$92
	db $01,$92
	db $03,$91
	db $02,$91
	db $02,$90
	db $04,$90
	db $08,$90
	db $08,$90
	db $08,$8F
	db $08,$8E
	db $05,$8D
	db $03,$8D
	db $02,$8C
	db $06,$8C
	db $05,$8B
	db $05,$8A
	db $16,$89
	db $05,$88
	db $05,$87
	db $06,$86
	db $08,$85
	db $1D,$84
	db $05,$85
	db $05,$86
	db $04,$87
	db $02,$88
	db $01,$88
	db $03,$89
	db $01,$8A
	db $02,$8A
	db $03,$8B
	db $04,$8C
	db $02,$8C
	db $02,$8D
	db $03,$8D
	db $01,$8E
	db $04,$8E
	db $04,$8F
	db $03,$90
	db $01,$90
	db $02,$91
	db $0A,$91
	db $00
%RATS_end(0)