;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Field
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $0D,$3F
	db $05,$3E
	db $05,$3D
	db $06,$3C
	db $08,$3B
	db $18,$3A
	db $04,$39
	db $04,$38
	db $04,$37
	db $04,$36
	db $04,$35
	db $04,$34
	db $04,$33
	db $37,$32
	db $03,$33
	db $03,$34
	db $03,$35
	db $03,$36
	db $04,$37
	db $03,$38
	db $03,$39
	db $03,$3A
	db $03,$3B
	db $06,$3C
	db $05,$3D
	db $05,$3E
	db $24,$3F
	db $00

Color_Green:
	db $09,$53
	db $07,$52
	db $04,$52
	db $04,$52
	db $04,$52
	db $06,$52
	db $05,$52
	db $05,$52
	db $06,$52
	db $05,$53
	db $05,$54
	db $01,$55
	db $07,$54
	db $08,$54
	db $08,$54
	db $08,$55
	db $04,$56
	db $04,$57
	db $04,$58
	db $04,$59
	db $04,$5A
	db $03,$5B
	db $03,$5C
	db $03,$5D
	db $03,$5E
	db $01,$5F
	db $04,$5F
	db $04,$5F
	db $04,$5F
	db $27,$5F
	db $04,$5F
	db $04,$5F
	db $04,$5F
	db $01,$5F
	db $04,$5E
	db $04,$5E
	db $04,$5E
	db $04,$5E
	db $05,$5D
	db $03,$5D
	db $02,$5C
	db $09,$5C
	db $00

Color_Blue:
	db $09,$93
	db $07,$93
	db $04,$94
	db $04,$95
	db $04,$96
	db $06,$97
	db $05,$98
	db $05,$99
	db $06,$9A
	db $05,$9B
	db $05,$9C
	db $01,$9D
	db $07,$9D
	db $08,$9E
	db $08,$9F
	db $08,$9F
	db $04,$9F
	db $04,$9F
	db $04,$9F
	db $04,$9F
	db $04,$9F
	db $03,$9F
	db $03,$9F
	db $03,$9F
	db $03,$9F
	db $01,$9F
	db $04,$9E
	db $04,$9D
	db $04,$9C
	db $27,$9B
	db $04,$9C
	db $04,$9D
	db $04,$9E
	db $01,$9F
	db $04,$9E
	db $04,$9D
	db $04,$9C
	db $04,$9B
	db $05,$9A
	db $03,$99
	db $02,$99
	db $09,$98
	db $00
%RATS_end(0)