;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Grey
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $0C,$26
	db $08,$27
	db $08,$28
	db $06,$29
	db $05,$2A
	db $05,$2B
	db $06,$2C
	db $05,$2D
	db $05,$2E
	db $06,$2F
	db $05,$30
	db $05,$31
	db $06,$32
	db $05,$33
	db $05,$34
	db $08,$35
	db $08,$36
	db $08,$37
	db $08,$38
	db $06,$39
	db $05,$3A
	db $05,$3B
	db $06,$3C
	db $05,$3D
	db $05,$3E
	db $01,$3F
	db $05,$3E
	db $05,$3D
	db $06,$3C
	db $05,$3B
	db $05,$3A
	db $06,$39
	db $08,$38
	db $08,$37
	db $08,$36
	db $0B,$35
	db $00

Color_Green:
	db $0C,$48
	db $06,$49
	db $05,$4A
	db $05,$4B
	db $06,$4C
	db $02,$4D
	db $03,$4D
	db $05,$4E
	db $08,$4F
	db $08,$50
	db $06,$51
	db $05,$52
	db $05,$53
	db $08,$54
	db $08,$55
	db $08,$56
	db $08,$57
	db $08,$58
	db $08,$59
	db $06,$5A
	db $05,$5B
	db $05,$5C
	db $08,$5D
	db $08,$5E
	db $01,$5F
	db $08,$5E
	db $08,$5D
	db $05,$5C
	db $05,$5B
	db $06,$5A
	db $08,$59
	db $08,$58
	db $08,$57
	db $0B,$56
	db $00

Color_Blue:
	db $0C,$8A
	db $06,$8B
	db $05,$8C
	db $05,$8D
	db $06,$8E
	db $02,$8E
	db $03,$8F
	db $05,$8F
	db $08,$90
	db $08,$91
	db $06,$92
	db $05,$93
	db $05,$94
	db $08,$95
	db $08,$96
	db $08,$97
	db $08,$98
	db $08,$99
	db $08,$9A
	db $06,$9B
	db $05,$9C
	db $05,$9D
	db $08,$9E
	db $08,$9E
	db $01,$9F
	db $08,$9E
	db $08,$9E
	db $05,$9D
	db $05,$9C
	db $06,$9B
	db $08,$9A
	db $08,$99
	db $08,$98
	db $0B,$97
	db $00
%RATS_end(0)