;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Night
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $08,$21
	db $08,$22
	db $10,$23
	db $08,$23
	db $08,$23
	db $10,$24
	db $10,$24
	db $08,$25
	db $08,$25
	db $10,$25
	db $10,$26
	db $06,$26
	db $02,$26
	db $03,$27
	db $05,$27
	db $08,$28
	db $08,$29
	db $06,$2A
	db $02,$2A
	db $03,$2B
	db $05,$2B
	db $08,$2C
	db $08,$2D
	db $04,$2E
	db $02,$2F
	db $02,$2F
	db $03,$30
	db $01,$30
	db $04,$31
	db $06,$32
	db $05,$33
	db $09,$34
	db $00

Color_Green:
	db $08,$42
	db $08,$43
	db $10,$44
	db $08,$45
	db $08,$46
	db $10,$47
	db $10,$48
	db $08,$49
	db $08,$4A
	db $10,$4B
	db $10,$4C
	db $06,$4D
	db $02,$4E
	db $03,$4E
	db $05,$4F
	db $08,$50
	db $08,$51
	db $06,$52
	db $02,$53
	db $03,$53
	db $05,$54
	db $08,$55
	db $08,$56
	db $04,$57
	db $02,$57
	db $02,$58
	db $03,$58
	db $01,$59
	db $04,$59
	db $06,$5A
	db $05,$5B
	db $09,$5C
	db $00

Color_Blue:
	db $08,$85
	db $08,$86
	db $08,$87
	db $08,$88
	db $08,$89
	db $08,$8A
	db $08,$8B
	db $08,$8C
	db $08,$8D
	db $08,$8E
	db $08,$8F
	db $08,$90
	db $08,$91
	db $08,$92
	db $08,$93
	db $08,$94
	db $08,$95
	db $08,$96
	db $10,$97
	db $08,$98
	db $08,$99
	db $10,$9A
	db $18,$9B
	db $0C,$9C
	db $00
%RATS_end(0)