;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Sky
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $08,$26
	db $08,$27
	db $08,$28
	db $08,$29
	db $06,$2A
	db $02,$2A
	db $03,$2B
	db $05,$2B
	db $08,$2C
	db $08,$2D
	db $04,$2E
	db $02,$2F
	db $02,$2F
	db $03,$30
	db $01,$30
	db $04,$31
	db $06,$32
	db $05,$33
	db $05,$34
	db $08,$35
	db $08,$36
	db $06,$37
	db $05,$38
	db $05,$39
	db $04,$3A
	db $03,$3B
	db $03,$3C
	db $03,$3D
	db $03,$3E
	db $21,$3F
	db $05,$3E
	db $05,$3D
	db $06,$3C
	db $03,$3B
	db $02,$3A
	db $01,$3A
	db $03,$39
	db $01,$38
	db $02,$38
	db $04,$37
	db $02,$36
	db $03,$35
	db $03,$34
	db $02,$33
	db $01,$32
	db $08,$33
	db $00

Color_Green:
	db $08,$4E
	db $08,$4F
	db $08,$50
	db $08,$51
	db $06,$52
	db $02,$53
	db $03,$53
	db $05,$54
	db $08,$55
	db $08,$56
	db $04,$57
	db $02,$57
	db $02,$58
	db $03,$58
	db $01,$59
	db $04,$59
	db $06,$5A
	db $05,$5B
	db $05,$5C
	db $08,$5D
	db $08,$5E
	db $06,$5F
	db $05,$5F
	db $05,$5F
	db $04,$5F
	db $03,$5F
	db $03,$5F
	db $03,$5F
	db $03,$5F
	db $21,$5F
	db $05,$5F
	db $05,$5F
	db $06,$5F
	db $03,$5E
	db $02,$5E
	db $01,$5D
	db $03,$5D
	db $01,$5D
	db $02,$5C
	db $04,$5C
	db $02,$5B
	db $03,$5B
	db $03,$5B
	db $02,$5A
	db $01,$5A
	db $08,$5A
	db $00

Color_Blue:
	db $08,$95
	db $08,$96
	db $10,$97
	db $08,$98
	db $08,$99
	db $10,$9A
	db $18,$9B
	db $08,$9C
	db $08,$9D
	db $08,$9E
	db $01,$9F
	db $05,$9E
	db $05,$9D
	db $06,$9C
	db $08,$9B
	db $0B,$9A
	db $03,$9B
	db $03,$9C
	db $03,$9D
	db $03,$9E
	db $01,$9F
	db $03,$9E
	db $03,$9D
	db $03,$9C
	db $03,$9B
	db $14,$9A
	db $08,$99
	db $08,$98
	db $08,$97
	db $0B,$96
	db $00
%RATS_end(0)