;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Yoshi's Island Gradient Sunset
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$3200			;| $4330 = $2132
	STA $4330			;| $4331 = Mode 00
	LDA #Color_Red		;| Get gradient pointer
	STA $4332			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4334			;| Store to address bank
	LDA #$3200			;| $4340 = $2132
	STA $4340			;| $4341 = Mode 00
	LDA #Color_Green	;| Get gradient pointer
	STA $4342			;| low and high byte
	STY $4344			;| Store to address bank
	LDA #$3200			;| $4350 = $2132
	STA $4350			;| $4351 = Mode 00
	LDA #Color_Blue		;| Get gradient pointer
	STA $4352			;| low and high byte
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$38			;\ Enable HDMA
	TSB $0D9F			;| on channel 3,4,5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Color_Red:
	db $0C,$3B
	db $08,$3C
	db $08,$3D
	db $10,$3E
	db $80,$3F
	db $34,$3F
	db $00

Color_Green:
	db $0C,$4C
	db $10,$4D
	db $08,$4E
	db $08,$4F
	db $08,$50
	db $08,$51
	db $10,$52
	db $08,$53
	db $08,$54
	db $08,$55
	db $08,$56
	db $08,$57
	db $08,$58
	db $08,$59
	db $08,$59
	db $10,$5A
	db $08,$5B
	db $08,$5C
	db $08,$5D
	db $08,$5E
	db $04,$5F
	db $04,$5F
	db $04,$5F
	db $04,$5F
	db $14,$5F
	db $00

Color_Blue:
	db $0C,$90
	db $10,$91
	db $08,$91
	db $08,$91
	db $08,$91
	db $08,$91
	db $10,$91
	db $08,$91
	db $08,$91
	db $08,$91
	db $08,$91
	db $08,$91
	db $08,$92
	db $08,$93
	db $08,$94
	db $10,$95
	db $08,$96
	db $08,$97
	db $08,$98
	db $08,$99
	db $04,$9A
	db $04,$9B
	db $04,$9C
	db $04,$9D
	db $14,$9E
	db $00
%RATS_end(0)