;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Mulitple Background Auto-Scroll
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$0F02			;| $4330 = $210F
	STA $4330			;| $4331 = Mode 02
	LDA #$9B00			;| 
	STA $4332			;| Destination: $7F9B00
	LDY #$7F			;| (low and high byte)
	STY $4334			;| 
	SEP #$20			;/ Set processor 8 bit

	LDA #$08			;\ Enable HDMA
	TSB $0D9F			;/ on channel 3	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	LDX #$0F			;| Data size ($0F bytes)
Loop:	
	LDA Scroll_Table,x	;\ 
	STA $7F9B00,x		;| Load scoll range
	DEX 				;| table config
	BPL Loop			;/ 

Start:
	LDA #$DF			;\ Size of very 1st row
	SEC 				;| Size can be $C0-$FF
	SBC $1468			;| Enables auto-scrolling
	INC A				;| for the range specified
	STA $7F9B00	   		;/

	REP #$20			;\ Set processor 16 bit
	LDA $1466			;| Do not scroll
	STA $7F9B07			;/ the 3rd row

	LDA $13				;\ Speed how much
	AND #$00FF			;| the range should scroll
	ASL A				;| Changing the value is
	CLC 				;| not recommended!!
	ADC $1466			;| Scroll the row
	AND #$01FF			;| automatically
	STA $7F9B0A			;| for 4th row
	ASL A				;| Scroll 5th row
	STA $7F9B0D			;/ fastest

	LDA $13				;\ Speed how much
	AND #$00FF			;| the range should scroll
	ASL A				;| Changing the value is
	CLC 				;| not recommended!!
	ADC $1466			;| Scroll the row
	AND #$01FF			;| automatically
	STA $7F9B04		 	;| for 2nd row
	ASL A				;| Scroll 1st row
	STA $7F9B01 		;/ fastest

	SEP #$20			;\ Set processor 8 bit
	RTL					;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Scroll_Table:
	db $00,$00,$00
	db $1F,$00,$00
	db $60,$00,$00
	db $1F,$00,$00
	db $32,$00,$00
%RATS_end(0)