;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Multiple Background Scroll
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$0F02			;| $4330 = $210F
	STA $4330			;| $4331 = Mode 02
	LDA #$9B00			;| 
	STA $4332			;| Destination: $7F9B00
	LDY #$7F			;| (low and high byte)
	STY $4334			;| 
	SEP #$20			;/ Set processor 8 bit

	LDA #$08			;\ Enable HDMA
	TSB $0D9F			;/ on channel 3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	LDX #$0C			;| Data size ($0C bytes)
Loop:
	LDA Scroll_Table,X	;\ 
	STA $7F9B00,X		;| Load scoll range
	DEX 				;| table config
	BPL Loop			;/ 

Start:  
	REP #$20			;\ Set processor 16 bit
	LDA $1466			;| Scroll 1st row
	STA $7F9B01			;| at normal speed
	LSR A				;| Scroll 2nd row
	STA $7F9B04			;| slower than 1st
	LSR A				;| Scroll 3rd row
	STA $7F9B07			;| slower than 2nd
	LSR A				;| Scroll 4th row
	STA $7F9B0A			;| slower than 3rd
	SEP #$20			;| Set processor 8 bit
	RTL					;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Scroll_Table:
	db $38,$00,$00
	db $38,$00,$00
	db $38,$00,$00
	db $38,$00,$00
%RATS_end(0)