;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Bug-Fixes v4.0
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom							;\ ROM is Lorom
	header							;| and has a header.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Priority Fixes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	org $009CAD						;\ Title Screen
	NOP #3							;/ HDMA fix

	org $018E84						;\ Classic Piranha Plant
	db $10							;/ $20 fixed

	org $02E0D5						;\ Jumping Piranha Plant
	db $10							;/ $20 fixed
 
	org $0394C5						;\ 
	db $A1,$A1,$A1,$A1,$A1			;| Wooden Spike
	db $61,$61,$61,$61,$61			;/ +$10 each fixed

	org $02B893						;\ Torpedo Ted
	db $10							;/ $20 fixed

	org $029E74						;\ Torpedo Ted's Arm
	db $13							;/ $23 fixed

	org $039784						;\ Fishbone
	db $7D,$FD,$3D,$BD 				;/

	org $01BA71						;\ Net Climbing Koopa
	db $10							;/ 

	org $01DB9E						;\ Line Grinder
	db $23,$63,$A3,$E3				;/ 

	org $01C6C5						;\ 
	LDA #$20						;| Mushroom/Flower
	STA $64							;/ 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JSL to Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	org $0081AA						;| Hack NMI routine and
	JSL CodeStart					;| jump to our code.
	NOP #4							;/ 4 time NOP (No Operation)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org $198300						;| CHANGE THIS TO SOME FREE SPACE!!!!

	!CodeSize = CodeEnd-CodeStart	;\ 
RATS:								;| Write RATS tag to
	db "STAR"						;| prevent other programs
	dw !CodeSize-$01				;| from overwriting this 
	dw !CodeSize-$01^$FFFF			;/ code!

CodeStart:
	LDA $0100						;\ Check game mode.
	CMP #$05						;| Intro loading?
	BEQ Intro_HDMA					;| If yes, Intro HDMA
	CMP #$0B						;| Overworld loading?
	BEQ Overworld_HDMA				;| If yes, OW HDMA.
	CMP #$0F						;| Level loading?
	BCS Level_HDMA					;| If yes, Level HDMA.
	RTL								;/ Return

Intro_HDMA:
	LDA #$07						;\ Only enable HDMA on
	TRB $0D9F						;| channel 4,5,6,7,8.
	RTL								;/ Return

Overworld_HDMA:
	LDA $1B87						;\ Don't execute HDMA
	BNE EndOWHDMA					;/ on save prompt, etc..

	LDA $13D9						;\ Check if level beaten.
	CMP #$03						;| Don't execute HDMA
	BCC EndOWHDMA					;| if mode under #$03.
	CMP #$06						;| Don't execute HDMA
	BEQ EndOWHDMA					;| on fade in/out.
	CMP #$08						;| Don't execute HDMA
	BEQ EndOWHDMA					;| on fade in/out.
	CMP #$09						;| Don't execute HDMA
	BEQ EndOWHDMA					;| on black screens.
	CMP #$0A						;| Don't execute HDMA
	BEQ EndOWHDMA					;| on fade in/out.
	RTL								;/ Return

Level_HDMA:	
	LDA $0100						;\ Check game mode.
	CMP #$10						;\ Don't execute HDMA
	BEQ EndHDMA						;/ on black screens.
	CMP #$11						;\ Don't execute HDMA
	BEQ MarioHDMA					;/ on black screens.
	CMP #$12						;\ Don't execute HDMA
	BEQ EndHDMA						;/ on black screens.
	CMP #$15						;\ Don't execute HDMA
	BCS EndHDMA						;| if game mode over 15
	RTL								;/ Return

MarioHDMA:
	LDA #$C0						;\ Only enable HDMA
	STA $0D9F						;| on channel 6,7.
	BRA Restore						;| Restore code.
	RTL								;/ Return

EndOWHDMA:
	LDA #$80						;\ Only enable HDMA
	STA $0D9F						;| on channel 7.
	BRA Restore						;| Restore code.
	RTL								;/ Return

EndHDMA:
	STZ $0D9F						;| Disable HDMA transfer.

Restore:
	LDA #$80						;\ Restore part of the
	STA $2100						;| NMI code because we
	STZ $420C						;| JSLed to it.
	RTL								;/ Return

CodeEnd: