;UpDownConnect
;connects the top and bottom of the screen, meaning that if you fall down a hole, you
;will see mario fall from the top of the screen, and if a sprite falls down, it will also
;appear at the top of the screen. Make sure whatever level you use this on has no vertical
;scrolling enabled, and that mario starts on the lower half of the screen
;made by: HuFlungDu
;Note, hijacks the SAME status bar routine as everybody else since I'm far too lazy to find a better
;one, so check if I hijack the same place (8DC4) as any of your other patches.
;No credit neccesary
;Feel free to PM me if you have any problems

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro
lorom                   ;\ ROM is LoRom
header                  ;/ and has a header.

org $8DC4               ;\ Hijack NMI routine
JSL StatusCode          ;| and jump to our code
NOP                     ;/ also NOP one time.

org $218015                     ;| POINT TO FREE SPACE!!!
%RATS_start(0)
StatusCode:
LDA #$02                ;\ Restore previous
STA $420B               ;/ hijacked NMI routine.
;If you only want this in a particular level (which you probably do) copy all the code
;from here down (minus the RAT tag) into level ASM. A sprite will not work, I assume because
;of the 16bit addressing
JSR Mario	;jump to check mario
JSR Sprite	;jump to check for sprites
RTL			;return

Sprite:
LDX #$00	;Activate an accumulator
loop:
LDA $14C8,x	;\Check if sprite is dead
CMP #$02	;| if it is, don't make it connect (that would just look funny)
BEQ end		;/
LDA $14D4,x	;\Check which screen the sprite is on
CMP #$01	;|
BNE UpS		;/
LDA $D8,x	;\Check the sprite's position on the screen
CMP #$A0	;|
BCC UpS		;/
LDA #$00	;\Move the sprite to screen 0
STA $14D4,x	;/
UpS:
LDA $14D4,x	;\Check if the sprite is on screen 0
BNE end		;/
LDA $D8,x	;\Check the sprite's position on the screen
CMP #$A0	;|
BCS end		;/
LDA #$01	;\Move the sprite to screen 1
STA $14D4,x	;/
end:
INX			;\Check the next sprite slot
CPX #$0C	;|
BCC loop	;/
RTS			;Return

Mario:
LDA $0100	;\Don't do it if the level is loading if the level is loading
CMP #$14	;|
BNE returnm	;/
LDA $13E0	;\Or if Mario is dead
CMP #$3E	;|
BEQ returnm	;/
REP #$20	;Enter 16bit mode
LDA $D3		;\see if Mario is low enough
CMP #$01A0	;|
BCC CheckUp	;/
LDA #$00A0	;\Put him at the top of the screen
STA $96		;/
BRA returnm
CheckUp:
LDA $D3		;\See if mario is High enough
CMP #$00A0	;/
BCS returnm
LDA #$0190	;\Put him at the bottom of the screen
STA $96		;/
returnm:
SEP #$20	;return to 8 bit addressing mode
RTS			;return
%RATS_end(0)