; LevelUp!
; By: HuFlungDu
; What it does: Implements a level system in Mario, allowing you to unlock different abilities
; based on what your score is. It's kind of difficult to use but once you get the hang of it
; it's really not that hard
; If you've seen this in my hack, note that this version has a few differences, mainly that
; there is now message that appears when you level up.
; currently allows high jump if  you reach level 2, wall slide if you reach level 3, 
; and Wall Jump (the old one) when you reach level 14 as examples
; Note, hijacks the SAME status bar routine as everybody else since I'm far too lazy to find a better
; one, so check if I hijack te same place (8DC4) as any of your other patches.
; only supports up to level 99, but if you get more than 9 million points... you've been playing
; too long
; credit to Deflaktor for his SRAM expand patch I used to save your score between games
; No credit to me necessary

; IMPORTANT!!!! If you had the old version that hijacked the NMI routine and you are going to
; apply this one now put the code below I put right below this right below where it says header
;org $8DC4
;LDA #$02
;STA $420B
; then remove the code and apply the patch again.

!freeram1 = $0660			; Requires 4 empty RAM address
!freeram2 = $0661			; Change these if you have another patch
!freeram3 = $0662			; that uses these RAM addresses
!freeram4 = $0663			; such as the YoshiFlutterJump patch
!freespace1 = $218015	;point to freespace
!freespace2 = $228015	;point to empty space in the rom
!SRAMSize = #$02


macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom                   ;\ ROM is LoRom
header                  ;/ and has a header.

org $FFD8
	db !SRAMSize	
	
org $9BCC		;Save Game Routine
	JSL SaveGame
	NOP #2
	
org $9E5C		;Load Game Routine (executed when 1 or 2 player is chosen)
	JSL LoadGame
	NOP #2

ORG $A21B               ;\ Hijack NMI routine
JSL StatusCode          ;| and jump to our code

org $0491BE
JSL StoreLevel
NOP
NOP

org !freespace1
%RATS_start(0)
StoreLevel:
		PHX						;| this whole thing isn't really necessary, but I left it in there incase
		JSL Level				;| someone wants to activate something special when they level up, like
		LDX $0F1C				;| spawning a message
		LDA $0F1D 
		CMP #$FC
		BNE NB
		LDA #$01
		STA $7FA000
		BRA return
		NB:
		STA $7FA000
		return:
		STX $7FA001
		PLX
		LDA $0DB4,x
		RTL 
StatusCode:
		PHX
		LDA $0100				;\Check if you haven't started the game yet
		CMP #$0B				;|and return if you haven't 
		BCC SendReturn2			;|(this is a bugfix, though I can't remember which one...)
		BRA NotReturn			;|
		SendReturn2:			;|
		JMP Return2				;|
		NotReturn:				;/
		LDA $0F1C
		CMP #$FC
		BEQ Skiplevel10
		CMP #$01
		BCS level10
		Skiplevel10:
		LDA $0F1D				;\Check what level you are
		CMP #$02				;|if not high enough,
		BCC SkipJump			;
		JSL HighJump
        SkipJump:
		LDA $0F1D
		CMP #$03
		BCC SkipWallJump
		JSL WallSlide
		JMP SkipWallJump
		level10:
		JSL HighJump			;\put all powers previously obtained if you are level 10 or above here
		JSL WallSlide			;/e.g. all powers you got before you reached level ten
		LDA $0F1C				;\Check if you are level 20 or more
		CMP #$02
		BCS level20
								;\all powers gained when you are level 10 to 20
								;|a power reached at level 14 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		LDA $0F1D				;\Looks like this
		CMP #$04				;|
		BCC SkipWallJump		;/
		JSL WallJump			; if you want to use something that isn't run every frame, just make
								; it only work if a RAM address is set, then set the RAM address here
								
		JMP SkipWallJump
		level20:
		JSL WallJump			;\All powers obtained between level 10 and level 20 
								;| (Notice I don't need  HighJump and WallSlide because those are set 
								;/	earlier)
		LDA $0F1C				;\Check if you are level 30 or more
		CMP #$03
		BCS level30								
								;\all powers gained when you are level 20 to 30
								;|a power reached at level 24 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level30:
								;\All powers obtained between level 20 and level 30 
								;|
								;/
		LDA $0F1C				;\Check if you are level 40 or more
		CMP #$04
		BCS level40								
								;\all powers gained when you are level 30 to 40
								;|a power reached at level 34 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level40:
								;\All powers obtained between level 30 and level 40 
								;|
								;/
		LDA $0F1C				;\Check if you are level 50 or more
		CMP #$05
		BCS level50								
								;\all powers gained when you are level 40 to 50
								;|a power reached at level 44 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level50:
								;\All powers obtained between level 40 and level 50 
								;|
								;/
		LDA $0F1C				;\Check if you are level 60 or more
		CMP #$06
		BCS level60								
								;\all powers gained when you are level 50 to 60
								;|a power reached at level 54 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level60:
								;\All powers obtained between level 50 and level 60 
								;|
								;/
		LDA $0F1C				;\Check if you are level 70 or more
		CMP #$07
		BCS level70								
								;\all powers gained when you are level 60 to 70
								;|a power reached at level 64 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level70:
								;\All powers obtained between level 60 and level 70 
								;|
								;/
		LDA $0F1C				;\Check if you are level 80 or more
		CMP #$08
		BCS level80								
								;\all powers gained when you are level 70 to 80
								;|a power reached at level 14 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level80:
								;\All powers obtained between level 70 and level 80 
								;|
								;/
		LDA $0F1C				;\Check if you are level 90 or more
		CMP #$09
		BCS level90								
								;\all powers gained when you are level 80 to 90
								;|a power reached at level 84 would look like:
								;/LDA $0F1D		CMP #$04	BCC SkipPower (should follow the same format as I have near the begginning)
		JMP SkipWallJump
		level90:
								;\All powers obtained between level 80 and level 90 
								;|
								;/		
		SkipWallJump:
		LDX $0F29				;| Load score (Millions)
		LDA $0F2A               ;| Load score (Hundred Thousands)
		CMP #$FC				;| check if blank tile
		BNE L1					;| if its not, don't change it to 1
		LDA #$01				;| Change blank tiles to 1
        STA $0F1D               ;| store ones into status bar
		BRA L3					;| skip to store tens
		L1:
		CMP #$09				;| Check if thousands place of score is 9
		BNE L2					;| 
		LDA #$00				;\ If it is, make the ones counter 0, instead of A
		STA $0F1D				;/
		LDX $0F29				
		INX						;| increase the tens position by 1, ONLY if the ones position is 0
		CPX #$FD				;\ Check if tens position is a blank tile
		BNE L3					;| If it is, change it to one, otherwise, add one to it and move on
		LDX #$01				;/
		BRA L3
		L2:
		LDA $0F2A
		INA
		STA $0F1D		
		L3:
        STX $0F1C               ;/ store tens into status bar
		LDA $7FA001			;/ Load tens score
		CMP $0F1C				;| 
		BEQ CheckOnes			;/
		BRA Return2
		CheckOnes:
		LDA $7FA000              ;\ Load ones score
		CMP $0F1D 				;\ compare ones and tens stored at level load to
		BEQ Return2				;| ones and tens now to see if they are different
								;\Put anything you want to happen when mario levels up here
								;/Like spawn a message or make a message appear on the status bar
		LDA $0F1D				;\Comment this out if you want whatever you put up there
		STA $7FA000				;|to only disapear once the level is over
		LDA $0F1C				;|
		CMP #$FC				;|
		BEQ Return2				;|
		LDA $0F1C				;|
		STA $7FA001				;/
		Return2:
		PLX
		LDA $16                   
		AND #$10
        RTL                     ;> and return.
		
Level:
		LDX #$00
		LDA $7FA001
		CMP #$FC
		BEQ End2
		Loop2:
		CLC
		ADC $7FA001
		INX
		CPX #$0A
		BEQ Loop2
		End2:
		CLC
		ADC $7FA000
		STA $7FA004
		RTL
WallJump:
		LDA $77				;  |
		AND #$04	 				; Check if mario is on ground
		BNE dontstoreleft
		LDA $77				;  |
		AND #$02	 				; Check if mario blocked from the left
		BEQ dontstoreleft
		LDA #$01			; tell the game you can jump off the left wall
		STA !freeram1
		dontstoreleft:
		LDA $15				;\ check if left is pressed
		AND #$02			;/
		BNE rightcheck
		LDA $16         ;\ check if either B or A is pressed
		AND #$80        ; |
		BEQ rightcheck        ;/ if neither, return
		LDA $18         	  ;\ check if it's B that's pressed
		AND #$80        	  ; |if A, not B,
		BNE rightcheck        ;/ return
		JSL Jumpright
		BRA reset
		rightcheck:
		LDA $77						;\
		AND #$04	 				;/ Check if mario is on ground
		BNE dontstoreright
		LDA $77						;\
		AND #$01	 				;/ Check if mario blocked from the right
		BEQ dontstoreright
		LDA #$01					; tell the game you can jump off the right wall
		STA !freeram2
		dontstoreright:
		LDA $15			; this will basically just skip everything if you didn't
		AND #$01		; get blocked
		BNE reset
		LDA $16         ;\ check if either B or A is pressed
		AND #$80        ; |
		BEQ reset        ;/ if neither, return
		LDA $18         ;\ check if it's B that's pressed
		AND #$80        ; |if A, not B,
		BNE reset        ;/ return
		JSL Jumpleft
		reset:
		LDA !freeram1				;\ used to remove a bug that I found
		BEQ right					;| where you could jump in mid air
		LDA $15						;| if you timed it correctly
		AND #$01					;|
		BEQ right					;|
		STZ !freeram1				;|
		right:						;|
		LDA !freeram2				;|		
		BEQ reset1					;|			
		LDA $15						;|				
		AND #$02					;|
		BEQ reset1					;|
		STZ !freeram2				;/
		reset1:
		LDA $77				;  |
		AND #$04	 				; Check if mario is on ground
		BEQ return2					; reset all the flags
		STZ !freeram1
		STZ !freeram2
		STZ !freeram3
		STZ !freeram4
		return2:
		RTL
		
Jumpleft:
		LDA !freeram3			;\ put a semicolon before these two lines if you
		BNE end1			;/ want mario to be able to jump off the same wall twice
		LDA !freeram1
		BEQ end1
		LDA #$B0				;\ Make mario jump
		STA $7D					;/
		LDA #$0D				;\change pose for split second
		STA $13E0				;/
		LDA #$30				;\ Make him move left
		STA $7B					;/
		LDA #$01				;\ Play sound effect
		STA $1DFA				;/
		LDA #$01				;\ tell the game that you just jumped off the left wall
		STA !freeram3           ;| and are ready for the right
		STZ !freeram4			;/
		STZ !freeram2
		STZ !freeram1		
		end1:
		RTL
		
Jumpright:
		LDA !freeram4			;\ put a semicolon before these two lines if you
		BNE end					;/ want mario to be able to jump off the same wall twice
		LDA !freeram2
		BEQ end
		LDA #$B0				;\ Make mario jump
		STA $7D					;/
		LDA #$0D				;\change pose for split second
		STA $13E0				;/
		LDA #$CF				;\ Make him move right
		STA $7B					;/
		LDA #$01				;\ Play sound effect
		STA $1DFA				;/
		LDA #$01				;\ tell the game that you just jumped off the right wall
		STA !freeram4			;| and are ready for the left
		STZ !freeram3			;/
		STZ !freeram1
		STZ !freeram2
		end:
		RTL
WallSlide:
		LDA $77				;  |
		AND #$04	 				; Check if mario is on ground
		BNE dontstoreleftslide
		LDA $77				;  |
		AND #$02	 				; Check if mario blocked from the left
		BEQ dontstoreleftslide
		LDA #$01			; tell the game you can jump off the left wall
		STA $0664
		dontstoreleftslide:
		LDA $15				;\ check if left is pressed
		AND #$02			;/
		BEQ rightcheckslide
		LDA $0664
		BEQ rightcheckslide
		LDA #$80
		CMP $7D
		BCC rightcheckslide
		LDA #$10
		STA $7D
		rightcheckslide:
		LDA $77				;  |
		AND #$04	 				; Check if mario is on ground
		BNE dontstorerightslide
		LDA $77				;  |
		AND #$01	 				; Check if mario blocked from the left
		BEQ dontstorerightslide
		LDA #$01			; tell the game you can jump off the left wall
		STA $0665
		dontstorerightslide:
		LDA $15				;\ check if left is pressed
		AND #$01			;/
		BEQ resetslide
		LDA $0665
		BEQ resetslide
		LDA #$80
		CMP $7D
		BCC resetslide
		LDA #$10
		STA $7D
		resetslide:		
		LDA $77				;  |
		AND #$04	 				; Check if mario is on ground
		BNE Wipe
		LDA $0664
		BEQ return1slide
		LDA $15				;\ check if left is pressed
		AND #$01			;/
		BNE return1slide
		STZ $0664
		BRA returnslide
		return1slide:
		LDA $0665
		BEQ returnslide
		LDA $15				;\ check if left is pressed
		AND #$02			;/
		BNE returnslide
		STZ $0665
		BRA returnslide
		Wipe:
		STZ $0664
		STZ $0665
		returnslide:
		RTL
HighJump:
		LDA $0100         		
		CMP #$14          		
		LDA $15           ;\
		AND #$80          ; check to see if A or B has been pressed. if not end
		BEQ returnjump        ;/

		LDA $77           ;\
		AND #$04          ; check to see if not touching the ground, if, end
		BNE returnjump       ;/

		LDA $7d           ;\
		SEC               ; move luigi up a bit
		SBC #$01          ; 
		STA $7D           ;/
		returnjump:
		RTL
%RATS_end(0)










; This is SRAM expand patch by Deflaktor, NOT MY WORK!
org !freespace2	;the SNES adress the code will be inserted to

!CodeSize = CodeEnd-CodeStart
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

CodeStart:	db "SRAMExpandRoutines"
SaveGame:	PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		SEP #$40			; a set overflow flag means we are saving
		BRA Main

LoadGame: 	STZ $0DD5			;\ replaced opcodes from the LoadGame jump
		STZ $0DB3			;/
		PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		REP #$40			; a cleared overflow flag means we are loading

		;<< SaveGame & LoadGame code start here >>

Main:		REP #$30			; let A,X and Y go 16 bit, since we deal with large numbers > FF
		LDA $010A			; load current save file # (use LDA #$04 to access fourth part of the expanded sram)
		AND #$00FF			; mask high bits to take care of the garbage
		ASL #!SRAMSize-1+8		; since we have got 3 files, we give every file a fourth of the expanded sram leaving another fourth free
		TAX				; transfer the offset to X
		SEP #$20			; let A go back to 8 bit

		BVC LoadCheck			; if overflow is clear -> Loading

SaveCheck:	LDA #$01			;\ write #$01 into the first byte of the expanded ram since everything stored there are FF
		STA $700800,x			;/ 
		BRA Checked

LoadCheck:	LDA $700800,x			;\ we need to check the first ram of our expanded area since everything stored there are FF
		CMP #$01			;/ the byte must be 01
		BNE Return			; Return if the byte isn't 01

Checked:	INX				; increment x
		LDY #$0000			; store 0 into the index for our loop

Loop:		PHX
		TYX
		LDA Table,x			; load the ram pointer from the table (low byte)
		STA $00				; store it to a temp ram
		INX
		LDA Table,x			; load the ram pointer from the table (high byte)
		STA $01				; store it to a temp ram	
		TXY
		PLX
		BVC Loading			; if Carry is clear -> Loading

Saving:		LDA ($00)			; load the ram content form the table
		STA $700800,x			; and save it
		BRA GoOn

Loading:	LDA $700800,x			; load the ram from the SRAM
		STA ($00)			; store it to the pointer of the temp ram

GoOn:		INX				; next ram
		INY				; increase index of the loop
		CPY.w #CodeEnd-Table		; have we reached the end of our table?
		BNE Loop			; loop if we haven't

		;<< SaveGame & LoadGame code end here >>

Return:		BVC GetBack			; if we are loading, we mustn't to execute the replaced opcodes

		PLP
		PLY
		PLX
		PLA

		LDX $010A			;\ replaced opcodes from the SaveGame jump
		LDA $9CCB,x			;/
		RTL

GetBack:	PLP
		PLY
		PLX
		PLA
		RTL

; >>>>>>>>> here you can define which ram adresses should be saved <<<<<<<<<
Table:
	dw	#$0F34		; 1st ram for marios score
	dw	#$0F35		; 2nd ram for marios score
	dw	#$0F36		; 3rd ram for marios score
	dw	#$0F37		; 1st ram for luigis score;
	dw	#$0F38		; 2nd ram for luigis score;
	dw	#$0F39		; 3rd ram for luigis score
CodeEnd: