; Mario/Luigi dynamic palette
; Pretty simple little hack that maps the character palettes to RAM instead of ROM. The positive upshot
; of that is you can change the palettes dyanamically. It's pretty simple, just store the palettes
; to the corresponding RAM tables and the palette will change accordingly. Leaves fire power changing stuff
; intact, but may break certain patches that set $0D82 directly.
; No credit necessary.

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

header
lorom

!MarioPalette		= $7FA000	;\These all need to be in the same RAM bank
!MarioFirePalette	= $7FA014	;|
!LuigiPalette		= $7FA028	;|
!LuigiFirePalette 	= $7FA03C	;/
!Bank				= #$7F		;The bank they are in
!FreeSpace			= $218000	;Point to freespace. This is important.


org $00A31A
LDY !Bank

org $008010
JML SetInitPal

org $00E31E
JML GetPalAddr

org !FreeSpace|$800000
%RATS_start(0)
GetPalAddr:
PHB
PHK
PLB
LDA.w PointerTable,Y
STA $0D82
PLB
JML $00E324

SetInitPal:
STZ $2142
STZ $2143
LDX #$14
.loopM
LDA $00B2C8,x
STA !MarioPalette,x
DEX
BPL .loopM
LDX #$14
.loopMF
LDA $00B2F0,x
STA !MarioFirePalette,x
DEX
BPL .loopMF
LDX #$14
.loopL
LDA $00B2DC,x
STA !LuigiPalette,x
DEX
BPL .loopL
LDX #$14
.loopLF
LDA $00B304,x
STA !LuigiFirePalette,x
DEX
BPL .loopLF
JML $008016

PointerTable:
dw !MarioPalette
dw !LuigiPalette
dw !MarioPalette
dw !LuigiPalette
dw !MarioPalette
dw !LuigiPalette
dw !MarioFirePalette
dw !LuigiFirePalette
%RATS_end(0)