@asar 1.35

!Map16Page1 = $0500
!Map16Page2 = $0600

org $06F690						; offset 1: player below
	autoclean JSL PlayerBelow		;

org $06F6A0						; offset 2: player above
	JSL PlayerAbove				;

org $06F6B0						; offset 3: player sides
	JSL PlayerSides					;

org $06F6C0						; offset 4: player top corner
	JSL TopCorner					;

org $06F6D0						; offset 5: player body inside
	JSL BodyInside					;

org $06F6E0						; offset 6: player head inside
	JSL HeadInside					;

org $06F720						; offset 7: sprite vertical
	JSL SpriteV					;

org $06F730						; offset 8: sprite horizontal
	JSL SpriteH					;

org $06F780						; offset 9: cape
	JSL CapeTouch					;

org $06F7C0						; offset 10: fireball
	JSL FireballTouch				;

freecode
prot CustBlkPointers
	
PlayerBelow:					;
	LDA #$00				;
	BRA MainJump				;
PlayerAbove:					;
	LDA #$01				;
	BRA MainJump				;
PlayerSides:					;
	LDA #$02				;
	BRA MainJump				;
TopCorner:					;
	LDA #$03				;
	BRA MainJump				;
BodyInside:					;
	LDA #$04				;
	BRA MainJump				;
HeadInside:					;
	LDA #$05				;
	BRA MainJump				;
SpriteV:						;
	LDA #$06				;
	BRA MainJump				;
SpriteH:						;
	LDA #$07				;
	BRA MainJump				;
CapeTouch:					;
	LDA #$08				;
	BRA MainJump				;
FireballTouch:					;
	LDA #$09				;

MainJump:					;
	PHP						;
	REP #$30					;
	AND.w #$00FF				;
	PHB						;
	PHK						;
	PLB						;
	PHX						;
	STA $05					; $05-$06 = offset index
	LDA $03					;
	AND #$FF00				; check the high byte of the Map16 number
	CMP #!Map16Page2			; if it is a tile on the second specified page...
	BEQ .SecondPage			; then it is a custom block
	CMP #!Map16Page1			; if it is NOT a tile on the second or first specified page...
	BNE .Return				; then it is not a custom block
.FirstPage						;
	LDA #$0000				;
	BRA .Shared				;
.SecondPage					;
	LDA #$0A00				; 0xA00 for the second page: 0x100 tiles * 10 offsets
.Shared						;
	STA $09					; $09-$0A = page index (* 0xA00)
	LDA $03					;
	AND #$00FF				;
	ASL						;
	STA $07					;
	ASL						;
	ASL						;
	ADC $07					;
	STA $07					; $07-$08 = tile index (* 10)
	LDA $09					; page index
	CLC						;
	ADC $07					; plus tile index
	CLC						;
	ADC $05					; plus offset index
	STA $0B					;
	ASL						;
	ADC $0B					; times 3 (3 bytes per pointer)
	TAX						; finally, call the pointer for a particular tile and offset
	LDA.l CustBlkPointers,x		;
	STA $06					;
	SEP #$20					;
	LDA.l CustBlkPointers+2,x	;
	PLX						;
	PHA						;
	PLB						;
	STA $08					;
	SEP #$10					;
	PHK						;
	PEA .Return2-1			;
	JML [$0006]				;
.Return						;
	PLX						;
.Return2						;
	PLB						;
	PLP						;
	RTL						;

incsrc cblist.asm
incsrc cbsubs.asm


freedata

CustBlkPointers:	

incsrc cbptrs.asm






