header
lorom

!FREESPACE = $17B000
!FreeRam = $0AF5

org $00A295	;$00A295
JSL MainCode

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Levelnum.ips disassembly
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ORG $05D8B9
	JSR Levelnummain

ORG $05DC46
Levelnummain:	LDA $0E  		;Load level number
		STA $010B		;Store it in free stack RAM
		ASL A    		;Multiply A by 2, probably to recover old code?
		RTS      		;Return from subroutine

org !FREESPACE
db "STAR"
dw CodeEnd-MainCode
dw CodeEnd-MainCode^$FFFF

MainCode:
JSL $7F8000
PHA
LDA $0100
CMP #$14
BNE Return
LDA $1426
ORA $1493
BNE Return
PHB
PHK
PLB
PHX
PHP
REP #$30
LDA $010B	;get level-index to X
STA $00
ASL
ASL
CLC
ADC $00
TAX
SEP #$20
LDA LevelPoss+4,x
BIT #$04
BNE IntReturn
PHX
JSR HDMA
JSR StripeCounter
PLX
JSR CalcPos
JSR DrawSprite
IntReturn:
PLP
PLX
PLB
Return:
PLA
RTL

LVL1BRIGHT:
db $08,$00,$00,$00,$00
db $00

HDMA:
	PHP
	REP #$20	; 16 bit A
	LDA #$1103	; $43X0 = 03 
	STA $4330	; $43x1 = 11
	LDA #LVL1BRIGHT	; get pointer to brightness table
	STA $4332	; store it to low and high byte pointer
	PHK		; get bank
	SEP #$10
	PLY		;
	STY $4334	; store to bank pointer byte
	SEP #$20	; 8 bit A
	LDA #$08	; Enable HDMA on channel 3
	TSB $0D9F	;
	PLP
	RTS		; return

StripeData:
db $50,$02,$00,$37
db $F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D
db $F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D
db $F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D
                db $F0,$3D,$F0,$3D,$F0,$3D,$F0,$3D,$FF

StripeCounter:
LDA #$08
TSB $3E
REP #$30
;STZ $22
;STZ $24
LDA $7F837B		;EHHHYXyy yyyxxxxx DRllllll LLLLLLLL
TAX			;01010000 00000010 00000000 00110110
SEP #$20
LDY #$0000
StripeUploadLoop:
LDA StripeData,y
STA $7F837D,x
INX
INY
CPY #$003E
BNE StripeUploadLoop
REP #$20
RTS



CalcPos:
LDA $1337
LDA LevelPoss+4,x
AND #$0001
ASL
TAY
LDA $0094,y
LSR #5
SEP #$20
STA $00
LDA LevelPoss+4,x
BIT #$02
BEQ NoInvert
LDA $00
SEC
SBC LevelPoss,x		;pos - start
STA $01
LDA LevelPoss+2,x	;if i bit is set in settings, flip the position within the area of the level
SEC
SBC LevelPoss,x		;end - start
SEC
SBC $01			;(end - start) - (pos - start)
STA $00
NoInvert:
LDA $00
CMP LevelPoss,x
BCS GTLB
LDA LevelPoss+1,x	;if it's lower than low, give it lowbar
STA !FreeRam
RTS
GTLB:
CMP LevelPoss+2,x
BCC EndExtreme
LDA LevelPoss+3,x	;if it's higher than high, give it highbar
STA !FreeRam
RTS
EndExtreme:

LDA LevelPoss+3,x
SEC
SBC LevelPoss+1,x
STA $4202
LDA $00
SEC
SBC LevelPoss,x
STA $4203
REP #$20
NOP #3
LDA $4216
STA $4204
SEP #$20
LDA LevelPoss+2,x
SEC
SBC LevelPoss,x
STA $4206
LDA LevelPoss+4,x
AND #$02
NOP;BNE DiDiff
NOP #4
LDA $4214
CLC
ADC LevelPoss+1,x
STA !FreeRam
RTS
DiDiff:
NOP #4
LDA $4214
CLC
ADC LevelPoss+3,x
STA !FreeRam
RTS


DrawSprite:
LDA !FreeRam
CLC
ADC #$10
STA $02EC
STZ $02ED
LDA #$38
STA $02EE
LDA #$32	;YX PP CCC T - 00 11 001 0
STA $02EF
STZ $045B
RTS

TestStar:
LDA #$40
STA $02EC
STA $02ED
LDA #$EF
STA $02EE
LDA #$34
STA $02EF
STZ $045B
RTS


;Reg level:
;startpos, startbar, endpos, endbar

;inverted level:
;endpos, startbar, startpos, endbar

;all:
;lowpos, lowbar, highpos, highbar

;Startpos: What Lunar Magic reads as mario's start position, divided by 2 and converted to hex.
;		(Put the mouse cursor on mario and use the first number in the bottom-left corner of the window)
;Startbar: The position on the bar the slide should be when mario is at the 'startbar' position in the level

;Endpos: What Lunar Magic reads as the position that mario exits the level at, divided by 2 and converted to hex.
;		(Put the mouse cursor on where mario exits and use the first number in the bottom-left corner of the window)
;Startbar: The position on the bar the slide should be when mario is at the 'startbar' position in the level

;note: the hightest the bar can go is DF. Don't set startbar/endbar higher than that.

;(+0, +1, +2, and +3 respectively)

;Fifth byte: 00000niv
;v: vertical level, use y-pos to calculate position.
;i: invert bit, set if mario starts at a greater position than he ends.
;n: no-show bit, set to disable display of counter and bar


LevelPoss:
db $00,$00,$00,$00,$00	;Level 0
db $00,$00,$00,$00,$00	;Level 1
db $00,$00,$00,$00,$00	;Level 2
db $00,$00,$00,$00,$00	;Level 3
db $00,$00,$00,$00,$00	;Level 4
db $00,$00,$00,$00,$00	;Level 5
db $00,$00,$00,$00,$00	;Level 6
db $00,$00,$00,$00,$00	;Level 7
db $00,$00,$00,$00,$00	;Level 8
db $00,$00,$00,$00,$00	;Level 9
db $00,$00,$00,$00,$00	;Level A
db $00,$00,$00,$00,$00	;Level B
db $00,$00,$00,$00,$00	;Level C
db $00,$00,$00,$00,$00	;Level D
db $00,$00,$00,$00,$00	;Level E
db $00,$00,$00,$00,$00	;Level F
db $00,$00,$00,$00,$00	;Level 10
db $00,$00,$00,$00,$00	;Level 11
db $00,$00,$00,$00,$00	;Level 12
db $00,$00,$00,$00,$00	;Level 13
db $00,$00,$00,$00,$00	;Level 14
db $00,$00,$00,$00,$00	;Level 15
db $00,$00,$00,$00,$00	;Level 16
db $00,$00,$00,$00,$00	;Level 17
db $00,$00,$00,$00,$00	;Level 18
db $00,$00,$00,$00,$00	;Level 19
db $00,$00,$00,$00,$00	;Level 1A
db $00,$00,$00,$00,$00	;Level 1B
db $00,$00,$00,$00,$00	;Level 1C
db $00,$00,$00,$00,$00	;Level 1D
db $00,$00,$00,$00,$00	;Level 1E
db $00,$00,$00,$00,$00	;Level 1F
db $00,$00,$00,$00,$00	;Level 20
db $00,$00,$00,$00,$00	;Level 21
db $00,$00,$00,$00,$00	;Level 22
db $00,$00,$00,$00,$00	;Level 23
db $00,$00,$00,$00,$00	;Level 24
db $00,$00,$00,$00,$00	;Level 25
db $00,$00,$00,$00,$00	;Level 26
db $00,$00,$00,$00,$00	;Level 27
db $00,$00,$00,$00,$00	;Level 28
db $00,$00,$00,$00,$00	;Level 29
db $00,$00,$00,$00,$00	;Level 2A
db $00,$00,$00,$00,$00	;Level 2B
db $00,$00,$00,$00,$00	;Level 2C
db $00,$00,$00,$00,$00	;Level 2D
db $00,$00,$00,$00,$00	;Level 2E
db $00,$00,$00,$00,$00	;Level 2F
db $00,$00,$00,$00,$00	;Level 30
db $00,$00,$00,$00,$00	;Level 31
db $00,$00,$00,$00,$00	;Level 32
db $00,$00,$00,$00,$00	;Level 33
db $00,$00,$00,$00,$00	;Level 34
db $00,$00,$00,$00,$00	;Level 35
db $00,$00,$00,$00,$00	;Level 36
db $00,$00,$00,$00,$00	;Level 37
db $00,$00,$00,$00,$00	;Level 38
db $00,$00,$00,$00,$00	;Level 39
db $00,$00,$00,$00,$00	;Level 3A
db $00,$00,$00,$00,$00	;Level 3B
db $00,$00,$00,$00,$00	;Level 3C
db $00,$00,$00,$00,$00	;Level 3D
db $00,$00,$00,$00,$00	;Level 3E
db $00,$00,$00,$00,$00	;Level 4F
db $00,$00,$00,$00,$00	;Level 40
db $00,$00,$00,$00,$00	;Level 41
db $00,$00,$00,$00,$00	;Level 42
db $00,$00,$00,$00,$00	;Level 43
db $00,$00,$00,$00,$00	;Level 44
db $00,$00,$00,$00,$00	;Level 45
db $00,$00,$00,$00,$00	;Level 46
db $00,$00,$00,$00,$00	;Level 47
db $00,$00,$00,$00,$00	;Level 48
db $00,$00,$00,$00,$00	;Level 49
db $00,$00,$00,$00,$00	;Level 4A
db $00,$00,$00,$00,$00	;Level 4B
db $00,$00,$00,$00,$00	;Level 4C
db $00,$00,$00,$00,$00	;Level 4D
db $00,$00,$00,$00,$00	;Level 4E
db $00,$00,$00,$00,$00	;Level 4F
db $00,$00,$00,$00,$00	;Level 50
db $00,$00,$00,$00,$00	;Level 51
db $00,$00,$00,$00,$00	;Level 52
db $00,$00,$00,$00,$00	;Level 53
db $00,$00,$00,$00,$00	;Level 54
db $00,$00,$00,$00,$00	;Level 55
db $00,$00,$00,$00,$00	;Level 56
db $00,$00,$00,$00,$00	;Level 57
db $00,$00,$00,$00,$00	;Level 58
db $00,$00,$00,$00,$00	;Level 59
db $00,$00,$00,$00,$00	;Level 5A
db $00,$00,$00,$00,$00	;Level 5B
db $00,$00,$00,$00,$00	;Level 5C
db $00,$00,$00,$00,$00	;Level 5D
db $00,$00,$00,$00,$00	;Level 5E
db $00,$00,$00,$00,$00	;Level 5F
db $00,$00,$00,$00,$00	;Level 60
db $00,$00,$00,$00,$00	;Level 61
db $00,$00,$00,$00,$00	;Level 62
db $00,$00,$00,$00,$00	;Level 63
db $00,$00,$00,$00,$00	;Level 64
db $00,$00,$00,$00,$00	;Level 65
db $00,$00,$00,$00,$00	;Level 66
db $00,$00,$00,$00,$00	;Level 67
db $00,$00,$00,$00,$00	;Level 68
db $00,$00,$00,$00,$00	;Level 69
db $00,$00,$00,$00,$00	;Level 6A
db $00,$00,$00,$00,$00	;Level 6B
db $00,$00,$00,$00,$00	;Level 6C
db $00,$00,$00,$00,$00	;Level 6D
db $00,$00,$00,$00,$00	;Level 6E
db $00,$00,$00,$00,$00	;Level 6F
db $00,$00,$00,$00,$00	;Level 70
db $00,$00,$00,$00,$00	;Level 71
db $00,$00,$00,$00,$00	;Level 72
db $00,$00,$00,$00,$00	;Level 73
db $00,$00,$00,$00,$00	;Level 74
db $00,$00,$00,$00,$00	;Level 75
db $00,$00,$00,$00,$00	;Level 76
db $00,$00,$00,$00,$00	;Level 77
db $00,$00,$00,$00,$00	;Level 78
db $00,$00,$00,$00,$00	;Level 79
db $00,$00,$00,$00,$00	;Level 7A
db $00,$00,$00,$00,$00	;Level 7B
db $00,$00,$00,$00,$00	;Level 7C
db $00,$00,$00,$00,$00	;Level 7D
db $00,$00,$00,$00,$00	;Level 7E
db $00,$00,$00,$00,$00	;Level 7F
db $00,$00,$00,$00,$00	;Level 80
db $00,$00,$00,$00,$00	;Level 81
db $00,$00,$00,$00,$00	;Level 82
db $00,$00,$00,$00,$00	;Level 83
db $00,$00,$00,$00,$00	;Level 84
db $00,$00,$00,$00,$00	;Level 85
db $00,$00,$00,$00,$00	;Level 86
db $00,$00,$00,$00,$00	;Level 87
db $00,$00,$00,$00,$00	;Level 88
db $00,$00,$00,$00,$00	;Level 89
db $00,$00,$00,$00,$00	;Level 8A
db $00,$00,$00,$00,$00	;Level 8B
db $00,$00,$00,$00,$00	;Level 8C
db $00,$00,$00,$00,$00	;Level 8D
db $00,$00,$00,$00,$00	;Level 8E
db $00,$00,$00,$00,$00	;Level 8F
db $00,$00,$00,$00,$00	;Level 90
db $00,$00,$00,$00,$00	;Level 91
db $00,$00,$00,$00,$00	;Level 92
db $00,$00,$00,$00,$00	;Level 93
db $00,$00,$00,$00,$00	;Level 94
db $00,$00,$00,$00,$00	;Level 95
db $00,$00,$00,$00,$00	;Level 96
db $00,$00,$00,$00,$00	;Level 97
db $00,$00,$00,$00,$00	;Level 98
db $00,$00,$00,$00,$00	;Level 99
db $00,$00,$00,$00,$00	;Level 9A
db $00,$00,$00,$00,$00	;Level 9B
db $00,$00,$00,$00,$00	;Level 9C
db $00,$00,$00,$00,$00	;Level 9D
db $00,$00,$00,$00,$00	;Level 9E
db $00,$00,$00,$00,$00	;Level 9F
db $00,$00,$00,$00,$00	;Level A0
db $00,$00,$00,$00,$00	;Level A1
db $00,$00,$00,$00,$00	;Level A2
db $00,$00,$00,$00,$00	;Level A3
db $00,$00,$00,$00,$00	;Level A4
db $00,$00,$00,$00,$00	;Level A5
db $00,$00,$00,$00,$00	;Level A6
db $00,$00,$00,$00,$00	;Level A7
db $00,$00,$00,$00,$00	;Level A8
db $00,$00,$00,$00,$00	;Level A9
db $00,$00,$00,$00,$00	;Level AA
db $00,$00,$00,$00,$00	;Level AB
db $00,$00,$00,$00,$00	;Level AC
db $00,$00,$00,$00,$00	;Level AD
db $00,$00,$00,$00,$00	;Level AE
db $00,$00,$00,$00,$00	;Level AF
db $00,$00,$00,$00,$00	;Level B0
db $00,$00,$00,$00,$00	;Level B1
db $00,$00,$00,$00,$00	;Level B2
db $00,$00,$00,$00,$00	;Level B3
db $00,$00,$00,$00,$00	;Level B4
db $00,$00,$00,$00,$00	;Level B5
db $00,$00,$00,$00,$00	;Level B6
db $00,$00,$00,$00,$00	;Level B7
db $00,$00,$00,$00,$00	;Level B8
db $00,$00,$00,$00,$00	;Level B9
db $00,$00,$00,$00,$00	;Level BA
db $00,$00,$00,$00,$00	;Level BB
db $00,$00,$00,$00,$00	;Level BC
db $00,$00,$00,$00,$00	;Level BD
db $00,$00,$00,$00,$00	;Level BE
db $00,$00,$00,$00,$00	;Level BF
db $00,$00,$00,$00,$00	;Level C0
db $00,$00,$00,$00,$00	;Level C1
db $00,$00,$00,$00,$00	;Level C2
db $00,$00,$00,$00,$00	;Level C3
db $00,$00,$00,$00,$00	;Level C4
db $00,$00,$00,$00,$00	;Level C5
db $00,$00,$00,$00,$00	;Level C6
db $00,$00,$00,$00,$00	;Level C7
db $00,$00,$00,$00,$00	;Level C8
db $00,$00,$00,$00,$00	;Level C9
db $00,$00,$00,$00,$00	;Level CA
db $00,$00,$00,$00,$00	;Level CB
db $00,$00,$00,$00,$00	;Level CC
db $00,$00,$00,$00,$00	;Level CD
db $00,$00,$00,$00,$00	;Level CE
db $00,$00,$00,$00,$00	;Level CF
db $00,$00,$00,$00,$00	;Level D0
db $00,$00,$00,$00,$00	;Level D1
db $00,$00,$00,$00,$00	;Level D2
db $00,$00,$00,$00,$00	;Level D3
db $00,$00,$00,$00,$00	;Level D4
db $00,$00,$00,$00,$00	;Level D5
db $00,$00,$00,$00,$00	;Level D6
db $00,$00,$00,$00,$00	;Level D7
db $00,$00,$00,$00,$00	;Level D8
db $00,$00,$00,$00,$00	;Level D9
db $00,$00,$00,$00,$00	;Level DA
db $00,$00,$00,$00,$00	;Level DB
db $00,$00,$00,$00,$00	;Level DC
db $00,$00,$00,$00,$00	;Level DD
db $00,$00,$00,$00,$00	;Level DE
db $00,$00,$00,$00,$00	;Level DF
db $00,$00,$00,$00,$00	;Level E0
db $00,$00,$00,$00,$00	;Level E1
db $00,$00,$00,$00,$00	;Level E2
db $00,$00,$00,$00,$00	;Level E3
db $00,$00,$00,$00,$00	;Level E4
db $00,$00,$00,$00,$00	;Level E5
db $00,$00,$00,$00,$00	;Level E6
db $00,$00,$00,$00,$00	;Level E7
db $00,$00,$00,$00,$00	;Level E8
db $00,$00,$00,$00,$00	;Level E9
db $00,$00,$00,$00,$00	;Level EA
db $00,$00,$00,$00,$00	;Level EB
db $00,$00,$00,$00,$00	;Level EC
db $00,$00,$00,$00,$00	;Level ED
db $00,$00,$00,$00,$00	;Level EE
db $00,$00,$00,$00,$00	;Level EF
db $00,$00,$00,$00,$00	;Level F0
db $00,$00,$00,$00,$00	;Level F1
db $00,$00,$00,$00,$00	;Level F2
db $00,$00,$00,$00,$00	;Level F3
db $00,$00,$00,$00,$00	;Level F4
db $00,$00,$00,$00,$00	;Level F5
db $00,$00,$00,$00,$00	;Level F6
db $00,$00,$00,$00,$00	;Level F7
db $00,$00,$00,$00,$00	;Level F8
db $00,$00,$00,$00,$00	;Level F9
db $00,$00,$00,$00,$00	;Level FA
db $00,$00,$00,$00,$00	;Level FB
db $00,$00,$00,$00,$00	;Level FC
db $00,$00,$00,$00,$00	;Level FD
db $00,$00,$00,$00,$00	;Level FE
db $00,$00,$00,$00,$00	;Level FF
db $00,$00,$00,$00,$00	;Level 100
db $00,$00,$00,$00,$00	;Level 101
db $00,$00,$00,$00,$00	;Level 102
db $00,$00,$00,$00,$00	;Level 103
db $00,$00,$00,$00,$00	;Level 104
db $00,$00,$00,$00,$00	;Level 105
db $00,$00,$26,$B0,$03	;Level 106	;\set for the example level
db $03,$B0,$0A,$DF,$00	;Level 107	;/
db $00,$00,$00,$00,$00	;Level 108
db $00,$00,$00,$00,$00	;Level 109
db $00,$00,$00,$00,$00	;Level 10A
db $00,$00,$00,$00,$00	;Level 10B
db $00,$00,$00,$00,$00	;Level 10C
db $00,$00,$00,$00,$00	;Level 10D
db $00,$00,$00,$00,$00	;Level 10E
db $00,$00,$00,$00,$00	;Level 10F
db $00,$00,$00,$00,$00	;Level 110
db $00,$00,$00,$00,$00	;Level 111
db $00,$00,$00,$00,$00	;Level 112
db $00,$00,$00,$00,$00	;Level 113
db $00,$00,$00,$00,$00	;Level 114
db $00,$00,$00,$00,$00	;Level 115
db $00,$00,$00,$00,$00	;Level 116
db $00,$00,$00,$00,$00	;Level 117
db $00,$00,$00,$00,$00	;Level 118
db $00,$00,$00,$00,$00	;Level 119
db $00,$00,$00,$00,$00	;Level 11A
db $00,$00,$00,$00,$00	;Level 11B
db $00,$00,$00,$00,$00	;Level 11C
db $00,$00,$00,$00,$00	;Level 11D
db $00,$00,$00,$00,$00	;Level 11E
db $00,$00,$00,$00,$00	;Level 11F
db $00,$00,$00,$00,$00	;Level 120
db $00,$00,$00,$00,$00	;Level 121
db $00,$00,$00,$00,$00	;Level 122
db $00,$00,$00,$00,$00	;Level 123
db $00,$00,$00,$00,$00	;Level 124
db $00,$00,$00,$00,$00	;Level 125
db $00,$00,$00,$00,$00	;Level 126
db $00,$00,$00,$00,$00	;Level 127
db $00,$00,$00,$00,$00	;Level 128
db $00,$00,$00,$00,$00	;Level 129
db $00,$00,$00,$00,$00	;Level 12A
db $00,$00,$00,$00,$00	;Level 12B
db $00,$00,$00,$00,$00	;Level 12C
db $00,$00,$00,$00,$00	;Level 12D
db $00,$00,$00,$00,$00	;Level 12E
db $00,$00,$00,$00,$00	;Level 12F
db $00,$00,$00,$00,$00	;Level 130
db $00,$00,$00,$00,$00	;Level 131
db $00,$00,$00,$00,$00	;Level 132
db $00,$00,$00,$00,$00	;Level 133
db $00,$00,$00,$00,$00	;Level 134
db $00,$00,$00,$00,$00	;Level 135
db $00,$00,$00,$00,$00	;Level 136
db $00,$00,$00,$00,$00	;Level 137
db $00,$00,$00,$00,$00	;Level 138
db $00,$00,$00,$00,$00	;Level 139
db $00,$00,$00,$00,$00	;Level 13A
db $00,$00,$00,$00,$00	;Level 13B
db $00,$00,$00,$00,$00	;Level 13C
db $00,$00,$00,$00,$00	;Level 13D
db $00,$00,$00,$00,$00	;Level 13E
db $00,$00,$00,$00,$00	;Level 14F
db $00,$00,$00,$00,$00	;Level 140
db $00,$00,$00,$00,$00	;Level 141
db $00,$00,$00,$00,$00	;Level 142
db $00,$00,$00,$00,$00	;Level 143
db $00,$00,$00,$00,$00	;Level 144
db $00,$00,$00,$00,$00	;Level 145
db $00,$00,$00,$00,$00	;Level 146
db $00,$00,$00,$00,$00	;Level 147
db $00,$00,$00,$00,$00	;Level 148
db $00,$00,$00,$00,$00	;Level 149
db $00,$00,$00,$00,$00	;Level 14A
db $00,$00,$00,$00,$00	;Level 14B
db $00,$00,$00,$00,$00	;Level 14C
db $00,$00,$00,$00,$00	;Level 14D
db $00,$00,$00,$00,$00	;Level 14E
db $00,$00,$00,$00,$00	;Level 14F
db $00,$00,$00,$00,$00	;Level 150
db $00,$00,$00,$00,$00	;Level 151
db $00,$00,$00,$00,$00	;Level 152
db $00,$00,$00,$00,$00	;Level 153
db $00,$00,$00,$00,$00	;Level 154
db $00,$00,$00,$00,$00	;Level 155
db $00,$00,$00,$00,$00	;Level 156
db $00,$00,$00,$00,$00	;Level 157
db $00,$00,$00,$00,$00	;Level 158
db $00,$00,$00,$00,$00	;Level 159
db $00,$00,$00,$00,$00	;Level 15A
db $00,$00,$00,$00,$00	;Level 15B
db $00,$00,$00,$00,$00	;Level 15C
db $00,$00,$00,$00,$00	;Level 15D
db $00,$00,$00,$00,$00	;Level 15E
db $00,$00,$00,$00,$00	;Level 15F
db $00,$00,$00,$00,$00	;Level 160
db $00,$00,$00,$00,$00	;Level 161
db $00,$00,$00,$00,$00	;Level 162
db $00,$00,$00,$00,$00	;Level 163
db $00,$00,$00,$00,$00	;Level 164
db $00,$00,$00,$00,$00	;Level 165
db $00,$00,$00,$00,$00	;Level 166
db $00,$00,$00,$00,$00	;Level 167
db $00,$00,$00,$00,$00	;Level 168
db $00,$00,$00,$00,$00	;Level 169
db $00,$00,$00,$00,$00	;Level 16A
db $00,$00,$00,$00,$00	;Level 16B
db $00,$00,$00,$00,$00	;Level 16C
db $00,$00,$00,$00,$00	;Level 16D
db $00,$00,$00,$00,$00	;Level 16E
db $00,$00,$00,$00,$00	;Level 16F
db $00,$00,$00,$00,$00	;Level 170
db $00,$00,$00,$00,$00	;Level 171
db $00,$00,$00,$00,$00	;Level 172
db $00,$00,$00,$00,$00	;Level 173
db $00,$00,$00,$00,$00	;Level 174
db $00,$00,$00,$00,$00	;Level 175
db $00,$00,$00,$00,$00	;Level 176
db $00,$00,$00,$00,$00	;Level 177
db $00,$00,$00,$00,$00	;Level 178
db $00,$00,$00,$00,$00	;Level 179
db $00,$00,$00,$00,$00	;Level 17A
db $00,$00,$00,$00,$00	;Level 17B
db $00,$00,$00,$00,$00	;Level 17C
db $00,$00,$00,$00,$00	;Level 17D
db $00,$00,$00,$00,$00	;Level 17E
db $00,$00,$00,$00,$00	;Level 17F
db $00,$00,$00,$00,$00	;Level 180
db $00,$00,$00,$00,$00	;Level 181
db $00,$00,$00,$00,$00	;Level 182
db $00,$00,$00,$00,$00	;Level 183
db $00,$00,$00,$00,$00	;Level 184
db $00,$00,$00,$00,$00	;Level 185
db $00,$00,$00,$00,$00	;Level 186
db $00,$00,$00,$00,$00	;Level 187
db $00,$00,$00,$00,$00	;Level 188
db $00,$00,$00,$00,$00	;Level 189
db $00,$00,$00,$00,$00	;Level 18A
db $00,$00,$00,$00,$00	;Level 18B
db $00,$00,$00,$00,$00	;Level 18C
db $00,$00,$00,$00,$00	;Level 18D
db $00,$00,$00,$00,$00	;Level 18E
db $00,$00,$00,$00,$00	;Level 18F
db $00,$00,$00,$00,$00	;Level 190
db $00,$00,$00,$00,$00	;Level 191
db $00,$00,$00,$00,$00	;Level 192
db $00,$00,$00,$00,$00	;Level 193
db $00,$00,$00,$00,$00	;Level 194
db $00,$00,$00,$00,$00	;Level 195
db $00,$00,$00,$00,$00	;Level 196
db $00,$00,$00,$00,$00	;Level 197
db $00,$00,$00,$00,$00	;Level 198
db $00,$00,$00,$00,$00	;Level 199
db $00,$00,$00,$00,$00	;Level 19A
db $00,$00,$00,$00,$00	;Level 19B
db $00,$00,$00,$00,$00	;Level 19C
db $00,$00,$00,$00,$00	;Level 19D
db $00,$00,$00,$00,$00	;Level 19E
db $00,$00,$00,$00,$00	;Level 19F
db $00,$00,$00,$00,$00	;Level 1A0
db $00,$00,$00,$00,$00	;Level 1A1
db $00,$00,$00,$00,$00	;Level 1A2
db $00,$00,$00,$00,$00	;Level 1A3
db $00,$00,$00,$00,$00	;Level 1A4
db $00,$00,$00,$00,$00	;Level 1A5
db $00,$00,$00,$00,$00	;Level 1A6
db $00,$00,$00,$00,$00	;Level 1A7
db $00,$00,$00,$00,$00	;Level 1A8
db $00,$00,$00,$00,$00	;Level 1A9
db $00,$00,$00,$00,$00	;Level 1AA
db $00,$00,$00,$00,$00	;Level 1AB
db $00,$00,$00,$00,$00	;Level 1AC
db $00,$00,$00,$00,$00	;Level 1AD
db $00,$00,$00,$00,$00	;Level 1AE
db $00,$00,$00,$00,$00	;Level 1AF
db $00,$00,$00,$00,$00	;Level 1B0
db $00,$00,$00,$00,$00	;Level 1B1
db $00,$00,$00,$00,$00	;Level 1B2
db $00,$00,$00,$00,$00	;Level 1B3
db $00,$00,$00,$00,$00	;Level 1B4
db $00,$00,$00,$00,$00	;Level 1B5
db $00,$00,$00,$00,$00	;Level 1B6
db $00,$00,$00,$00,$00	;Level 1B7
db $00,$00,$00,$00,$00	;Level 1B8
db $00,$00,$00,$00,$00	;Level 1B9
db $00,$00,$00,$00,$00	;Level 1BA
db $00,$00,$00,$00,$00	;Level 1BB
db $00,$00,$00,$00,$00	;Level 1BC
db $00,$00,$00,$00,$00	;Level 1BD
db $00,$00,$00,$00,$00	;Level 1BE
db $00,$00,$00,$00,$00	;Level 1BF
db $00,$00,$00,$00,$00	;Level 1C0
db $00,$00,$00,$00,$00	;Level 1C1
db $00,$00,$00,$00,$00	;Level 1C2
db $00,$00,$00,$00,$00	;Level 1C3
db $00,$00,$00,$00,$00	;Level 1C4
db $00,$00,$00,$00,$00	;Level 1C5
db $00,$00,$00,$00,$00	;Level 1C6
db $00,$00,$00,$00,$00	;Level 1C7
db $00,$00,$00,$00,$00	;Level 1C8
db $00,$00,$00,$00,$00	;Level 1C9
db $00,$00,$00,$00,$00	;Level 1CA
db $00,$00,$00,$00,$00	;Level 1CB
db $00,$00,$00,$00,$00	;Level 1CC
db $00,$00,$00,$00,$00	;Level 1CD
db $00,$00,$00,$00,$00	;Level 1CE
db $00,$00,$00,$00,$00	;Level 1CF
db $00,$00,$00,$00,$00	;Level 1D0
db $00,$00,$00,$00,$00	;Level 1D1
db $00,$00,$00,$00,$00	;Level 1D2
db $00,$00,$00,$00,$00	;Level 1D3
db $00,$00,$00,$00,$00	;Level 1D4
db $00,$00,$00,$00,$00	;Level 1D5
db $00,$00,$00,$00,$00	;Level 1D6
db $00,$00,$00,$00,$00	;Level 1D7
db $00,$00,$00,$00,$00	;Level 1D8
db $00,$00,$00,$00,$00	;Level 1D9
db $00,$00,$00,$00,$00	;Level 1DA
db $00,$00,$00,$00,$00	;Level 1DB
db $00,$00,$00,$00,$00	;Level 1DC
db $00,$00,$00,$00,$00	;Level 1DD
db $00,$00,$00,$00,$00	;Level 1DE
db $00,$00,$00,$00,$00	;Level 1DF
db $00,$00,$00,$00,$00	;Level 1E0
db $00,$00,$00,$00,$00	;Level 1E1
db $00,$00,$00,$00,$00	;Level 1E2
db $00,$00,$00,$00,$00	;Level 1E3
db $00,$00,$00,$00,$00	;Level 1E4
db $00,$00,$00,$00,$00	;Level 1E5
db $00,$00,$00,$00,$00	;Level 1E6
db $00,$00,$00,$00,$00	;Level 1E7
db $00,$00,$00,$00,$00	;Level 1E8
db $00,$00,$00,$00,$00	;Level 1E9
db $00,$00,$00,$00,$00	;Level 1EA
db $00,$00,$00,$00,$00	;Level 1EB
db $00,$00,$00,$00,$00	;Level 1EC
db $00,$00,$00,$00,$00	;Level 1ED
db $00,$00,$00,$00,$00	;Level 1EE
db $00,$00,$00,$00,$00	;Level 1EF
db $00,$00,$00,$00,$00	;Level 1F0
db $00,$00,$00,$00,$00	;Level 1F1
db $00,$00,$00,$00,$00	;Level 1F2
db $00,$00,$00,$00,$00	;Level 1F3
db $00,$00,$00,$00,$00	;Level 1F4
db $00,$00,$00,$00,$00	;Level 1F5
db $00,$00,$00,$00,$00	;Level 1F6
db $00,$00,$00,$00,$00	;Level 1F7
db $00,$00,$00,$00,$00	;Level 1F8
db $00,$00,$00,$00,$00	;Level 1F9
db $00,$00,$00,$00,$00	;Level 1FA
db $00,$00,$00,$00,$00	;Level 1FB
db $00,$00,$00,$00,$00	;Level 1FC
db $00,$00,$00,$00,$00	;Level 1FD
db $00,$00,$00,$00,$00	;Level 1FE
db $00,$00,$00,$00,$00	;Level 1FF


CodeEnd: