;SM64 wall-slide - by Noobish Noobsicle
;
;Allows you to slide down and bounce off of walls like in the super mario 3D series.
;
;also, I know HuFlunDu made one, but I made this without knowing that, and I used not a line of his code in making this patch.


header
lorom

!FreeRam = $7C
!FreeRam2 = $58

!FreeSpace = $14F000

org $008E81
	JSL NewCode

org $00F875
	JML Freescroll
	NOP

org $00E9CE
	JML SetNewBit
	NOP

org !FreeSpace

	db "STAR"
	dw CodeEnd-NewCode
	dw CodeEnd-NewCode^$FFFF

Freescroll:
	LDX $1404
	BNE .yayscroll
	LDA !FreeRam
	AND #$00FF
	BNE .yayscroll
	JML $00F87A
.yayscroll
	JML $00F881

SetNewBit:
	LDA $1411
	BNE .fixdhorz
	JML $00E9D3
.fixdhorz
	LDA #$40
	TSB $77
	JML $00E9F6

NewCode:
	PHA
	PHB
	PHK
	PLB
	;LDA $1337		;used as breakpoint
	JSR Routine
	PLB
	PLA
	LDX #$10
	LDY #$00
RTL

Routine:
	LDA $77
	AND #$04
	BEQ Elsewhere
	STZ !FreeRam2
Elsewhere:
	JSR Checks
	LDA !FreeRam
	BNE AlreadySlide
	LDA $77		;must be touching wall
	AND #$03
	AND $15		;and be pressing corrosponding button
	BEQ Return
	CMP !FreeRam2
	BEQ Return
	STA !FreeRam
Return:
RTS

AlreadySlide:
	AND $15			;don't press the wrong button
	BNE Life
	STZ !FreeRam
RTS

Life:
	LDA $7B
	BPL Rawrz
	EOR #$FF
	INC
Rawrz:
	CMP #$09
	BCC nopgra
	STZ !FreeRam
nopgra:
	JSR MscSmallStuff
	LDA #$03
	JSR DoSmokeCloud
	LDA $16
	ORA $18			;if you should jump (A or B, one frame)
	AND #$80
	BEQ Return		;Jump
	LDA #$02
	STA $1DF9		;clicking sound
	LDA #$C0		;yspeed
	STA $7D
	LDA #$D0
	STA $7B			;xspeed: 40 right
	LDA !FreeRam		;if touching right,
	AND #$02
	BEQ NoNeedForChange
	LDA #$30
	STA $7B			;make it 20 left
NoNeedForChange:
	LDA #$02
	JSR DoSmokeCloud		;contact graphic
	LDA !FreeRam
	;EOR #$03
	STA !FreeRam2
RTS

MscSmallStuff:
	LDA !FreeRam
	DEC
	STA $76
	;STZ $7B			;zero xspeed
	LDA $7D
	CMP #$13
	BCC Smaller		;speed maximum is 12
	LDA #$12
	STA $7D
Smaller:
	LDA #$0D
	STA $13E0		;use sliding position
RTS

DoSmokeCloud:
	PHY
	PHA
	LDY #$FF
	SmokeLoop:
	INY
	CPY #$04
	BEQ .NR
	LDA $17C0,y
	BEQ .Result		;find empty smoke spot
	BRA SmokeLoop
.NR
	LDY #$03		;if none is found, take last one
.Result
	PLA
	STA $17C0,y		;'turn around' smoke
	TAX
	LDA.w Smoketable,x
	STA $01
	LDA $96			;Mario's Ypos
	CLC
	ADC $01		;+0x1A
	STA $17C4,y		;=smoke ypos
	LDA !FreeRam
	EOR #$03
	DEC
	ASL #3
	STA $00
	REP #$20
	LDA $94
	CLC
	ADC $00
	SEP #$20
	STA $17C8,y		;x-pos = mariox + 8
	LDA #$10
	STA $17CC,y		;ten frames for smoke to exist
Smoketable:
	PLY
RTS
	db $10,$1A

Checks:
	LDA $7D		;upward yspeed
	BMI HardReturn
	LDA $77		;touching ground or side of screen
	BIT #$C4
	BNE HardReturn
	LDA $14A5	;flight
	ORA $140D	;spin-jump
	ORA $1470	;carrying/p-baloon
	ORA $187A	;yoshi
	ORA $73		;ducking
	ORA $74		;climbing
	ORA $75		;swimming
	BNE HardReturn
	;LDA $7E
	;CMP #$09 	;If equal to 08 or less than 08 return
	;BCC HardReturn
	;CMP #$E8 	;If equal to E8 or higher than E8 return
	;BCS HardReturn	;Thank you, fakescaper/chdata!			...Or not...
	SoftReturn:
RTS

HardReturn:
	STZ !FreeRam
	;STZ !FreeRam2
	PLA
	PLA
RTS

CodeEnd: