!Lives = $0DBE
!GFXBuffer = $7EAD00
; Definitions
!Freespace = $3D8000
!ShowOnYoshisHouse = $01 ;$00 = No, $01 = Yes
!TilesYPosition = $80 ;$00 = Top, $FF = Bottom
!TilesXPosition = $60 ;$00 = Left, $FF = Right
!SubmapYPosition = $08 ;$00 = Top, $FF = Bottom
!SubmapXPosition = $08 ;$00 = Left, $FF = Right
!PreviewYPosition = $30 ;$00 = Top, $FF = Bottom
!PreviewXPosition = $48 ;$00 = Left, $FF = Right
!Delay = 10 ;This is DECIMAL! It's the delay between the screen with the level name, lives... and the level start. Don't go highter than 50!
		    ;NOTE: It's not like frames.

cleartable
table LettersTable.txt

; ======================================================
; Mario Start - Lives Shower
; ======================================================

Header
LoROM

; ======================================================
; Patch Code + RATS Tag
; ======================================================

org $009216
JSL MainCode
NOP #1
JML IfElse

org $0096A1
JML OnYoshisHouse

org $009708
JSL GiveMoreTime

org $0093D7
JSL asd
NOP #2
;===========================
org !Freespace
print "Code inserted at: ",pc   
!CodeSize = Ending-Routine  
db "STAR"		    
dw !CodeSize-$01            
dw !CodeSize-$01^$FFFF      
Routine:		    
;===========================
MainCode:

;====================;
;Your Code Goes Here ;
;====================;

PHA
PHX
PHY

LDA $0100
CMP #$17
BEQ DontDoIt

LDA $0109
CMP #$E9
BEQ DontDoIt

JSR CustomMarioStart 

DontDoIt:

PLY
PLX
PLA

RTL

GiveMoreTime:
LDA $0100
CMP #$11
BNE ReturnCode

LDA $0109
CMP #$E9
BEQ ReturnCode

PHA
PHX
PHY

;Please, if you know what I am doing, don't kill me >:
LDX #$FF				;\Yo dawg, I heard you liek loops
WasteSuperTimeLoop:		;|
LDA #$FF				;|\
WasteTimeLoop:			;||
NOP #!Delay				;||So we put a loop inside a loop
DEC A					;||
CMP #$00				;||
BNE WasteTimeLoop		;|/
NOP #!Delay				;|\
DEX						;||So you can waste time
CPX #$00				;||while you waste time
BNE WasteSuperTimeLoop	;//Good luck on that...
PLY
PLX
PLA

ReturnCode:
LDA #$20                
STA $5E  
RTL

NormalPalettes:
   PHK
   PEA.w Return-1
   PEA $84CE
   JML.l $00ABED
Return:
STZ $0701
RTL

asd:
STZ $0701

LDA $0100
CMP #$0C
BCC NormalPalettes

LDA $0109
CMP #$E9
BEQ NormalPalettes

JSR GetTransLevel ;Since the translevel number is updated later, we need to update it now

REP #$30
LDA $13BF
ASL A
ADC $13BF
TAX
LDA MessagesPointer,x
STA $05
SEP #$20
LDA MessagesPointer+2,x
STA $07
SEP #$10

LDY #$03

LDA [$05],y
STA $00
INY
LDA [$05],y
STA $01
INY
LDA [$05],y
STA $02

LDY #$00
DownloadPal:
LDA [$00],y
STA $0843,y
INY
LDA [$00],y
STA $0843,y
INY
CPY #$20
BNE DownloadPal

FontColor:
LDX #$00
DownloadFontpal:
LDA FontPalettePointer,x
STA $0823,x
INX
LDA FontPalettePointer,x
STA $0823,x
INX
CPX #$20
BNE DownloadFontpal
RTL

IfElse:
LDA $0100
CMP #$17
BEQ GameOver
JML $00922E

GameOver:
LDA $0090D1,X       
BMI Return00922E          
STA $030A,Y         
LDA $009105,X       
STA $030E,Y         
LDA #$68                
STA $0309,Y    
LDA #$70                
STA $030D,Y  
Return00922E:
JML $00922E

OnYoshisHouse:
LDA $13C1               
CMP #$56                
BEQ CODE_0096AB  
Show:
JML $0096A8
CODE_0096AB:
LDA #!ShowOnYoshisHouse
BNE Show
JML $0096AB


CustomMarioStart:
JSR Lives
JSR SubmapName
JSR SpriteDMA
JSR PaletteDMA
RTS

SubmapName:
STZ $01 ;Reset OAM index
STZ $03 ;Reset XPos
STZ $04 ;Reset YPos
STZ $08

LDA $1425
BNE EndName

JSR GetTransLevel ;Since the translevel number is updated later, we need to update it now

REP #$30
LDA $13BF
ASL A
ADC $13BF
TAX
LDA MessagesPointer,x
STA $05
SEP #$20
LDA MessagesPointer+2,x
STA $07
SEP #$10

LDX $13BF
LDA MessagesSizePointer,x
STA $08

Done:

LDY #$00

LDA [$05],y
BEQ DontDrawAnything ;If the first byte is 00, don't draw anything

LDA $01
PHA
LDA $02
PHA
LDA $03
PHA
LDA $04
PHA
LDA $05
PHA
LDA $06
PHA
LDA $07
PHA
LDA $08
PHA

JSR DrawingImage

PLA
STA $08
PLA
STA $07
PLA
STA $06
PLA
STA $05
PLA
STA $04
PLA
STA $03
PLA
STA $02
PLA
STA $01

DontDrawAnything:

LDY #$06 ;The first five bytes define things about the image

LDX $08			;Run loop X times
ReadTextLoop:

LDA [$05],y     	;\Set byte
CMP #$FE
BEQ EndName
STA $00				;/at ram $00
JSR DrawMapName		;Self explanatory
INY					;Next byte
DEX					;Loop count -= 1
BPL ReadTextLoop	;While loop count is positive (00-7F), loop

EndName:

RTS


DrawingImage:
INY
LDA [$05],y
STA $00
INY
LDA [$05],y
STA $01
INY

REP #$30
LDX #$7800
LDA $00
JSR UploadGFXFile
SEP #$30	


LDY #$20
LDX #$1F

ImageLoop:
LDA #!PreviewXPosition
CLC
ADC XDisp,x
STA $0200,y

LDA #!PreviewYPosition
CLC
ADC YDisp,x
STA $0201,y

LDA PreviewTilemap,x
STA $0202,y

LDA #$05
STA $0203,y

PHY
TYA
LSR A
LSR A
TAY
LDA #$02
STA $0420,y
PLY

INY
INY
INY
INY
DEX
BPL ImageLoop

RTS

XDisp:
db $00,$10,$20,$30,$40,$50,$60,$70
db $00,$10,$20,$30,$40,$50,$60,$70
db $00,$10,$20,$30,$40,$50,$60,$70
db $00,$10,$20,$30,$40,$50,$60,$70

YDisp:
db $00,$00,$00,$00,$00,$00,$00,$00
db $10,$10,$10,$10,$10,$10,$10,$10
db $20,$20,$20,$20,$20,$20,$20,$20
db $30,$30,$30,$30,$30,$30,$30,$30

PreviewTilemap:
db $80,$82,$84,$86,$88,$8A,$8C,$8E
db $A0,$A2,$A4,$A6,$A8,$AA,$AC,$AE
db $C0,$C2,$C4,$C6,$C8,$CA,$CC,$CE
db $E0,$E2,$E4,$E6,$E8,$EA,$EC,$EE


UploadGFXFile:	PHY			; back up Y
		PHX			; back up X
		CMP.w #$0032		; \ < 32, use code
		BCC GFX00to31		; / for GFX 00-31
		CMP.w #$0080		; \ still < 80,
		BCC UploadReturn	; / return
		CMP.w #$0100		; \ > 100, use code
		BCS ExGFX100toFFF	; / for 100-FFF
GFX80toFF:	AND.w #$007F		; reset most significant bit
		STA.b $8A		; \
		ASL A			;  | multiply by 3 using
		CLC			;  | shift-add method
		ADC.b $8A		; /
		TAY			; -> Y
		LDA.l $0FF94F		; \
		STA.b $06		;  | $0FF94F-$0FF950 contains the pointer
		LDA.l $0FF950		;  | for the ExGFX table for 80-FF
		STA.b $07		; /
		BRA FinishDecomp	; branch to next step

UploadReturn:	PLX
		PLY
		RTS

GFX00to31:	TAX			; ExGFX file -> X
		LDA.l $00B992,x		; \
		STA $8A			;  | copy ExGFX
		LDA.l $00B9C4,x		;  | pointer to
		STA $8B			;  | $8A-$8C
		LDA.l $00B9F6,x		;  |
		STA $8C			; /
		BRA FinishDecomp2	; branch to next step

ExGFX100toFFF:	;SEC			; \ subtract #$100
		SBC.w #$0100		; / SEC commented out because the BCS that branches here would only branch if the carry flag were already set
		STA.b $8A		; \
		ASL A			;  | multiply result
		CLC			;  | by 3 to get
		ADC.b $8A		;  | index
		TAY			; /
		LDA.l $0FF873		; \
		STA.b $06		;  | $0FF873-$0FF875 contans the pointer
		LDA.l $0FF874		;  | for the ExGFX table for 100-FFF
		STA.b $07		; /
FinishDecomp:	LDA.b [$06],y		; \ Get low byte.
		STA.b $8A		; / and high byte
		INC.b $06		; Increase pointer position by 1.
		BNE NoCrossBank		; \
		SEP #%00100000		;  | allow bank crossing
		INC $08			;  | (not sure if this is necessary here)
		REP #%00100000		; /
NoCrossBank:	LDA.b [$06],y		; \ Get the high byte (again)
		STA.b $8B		; / and bank byte.
FinishDecomp2:	LDA.w #!GFXBuffer	; \ GFX buffer low
		STA.b $00		; / and high byte
		SEP #%00100000		; 8-bit A
		LDA.b #!GFXBuffer>>16	; \ GFX buffer
		STA.b $02		; / bank byte
		PHK			; \
		PEA.w Ret1-1		;  | local JSL to LZ2 routine
		PEA $84CE		;  | (afterwards A/X/Y all 8-bit)
		JML $00B8DC		; /
Ret1:		REP.b #%00010000	; 16-bit X/Y
		PLX			; \ restore X, X is the
		STX.w $2116		; / VRAM destination
		LDA.b #%00000001	; \ control
		STA.w $4330		; / register
		LDA.b #$18		; \ dma to
		STA.w $4331		; / [21]18
		LDX.w #!GFXBuffer	; \
		STX.w $4332		;  | source
		LDA.b #!GFXBuffer>>16	;  | of data
		STA.w $4334		; /
		LDX.b $8D		; \ size of decompressed
		STX.w $4335		; / GFX File
		LDA.b #%00001000	; \ start DMA
		STA.w $420B		; / transfer
		REP #%00100000		; 16-bit A
		PLY			; restore Y
		RTS

GetExGFXPtrs:	CMP.w #$0032		; \ < 32, use code
		BCC .GFX00to31		; / for GFX 00-31
		CMP.w #$0080		; \ still < 80,
		BCC .UploadReturn	; / return
		CMP.w #$0100		; \ > 100, use code
		BCS .ExGFX100toFFF	; / for 100-FFF
.GFX80toFF	AND.w #$007F		; reset most significant bit
		STA.b $8A		; \
		ASL A			;  | multiply by 3 using
		CLC			;  | shift-add method
		ADC.b $8A		; /
		TAY			; -> Y
		LDA.l $0FF94F		; \
		STA.b $06		;  | $0FF94F-$0FF950 contains the pointer
		LDA.l $0FF950		;  | for the ExGFX table for 80-FF
		STA.b $07		; /
		BRA .FinishDecomp	; branch to next step

.UploadReturn	CLC			; "return true"
		RTS

.GFX00to31	TAX			; ExGFX file -> X
		LDA.l $00B992,x		; \
		STA $8A			;  | copy ExGFX
		LDA.l $00B9C4,x		;  | pointer to
		STA $8B			;  | $8A-$8C
		LDA.l $00B9F6,x		;  |
		STA $8C			; /
		BRA .FinishDecomp2	; branch to next step

.ExGFX100toFFF	;SEC			; \ subtract #$100
		SBC.w #$0100		; / SEC commented out because the BCS that branches here would only branch if the carry flag were already set
		STA.b $8A		; \
		ASL A			;  | multiply result
		CLC			;  | by 3 to get
		ADC.b $8A		;  | index
		TAY			; /
		LDA.l $0FF873		; \
		STA.b $06		;  | $0FF873-$0FF875 contans the pointer
		LDA.l $0FF874		;  | for the ExGFX table for 100-FFF
		STA.b $07		; /
.FinishDecomp	LDA.b [$06],y		; \ Get low byte.
		STA.b $8A		; / and high byte
		INC.b $06		; Increase pointer position by 1.
		BNE .NoCrossBank	; \
		SEP #%00100000		;  | allow bank crossing
		INC $08			;  | (not sure if this is necessary here)
		REP #%00100000		; /
.NoCrossBank	LDA.b [$06],y		; \ Get the high byte (again)
		STA.b $8B		; / and bank byte.
.FinishDecomp2	SEC
		RTS


DrawMapName:
LDA $00
CMP #$FF
BNE StartDrawing
LDA $03
CLC
ADC #$08
STA $03
RTS
StartDrawing:
PHY
PHX
LDA $00
CMP #$AB
BEQ RunOneTime
CMP #$BB
BEQ Down
CMP #$AC
BEQ RunOneTime
CMP #$BC
BEQ Down


RunTwoTimes:
LDX #$01
BRA MapNameLoop

Down:
LDA $04
CLC
ADC #$08
STA $04

RunOneTime:
LDX #$00

MapNameLoop:
LDY $01					;Load OAM Index (initially 0)
LDA #!SubmapXPosition	;Load text's X position
CLC						;\Add currently
ADC $03					;/text's position
STA $0300,y				;And store this position
STZ $02					;Reset the bonus position
LDA #!SubmapYPosition	;Load text's Y position
CLC						;\Add currently
ADC $04					;/text's position
STA $0301,y				;Store it (it can be static since there's no changes)
LDA $00					;Load current tile
STA $0302,y				;And store the current tile
LDA #$02				;\This can be anything
STA $0303,y				;/

PHY
TYA
LSR A
LSR A
TAY
LDA #$00
STA $0460,y
PLY

INC $01					;\
INC $01					;|Next OAM
INC $01					;|Position
INC $01					;/

LDA $00		;\
CLC			;|Load the underneath tile
ADC #$10	;|
STA $00		;/

LDA $04
CLC
ADC #$08
STA $04

DEX
BPL MapNameLoop

STZ $02
STZ $02
STZ $04
LDA $03
CLC
ADC #$08
STA $03

PLX
PLY
RTS

Lives:
LDA !Lives
INC A
JSR HexToDec
INC A
INC A
INC A
INC A
INC A
INC A
STA $00
INX #6
STX $01

STZ $02

LDA $19
BEQ DrawThings
LDA $02
CLC
ADC #$04
STA $02

DrawThings:
LDX #$00
LDY #$00

TextLoop:
LDA XPos2,x
CLC
ADC #!TilesXPosition
STA $0200,y
LDA YPos2,x
CLC
ADC #!TilesYPosition
STA $0201,y
LDA Tilemap,x
CLC
ADC #$06
CMP #$16
BEQ JustStore
CLC
ADC $02
JustStore:
STA $0202,y
CPX #$04
BNE NormalPalette
LDA #$02
BRA StoreProperties
NormalPalette:
LDA #$00
StoreProperties:
STA $0203,y
INY #4
INX
CPX #$05
BCC TextLoop


DrawLives:
LDX #$00 ;Reset X
LivesLoop:
LDA XPos,x
CLC
ADC #!TilesXPosition
STA $0200,y

LDA #!TilesYPosition
STA $0201,y

LDA $00,x
STA $0202,y

LDA #$02
STA $0203,y

INY #4
INX
CPX #$02
BCC LivesLoop
RTS

Tilemap:
db $11,$12,$13,$14,$10
db $15,$16,$17,$18,$10
XPos:
db $38,$30
XPos2:
db $10,$18,$10,$18,$24
YPos2:
db $F8,$F8,$00,$00,$00


HexToDec:                                    ;HEX->DEC converter
                     LDX #$00                ;> Set X to 0
                     LDY #$00                ;> Set Y to 0
StartCompare1:
                     CMP #$64                ;\
                     BCC StartCompare2       ; |While A >= 100:
                     SBC #$64                ; |Decrease A by 100
                     INY                     ; |Increase Y by 1
                     BRA StartCompare1       ;/
StartCompare2:
                     CMP #$0A                ;\
                     BCC ReturnLong          ; |While A >= 10:
                     SBC #$0A                ; |Decrease A by 10
                     INX                     ; |Increase X by 1
                     BRA StartCompare2       ;/
ReturnLong:
                     RTS


					 
					 
PaletteDMA:
LDA $0DB3
BNE IsLuigi

IsMario:
LDX #$20
SetPalLoop:
CPX #$00
BEQ StartDMA
LDA PalBeg,x
STA $0803,x
DEX
LDA PalBeg,x
STA $0803,x
DEX
BRA SetPalLoop

IsLuigi:
LDX #$20
SetPalLoop2:
CPX #$00
BEQ StartDMA
LDA PalBeg2,x
STA $0803,x
DEX
LDA PalBeg2,x
STA $0803,x
DEX
BRA SetPalLoop2

StartDMA:
RTS

PalBeg:
incbin MarioPal.bin
PalEnd:

PalBeg2:
incbin LuigiPal.bin
PalEnd2:

!owram = $0E85           ; 4 bytes of free RAM

GetTransLevel:
	ldy #$00
	rep #$30
	ldx $0DD6
	lda $1F1F,x
	and #$000F
	sta !owram
	lda $1F21,x
	and #$000F
	asl
	asl
	asl
	asl
	sta !owram+2
	lda $1F1F,x
	and #$0010
	asl
	asl
	asl
	asl
	ora !owram
	sta !owram
	lda $1F21,x
	and #$0010
	asl
	asl
	asl
	asl
	asl
	ora !owram+2
	ora !owram
	tax
	lda $0DD6
	and #$00FF
	lsr
	lsr
	tay
	lda $1F11,y
	and #$000F
	beq .nosubmap
	txa
	clc
	adc #$0400
	tax

.nosubmap
	sep #$20
	lda $7ED000,x
	sta $13BF
	sep #$10

	rts


SpriteDMA:
REP #$20
LDA #$6060
STA $2116			;/Destination
SEP #$20

LDA.b #%00000001		;\(Byte load)  Transfer Mode:
STA.w $4350			;/(Word Store) Two registers, one byte per register (p, p+1)

LDA.b #$18			;\(Byte load)  DMA to VRAM Data Write regs
STA.w $4351			;/(Word Store) Low: 2118 High: 2119

REP #$20			;\	
LDA #FinishDMA_Graphics 	;|Since our table (probably)	
STA $4352		;|remains on the current bank
PHK 				;|We can just push the current bank
PLY 				;|and use it :3
STY $4354 		;/

LDA #$0340		;\How many bytes
STA $4355		;|to transfer (A GFX file)
SEP #$20			;/

LDA.b #%00100000	;\ start DMA
STA.w $420B		;/ transfer

REP #$20
LDA #$6800
STA $2116			;/Destination
SEP #$20

LDA $1425
BNE FinishDMA

LDA.b #%00000001		;\(Byte load)  Transfer Mode:
STA.w $4340			;/(Word Store) Two registers, one byte per register (p, p+1)

LDA.b #$18			;\(Byte load)  DMA to VRAM Data Write regs
STA.w $4341			;/(Word Store) Low: 2118 High: 2119

REP #$20			;\	
LDA #FinishDMA_Graphics2 	;|Since our table (probably)	
STA $4342		;|remains on the current bank
PHK 				;|We can just push the current bank
PLY 				;|and use it :3
STY $4344 		;/

LDA #$1000		;\How many bytes
STA $4345		;|to transfer (A GFX file)
SEP #$20			;/

LDA.b #%00010000	;\ start DMA
STA.w $420B		;/ transfer

FinishDMA:
RTS
	
	
.Graphics



incbin Numbers.bin

.Graphics2



incbin Letters.bin

MessagesSizePointer:



incsrc MessagesSizePointer.asm

Messages:



incsrc Messages.asm

MessagesPointer:



incsrc MessagesPointer.asm

PalettesPointer:


FontPalettePointer:
incbin FontPalette.pal


incsrc Palettes.asm

Ending:

print "Total bytes used: ", bytes