@xkas
HEADER
LOROM

;Tilemap defines
;Note that the tiles can be found in GFX28.bin!

!EmptyTopTri	= $3D		;Empty tile of triangle
!FillTopTri	= $60		;Filled tile of triangle
!EmptyBotTri	= $3E		;Empty tile of triangle
!FillBotTri	= $70		;Filled tile of triangle

!EmptyTLP	= $61		;Empty tile of P, left side
!EmptyTRP	= $62		;Empty tile of P, right side
!EmptyBLP	= $71		;Empty tile of P, left side
!EmptyBRP	= $72		;Empty tile of P, right side

!FillTLP	= $63		;Filled tile of P, left side
!FillTRP	= $64		;Filled tile of P, right side
!FillBLP	= $73		;Filled tile of P, left side
!FillBRP	= $74		;Filled tile of P, right side

;Misc defines

!Sound		= $19		;Sound effect to play when you are in full speed
				;v
!FreeSpace	= $108000	;POINT IT TO SOME FREE SPACE
				;^
ORG $8E1A
		JML.l Main	;Hijack routine
		NOP		;And point to new routine.

ORG !FreeSpace
db "STAR"
dw CodeEnd-Main-$01
dw CodeEnd-Main-$01^$FFFF

Main:
		PHD		;\
		LDA #$0F	; |
		XBA		; |Set direct page to $0F00
		LDA #$00	; |Just for the sake of halving the size of writes to statusbar
		TCD		;/

		LDA #!EmptyTopTri : STA $0000	;\Empty tile
		LDA #!EmptyBotTri : STA $0001   ;/
		LDX #!FillTopTri		;\Filled tile
		LDY #!FillBotTri		;/
		LDA $13E4	;\ Load current speed
		AND #$F0	; |Filter 1st digit
		LSR A		;\|
		LSR A		; |1st digit becomes 2nd digit
		LSR A		; |
		LSR A		;/
		BEQ None	;Empty triangles when the speed is null
		CMP #$01	;\
		BEQ First	;/Fill Triangle 1
		CMP #$02	;\
		BEQ Second	;/Fill Triangle 2
		CMP #$03	;\
		BEQ Third	;/Fill Triangle 3
		CMP #$04	;\
		BEQ Fourth	;/Fill Triangle 4
		CMP #$05	;\
		BEQ Fifth	;/Fill Triangle 5
		CMP #$06	;\
		BEQ Sixth	;/Fill Triangle 6
		CMP #$07	;\
		BEQ FullPower	;/Fill P sign

End:		PLD		;Recover direct page.
		LDA.w $1493	;\
		ORA.b $9D	; |Recover old code and jump back to original code
 		JML $008E1F	;/

None:
LDY $0000
LDX $0001
JSR Empty1	;...too lazy to comment them all. lets just say this controls the triangles
BRA End

First:
JSR Fill1
LDY $0000
LDX $0001
JSR Empty2
BRA End

Second:
JSR Fill2
LDY $0000
LDX $0001
JSR Empty3
BRA End

Third:
JSR Fill3
LDY $0000
LDX $0001
JSR Empty4
BRA End

Fourth:
JSR Fill4
LDY $0000
LDX $0001
JSR Empty5
BRA End

Fifth:
JSR Fill5
LDY $0000
LDX $0001
JSR Empty6
BRA End

Sixth:
JSR Fill6
LDY $0000
LDX $0001
JSR Empty7
BRA End

FullPower:	LDA $0014	;\ Due to direct page modification we use a word address.
		LSR A		; |
		LSR A		; |
		LSR A		; |
		LSR A		; |
		AND #$01	; |
		PHX		; |Prepare flashing ( P ) bbdepending on frame counter blah blah
		TAX		; |
		LDA TopTable,x	;\|
		STA $0F	
		LDA Table,x
		STA $2A		; |Store flashing tiles blah blah
		LDA TopTable2,x	; |
		STA $10		;/|
		LDA Table2,x	
		STA $2B
		PLX		;/

Continue:	LDA $0014	;\
		AND #$07	; |
		BNE +		; |Keep the sound playing
		LDA #!Sound	; |
		STA $1DF9	;/
		+
		JMP End 	        ;

Empty1:		STY $09		;\
		STX $24		; |
Empty2:		STY $0A		; |































		STX $25		; |
Empty3:		STY $0B		; |
		STX $26		; |
Empty4:		STY $0C		; |
		STX $27		; |Clear triangles and ( P )
Empty5:		STY $0D		; |
		STX $28		; |
Empty6:		STY $0E		; |
		STX $29		; |
Empty7: 	LDA #!EmptyTLP	; |
		STA $0F
		LDA #!EmptyBLP	; |
		STA $2A		; |
		LDA #!EmptyTRP	; |
		STA $10
		LDA #!EmptyBRP	; |
		STA $2B		;/
		RTS		;return

Fill6:		STX $0E		;\
		STY $29		; |
Fill5:		STX $0D		; |
		STY $28		; |
Fill4:		STX $0C		; |	
		STY $27		; |
Fill3:		STX $0B		; |
		STY $26		; |Fill triangles
Fill2:		STX $0A		; |
		STY $25		; |
Fill1:		STX $09		; |
		STY $24		;/
		RTS

;Tables for flashing ( P ) tiles

Table: db !EmptyBLP,!FillBLP
TopTable: db !EmptyTLP,!FillTLP
Table2: db !EmptyBRP,!FillBRP
TopTable2: db !EmptyTRP,!FillTRP

CodeEnd:		;Remove this and you screw up the RATS tag.

ORG $8CA9
db $3D,$3C,$3D,$3C,$3D,$3C,$3D,$3C	;Arrange the statusbar so the P-meter can fit in...
db $3D,$3C,$3D,$3C,$61,$3C,$62,$3C	;
db $FC,$3C,$2E,$3C			;

ORG $8CDF
db $3E,$3C,$3E,$3C,$3E,$3C,$3E,$3C	;Arrange the statusbar so the P-meter can fit in...
db $3E,$3C,$3E,$3C,$71,$3C,$72,$3C	;
db $FC,$3C,$2E,$3C			;