;########################################################################################
;
; P-Balloon landing patch by JackTheSpades
; 
; This one turned out much easier than I thought it would, so no credit necessary.
; With this patch, Mario will automaticly lose the P-balloon when he "lands" somewhere
; That is to say, touch the ground. It will genertate a puff of smoke and play a sound
;
; On that note, the sound effect uses bank $1DF9, same as the getting hurt sound. So,
; When you try to land on munchers or other hurt blocks, it won't play the "hurt" sound
; If you dislike this, you'll have to choose a different bank (and sound) for this patch
;
	!Sound	= $0F
	!Bank	= $1DF9
;
;########################################################################################

ORG $019FA1
	autoclean JML BalloonHijack

freecode
BalloonHijack:

	LDA $77		;\ Player blocked status
	AND #$04	;/ Bit 3 is the ground
	BEQ NotOnFloor	;  If the bit is clear, skip the code

	LDY #$03
Loop:
	LDA $17C0,y
	BNE Next
	LDA #$01	; \ Puff of smoke
	STA $17C0,y	; /
	LDA #$1B	; \ Time the smoke lasts
	STA $17CC,y	; /
	
	LDA $96		; \
	CLC : ADC #$08	;  |
	STA $17C4,y	;  | Position of the smoke (add half a block to Y position)
	LDA $94		;  |
	STA $17C8,y	; /
	BRA Done

Next:	DEY
	BPL Loop
Done:
	LDA #!Sound	;\
	STA !Bank	;/ sound effect

	;LDA #$30	;\
	;STA $1497	;/ hurt-invincibilety timer
	;
	; I tried to use that for better visual effect, like when getting hit while flying
	; for temporare invincibilety. Though you still get hurt when trying to land on munchers (or other hurt blocks)
	; if you don't mind, feel free to remove the semicolons in front of the two lines

	STZ $1891	;expire balloon
	JML $019FC4	;return

NotOnFloor:
	LDA $13		;\ Restore Code
	AND #$03	;/
	JML $019FA5	;Return to original routine