;;;;;;;;;;;;;;;;
header
lorom
;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;

org $0093D7
JSL Main      ; Overwrite some colours.
NOP           ; \ Useless bytes.
NOP           ;  | We don't need them.
NOP           ;  |
NOP           ;  |
NOP           ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;===================================================================================================
; DEFINES
;===================================================================================================

!BackdropColour = #$0000         ; Nintendo Presents BG Colour.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $37B000       ; POINT TO FREESPACE!!!!!!!!!!

!CodeSize = Ending-Main	; DON'T CHANGE NOR REMOVE.

db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Main:
LDA $0100         ; \ Check if game mode is 'Nintendo Presents'
BEQ OnlyNinPre    ; / If so, branch.

PHK			; Preserve program bank.
PER Return-1		; Push next return address.
PHB			; Preserve data bank.
LDA #$00		; \ A = #$00
PHA		        ;  | Transfer A...
PLB			; / ... to data bank.
PEA $84CD		; Push return address.
JML $00ABED		; Jump, long.

Return:
STZ $0701               ; \ BG = black.
STZ $0702               ; /
RTL                     ; Return

OnlyNinPre:
REP #$20                ; Accumulator = 16-bit.
LDX #$00                ; X = #$00

Loop:
LDA PaletteTable,x      ; \ Load RGB value.
STA $0803,x             ; / Store in slots of palette 8.
INX
INX
CPX #$20
BCC Loop
LDA !BackdropColour     ; \ Background colour...
STA $0701               ; / ... on 'Nintendo Presents'.
SEP #$20
RTL                     ; Return

PaletteTable:
dw $FFFF      ;  Colour 0
dw $FFFF      ;  Colour 1
dw $FFFF      ;  Colour 2
dw $FFFF      ;  Colour 3
dw $FFFF      ;  Colour 4
dw $FFFF      ;  Colour 5
dw $FFFF      ;  Colour 6
dw $FFFF      ;  Colour 7
dw $FFFF      ;  Colour 8
dw $FFFF      ;  Colour 9
dw $FFFF      ;  Colour A
dw $FFFF      ;  Colour B
dw $FFFF      ;  Colour C
dw $FFFF      ;  Colour D
dw $FFFF      ;  Colour E
dw $FFFF      ;  Colour F

Ending: