; Ram Palette upload
; HuFlungDu
; Basically, this uploads the RAM at $0703 to CGRAM whenever the RAM address is set. 
; The positive upshot
; of this is that you can use that RAM to update the palette at any point outside
; a blank, without using DMA (Which a lot of people don't understand). Make sure any edit
; you make to the table at 0703 is mirrored in 0905, otherwise the colors won't fade
; correctly at the level end.
; No credit necessary

!Freespace = $138000
!FreeRAM = $7FA000

header
lorom

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro
org $008176
JSL PalUpload         ;| and jump to our code
NOP                     ;/ also NOP one time.
NOP

org !Freespace
%RATS_start(0)
PalUpload:
LDA $1493				;\Trust me, you don't want to uplad colors during the fadeout
BNE +					;/routine, you won't like what happens.
LDA !FreeRAM			;\Comment out these lines if you want it to upload every frame
BEQ +					;/
REP #$20
LDY #$00                ;\Set Address for CG-RAM Write to 00
STY $2121               ;/Address for CG-RAM Write
LDA #$2200              ;\One register write once, to 2122
STA $4320               ;/
LDA #$0703				;\Address of palette to upload
STA $4322               ;/ 
LDY.b #$7E				;\Bank to grab palette from
STY $4324               ;/ 
LDA #$0200              ;\Upload the whole palette, 200 bytes
STA $4325               ;/
LDX #$04				;\Start DMA
STX $420B				;/
SEP #$20	
+
LDA #$00				;\Comment these two lines out if you don't 
STA !FreeRAM			;/want the FreeRAM to reset every frame
LDA $4210               ;\Restore code
LDA $1DFB               ;/
RTL
%RATS_end(0)