;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Welcome to the renovated Parallel Worlds Patch

;;No more getting confused about the separate .ips patch and some other random things!

;;All you need to do to patch this is, in cmd, type: xkas parallelworldsfix.asm romname.smc

;;This patch now includes altogether...

;;The dissassembly of levelnum.ips - This basically stores the level number to the stack.

;;RolloverFix.asm by Noobish Noobsicle, fixes the fact that if you enter a door or pipe about 256 times you'll end up in the first sublevel you entered on the ow. With the time travel ability this is sort of more likely to happen??

;;Deflakator's other patch, SRAM expand and save. The patch as I integrated it into this one currently expands your SRAM size to #$03. It will start saving things to 708000 just so you know, since it might be important for some ASM hackers.

;;The patch currently saves to the SRAM... well just CTRL + F search for the table "Tablezorz" in this patch.

;;Just so you know, saving to the SRAM means, if you start the game and collect 50 lives then reset, when you play again you'll start at the default 5 lives again. With the SRAM expand patch, it will save that 50 lives among other things and it even has it separate for the three different save files possible in the game.

;;Many bugfixes with the time travel ability

;;Including...

;;When the special world is passed, red koopas become blue koopas and green koopas become yellow koopas. Nintendo did this to vary up the game or something.

;;You could time travel when the game was paused and that was odd.

;;Only glitch that I am unable to fix - If you teleport enough times, the background can move downwards some how and even show some of the garbage layers.

;;But I think you are less likely to run into that problem as long as your levels actually do correspond correctly enough.

;;And the flag for whether or not this ability is unlocked is saved to SRAM

;;Only side effect I guess is that the ASM code is sort of alot messier than it may have been before so if you want to learn anything from this good luck.

;;Credit Deflakator for the SRAM expand and Parallel Worlds part of the patch, he is the one who made this.

;;All I did was fix it up. (If you want to credit me you can though)

;;Also credit Noobish Noobsicle for the Rollover Fix patch

;;Another note from Chdata - This is my very first submission to Super Mario World Central!!!

;;This patch was intended to be patched to a clean ROM, but now it should be ok as long as you patch it to free space correctly.

;;Be sure that your ROM has been edited with Lunar Magic, in a level and the OverWorld

;;AND MAKE A BACK UP BEFORE PATCHING THIS!!!

;the following is an SNES lorom address (or lorom offset as slogger says)
!FREESPACE = $168000	;change to a free space address OR ELSE YOU WILL SCREW UP AND DATA DIE MESS UP WRONG NO!!!
			;Technically if your ROM is clean except for being edited by Lunar Magic in a level and OW you'll be fine.

header
lorom

;--------------------------
;---------defines----------
;--------------------------

;These are ram adresses

!FreeRAM  = $010B       ;I think this is the ram address of the stack. Not sure if you should ever change this.
;!AnotherRAM = $06B0	;only uncomment if using MarioExgfx.asm by Roy
!SRAMSize = #$03	;SRAM Size amount of bytes = 2048*decimal value (game default: #$01) - This is for the SRAM expand patch I added in
!ACTIVATE = $06F0	;set to 1 to activate time travel
!TEST     = $06F1	;internal ram
!MarioX   = $06F2	;saves current Mario X pos
!MarioY   = $06F4	;saves current Mario Y pos
!YScreen  = $06F6	;saves the Y pos of the screen
!Layer2Y  = $06F7	;saves the background Y pos
!IngmKey  = #$20	;button to warp between worlds ingame (currently "select")
			;01=Right, 02=Left, 04=Down, 08=Up, 10=Start, 20=Select, 40=Y and X, 80=B and A

;--------------------------
;---------replaces---------
;--------------------------

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RolloverFix.asm by Noobish Noobsicle.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ORG $00D273
JSL PipeFix
NOP

ORG $01A64B
JSL ShellFix

ORG $01AB4E
JSL BounceFix

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Levelnum.ips disassembly from levelASM added by chdata
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ORG $05D8B9
	JSR Levelnummain

ORG $05DC46
Levelnummain:	LDA $0E  		;Load level number
		STA !FreeRAM		;Store it in free stack RAM
		ASL A    		;Multiply A by 2, probably to recover old code?
               ;STZ !AnotherRAM		;only uncomment if using MarioExgfx.asm by Roy
		RTS      		;Return from subroutine

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SRAM Expand v1.0
;made by Deflaktor, added by Chdata - includes saving whether or not you have the time travel ability unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;this asm hack uses up 146 bytes of data, plus 2 bytes for every ram you want to save to the sram
;in this case it saves 24 ram adresses so it uses up 146+24*2 = 194 bytes
;I (Chdata) have no idea why he wanted us to know that

org $FFD8
	db !SRAMSize	

org $9BCC		;Save Game Routine
	JSL SaveGames
	NOP #2

org $9E5C		;Load Game Routine (executed when 1 or 2 player is chosen)
	JSL LoadGames
	NOP #2
;--------------------------
;---------overworld--------
;--------------------------

org $049AA5
JSL MainOW
NOP #2

org $049136
db $F0,$09
JSL Control
NOP #3

org $04850F
JSL Control2
db $F0,$25

org $04854D
JSL Warpx
NOP #6

org $04855A
JSL Warpy
NOP #6

org $05DCE7
JSL LvlPlus
NOP

;--------------------------
;----------ingame----------
;--------------------------

org $00A21B
JSL Main2

org $05D9FA
JSL LoadCord

org $02A98B  ;by chdata.
db $00       ;these fix red koopas becoming blue and another turning yellow
org $02A98F  ;the org tells the patch where to make a hex edit
db $00       ;the db $00 hex edits the value defined at the org (SNES address) 
org $02A991  ;from whatever it is to 00
db $01       ;look in the rom map for 12B8B to understand this better
org $02A995  ;the hex edit basically causes x sprite to turn into x sprite when the special world is passed
db $01       ;and since the values are the same it changes into itself

;--------------------------
;----overworld routines----
;--------------------------

org !FREESPACE              ;the SNES adress the code will be inserted to
db "STAR"
dw FREEEND-FREESTART
dw FREEEND-FREESTART^#$FFFF
FREESTART:
MainOW:   PHA            ;save stack
          SEP #$20
          LDA !TEST      ;adress to work with
          CMP #$EE
          BNE Normal
          LDA $1EEB
          CMP #$80
          BEQ Change
          LDA #$80
          STA $1EEB
          REP #$20
          PLA
          AND #$00FF
          BRA Init2

Normal:   REP #$20
          PLA            ;load stack
          STA $1F11,x    ;the replaced action
          AND #$00FF
          BRA Init2

Change:   LDA #$00
          STA $1EEB
          REP #$20
          PLA
          AND #$00FF
          BRA Init2

Init2:    SEP #$20
          STZ !TEST
          REP #$20
          RTL

Warpx:    PHA
          SEP #$20
          LDA !TEST
          CMP #$EE
          REP #$20
          BNE Warpnox
          PLA
          LDA $C2,x
          STA $1F17,x
          STZ $C2,x
          BRA Warpxend

Warpnox:  PLA
          STA $1F17,x
Warpxend: LSR a
          LSR a
          LSR a
          LSR a
          STA $1F1F,x
          RTL

Warpy:    PHA
          SEP #$20
          LDA !TEST
          CMP #$EE
          REP #$20
          BNE Warpnoy
          PLA
          LDA $C4,x
          STA $1F19,x
          STZ $C4,x
          BRA Warpyend

Warpnoy:  PLA
          STA $1F19,x
Warpyend: LSR a
          LSR a
          LSR a
          LSR a
          STA $1F21,x
          RTL

Control:  LDA !ACTIVATE
          CMP #$00
          BEQ ReturnC
          LDA $0DB3
          ASL
          ASL
          ASL
          TAX
          REP #$20
          LDA $1F17,x
          STA $C2,x
          LDA $1F19,x
          STA $C4,x
          SEP #$20
          LDA #$EE
          STA !TEST
          CMP #$EE
          RTL

ReturnC:  LDA #$00
          CMP #$01
          RTL

Control2: STA $01
          STZ $00   ;replaced actions
          LDA !TEST
          CMP #$EE
          BEQ ReturnC2
          REP #$20
ReturnC2: RTL

LvlPlus:  PHA
          LDA $1EEB
          CMP #$80
          BNE ReturnL
          PLA
          INC            ;increase lvl number
          BRA ReturnL2
ReturnL:  PLA
ReturnL2: STA $14BB      ;replaced actions
          STA $0E        ;replaced actions
          RTL

;--------------------------
;-----ingame routines------
;--------------------------

Main2:    LDA !ACTIVATE ;if time travel ability
          CMP #$01
          BNE ReturnM2  ;else return
          LDA $72       ;if Mario is on ground
          BNE ReturnM2  ;else return
          LDA $71       ;if Mario doing nothing
          BNE ReturnM2  ;else return
          LDA $1493     ;if level is not finishing
          BNE ReturnM2  ;else return
	  LDA $13D4     ;by chdata. Prevents teleport if paused.
	  BNE ReturnM2  ;the patch didn't have this before and you could teleport during the pause which just didn't really make sense
          LDA $16
          AND !IngmKey
          CMP !IngmKey
          BNE ReturnM2  ;if button not pressed, return
          BRA Start
ReturnM2: LDA $16       ;replaced actions
          AND #$10      ;replaced actions
          RTL		;return
Start:    LDA $5B       ;if level vertical
	  BEQ Horz
	  LDX $97       ;load mario y pos
	  BRA Setup     ;else
Horz:     LDX $95       ;load mario X pos
Setup:    LDA $1EEB
          CMP #$00      ;if NOT special world
          BNE NoInc
          LDA #$80
          STA $1EEB     ;make special world
          REP #$20      ;let A go 16 bit
          LDA $010B     ;load lvl number
          INC           ;increase lvl number
          BRA GoOn      ;Go on
NoInc:    STZ $1EEB     ;make normal world
          REP #$20      ;let A go 16 bit
          LDA $010B     ;load lvl number
          DEC           ;decrease lvl number
GoOn:     PHA           ;push 16 bit A into stack
          SEP #$20      ;let A go 8 bit
          PLA           ;get high byte from stack
          STA $19B8,x   ;write exit table
          PLA           ;get low byte from stack
          ORA #$04      ;exit present
	  PHA
          LDA $85       ;load water lvl flag
          LSR
          LSR
          LSR
          STA !TEST     ;store into unused ram
          PLA
          ORA !TEST     ;water lvl flag
	  STA $19D8,x	;write high bit and properties
          REP #$20
          LDA $94       ;remember Mario X Pos
          STA !MarioX   ;remember Mario X Pos
          LDA $96       ;remember Mario Y Pos
          STA !MarioY   ;remember Mario Y Pos
          SEP #$20
          LDA $1C       ;remember Screen Y Pos
          STA !YScreen  ;remember Screen Y Pos
          LDA $20       ;remember Layer2 Y Pos
          STA !Layer2Y  ;remember Layer2 Y Pos
          LDA #$0D      ;play sound effect
          STA $1DF9
          LDA #$06      ;teleport
	  STA $71
          STA !TEST
	  STZ $89
	  STZ $88
          LDA $16       ;replaced actions
          AND #$10      ;replaced actions
          RTL		;return

LoadCord: LDA !TEST
          CMP #$06
          BNE RetLoad
          REP #$20
          LDA !MarioX
          STA $94
          LDA !MarioY
          STA $96
          SEP #$20
          LDA !YScreen
          STA $1C
          LDA !Layer2Y
          STA $20
          STZ !TEST
          LDA $01
          RTL
RetLoad:  LDA $01
          STA $95
          RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;RolloverFix.asm stuff here				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PipeFix:
LDA $141A
INC
BPL PipeEnd
LDA #$70
PipeEnd:
STA $141A
LDA #$0F
RTL

BounceFix:
PHA
LDA $1697
INC
BPL BounceEnd
LDA #$70
BounceEnd:
STA $1697
PLY
RTL

ShellFix:
LDA $1626,y
INC
BPL ShellEnd
LDA #$70
ShellEnd:
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SRAM expand stuff here				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
db "SRAMExpandRoutines"
SaveGames:	PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		SEP #$40			; a set overflow flag means we are Saving
		BRA Mainthing

LoadGames: 	STZ $0DD5			;\ replaced opcodes from the LoadGame jump
		STZ $0DB3			;/
		PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		REP #$40			; a cleared overflow flag means we are Loading

		;<< SaveGame & LoadGame code start here >>

Mainthing:	REP #$30			; let A,X and Y go 16 bit, since we deal with large numbers > FF
		LDA $010A			; load current save file # (use LDA #$04 to access fourth part of the expanded sram)
		AND #$00FF			; mask high bits to take care of the garbage
		ASL #!SRAMSize-1+8		; since we have got 3 files, we give every file a fourth of the expanded sram leaving another fourth free
		TAX				; transfer the offset to X
		SEP #$20			; let A go back to 8 bit

		BVC LoadCheck2			; if overflow is clear -> Loading

SaveCheck2:	LDA #$01			;\ write #$01 into the first byte of the expanded ram since everything stored there are FF
		STA $700800,x			;/ 
		BRA Checked2

LoadCheck2:	LDA $700800,x			;\ we need to check the first ram of our expanded area since everything stored there are FF
		CMP #$01			;/ the byte must be 01
		BNE Returner			; Return if the byte isn't 01

Checked2:	INX				; increment x
		LDY #$0000			; store 0 into the index for our Loop

Loopy:		PHX
		TYX
		LDA Tablezorz,x			; load the ram pointer from the Table (low byte)
		STA $00				; store it to a temp ram
		INX
		LDA Tablezorz,x			; load the ram pointer from the Table (high byte)
		STA $01				; store it to a temp ram
		TXY
		PLX
		BVC Loading2			; if Carry is clear -> Loading

Saving2:	LDA ($00)			; load the ram content form the Table
		STA $700800,x			; and save it
		BRA GoOn2

Loading2:	LDA $700800,x			; load the ram from the SRAM
		STA ($00)			; store it to the pointer of the temp ram

GoOn2:		INX				; next ram
		INY				; increase index of the Loopy
		CPY.w #CodeEnd-Tablezorz	; have we reached the end of our Table?
		BNE Loopy			; Loop if we haven't

		;<< SaveGame & LoadGame code end here >>

Returner:	BVC GetBackss			; if we are Loading, we mustn't to execute the replaced opcodes

		PLP
		PLY
		PLX
		PLA

		LDX $010A			;\ replaced opcodes from the SaveGame jump
		LDA $9CCB,x			;/
		RTL

GetBackss:	PLP
		PLY
		PLX
		PLA
		RTL

; >>>>>>>>> here you can define which ram adresses should be saved <<<<<<<<<
Tablezorz:	
	dw	#$0DB4		; marios lives
	dw	#$0DB5		; luigis lives
	dw	#$0DB6		; marios coins
	dw	#$0DB7		; luigis coins
	dw	#$0DB8		; marios powerup
	dw	#$0DB9		; luigis powerup
	dw	#$0019		; current players powerup
	dw	#$0DB3		; current player
	dw 	#$0DBE		; current players lives
	dw	#$0DBF		; current players coins
	dw	#$0DC2		; current players item box
	dw	#$0DBA		; marios yoshi (color)
	dw	#$0DBB		; luigis yoshi (color)
	dw	#$0DBC		; marios item box
	dw	#$0DBD		; luigis item box
	dw	#$0F34		; 1st ram for marios score
	dw	#$0F35		; 2nd ram for marios score
	dw	#$0F36		; 3rd ram for marios score
	dw	#$0F37		; 1st ram for luigis score
	dw	#$0F38		; 2nd ram for luigis score
	dw	#$0F39		; 3rd ram for luigis score
	dw	#$0F48		; marios bonus stars
	dw	#$0F49		; luigis bonus stars
	dw	#!ACTIVATE	; FREERAM flag for Parallelworlds.asm		;add more stuff following this format if you're a good enough ASM hacker for this
CodeEnd:
FREEEND:
print "I'm psychic, I knew that you would patch this."