
;-----------
;SM64 HP Bar
;-----------

!Freespace = $268000		;/ Freespace.
!Health = $0DC4			;\ RAM for main health bar.
!CoinRAM = $0DC5		;/ RAM for figuring out # of coins collected.
!Mush = $02			;\ How much health a mushroom heals.
!Timer = $FF			;/ Time to stay in water before losing a segment. $FF = 4.5 seconds.
!WaterSound = $01		;\ Sound to play when the above happens.
!Coins = $05			;/ Coins needed to heal one segment.
!UpgradeSFX = $23		;\ Sound to play when a segment is healed.
!Dmg = $7F8611			;/ Used by sprites to determine how much health to take away from Mario.

!knockSpeed1 = $40
!knockSpeed2 = $C0

;These don't need to be changed.
!Palette = $1F			; Palette. Either make it this or $1E
!BlueHigh = $AB	
!BlueLow = $7A
!GreenHigh = $26
!GreenLow = $13
!YellowHigh = $9F
!YellowLow = $07
!RedHigh = $7F
!RedLow = $2D

Header
LoROM

org $8C81			
db $5C,$3C,$5D,$3C,$5E,$3C,$5F,$3C	; Modify the top row of the status bar
org $8CA1
db $3F,$3C,$3F,$3C,$3F,$3C,$3D,$3C	; Modify the second row of the status bar
org $8CD7
db $3E,$3C,$FC,$3C,$FC,$3C,$3C,$3C	; Modify the third row of the status bar
org $8CF7
db $6C,$3C,$6D,$3C,$6E,$3C,$6F,$3C	; Modify the bottom row of the status bar
;----------------
org $01C545
NOP #3					; Disable item box.
org $01C524
db $00,$00,$00,$00			; Re-arrange item-handling.
org $F5D5
JML Hit
org $F60A
JML SubDead
org $01C561
JML Mushroom
org $008F25
JSL Coin
NOP #2
org $8F7E
JSL Tilemaps
org $9E2C
JSL GameLoad
NOP #2
org $F2E0
JML Midway
NOP #4
org $0491DB
JML Level
NOP
org $02A4AE
JSL ExSprite
org !Freespace	
!CodeSize = Ending-Routine 	
db "STAR"			
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
Routine:
;----------------
;New Coin Routine
;----------------
Coin:
	JSL GetCoin
	LDA !Health
	CMP #$08			; If health > 8..
	BCS NoInc			; There's no need to do the below code.
	LDA !CoinRAM
	INC				; This tells us if we've gotten enough coins..
	CMP #!Coins			; .. to heal a segment.
	BEQ Inc
	STA !CoinRAM
NoInc:
	LDA $0DBF
	INC $0DBF			; Part of the hacked code
	RTL
Inc:
	LDA #!UpgradeSFX
	STA $1DFC			; Play the defined sound effect..
	INC !Health			; ... increment a segment..
	STZ !CoinRAM			; ... and reset the coin checking RAM
	BRA NoInc
GetCoin:
	LDA $7EC109
	INC A
	STA $7EC109
	RTL
;---------------
;Level Load
;---------------
Level:
	LDA !Health			; If health != 0..
	BNE NoRefill			; ... just end
	LDA #$08
	STA !Health			; Refill health..
NoRefill:
	LDA #$02
	STA $0DB1			; And return. (hacked code)
	JML $0491E0
;---------------
;Midway Heal
;---------------
Midway:
	LDA !Health
	CMP #$08			; If health != 8..
	BEQ .Skip
	INC				; + 1 to it ...
	STA !Health
	LDA $19
	BNE .Skip			; And make Mario big if needed.
	INC
	STA $19
	.Skip
	JML $00F2E8
;---------------
;Mushroom Routine
;---------------
Mushroom:
	LDA !Health
	CMP #$07			; If health >= 7, just set health to 8.
	BCS Return
	CLC				; Else, add the defined # of segments.
	ADC #!Mush
	BRA Set
Return:
	LDA #$08
Set:
	STA !Health
	JML $01C565
;---------------
;New Game Routine
;---------------
GameLoad:
	STA $0DBE
	STZ $0DBF
	LDA #$08			; Health is initially full on game load.
	STA !Health
	RTL
;--------------
;In-Water Code
;--------------
Water:
	LDA $75	
	BEQ Skip			; If you're not in water, return (obviously).
	LDA !Health
	BEQ Death
	LDA $13
	AND #!Timer
	BNE Skip
	DEC !Health			; Decrement a segment every #$FF frames.
	LDA #!WaterSound		; ... and play a sound effect, too.
	STA $1DFC
Skip:
	RTL
Death:
	STZ $19				; Kill Mario if he's been in water for too long.
	JSL $00F5B7			; I.e., if HP = 0.
EndOpcode:
	RTL
;---------------
;Tilemaps Routine
;---------------
Tiles0F06:
	db $4A,$4B,$4C,$4C,$4C,$4C,$4C,$4C,$4C
Tiles0F07:
	db $3A,$3A,$3A,$3A,$3A,$3A,$3A,$3B,$4D
Tiles0F22:
	db $38,$38,$38,$38,$38,$39,$4F,$4F,$4F
Tiles0F21:
	db $36,$36,$36,$37,$4E,$4E,$4E,$4E,$4E
;-----------------
;Status Bar Hijack
;-----------------
Tilemaps:
	STA $0F14		;/ Part of the hacked code.
	STX $0F13		;\
	LDA $19
	BEQ MakeBig		; Mario's always big (unless he's fiery or caped).
	BNE NoWater
MakeBig:
	LDA #$01
	STA $19
NoWater:
	JSL Water
	LDX !Health
	LDA Tiles0F06,x		; Tiles drawn are indexed by health.
	STA $0F06		; They're drawn to $0F06,$0F07,$0F21 and $0F22.
	LDA Tiles0F07,x
	STA $0F07
	LDA Tiles0F21,x		
	STA $0F21
	LDA Tiles0F22,x
	STA $0F22
;-------------
;Color Routine
;-------------
	LDA $0D9B		; Colors code don't get executed on the title screen.
	BNE NoColor
	LDY #!Palette		; Get the high byte into $2121.
	STY $2121		
	TXA			; Health -> A.
	ASL			; Use a pointer to indicate color.
	TAX
	JSR (ColorPtr,x)
NoColor:
	RTL
;---------------
;Health Bar Colors
;---------------
ColorPtr:
	dw Red, Red, Red, Yellow, Yellow, Green, Green, Blue, Blue
;	00	01   02   03      04      05     06     07    08
Red:
	LDA #!RedHigh
	STA $2122
	LDA #!RedLow
	STA $2122
	RTS
Blue:	
	LDA #!BlueHigh	
	STA $2122 	
	LDA #!BlueLow
	STA $2122
	RTS
Green:
	LDA #!GreenHigh 
	STA $2122 	
	LDA #!GreenLow
	STA $2122
	RTS
Yellow:
	LDA #!YellowHigh 
	STA $2122 	
	LDA #!YellowLow
	STA $2122
	RTS
;-----------------
;Extended Sprite Damage
;-----------------
ExSprite:
	LDA !Health
	BEQ SubDead
	BMI SubDead
	LDA $1497
	BNE EndEx
	DEC $0DC4
	LDA #$04
	STA $1DF9
	LDA #$01
	STA $71
	STA $1497
	LDA #$2A
	STA $9D
	STA $1496
EndEx:
	RTL
;-----------------
;Hit/Death Routine
;-----------------
Hit:
	JMP New
Hit2:
	PHB
	PHK			; Always change the current data bank.
	PLB
	LDA $7FAB10,x
	AND #$08		; Check to see if the sprite's custom..
	BEQ NotCustom		; .. if bit 3 of $7FAB10 set, it is.
	LDA $7FAB9E,x
	TAY			; Current sprite -> Y.
	LDA CustSprList,y
	BRA StoreSprDmg		; Get HP to decrement into $7F8611...
NotCustom:
	LDY $9E,x	
	LDA NormSprList,y
StoreSprDmg:
	STA !Dmg
	LDA !Dmg
	BEQ NoSpr	
	LDA !Health
	SEC
	SBC !Dmg
	BRA SprSet
NoSpr:
	LDA !Health
	DEC
SprSet:
	STA !Health
	PLB
	LDA !Health		;/
	BEQ SubDeath		;\ Sprite kills Mario ...
	BMI SubDeath		;/ If his HP = 0, and negative.
	JML $00F5F3

SubDeath:
	STZ $19
	STZ !Health
SubDead:
	LDA #$09
	STA $1DFB
	JML $00F60F

New:
	LDA !Health		;\
	BEQ SubDead		;|If low health, Die
	BMI SubDead		;/

    LDA #!knockSpeed2
    STA $7D
    
    LDA $76
    BNE Other
    
    LDA #!knockSpeed1
    STA $7B
BRA Hit2

Other:
    LDA #!knockSpeed2
    STA $7B
    JMP Hit2

SprReturn:
	RTL

CustSprList:
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 00
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 10
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 20
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 30
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 40
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 50
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 60
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 70
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 80
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; 90
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; A0
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; B0

NormSprList: 
.00_Green_Koopa_no_shell
    db $01
.01_Red_Koopa_no_shell
    db $01
.02_Blue_Koopa_no_shell
    db $01
.03_Yellow_Koopa_no_shell
    db $01
.04_Green_Koopa
    db $02
.05_Red_Koopa
    db $02
.06_Blue_Koopa
    db $02
.07_Yellow_Koopa
    db $02
.08_Green_Koopa_flying_left
    db $02
.09_Green_bouncing_Koopa
    db $02
.0A_Red_vertical_flying_Koopa
    db $02
.0B_Red_horizontal_flying_Koopa:
    db $02
.0C_Yellow_Koopa_with_wings:
    db $02
.0D_Bob-omb
    db $03
.0E_Keyhole
    db $00					; Keyhole doesn't do damage, but it still has to be here..
.0F_Goomba					; Same goes for other non-damage sprites, like the platforms.
    db $01
.10_Bouncing_Goomba_with_wings
    db $01
.11_Buzzy_Beetle
    db $02
.12_Unused
    db $01					; LEAVE THIS!
.13_Spiny
    db $02
.14_Spiny_falling
    db $02
.15_Fish,_horizontal
    db $01
.16_Fish,_vertical
    db $01
.17_Fish,_created_from_generator
    db $01
.18_Surface_jumping_fish
    db $01
.19_Display_text_from_level_Message_Box_#1
    db $00					; Doesn't take any damage.
.1A_Classic_Piranha_Plant
    db $01
.1B_Bouncing_football_in_place
    db $02
.1C_Bullet_Bill
    db $02
.1D_Hopping_flame
    db $02
.1E_Lakitu
    db $02
.1F_Magikoopa
    db $03
.20_Magikoopa's_magic
    db $03
.21_Moving_coin
    db $00					; Doesn't take any damage.
.22_Green_vertical_net_Koopa
    db $02
.23_Red_vertical_net_Koopa
    db $02
.24_Green_horizontal_net_Koopa
    db $02
.25_Red_horizontal_net_Koopa
    db $02
.26_Thwomp
    db $04
.27_Thwimp
    db $03
.28_Big_Boo
    db $00					; Big Boo doesn't hurt Mario.
.29_Koopa_Kid
    db $04					; These are shared by all Koopalings (Lemmy, Wendy, Morton, Roy, etc.)
.2A_Upside_down_Piranha_Plant
    db $01
.2B_Sumo_Brother's_fire_lightning
    db $03
.2C_Yoshi_egg
    db $00					; Doesn't take any damage.
.2D_Baby_green_Yoshi
    db $00					; Doesn't take any damage.
.2E_Spike_Top
    db $02
.2F_Portable_spring_board
    db $00					; Doesn't take any damage.
.30_Dry_Bones,_throws_bones
    db $02
.31_Bony_Beetle
    db $02
.32_Dry_Bones,_stay_on_ledge
    db $02
.33_Fireball
    db $03					; Vertical fireball as seen in castles.
.34_Boss_fireball
    db $04
.35_Green_Yoshi
    db $00					; Doesn't take any damage.
.36_Unused
    db $01					; DO NOT USE!
.37_Boo
    db $02
.38_Eerie
    db $02
.39_Eerie,_wave_motion
    db $02
.3A_Urchin,_fixed
    db $03
.3B_Urchin,_wall_detect
    db $03
.3C_Urchin,_wall_follow
    db $03
.3D_Rip_Van_Fish
    db $02
.3E_POW
    db $00					; Doesn't take any damage.
.3F_Para-Goomba
    db $02
.40_Para-Bomb
    db $02
.41_Dolphin,_horizontal
    db $00					; Doesn't take any damage.
.42_Dolphin2,_horizontal
    db $00					; Doesn't take any damage.
.43_Dolphin,_vertical
    db $00					; Doesn't take any damage.
.44_Torpedo_Ted
    db $03
.45_Directional_coins
    db $00					; Doesn't take any damage.
.46_Diggin'_Chuck
    db $03
.47_Swimming/Jumping_fish
    db $01
.48_Diggin'_Chuck's_rock
    db $03
.49_Growing/shrinking_pipe_end
    db $00					; Doesn't take any damage.
.4A_Goal_Point_Question_Sphere
    db $01
.4B_Pipe_dwelling_Lakitu
    db $01
.4C_Exploding_Block
    db $02
.4D_Ground_dwelling_Monty_Mole
    db $02
.4E_Ledge_dwelling_Monty_Mole
    db $02
.4F_Jumping_Piranha_Plant
    db $01
.50_Jumping_Piranha_Plant,_spit_fire
    db $03
.51_Ninji
    db $03
.52_Moving_ledge_hole_in_ghost_house
    db $00					; Doesn't take any damage.
.53_Throw_block_sprite
    db $00					; Doesn't take any damage.
.54_Climbing_net_door
    db $00					; Doesn't take any damage.
.55_Checkerboard_platform,_horizontal
    db $00					; Doesn't take any damage.
.56_Flying_rock_platform,_horizontal
    db $00					; Doesn't take any damage.
.57_Checkerboard_platform,_vertical
    db $00					; Doesn't take any damage.
.58_Flying_rock_platform,_vertical
    db $00					; Doesn't take any damage.
.59_Turn_block_bridge,_horizontal_and_vertical
    db $00					; Doesn't take any damage.
.5A_Turn_block_bridge,_horizontal
    db $00					; Doesn't take any damage.
.5B_Brown_platform_floating_in_water
    db $00					; Doesn't take any damage.
.5C_Checkerboard_platform_that_falls
    db $00					; Doesn't take any damage.
.5D_Orange_platform_floating_in_water
    db $00					; Doesn't take any damage.
.5E_Orange_platform,_goes_on_forever
    db $00					; Doesn't take any damage.
.5F_Brown_platform_on_a_chain
    db $00					; Doesn't take any damage.
.60_Flat_green_switch_palace_switch
    db $00					; Doesn't take any damage.
.61_Floating_skulls
    db $00					; Doesn't take any damage.
.62_Brown_platform,_line-guided
    db $00					; Doesn't take any damage.
.63_Checker/brown_platform,_line-guided
    db $00					; Doesn't take any damage.
.64_Rope_mechanism,_line-guided
    db $00					; Doesn't take any damage.
.65_Chainsaw,_line-guided
    db $03
.66_Upside_down_chainsaw,_line-guided
    db $03
.67_Grinder,_line-guided
    db $03
.68_Fuzz_ball,_line-guided
    db $02
.69_Unused					; DO NOT USE!
    db $01
.6A_Coin_game_cloud
    db $00					; Doesn't take any damage.
.6B_Spring_board,_left_wall
    db $00					; Doesn't take any damage.
.6C_Spring_board,_right_wall
    db $00					; Doesn't take any damage.
.6D_Invisible_solid_block
    db $00					; Doesn't take any damage.
.6E_Dino_Rhino
    db $03
.6F_Dino_Torch
    db $02
.70_Pokey
    db $03
.71_Super_Koopa,_red_cape
    db $02
.72_Super_Koopa,_yellow_cape
    db $02
.73_Super_Koopa,_feather
    db $02
.74_Mushroom
    db $00					; lol why'd you want mushrooms you hurt you!?
.75_Flower
    db $00
.76_Star
    db $00
.77_Feather
    db $00
.78_1-Up
    db $00
.79_Growing_Vine
    db $00					; Doesn't take any damage.
.7A_Firework
    db $00					; Doesn't take any damage.
.7B_Goal_Point
    db $00					; Doesn't take any damage.
.7C_Princess_Peach
    db $00					; Doesn't take any damage.
.7D_Balloon
    db $00					; Doesn't take any damage.
.7E_Flying_Red_coin
    db $00					; Doesn't take any damage.
.7F_Flying_yellow_1-Up
    db $00					; Doesn't take any damage.
.80_Key
    db $00					; Doesn't take any damage.
.81_Changing_item_from_translucent_block
    db $00					; Doesn't take any damage.
.82_Bonus_game_sprite
    db $00					; Doesn't take any damage.
.83_Left_flying_question_block
    db $01					; Doesn't take any damage.
.84_Flying_question_block
    db $00					; Doesn't take any damage.
.85_Unused_(Pretty_sure)
    db $00					; Doesn't take any damage.
;.86_Wiggler
    db $03
.87_Lakitu's_cloud
    db $00					; Doesn't take any damage.
.88_Unused_(Winged_cage_sprite)
    db $01
.89_Layer_3_smash
    db $05
.8A_Bird_from_Yoshi's_house
    db $00					; Doesn't take any damage.
.8B_Puff_of_smoke_from_Yoshi's_house
    db $00					; Doesn't take any damage.
.8C_Fireplace_smoke/exit_from_side_screen
    db $00					; Doesn't take any damage.
.8D_Ghost_house_exit_sign_and_door
    db $00					; Doesn't take any damage.
.8E_Invisible_"Warp_Hole"_blocks
    db $00
.8F_Scale_platforms
    db $00
.90_Large_green_gas_bubble
    db $05
.91_Chargin'_Chuck
    db $03
.92_Splittin'_Chuck
    db $03
.93_Bouncin'_Chuck
    db $03
.94_Whistlin'_Chuck
    db $03
.95_Clapin'_Chuck
    db $03
.96_Unused_(Chargin'_Chuck_clone)
    db $00					; Leave this.
.97_Puntin'_Chuck
    db $05
.98_Pitchin'_Chuck
    db $05
.99_Volcano_Lotus
    db $03
.9A_Sumo_Brother
    db $03
.9B_Hammer_Brother
    db $03
.9C_Flying_blocks_for_Hammer_Brother
    db $00					; Doesn't take any damage.
.9D_Bubble_with_sprite
    db $00					; Doesn't take any damage.
.9E_Ball_and_Chain
    db $04
.9F_Banzai_Bill
    db $03
.A0_Activates_Bowser_scene
    db $00					; Doesn't take any damage.
.A1_Bowser's_bowling_ball
    db $05
.A2_MechaKoopa
    db $03
.A3_Grey_platform_on_chain
    db $00					; Doesn't take any damage.
.A4_Floating_Spike_ball
    db $00					; Doesn't take any damage.
.A5_Fuzzball/Sparky,_ground-guided
    db $04
.A6_HotHead,_ground-guided
    db $03
.A7_Iggy's_ball
    db $04
.A8_Blargg
    db $04
.A9_Reznor
    db $01
.AA_Fishbone
    db $03
;.AB_Rex
    db $02
.AC_Wooden_Spike,_moving_down_and_up
    db $04
.AD_Wooden_Spike,_moving_up/down_first
    db $04
.AE_Fishin'_Boo
    db $04
.AF_Boo_Block
    db $02
.B0_Reflecting_stream_of_Boo_Buddies
    db $03
.B1_Creating/Eating_block
    db $01
.B2_Falling_Spike
    db $03
.B3_Bowser_statue_fireball
    db $04
.B4_Grinder,_non-line-guided
    db $04
.B5_Sinking_fireball_used_in_boss_battles
    db $04
.B6_Reflecting_fireball
    db $04
.B7_Carrot_Top_lift,_upper_right
    db $00					; Doesn't take any damage.
.B8_Carrot_Top_lift,_upper_left
    db $00					; Doesn't take any damage.
.B9_Info_Box
    db $00					; Doesn't take any damage.
.BA_Timed_lift
    db $00					; Doesn't take any damage.
.BB_Grey_moving_castle_block
    db $00					; Doesn't take any damage.
.BC_Bowser_statue
    db $04
.BD_Sliding_Koopa_without_a_shell
    db $02
.BE_Swooper_bat
    db $01
.BF_Mega_Mole
    db $02
.C0_Grey_platform_on_lava
    db $00					; Doesn't take any damage.
.C1_Flying_grey_turnblocks
    db $00					; Doesn't take any damage.
.C2_Blurp_fish
    db $02
.C3_Porcu-Puffer_fish
    db $03
.C4_Grey_platform_that_falls
    db $00					; Doesn't take any damage.
.C5_Big_Boo_Boss
    db $00					; Doesn't take any damage.
.C6_Dark_room_with_spot_light
    db $00					; Doesn't take any damage.
.C7_Invisible_mushroom
    db $00					; Doesn't take any damage.
.C8_Light_switch_block_for_dark_room
    db $00					; Doesn't take any damage.
.C9_Bullet_Bill_shooter
    db $02
.CA_Torpedo_Launcher
    db $02
.CB_Eerie,_generator
    db $02
.CC_Para-Goomba,_generator
    db $02
.CD_Para-Bomb,_generator
    db $02
.CE_Para-Bomb_and_Para-Goomba,_generator
    db $02
.CF_Dolphin,_left,_generator
    db $00					; Doesn't take any damage.
.D0_Dolphin,_right,_generator
    db $00					; Doesn't take any damage.
.D1_Jumping_fish,_generator
    db $00					; Doesn't take any damage.
.D2_Turn_off_generator_2_(sprite_E5)
    db $00					; Doesn't take any damage.
.D3_Super_Koopa,_generator
    db $01
.D4_Bubble_with_Goomba_and_Bob-omb,_generator
    db $02
.D5_Bullet_Bill,_generator
    db $03
.D6_Bullet_Bill_surrounded,_generator
    db $03
.D7_Bullet_Bill_diagonal,_generator
    db $03
.D8_Bowser_statue_fire_breath,_generator
    db $03
.D9_Turn_off_standard_generators
    db $00					; Doesn't take any damage.
.DA_Green_Koopa_shell
    db $00					; Doesn't take any damage.
.DB_Red_Koopa_shell
    db $00					; Doesn't take any damage.
.DC_Blue_Koopa_shell
    db $00					; Doesn't take any damage.
.DD_Yellow_Koopa_shell
    db $00					; Doesn't take any damage.
.DE_Group_of_5_eeries,_wave_motion
    db $03
.DF_Green_bouncing_Koopa_shell
    db $00					; Doesn't take any damage.
.E0_3_platforms_on_chains
    db $00					; Doesn't take any damage.
.E1_Ghost_ceiling
    db $03
.E2_Boo_Buddies,_counter_clockwise
    db $03
.E3_Boo_Buddies,_clockwise
    db $03
.E4_Swooper_bat_ceiling
    db $03
.E5_Reappearing_ghost,_generator_2
    db $03
.E6_Candle_flame_background
    db $00					; !LEAVE ALL OF THE BELOW ONES!
.E7_Auto-Scroll,_Unused?
    db $00	
.E8_Auto-Scroll
    db $00
.E9_Layer_2_Smash
    db $00
.EA_Layer_2_Scroll
    db $00
.EB_Unused
    db $00
.EC_Unused
    db $00
.ED_Layer_2_Falls
    db $00
.EE_Unused
    db $00
.EF_Layer_2_Scroll
    db $00
.F0_Unused
    db $00
.F1_Unused
    db $00
.F2_Layer_2_On/Off_Switch_controlled
    db $00
.F3_Auto-Scroll_level
    db $00
.F4_Fast_BG_scroll
    db $00
.F5_Layer_2_sink/rise
    db $00
.F6_Unused,_fatal_error
    db $00
.F7_Unused,_fatal_error
    db $00
.F8_Unused,_fatal_error
    db $00
.F9_Unused,_fatal_error
    db $00
.FA_Unused,_fatal_error
    db $00
.FB_Unused,_fatal_error
    db $00
.FC_Unused,_fatal_error
    db $00
.FD_Unused,_fatal_error
    db $00
.FE_Unused,_fatal_error
    db $00
.FF_Unused,_fatal_error
    db $00
;------
;End RATS
;------
Ending: