; Seperate Luigi/Fire/Whatever GFX
; By: HuFlungDu
; Basically, this patch changes Mario's GFX based on a RAM address you specify a little farther
; down the patch. It's default set up to be a seperate Luigi GFX, but you can change it to whatever
; You want. As with the original, you no longer need GFX32, it's all handled directly.
; Due to many of the hijacks, you need to have edited the ROM in LM to use this patch.
; Also, if you don't use ExGfx (In other words pressed the yellow mushroom button, you don't
; need to actually have ExGfx files) there is a line farther down you need to change, it's
; all explained there.

; Also: If you don't use MarioExGfx, this patch will free up 7E2000-7E7D00 for free RAM
; WITHIN THE LEVEL. RAM in that area will be overwitten between levels due to Mario's graphics
; still being uploaded from GFX32.

; To use more than 2 GFX files: If you don't know ASM then just move along, you probably
; won't be able to do this. If you do, it's a simple matter of making a couple more incbin's
; and storing the addresses to the 4 different RAM addresses used (0D85,0D87,0D89, and 0D99)
; in pretty much the same style as I did it and adding some extra checks for different RAMs/values

; To use with MarioExGfx: It's pretty simple. First, scroll down this file and uncomment every
; place where it says to uncomment to use MarioExGfx. If you are using LM1.65 uncomment the line
; incsrc marioexgfxold, if you are using 1.7x uncomment incsrc marioexgfx. DO NOT UNCOMMENT BOTH.
; Everything you want to do with MarioExGfx should be done in the original file. Nothing
; in here controls that. MarioExGfx is included, so you can use that or your normal one if
; you already are using it.

;Make sure you read all of the defines (Any line that starts with an !) for more info.


macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom                   ;\ ROM is LoRom
header                  ;/ and has a header.

!Freespace1 = $138000	;\These two should probably be pointed to the beginning of a bank
!Freespace2 = $148000	;/(Along with any other GFX files you insert)
!Freespace3 = $158000	;This doesn't matter that much, just make sure it's free.

!LuigiExtras = #$00		;These are the GFX file numbers for Luigi's extra tiles (in GFX00)
!LuigiLilBlush = #$22	;Blush while small and blush while large (when princess kisses him)
!LuigiBigBlush = #$24	;These need to be 8bit however, so between 00 and 33 and 
						;80 and FF, anything above that will crash your game.

;incsrc marioexgfxold.asm	;Uncomment this is you have the old marioexgfx in your hack
;incsrc marioexgfx.asm		;and this if you have the new one.
							;You need to have the file in the directory with this patch and it will
							;be re-inserted, but only if you want it to be MarioExGfx compatible.
!FlagRAM = $0DB3			;RAM checked to change graphics. For instance can be used for 
							;giving firepower different GFX
!FlagValue = #$01			;Value of RAM address to change GFX
!Emptydb = $87				;FreeRAM. MUST BE 8BIT! If you don't know what that means, you shouldn't
							;need to change this
							
;org $9F77					;Uncomment these three lines if you are using MarioExGfx
;	JML ClearLevel
;	NOP
org $F649					;\
	JSL CodeStuff1			;|All the hijacks that take care of
	NOP						;|The address Mario's graphics are 
	NOP						;|loaded from
org $F667					;|
	JSL CodeStuff2			;|
	NOP						;|
	NOP						;|
org $F67C					;|
	JSL CodeStuff3			;|
	NOP						;|
	NOP						;|
org $F691					;|
	JSL CodeStuff4			;|
	NOP						;|
	NOP						;/
	
org $A33F					;\Bank number graphics are loaded from
	LDY !Emptydb			;/

org $A355					;\Mario's DMA hijacks
	JSL YoshiStuff2			;|(Yoshi is done in the same place as Mario
	NOP						;|
	NOP						;|
org $A375					;|
	JSL YoshiStuff1			;|
	NOP						;|
	NOP						;/
	
org $AA6B					;\Hijack for GFX file upload
	JSL GFX00Stuff			;/(lifted from the original)
	
org !Freespace3
%RATS_start(2)
	CodeStuff1:
	PHA
	;REP #$10					;Uncomment all this if you are using MarioExGfx
	;LDA !FreeRAM               ;\If this level uses MarioExGfx
	;ASL A                      ;|Make it use the regular place for player GFX
	;TAX                        ;|
	;LDA.l MarGFX,x				;|
	;CMP #$0080					;|
	;BCS .DoSpecial				;/
	SEP #$30					;Get everything out of 16bit mode
	LDA !FlagRAM				;\If the value of RAM is correct
	CMP !FlagValue				;|Use different GFX
	BEQ .Luigi					;/
	LDA.b #MarioGFX/65536		;\Get the bank of Mario's graphics
	STA !Emptydb				;/And store it into RAM to be used later
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #MarioGFX				;|And set the address
	STA $0D85					;/
	RTL							;Then return
	.Luigi
	LDA.b #LuigiGFX/65536		;\Get the bank of Luigi's graphics
	STA !Emptydb				;/And store it into RAM to be used later
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #LuigiGFX				;|And set the address
	STA $0D85					;/
	RTL							;Then return
	;.DoSpecial					;Uncomment all this if you are using MarioExGfx
	;SEP #$10					;\Set bank to grab from back to RAM like it usually is.
	;LDY #$7E					;|
	;STY !Emptydb				;/
	;REP #$21					;Enter 16bit mode and clear the carry flag			
	;PLA						;\Get back what we had before
	;ADC #$2000					;|And set the address
	;STA $0D85					;/				
	;RTL						;Then return
	
	
	
	CodeStuff2:
	PHA
	;REP #$10					;Uncomment all this if you are using MarioExGfx
	;LDA !FreeRAM               ;\If this level uses MarioExGfx
	;ASL A                      ;|Make it use the regular place for player GFX
	;TAX                        ;|
	;LDA.l MarGFX,x				;|
	;CMP #$0080					;|
	;BCS .DoSpecial				;/
	SEP #$30					;Get everything out of 16bit mode
	LDA !FlagRAM				;\If the value of RAM is correct
	CMP !FlagValue				;|Use different GFX
	BEQ .Luigi					;/
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #MarioGFX				;|And set the address
	STA $0D87					;/
	RTL							;Then return
	.Luigi
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #LuigiGFX				;|And set the address
	STA $0D87					;/
	RTL							;Then return
	;.DoSpecial					;Uncomment all this if you are using MarioExGfx
	;SEP #$10					;\Set bank to grab from back to RAM like it usually is.
	;LDY #$7E					;|
	;STY !Emptydb				;/
	;REP #$21					;Enter 16bit mode and clear the carry flag			
	;PLA						;\Get back what we had before
	;ADC #$2000					;|And set the address
	;STA $0D87					;/				
	;RTL						;Then return
	
	
	CodeStuff3:
	PHA
	;REP #$10					;Uncomment all this if you are using MarioExGfx
	;LDA !FreeRAM               ;\If this level uses MarioExGfx
	;ASL A                      ;|Make it use the regular place for player GFX
	;TAX                        ;|
	;LDA.l MarGFX,x				;|
	;CMP #$0080					;|
	;BCS .DoSpecial				;/
	SEP #$30					;Get everything out of 16bit mode
	LDA !FlagRAM				;\If the value of RAM is correct
	CMP !FlagValue				;|Use different GFX
	BEQ .Luigi					;/
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #MarioGFX				;|And set the address
	STA $0D89					;/
	RTL							;Then return
	.Luigi
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #LuigiGFX				;|And set the address
	STA $0D89					;/
	RTL							;Then return
	;.DoSpecial					;Uncomment all this if you are using MarioExGfx
	;SEP #$10					;\Set bank to grab from back to RAM like it usually is.
	;LDY #$7E					;|
	;STY !Emptydb				;/
	;REP #$21					;Enter 16bit mode and clear the carry flag			
	;PLA						;\Get back what we had before
	;ADC #$2000					;|And set the address
	;STA $0D89					;/				
	;RTL						;Then return
	
	
	
	CodeStuff4:
	PHA
	;REP #$10					;Uncomment all this if you are using MarioExGfx
	;LDA !FreeRAM               ;\If this level uses MarioExGfx
	;ASL A                      ;|Make it use the regular place for player GFX
	;TAX                        ;|
	;LDA.l MarGFX,x				;|
	;CMP #$0080					;|
	;BCS .DoSpecial				;/
	SEP #$30					;Get everything out of 16bit mode
	LDA !FlagRAM				;\If the value of RAM is correct
	CMP !FlagValue				;|Use different GFX
	BEQ .Luigi					;/
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #MarioGFX				;|And set the address
	STA $0D99					;/
	RTL							;Then return
	.Luigi
	REP #$21					;Enter 16Bit mode and also clear carry flag
	PLA							;\Get back what we had before
	ADC.w #LuigiGFX				;|And set the address
	STA $0D99					;/
	RTL							;Then return
	;.DoSpecial					;Uncomment all this if you are using MarioExGfx
	;SEP #$10					;\Set bank to grab from back to RAM like it usually is.
	;LDY #$7E					;|
	;STY !Emptydb				;/
	;REP #$21					;Enter 16bit mode and clear the carry flag			
	;PLA						;\Get back what we had before
	;ADC #$2000					;|And set the address
	;STA $0D99					;/				
	;RTL						;Then return
	
	
	
	YoshiStuff1:
	CPX #$06					;\If these are yohi/podoboo tiles
	BEQ .Yoshi					;|Grab from the normal place
	CPX #$08					;|
	BEQ .Yoshi					;/
	LDY !Emptydb				;\Set the bank for the DMA transfer
	STY $4324					;/
	LDA $0D8F,X					;\Set the address for the tiles to 
	STA $4322					;/be read from
	RTL							;and return
	.Yoshi
	LDY #$7E					;\Return bank to RAM if it's yoshi tile
	STY $4324					;/
	LDA $0D8F,X					;\and do this like normal
	STA $4322					;/
	RTL							;and return
	
	
	
	
	YoshiStuff2:
	CPX #$06					;\If these are yohi/podoboo tiles
	BEQ .Yoshi					;|Grab from the normal place
	CPX #$08					;|
	BEQ .Yoshi					;/
	LDY !Emptydb				;\Set the bank for the DMA transfer
	STY $4324					;/
	LDA $0D85,X					;\Set the address for the tiles to 
	STA $4322					;/be read from
	RTL							;and return
	.Yoshi
	LDY #$7E					;\Return bank to RAM if it's yoshi tile
	STY $4324					;/
	LDA $0D85,X					;\and do this like normal
	STA $4322					;/
	RTL							;and return
	
	
	
	
								;Some (most) of this label was 
								;lifted from smallhacker's original patch
	GFX00Stuff:
	LDA !FlagRAM				;\If not Luigi (Or whatever)	
	CMP !FlagValue				;|don't even worry about this
	BNE .DoIt					;/
	CPY #$00					;\If file is 00 and you are luigi
	BEQ .LuigiExtras			;/Use the file sepcified earlier
	CPY #$22					;\If file is 22 and you are luigi
	BEQ .LuigiLilBlush			;/Use the file sepcified earlier
	CPY #$24					;\If file is 22 and you are luigi
	BEQ .LuigiBigBlush			;/Use the file sepcified earlier
	.DoIt
	JML $0FF160 				;$00BA28 if no ExGfx.
								;Finish uploading the GFX file
	.LuigiExtras				;\These all just set which file to use.
	LDY !LuigiExtras			;|I'm sure you can figure it out.
	BRA .DoIt					;|
	.LuigiLilBlush				;|
	LDY !LuigiLilBlush			;|
	BRA .DoIt					;|
	.LuigiBigBlush				;|
	LDY !LuigiBigBlush			;|
	BRA .DoIt					;/
	
	
	;ClearLevel:		;Uncomment these 7 lines if you are using MarioExGfx
	;REP #$20			;\This all resets the level number at OW load
	;LDA #$0201			;|So that the MarioExGfx doesn't influence what
	;STA !FreeRAM		;|the player looks like on the OW
	;SEP #$20			;|
	;LDY $0DAF			;|
	;JML $009F4C		;/

%RATS_end(2)
org !Freespace2
%RATS_start(0)
MarioGFX:
	incbin Mario.bin			;Store Mario's GFX decompressed
%RATS_end(0)
org !Freespace1
%RATS_start(1)
LuigiGFX:
	incbin Luigi.bin			;Store Luigi's GFX decompressed
%RATS_end(1)