header
lorom

;========================
; DEFINES
;========================

!CodeFreeSpace = $1A8000

!FreeRAM = $010B
!AnotherRAM = $06B0
;========================
; HIJACKS
;========================

org $009476
JSL Label3
NOP

org $00A0B9
;STZ $0DDA : LDX $0DB3 ; Remove the semi-colon if you applied an earlier version of this patch

org $00A0BF
JML Label5

org $00A5D5
JSL Label2
NOP

;==========================
; FROM LEVELASM, NOT BY ME
;==========================

ORG $05D8B9
	JSR Levelnummain

ORG $05DC46
Levelnummain:	LDA $0E  		;Load level number
		STA !FreeRAM		;Store it in free stack RAM
		ASL A    		;Multiply A by 2, probably to recover old code?
                STZ !AnotherRAM
		RTS      		;Return from subroutine

;-----------------------
; CUSTOM CODE
;-----------------------

org !CodeFreeSpace

!CodeSize = End-Label2
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

Label2:
PHK                        ; \ Because of a hijack, we need...
PER ReturnAZ-$01           ;  | ... to jump to a routine, ending in RTS...
PHB                        ;  | ... this way.
LDA #$00                   ;  |
PHA                        ;  |
PLB			   ;  |
PEA $84CD		   ;  |
JML $008E1A		   ; /

ReturnAZ:
PHK                        ; \
PER Return5-$01            ;  | Reload Mario default GFX.
PHB                        ;  |
LDA #$00                   ;  |
PHA                        ;  | SMW doesn't do this originally.
PLB                        ;  |
PEA $84CD                  ;  |
JML $00B888                ; /

Return5:
PHB                        ; \ Preserve bank.
PHK                        ;  | PBR into DBR.
PLB                        ; /
REP #$30                   ; 
LDA $010B                  ; \ Level num * 2
ASL A                      ;  |
TAY                        ; / Into index

LoopTiles:
LDA.w MarGFX,y      ; \ Get GFX file num.
CMP #$0100                 ;  | If >= #$0100, handle a different decompression method.
BCS ExGFX100AndPlusRt       ; /
CMP #$0080
BCC ReturnFinally
AND #$007F
STA $8A
ASL A
CLC
ADC $8A
TAY
LDA $0FF1DD
STA $06
LDA $0FF1DE
STA $07
LDA [$06],y
STA $8A
INC $06
LDA [$06],y
STA $8B
BRA Decompress

ReturnFinally:
PLB                       ; Code we hijacked. 
REP #$30                  ;
RTL

;-------------------------------------;
; ExGFX 100-FFF Decompression Routine ;
;-------------------------------------;

ExGFX100AndPlusRt:
SEC                       ; \ GFX file minus #$0100.
SBC #$0100                ;  |
STA $8A                   ;  | Multiply result by three.
ASL A                     ;  |
CLC                       ;  |
ADC $8A                   ;  |
TAY                       ; /
LDA $0FF873               ; \ $0FF873-$0FF875 contains the address of the pointer where LM points to ExGFX 100-FFF.
STA $06                   ;  | The position of these pointers vary per ROM... 
LDA $0FF874               ;  | That is why the pointers will be uploaded indirectly.
STA $07                   ; /
LDA [$06],y               ; \ Get low byte.
STA $8A                   ; /
INC $06                   ; Increase pointer position by 1.
LDA [$06],y               ; \ Get the middle byte and bank byte.
STA $8B                   ; /

Decompress:
SEP #$30
PHK                       ; \ Decompress graphics.
PER ReturnFinally-1       ;  |
PHB                       ;  |
PHY                       ;  |
LDA #$00
STA $00
LDA #$20
STA $01
LDA #$7E
STA $02
JML $00BA47               ; /

;----------------------------------;
; Mario GFX and Animated Tiles GFX ;
;----------------------------------;

MarGFX:
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 0-F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 10-1F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 20-2F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 30-3F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 40-4F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 50-5F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 60-6F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 70-7F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 80-8F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 90-9F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels A0-AF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels B0-BF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels C0-CF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels D0-DF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels E0-EF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels F0-FF
dw $0032,$0032,$0032,$0032,$0032,$0100,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 100-10F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 110-11F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 120-12F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 130-13F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 140-14F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 150-15F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 160-16F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 170-17F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 180-18F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 190-19F
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1A0-1AF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1B0-1BF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1C0-1CF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1D0-1DF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1E0-1EF
dw $0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032,$0032 ; Levels 1F0-1FF

;-----------;
; Credits   ;
;-----------;

Label3:
STA $1931
CPX #$08
BNE Label4
PHK
PER Label4-1
PHB
LDA #$00
PHA
PLB
PEA $84CD
JML $00B888

Label4:
LDA #$14
RTL

;-----;
; OW  ;
;-----;

Label5:
PHX
PHK
PER Label6-1
PHB
LDA #$00
PHA
PLB
PEA $84CD
JML $00B888

Label6:
PLX
LDA $0DBE
BPL CODE_00A0C7
JML $00A0C4

CODE_00A0C7:
JML $00A0C7

End: