;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Show Current Power-up and "Hook" select
;By Scepile3
;
;If you just want to disable a button, remove LDA(the first one) to next:(removing next:last)
;If you want to disable a different button, change 16, 15 and/or the button value
;(Don't forget to change 16 and 15 at the same time if you want to change controller RAM address)
;Change both $15 and $16 if you change one.(all of them)
;
;Original code from:
; LR Hook - Version 1.1
; By Smallhacker
; 
; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $008F49 ;Unused ROM address here
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $F5F8
	NOP #$4 ; Disable item box getting used when hurt
org $008F49;Hijack the status bar routine
	JSL NewRoutine

org $382ED
%RATS_start(0)

NewRoutine:
    LDA $1490  ;If star timer isn't zero, go to Star
    BNE Star
    LDA $19    ;If small, go to Reset
    BEQ Reset
    LDA $19    ;If cape Mario, go to Cape
    CMP #$02
    BEQ Cape
    LDA $19    ;If big Mario, go to Mush
    CMP #$01
    BEQ Mush
    LDA $19    ;If not Fire Mario, go to next
    CMP #$03
    BNE next
    LDA #$02   ;Put Flower in item box
    STA $0DC2
    BRA next   ;Go to next
Cape:
    LDA #$04   ;Put Feather in item box
    STA $0DC2
    BRA next   ;Go to next
Mush:
    LDA #$01   ;Put Mushroom in item box
    STA $0DC2
    BRA next   ;Go to next
Reset:
    STZ $0DC2  ;Remove item
    BRA next   ;Go to next
Star:
    LDA #$03   ;Put Star in item box
    STA $0DC2  ;Go to next
next:
    LDA $16    ;(disable select)check if just pressed select. If not, go to Return
    CMP #$20
    BNE Return
    STZ $15    ;No button was/is held
    STZ $16    ;No button was/is pressed
               ;New code here. (if none, leave blank.)
Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)