; Smoke Image tool
; By: HuFlungDu
; The next part of my little project to allow the creation of all different kinds of sprites
; This one is smoke images. Slightly more useful than minor extended sprites, but still not much.
; Either way, this can be used to insert custom smoke images into your ROM, you just spawn them
; like you would any other smoke image. Coding them is another story, basically you just
; have to follow examples of premade ones and the one I included with the patch.
; That's all really, do what you want with this, there is no copyright.

!Freespace = $158000

header
lorom

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

; Change all the returns into RTLs since we will be jumping long
org $0296D7
	RTL
org $029749
	RTL
org $029837
	RTL
org $0298BD
	RTL
org $0298C1
	RTL
org $029796
	RTL
org $02999E
	RTL
org $0299D1
	RTL
org $029921
	RTL
org $0296E2
	RTL
org $029792
	RTL
; Except these two, which need to be RTSs
org $0296C3
	BEQ ReturnShort
;Hijack
org $0296C5
	JSL SmokeImages
	ReturnShort:
	RTS

org !Freespace	
%RATS_start(0)
SmokeImages:
	REP #$20			;\This is my super neat way of
	PHX					;|jumping somewhere from a table
	ASL					;|without using SMWs built in one
	TAX					;|(and making it much easier for me)
	LDA.l Pointers,x	;|Basically you load the labels
	DEC					;|indexed by the sprite number
	PLX					;|Decrease it by 1 due to the way RTS/L works
	PHA					;|Then push it onto the stack
	SEP #$20			;|Then, when you RTS, it grabs the location
	LDA $17C0,X			;|I pushed earlier and "returns" there.
	RTS					;/(Actually it jumps, but it doesn't need to know that)

; Regular smoke images. These just jump to the normal routines. Don't touch these.	
SmokeImage0:
JML $0296D7
SmokeImage1:
JML $0296E3
SmokeImage2:
JML $029797
SmokeImage3:
JML $029927
SmokeImage4:
JML $0296D7
SmokeImage5:
JML $0298CA
;The custom smoke images. The one included acts basically like a puff of smoke,
;except it rises faster and doesn't use the biggest puff graphics. I use it to spawn
;when a fireball enters the water to make it look like the water put out the fire.
SmokeImageOAMIndex:                      
db $20,$24,$28,$2C
TileNumbers:                      
db $66,$66,$64,$62,$62,$62,$62
SmokeImage6:
					PHB							;\Change the data bank to the program
					PHK							;|bank just like you would in a normal sprite
					PLB							;/
					LDA $17CC,X             	;\If the amount of time left to show the sprite
					BNE DoSmoke                 ;/is more than 0, then do the code
					KillSmoke:					;\Otherwise, kill the sprite
					STZ $17C0,X  				;/
					PLB           				;Get back the data bank
					RTL                       	;And return         
        
DoSmoke:
					LDY $9D     				;\This decreases the smoke image timer
					BNE Frozen     				;|Don't do it if sprites are frozen
					DEC $17CC,X             	;/
					AND #$04					;\Don't move the smoke image up
					BEQ Frozen					;|every frame, only every 4th frame
					DEC $17C4,X     			;/(Or if sprites are frozen don't)

Frozen:
					LDY.w SmokeImageOAMIndex,X  ;\Get the OAM index based on which smoke number
												;/the game is on (Needs to be
					LDA $17C8,X           		;\Get it's XPos relative to the screen border  
					SEC                       	;|
					SBC $1A    					;|
					STA $0200,Y 				;/
					LDA $17C4,X             	;\Same with Y
					SEC                       	;|
					SBC $1C    					;|
					STA $0201,Y 				;/
					LDA $64       				;\Most properties don't matter because           
					STA $0203,Y  				;|smoke images tend to be white
												;/and I have no need to flip
					PHX							;\Preserves X and gets the index to the tile
					LDA $17CC,X          		;|it should grab from based on how much time
					LSR                       	;|is left for the smoke image to be
					LSR                       	;|
					TAX                       	;/
					LDA TileNumbers,X       	;\Grab the tile number from the table earlier
					STA $0202,Y  				;/And store it into OAM
					TYA							;\Get the OAM index back to		               
					LSR                       	;|what it needs to be for storing
					LSR                       	;|to $0420,y (since it doesn't have 4
					TAY                       	;/bytes together, the OAM index to it is 1/4)
					LDA #$02      				;\Tell it we are drawing 16x16 tiles          
					STA $0420,Y  				;/(Same as in normal sprites)
					PLX							;\Get back X and the data bank
					PLB       					;/
					RTL                       	;And return 

SmokeImage7:
SmokeImage8:
SmokeImage9:
SmokeImageA:
SmokeImageB:
SmokeImageC:
SmokeImageD:
SmokeImageE:
SmokeImageF:
SmokeImage10:
SmokeImage11:
SmokeImage12:
SmokeImage13:
SmokeImage14:
SmokeImage15:
SmokeImage16:
SmokeImage17:
SmokeImage18:
SmokeImage19:
SmokeImage1A:
SmokeImage1B:
SmokeImage1C:
SmokeImage1D:
SmokeImage1E:
SmokeImage1F:
SmokeImage20:
SmokeImage21:
SmokeImage22:
SmokeImage23:
SmokeImage24:
SmokeImage25:
SmokeImage26:
SmokeImage27:
SmokeImage28:
SmokeImage29:
SmokeImage2A:
SmokeImage2B:
SmokeImage2C:
SmokeImage2D:
SmokeImage2E:
SmokeImage2F:
SmokeImage30:
SmokeImage31:
SmokeImage32:
SmokeImage33:
SmokeImage34:
SmokeImage35:
SmokeImage36:
SmokeImage37:
SmokeImage38:
SmokeImage39:
SmokeImage3A:
SmokeImage3B:
SmokeImage3C:
SmokeImage3D:
SmokeImage3E:
SmokeImage3F:
SmokeImage40:
SmokeImage41:
SmokeImage42:
SmokeImage43:
SmokeImage44:
SmokeImage45:
SmokeImage46:
SmokeImage47:
SmokeImage48:
SmokeImage49:
SmokeImage4A:
SmokeImage4B:
SmokeImage4C:
SmokeImage4D:
SmokeImage4E:
SmokeImage4F:
SmokeImage50:
SmokeImage51:
SmokeImage52:
SmokeImage53:
SmokeImage54:
SmokeImage55:
SmokeImage56:
SmokeImage57:
SmokeImage58:
SmokeImage59:
SmokeImage5A:
SmokeImage5B:
SmokeImage5C:
SmokeImage5D:
SmokeImage5E:
SmokeImage5F:
SmokeImage60:
SmokeImage61:
SmokeImage62:
SmokeImage63:
SmokeImage64:
SmokeImage65:
SmokeImage66:
SmokeImage67:
SmokeImage68:
SmokeImage69:
SmokeImage6A:
SmokeImage6B:
SmokeImage6C:
SmokeImage6D:
SmokeImage6E:
SmokeImage6F:
SmokeImage70:
SmokeImage71:
SmokeImage72:
SmokeImage73:
SmokeImage74:
SmokeImage75:
SmokeImage76:
SmokeImage77:
SmokeImage78:
SmokeImage79:
SmokeImage7A:
SmokeImage7B:
SmokeImage7C:
SmokeImage7D:
SmokeImage7E:
SmokeImage7F:
SmokeImage80:
SmokeImage81:
SmokeImage82:
SmokeImage83:
SmokeImage84:
SmokeImage85:
SmokeImage86:
SmokeImage87:
SmokeImage88:
SmokeImage89:
SmokeImage8A:
SmokeImage8B:
SmokeImage8C:
SmokeImage8D:
SmokeImage8E:
SmokeImage8F:
SmokeImage90:
SmokeImage91:
SmokeImage92:
SmokeImage93:
SmokeImage94:
SmokeImage95:
SmokeImage96:
SmokeImage97:
SmokeImage98:
SmokeImage99:
SmokeImage9A:
SmokeImage9B:
SmokeImage9C:
SmokeImage9D:
SmokeImage9E:
SmokeImage9F:
SmokeImageA0:
SmokeImageA1:
SmokeImageA2:
SmokeImageA3:
SmokeImageA4:
SmokeImageA5:
SmokeImageA6:
SmokeImageA7:
SmokeImageA8:
SmokeImageA9:
SmokeImageAA:
SmokeImageAB:
SmokeImageAC:
SmokeImageAD:
SmokeImageAE:
SmokeImageAF:
SmokeImageB0:
SmokeImageB1:
SmokeImageB2:
SmokeImageB3:
SmokeImageB4:
SmokeImageB5:
SmokeImageB6:
SmokeImageB7:
SmokeImageB8:
SmokeImageB9:
SmokeImageBA:
SmokeImageBB:
SmokeImageBC:
SmokeImageBD:
SmokeImageBE:
SmokeImageBF:
SmokeImageC0:
SmokeImageC1:
SmokeImageC2:
SmokeImageC3:
SmokeImageC4:
SmokeImageC5:
SmokeImageC6:
SmokeImageC7:
SmokeImageC8:
SmokeImageC9:
SmokeImageCA:
SmokeImageCB:
SmokeImageCC:
SmokeImageCD:
SmokeImageCE:
SmokeImageCF:
SmokeImageD0:
SmokeImageD1:
SmokeImageD2:
SmokeImageD3:
SmokeImageD4:
SmokeImageD5:
SmokeImageD6:
SmokeImageD7:
SmokeImageD8:
SmokeImageD9:
SmokeImageDA:
SmokeImageDB:
SmokeImageDC:
SmokeImageDD:
SmokeImageDE:
SmokeImageDF:
SmokeImageE0:
SmokeImageE1:
SmokeImageE2:
SmokeImageE3:
SmokeImageE4:
SmokeImageE5:
SmokeImageE6:
SmokeImageE7:
SmokeImageE8:
SmokeImageE9:
SmokeImageEA:
SmokeImageEB:
SmokeImageEC:
SmokeImageED:
SmokeImageEE:
SmokeImageEF:
SmokeImageF0:
SmokeImageF1:
SmokeImageF2:
SmokeImageF3:
SmokeImageF4:
SmokeImageF5:
SmokeImageF6:
SmokeImageF7:
SmokeImageF8:
SmokeImageF9:
SmokeImageFA:
SmokeImageFB:
SmokeImageFC:
SmokeImageFD:
SmokeImageFE:
SmokeImageFF:
RTL

Pointers:
dw SmokeImage0
dw SmokeImage1
dw SmokeImage2
dw SmokeImage3
dw SmokeImage4
dw SmokeImage5
dw SmokeImage6
dw SmokeImage7
dw SmokeImage8
dw SmokeImage9
dw SmokeImageA
dw SmokeImageB
dw SmokeImageC
dw SmokeImageD
dw SmokeImageE
dw SmokeImageF
dw SmokeImage10
dw SmokeImage11
dw SmokeImage12
dw SmokeImage13
dw SmokeImage14
dw SmokeImage15
dw SmokeImage16
dw SmokeImage17
dw SmokeImage18
dw SmokeImage19
dw SmokeImage1A
dw SmokeImage1B
dw SmokeImage1C
dw SmokeImage1D
dw SmokeImage1E
dw SmokeImage1F
dw SmokeImage20
dw SmokeImage21
dw SmokeImage22
dw SmokeImage23
dw SmokeImage24
dw SmokeImage25
dw SmokeImage26
dw SmokeImage27
dw SmokeImage28
dw SmokeImage29
dw SmokeImage2A
dw SmokeImage2B
dw SmokeImage2C
dw SmokeImage2D
dw SmokeImage2E
dw SmokeImage2F
dw SmokeImage30
dw SmokeImage31
dw SmokeImage32
dw SmokeImage33
dw SmokeImage34
dw SmokeImage35
dw SmokeImage36
dw SmokeImage37
dw SmokeImage38
dw SmokeImage39
dw SmokeImage3A
dw SmokeImage3B
dw SmokeImage3C
dw SmokeImage3D
dw SmokeImage3E
dw SmokeImage3F
dw SmokeImage40
dw SmokeImage41
dw SmokeImage42
dw SmokeImage43
dw SmokeImage44
dw SmokeImage45
dw SmokeImage46
dw SmokeImage47
dw SmokeImage48
dw SmokeImage49
dw SmokeImage4A
dw SmokeImage4B
dw SmokeImage4C
dw SmokeImage4D
dw SmokeImage4E
dw SmokeImage4F
dw SmokeImage50
dw SmokeImage51
dw SmokeImage52
dw SmokeImage53
dw SmokeImage54
dw SmokeImage55
dw SmokeImage56
dw SmokeImage57
dw SmokeImage58
dw SmokeImage59
dw SmokeImage5A
dw SmokeImage5B
dw SmokeImage5C
dw SmokeImage5D
dw SmokeImage5E
dw SmokeImage5F
dw SmokeImage60
dw SmokeImage61
dw SmokeImage62
dw SmokeImage63
dw SmokeImage64
dw SmokeImage65
dw SmokeImage66
dw SmokeImage67
dw SmokeImage68
dw SmokeImage69
dw SmokeImage6A
dw SmokeImage6B
dw SmokeImage6C
dw SmokeImage6D
dw SmokeImage6E
dw SmokeImage6F
dw SmokeImage70
dw SmokeImage71
dw SmokeImage72
dw SmokeImage73
dw SmokeImage74
dw SmokeImage75
dw SmokeImage76
dw SmokeImage77
dw SmokeImage78
dw SmokeImage79
dw SmokeImage7A
dw SmokeImage7B
dw SmokeImage7C
dw SmokeImage7D
dw SmokeImage7E
dw SmokeImage7F
dw SmokeImage80
dw SmokeImage81
dw SmokeImage82
dw SmokeImage83
dw SmokeImage84
dw SmokeImage85
dw SmokeImage86
dw SmokeImage87
dw SmokeImage88
dw SmokeImage89
dw SmokeImage8A
dw SmokeImage8B
dw SmokeImage8C
dw SmokeImage8D
dw SmokeImage8E
dw SmokeImage8F
dw SmokeImage90
dw SmokeImage91
dw SmokeImage92
dw SmokeImage93
dw SmokeImage94
dw SmokeImage95
dw SmokeImage96
dw SmokeImage97
dw SmokeImage98
dw SmokeImage99
dw SmokeImage9A
dw SmokeImage9B
dw SmokeImage9C
dw SmokeImage9D
dw SmokeImage9E
dw SmokeImage9F
dw SmokeImageA0
dw SmokeImageA1
dw SmokeImageA2
dw SmokeImageA3
dw SmokeImageA4
dw SmokeImageA5
dw SmokeImageA6
dw SmokeImageA7
dw SmokeImageA8
dw SmokeImageA9
dw SmokeImageAA
dw SmokeImageAB
dw SmokeImageAC
dw SmokeImageAD
dw SmokeImageAE
dw SmokeImageAF
dw SmokeImageB0
dw SmokeImageB1
dw SmokeImageB2
dw SmokeImageB3
dw SmokeImageB4
dw SmokeImageB5
dw SmokeImageB6
dw SmokeImageB7
dw SmokeImageB8
dw SmokeImageB9
dw SmokeImageBA
dw SmokeImageBB
dw SmokeImageBC
dw SmokeImageBD
dw SmokeImageBE
dw SmokeImageBF
dw SmokeImageC0
dw SmokeImageC1
dw SmokeImageC2
dw SmokeImageC3
dw SmokeImageC4
dw SmokeImageC5
dw SmokeImageC6
dw SmokeImageC7
dw SmokeImageC8
dw SmokeImageC9
dw SmokeImageCA
dw SmokeImageCB
dw SmokeImageCC
dw SmokeImageCD
dw SmokeImageCE
dw SmokeImageCF
dw SmokeImageD0
dw SmokeImageD1
dw SmokeImageD2
dw SmokeImageD3
dw SmokeImageD4
dw SmokeImageD5
dw SmokeImageD6
dw SmokeImageD7
dw SmokeImageD8
dw SmokeImageD9
dw SmokeImageDA
dw SmokeImageDB
dw SmokeImageDC
dw SmokeImageDD
dw SmokeImageDE
dw SmokeImageDF
dw SmokeImageE0
dw SmokeImageE1
dw SmokeImageE2
dw SmokeImageE3
dw SmokeImageE4
dw SmokeImageE5
dw SmokeImageE6
dw SmokeImageE7
dw SmokeImageE8
dw SmokeImageE9
dw SmokeImageEA
dw SmokeImageEB
dw SmokeImageEC
dw SmokeImageED
dw SmokeImageEE
dw SmokeImageEF
dw SmokeImageF0
dw SmokeImageF1
dw SmokeImageF2
dw SmokeImageF3
dw SmokeImageF4
dw SmokeImageF5
dw SmokeImageF6
dw SmokeImageF7
dw SmokeImageF8
dw SmokeImageF9
dw SmokeImageFA
dw SmokeImageFB
dw SmokeImageFC
dw SmokeImageFD
dw SmokeImageFE
dw SmokeImageFF
%RATS_end(0)