; =========================================
; IRQ Trigger scanline change
; Can also be used to hide the statusbar
; Newer version. Doesn't use freeram now.
; =========================================
; Bunch of definitions
; =========================================

	!LevelNum		= $010B		;Free RAM to store the level number in it. 2 bytes long.

	!FreeSpace		= $1FB000	;POINT THIS TO SOME FREE SPACE!!!111! More yelling here.

HEADER
LOROM

; ==============================
; Levelnum.ips disassembly
; ==============================

ORG $05D8B9
		JSR Levelnummain

ORG $05DC46
Levelnummain:	LDA $0E  		;Load level number
		STA !LevelNum		;Store it in free stack RAM
		ASL A    		;Multiply level number by 2
		RTS      		;Return from subroutine and return the level value... or something

; ==============================
; Our actual IRQ code
; ==============================

ORG $8292
		JML MainCode		;Hijack code and redirect to our new one
		NOP			;Removing the leftover byte to prevent crash

ORG !FreeSpace

;RATS tag to protect this code from LM and other program's data overwriting stuff.

db "STAR"
dw EndCode-MainCode-$01 
dw EndCode-MainCode-$01^$FFFF

MainCode:	REP #$10
		LDX !LevelNum		;Load level number
		LDA IRQTable,x		;Load IRQ tables indexed with X
		SEP #$10
		TAY
		LDA $4211		;And continue the IRQ routine
		JML $008297


; ==========================================================================================
; This table works as following
; The value defines how many scanlines will be shown on the statusbar
; $00 = Show nothing of the statusbar. THE TIMER AND SCORES AND SO ON WILL STILL FUNCTION
; $24 = highest value you can get unless you want to screw up layer 3 horizontal scrolling.
; ==========================================================================================

IRQTable:	db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 00-07
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 08-0F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 10-17
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 18-1F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 20-27
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 28-2F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 30-37
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 38-3F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 40-47
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 48-4F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 50-57
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 58-5F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 60-67
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 68-6F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 70-77
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 78-7F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 80-87
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 88-8F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 90-97
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 98-9F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels A0-A7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels A8-AF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels B0-B7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels B8-BF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels C0-C7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels C8-CF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels D0-D7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels D8-DF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels E0-E7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels E8-EF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels F0-F7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels F8-FF
		db $24,$24,$24,$24,$24,$12,$00,$24 ;Levels 100-107
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 108-10F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 110-117
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 118-11F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 120-127
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 128-12F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 130-137
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 138-13F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 140-147
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 148-14F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 150-157
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 158-15F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 160-167
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 168-16F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 170-177
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 178-17F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 180-187
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 188-18F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 190-197
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 198-19F
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1A0-1A7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1A8-1AF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1B0-1B7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1B8-1BF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1C0-1C7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1C8-1CF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1D0-1D7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1D8-1DF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1E0-1E7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1E8-1EF
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1F0-1F7
		db $24,$24,$24,$24,$24,$24,$24,$24 ;Levels 1F8-1FF
EndCode: