;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Stripe Image Uploader Hack, by imamelia
;
; This patch hijacks the routine that utilizes RAM address $12 as an index to stripe
; image pointers, allowing you to use all values not used by SMW (which comprises
; all values not evenly divisible by 3) for your own stripe images.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

header
lorom

!Freespace = $1A8000

; start of the routine that checks $12
org $0085D2
JML CheckStimNumber          

org !Freespace
reset bytes
db "STAR"
dw End-Start-$01
dw End-Start-$01^$FFFF

Start:

CheckStimNumber:

LDY $12				;
STY $4204			; stripe image index into the dividend registers
STZ $4205			; high byte is 00
LDA #$03			; 03 into the divisor register
STA $4206			;
NOP #8				; waste some cycles
LDA $4216			; if there was no remainder, then just use the normal stripe image pointers
BEQ .UseOriginalImages	;
PHB					;
PHK					;
PLB					;
CMP #$01			; if the remainder was 1, use the first set of custom images
BEQ .UseFirstSet		;

.UseSecondSet			; if the remainder was 2, use the second set of custom images
LDA CustStimPtrs2-2,y	; set the low byte of the pointer
STA $00				;
LDA CustStimPtrs2-1,y	; set the high byte
STA $01				;
LDA CustStimPtrs2,y	; set the bank byte
STA $02				;
BRA .SetPointer		;

.UseFirstSet			;
LDA CustStimPtrs1-1,y	; set the low byte of the pointer
STA $00				;
LDA CustStimPtrs1,y	; set the high byte
STA $01				;
LDA CustStimPtrs1+1,y	; set the bank byte
STA $02				;

.SetPointer			;
PLB					;
JML $0085E3			; finish the original routine
.UseOriginalImages		;
LDA $84D0,y			; load the first byte of the original pointer
JML $0085D7			; and jump back to the original routine

incsrc custstimptrs.asm

End:
print "Freespace used by stripehack.asm: ",bytes," bytes."
print "Next address: $",pc

