;====================================
; IRQ Patch for work with SuperFX by DiscoMan
; This code is rewritten to make it a bit compatible with SuperFX AND the new place that this patch was put.
; This code is OPEN SOURCE, so you can modify as long as you want, since some patches uses NMI and IRQ routine to hijack, you can consider modifying this file to place a hijack OR make this routine better. It's up to you.
;====================================

LOROM

!Freespace = $AC9B

org !Freespace

Start:
IRQHandler:                     SEI                       ; Set Interrupt flag so routine can start 
PHP
REP #$30
PHA
PHX
PHY
PHB
SEP #$30
LDA #$00
PHA
PLB
CODE_00837E:                 SEP #$30                  ; Index (8 bit) Accum (8 bit) 
CODE_008380:              LDA.w $4211               ; Read the IRQ register, 'unapply' the interrupt ; IRQ Flag By H/V Count Timer
CODE_008383:                 BPL CODE_0083B2           ; If "Timer IRQ" is clear, skip the next code block 
CODE_008385:                LDA.b #$81                
CODE_008387:              LDY.w $0D9B               
CODE_00838A:                BMI CODE_0083BA           ; If Bit 7 (negative flag) is set, branch to a different IRQ mode 
IRQNMIEnding:             STA.w $4200               ; Enable NMI Interrupt and Automatic Joypad reading ; NMI, V/H Count, and Joypad Enable
CODE_00838F:             LDY.b #$1F                ;
CODE_008391:             JSR.w WaitForHBlank       ; Wait for H-blank
CODE_008394:             LDA $22                   ; \ Adjust scroll settings for layer 3 
CODE_008396:             STA.w $2111               ;  | ; BG 3 Horizontal Scroll Offset
CODE_008399:               LDA $23                   ;  | 
CODE_00839B:             STA.w $2111               ;  | ; BG 3 Horizontal Scroll Offset
CODE_00839E:                LDA $24                   ;  | 
CODE_0083A0:             STA.w $2112               ;  | ; BG 3 Vertical Scroll Offset
CODE_0083A3:                LDA $25                   ;  | 
CODE_0083A5:              STA.w $2112               ; /  ; BG 3 Vertical Scroll Offset
CODE_0083A8:             LDA $3E                   ; \Set the layer BG sizes, L3 priority, and BG mode 
CODE_0083AA:              STA.w $2105               ; /(Effectively, this is the screen mode) ; BG Mode and Tile Size Setting
CODE_0083AD:                 LDA $40                   ; \Write CGADSUB 
CODE_0083AF:              STA.w $2131               ; / ; Add/Subtract Select and Enable
CODE_0083B2:               REP #$30                  ; \ Pull everything back ; Index (16 bit) Accum (16 bit) 
CODE_0083B4:                    PLB                       ;  | 
CODE_0083B5:                    PLY                       ;  | 
CODE_0083B6:                    PLX                       ;  | 
CODE_0083B7:                    PLA                       ;  | 
CODE_0083B8:                  PLP                       ; / 
EmptyHandler:                   RTI                       ; And Return 

CODE_0083BA:              BIT.w $0D9B               ; Get bit 6 of $0D9B ; Index (8 bit) Accum (8 bit) 
CODE_0083BD:               BVC CODE_0083E3           ; If clear, skip the next code section 
CODE_0083BF:                 LDY $11                   ; \Skip if $11 = 0 
CODE_0083C1:                 BEQ CODE_0083D0           ; / 
CODE_0083C3:              STA.w $4200               ; #$81 -> NMI / Controller Enable reg ; NMI, V/H Count, and Joypad Enable
CODE_0083C6:                 LDY.b #$14                
CODE_0083C8:             JSR.w WaitForHBlank       
CODE_0083CB:              JSR.w SETL1SCROLL         
CODE_0083CE:                 BRA CODE_0083A8           

CODE_0083D0:                INC $11                   ; $11++ 
CODE_0083D2:              LDA.w $4211               ; \ Set up the IRQ routine for layer 3 ; IRQ Flag By H/V Count Timer
CODE_0083D5:                 LDA.b #$AE                ;  |-\  
CODE_0083D7:                   SEC                       ;  |  |Vertical Counter trigger at 174 - $1888 
CODE_0083D8:              SBC.w $1888   ;  |-/ Oddly enough, $1888 seems to be 16-bit, but the 
CODE_0083DB:              STA.w $4209               ;  |Store to Vertical Counter Timer ; V-Count Timer (Upper 8 Bits)
CODE_0083DE:              STZ.w $420A               ; / Make the high byte of said timer 0 ; V-Count Timer MSB (Bit 0)
CODE_0083E1:                 LDA.b #$A1                ; A = NMI enable, V count enable, joypad automatic read enable, H count disable 
CODE_0083E3:              LDY.w $1493               ; if $1493 = 0 skip down 
CODE_0083E6:              BEQ CODE_0083F3           
CODE_0083E8:              LDY.w $1495               ; \ If $1495 is <#$40 
CODE_0083EB:               CPY.b #$40                ;  | 
CODE_0083ED:                BCC CODE_0083F3           ; / Skip down 
CODE_0083EF:                LDA.b #$81                
CODE_0083F1:               BRA IRQNMIEnding          ; Jump up to IRQNMIEnding 

CODE_0083F3:              STA.w $4200               ; A -> NMI/Joypad Auto-Read/HV-Count Control Register ; NMI, V/H Count, and Joypad Enable
CODE_0083F6:             JSR.w CODE_008439         
CODE_0083F9:                   NOP                       ; \Not often you see NOP, I think there was a JSL here at one point maybe 
CODE_0083FA:                  NOP                       ; / 
CODE_0083FB:             LDA.b #$07                ; \Write Screen register 
CODE_0083FD:             STA.w $2105               ; / ; BG Mode and Tile Size Setting
CODE_008400:              LDA $3A                   ; \ Write L1 Horizontal scroll 
CODE_008402:              STA.w $210D               ;  | ; BG 1 Horizontal Scroll Offset
CODE_008405:               LDA $3B                   ;  | 
CODE_008407:           STA.w $210D               ; /  ; BG 1 Horizontal Scroll Offset
CODE_00840A:              LDA $3C                   ; \ Write L1 Vertical Scroll 
CODE_00840C:              STA.w $210E               ;  | ; BG 1 Vertical Scroll Offset
CODE_00840F:              LDA $3D                   ;  | 
CODE_008411:             STA.w $210E               ; /  ; BG 1 Vertical Scroll Offset
CODE_008414:              BRA CODE_0083B2           ; And exit IRQ 

SETL1SCROLL:             LDA.b #$59                ; \ 
CODE_008418:             STA.w $2107               ; /Write L1 GFX source address ; BG 1 Address and Size
CODE_00841B:              LDA.b #$07                ; \Write L1/L2 Tilemap address 
CODE_00841D:             STA.w $210B               ; / ; BG 1 & 2 Tile Data Designation
CODE_008420:               LDA $1A    ; \ Write L1 Horizontal scroll 
CODE_008422:              STA.w $210D               ;  | ; BG 1 Horizontal Scroll Offset
CODE_008425:               LDA $1B    ;  | 
CODE_008427:              STA.w $210D               ; / ; BG 1 Horizontal Scroll Offset
CODE_00842A:                 LDA $1C    ; \ $1C + $1888 -> L1 Vert scroll 
CODE_00842C:                    CLC                       ;  |$1888 = Some sort of vertioffset 
CODE_00842D:             ADC.w $1888   ;  | 
CODE_008430:              STA.w $210E               ; / ; BG 1 Vertical Scroll Offset
CODE_008433:                 LDA $1D    ; \Other half of L1 vert scroll 
CODE_008435:              STA.w $210E               ; / ; BG 1 Vertical Scroll Offset
Return008438:                  RTS                       ; Return 

CODE_008439:               LDY.b #$20                ; <<- Could this be just to waste time? 
WaitForHBlank:            BIT.w $4212               ; So... LDY gets set with 20 if there is a H-Blank...? ; H/V Blank Flags and Joypad Status
CODE_00843E:             BVS CODE_008439           ; if in H-Blank, make Y #$20 and try again 
CODE_008440:             BIT.w $4212               ; Now wait until not in H-Blank ; H/V Blank Flags and Joypad Status
CODE_008443:                 BVC CODE_008440           
CODE_008445:                    DEY                       ;  |Y = 0 
CODE_008446:                 BNE CODE_008445           ; / ...wait a second... why didn't they just do LDY #$00? ...waste more time? 
Return008448:                   RTS                       ; return 
End: