;====================================
; SuperFX Patch by DiscoMan
; By using this patch, you can enable SuperFX for your ROM and thus work with awsome graphical effects like in Yoshi's Island or DOOM.
; Read the Readme for more details
; No Credit needed but claim as your own.
;====================================

HEADER
LOROM

!Freespace = $2A8000

org $FFBD	;\Expansion RAM Size
db $05		;/For the SuperFX

org $FFD6	;\Activate SuperFX
db $15		;/

org $FFD8	;\No SRAM necessary
db $00		;/

org $9CEF	;\Store save file number
STX $0D9C	;/

org $9BCC	;\X = Save file
LDX	$0D9C	;/

org $96B8	;\Repoint
STA $0DC3,x	;/Currently loaded sprite GFX files - stored in reverse order.

org $AA01	;\Repoint
LDA $0DC3,x	;/Currently loaded sprite GFX files - stored in reverse order.

org $AA13	;\Repoint
STA $0DC3,x	;/Currently loaded sprite GFX files - stored in reverse order.

org $9E48	;\Fix the repointed place
db $80,$01,$EA	;/

org $AA42	;\Repoint
LDA $60,x	;/Currently loaded layer GFX files - stored in reverse order.
NOP

org $AA54	;\Repoint
STA $60,x	;/Currently loaded layer GFX files - stored in reverse order.
NOP

org $AA64	;\Repoint
STA $60,x	;/Currently loaded layer GFX files - stored in reverse order.
NOP

org $B08D	;\Fix the repointed place
db $80,$01,$EA	;/

org $8058	;\$0109 - OW Loading Routine
STZ $0AF5	;/

org $8139	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $969C	;\$0109 - OW Loading Routine
ORA $0AF5	;/

org $96BE	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $96CF	;\$0109 - OW Loading Routine
STA $0AF5	;/

org $971A	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $9CB2	;\$0109 - OW Loading Routine
STA $0AF5	;/

org $9CF8	;\$0109 - OW Loading Routine
STZ $0AF5	;/

org $A096	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $01EC33	;\$0109 - OW Loading Routine
ORA $0AF5	;/

org $05B132	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $05B160	;\$0109 - OW Loading Routine
STZ $0AF5	;/

org $05B186	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $05D842	;\$0109 - OW Loading Routine
LDA $0AF5	;/

org $FFE0	;|Repoint Vector Info - Native
dw $0104,$0104,$0104,$0104,$0104,$0108,$8000,$010C

org $FFF0	;|Repoint Vector Info - Emulation
dw $0104,$0104,$0104,$0104,$0104,$0108,$8000,$010C

org $008064
JML InitSuperFX

org !Freespace
db "STAR"
dw End-Start
dw End-Start^#$FFFF

Start:
InitSuperFX:

        PHB								;\
        REP #$30						;|
        LDA.w #$0019-1					;|Copy SuperFX Execute Routine into RAM
        LDX.w #SuperFXExecuteData		;|Actually RAM $7F9C7B
        LDY.w #$9C7B					;|
        db $54							;|
        db $7F							;|
        db SuperFXExecuteData>>16		;|
        LDA.w #$017D-1					;|Copy IRQ into RAM
        LDX.w #IRQ						;|Actually RAM $7FAC9B
        LDY.w #$AC9B					;|
        db $54							;|
        db $7F							;|
        db IRQ>>16						;|
        LDA.w #$0020-1					;|Copy NMI into RAM
        LDX.w #NMI						;|Actually RAM $7FAC7B
        LDY.w #$AC7B					;|
        db $54							;|
        db $7F							;|
        db NMI>>16						;|
        SEP #$30						;|
        PLB								;/

	LDA #$03			;\Restore OLD code
	STA $2101			;/

        lda #$81			;\
        sta $3037	;!CFGR	;|
        sta $3039	;!CLSR	;|SuperFX Init Code
        sta $3033	;!BRAMR	;|
        stz $3038	;!SCBR	;/

	LDA #$01	;\SuperFX now runs at 21.4 MHz
	STA $3039	;/Change it to STZ if you want to run at ~10 MHz

	LDA #$40	;\RTI
	STA $0104	;/

	LDA #$5C	;\
	STA $0108	;|
	LDA #$7B	;|
	STA $0109	;|NMI Code Location
	LDA #$AC	;|Uses RAM $7FAC7B
	STA $010A	;|
	LDA #$7F	;|
	STA $010B	;/	
	
	LDA #$5C	;\
	STA $010C	;|
	LDA #$9B	;|
	STA $010D	;|IRQ Code Location
	LDA #$AC	;|Uses RAM $7FADB0
	STA $010E	;|
	LDA #$7F	;|
	STA $010F	;/

	JML $008069
	
SuperFXExecuteData:
incbin SuperFXFiles/SuperFXExecuteCode.bin

IRQ:
incbin SuperFXFiles/IRQ.bin

NMI:
incbin SuperFXFiles/NMI.bin
End: