;Store level and translevel number and level+save file number to freeram
;levelnum.ips origionally by BMF, fixed RATS by Chdata/Fakescaper
;Extra Overworld Level RAM origionally made by Imamelia, integrated into this patch by Chdata/Fakescaper
;Credit BMF and Imamelia
;Optionally credit Chdata
;
;New version: Includes a level number +current Save File ram address
;
;Imamelia's origional description for EOLR
;
;This patch gives you an "extra overworld level" RAM address, just in case you happen to need it but are already changing $13BF elsewhere (such as with NPCs). You can load the other address, which never changes (or, at least, it shouldn't) instead.
;
;Yes, I realize this patch is so short, the RATS tag makes up half of it. Who knows, it might come in handy.
;
;Lol why hasn't this been submitted to SMWC's patch section yet?
;Also this version of levelnum.ips is more compatible with other patches, since before it hijacked freespace in the unhacked rom which may or may not be used by someone else.
;Included the origional ips and zip for levelnum.ips and EOLR

header
lorom

org $FFD8			;SRAM Size
db $05				;32kb

!FREESPACE = $A68000

!S16BitLevelnum = $010B		;This would store the level number in $010B (High byte) and $010C (Low byte)
!S8BitLevelnum  = $010D		;This would make a backup of $13BF, incase you want to change and restore it or something
				;$010B will contain the level number as you see it in LM, such as 0105 or 0025
				;$010D will contain the translevel number, which is the level number of the level you first enter on the OW. It will be 8-bit and be 00-FF, levels 00-24 will be the same level as those numbers, but then 25 will be level 101 and so on. Levels 25-100 aren't supported and levels above 13B are also not supported. (13B would be FF)
!16BitSaveFileLevelnum = $010F	;This will be the same as $010B, except that it'll have the current save file added to it. It'll be stored to $010F-$0110

org $05D8B9			;Levelnum.ips
JSL Levelnummain		;Levelnum.ips

org $05D89B			;Extra Overworld Level RAM
JSL Messain			;Extra Overworld Level RAM

org !FREESPACE
db "STAR"
dw Endcode-Startcode
dw Endcode-Startcode^#$FFFF

Startcode:
Messain:
LDA $7ED000,x			;hijacked code	; take the overworld level number...
STA !S8BitLevelnum		;and store it to our new RAM address
RTL				;(it will still store to $13BF after returning from the JSL)

Levelnummain:
.StoreLevelNum
LDA $0E				;16-bit AXY
STA !S16BitLevelnum		;
PHA				;
SEP #$20			;8-bit A
XBA				;
CLC				;Take the current level number (high byte)
ADC $010A			;add the current save file
ADC $010A			;we need to do that x2
XBA				;
REP #$20			;16-bit A
STA !16BitSaveFileLevelnum	;store it to a different freeram (This'll be "$0600" levels)
PLA				;
ASL A				;
CLC				;People who know ASM should be able to figure out what they can do with this.
RTL

;org $05D8B9
;JSR Levelnummain
;org $05DC46
;Levelnummain:
;LDA $0E
;STA !FreeRAM
;ASL A
;RTS
Endcode:

print "I'm psychic, I knew that you would patch this."
print "-Chdata-"