; Wario Dash - by K3fka
; Give credit, please

!Freespace = $1E8000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   Defines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!DashRAM1 = $1DFD	;The dash timer
!DashRAM2 = $1DFE	;The dash cooldown timer
!DashTimer = #$1F	;Time you will dash for
!Cooldown = #$30	;Time before you can dash again
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

;-------------
; Hex edits
;-------------

org $8E6F   ;  \ hack the routine neccesary to start
JSL Routine ;  /
NOP #2

org !Freespace

!CodeSize = Ending-Routine ; \
db "STAR"		   ;  | All code preservation
dw !CodeSize-$01           ;  |
dw !CodeSize-$01^$FFFF     ; /

Routine:
;---------------------
JSL K3fka
LDA $0F31		; \ Restore the 
STA $0F25		; / Hijacked code.
RTL

DisableController:
STZ $15            ;  \
STZ $16            ;   | Keep the controller value zero, simulating no button press
STZ $17            ;   | This is JSR to to because it saves space, keeping some branches working
STZ $18            ;  /  (BRA, BNE, BCS, etc)
RTS

K3fka:

DashCheck:
LDA !DashRAM1	;\We're not dashing if our dash timer is zero
BEQ Check2	;/
LDA $72 	;\
ORA $73 	; |
ORA $74 	; |
ORA $75 	; |Cancel the dash under certain conditions
ORA $1470 	; |
ORA $148F 	; |
ORA $187A 	; |
BNE Cancel	;/
DEC !DashRAM1	;Decrease the dash timer
LDA #$04	;\
STA $13EE	; |Simulate sliding
LDA #$01	; |
STA $13ED	;/
LDA #$B3	;\Set the pose
STA $13E0	;/
JSR DisableController
LDA $76		;\Dash left if we're facing left
BEQ DashL	;/
LDA #$2A	;\
STA $7B		; |
BRA WallCheck	; |Handles moving based on direction
DashL:		; |
LDA #$D5	; |
STA $7B		;/
BRA WallCheck	;Then jump to the wall check

Check2:
LDA !DashRAM2	;\If the cooldown timer is zero, start the dash
BEQ ButtonCheck	;/
DEC !DashRAM2	;If not, decrease the cooldown timer
BRA End		;Jump to the end

ButtonCheck:
LDA $18		;\
AND #$40	; |Jump to the end if we're NOT pressing X
BEQ End		;/
LDA $19		;\Or if we are small
BEQ End		;/

BeginDash:
LDA $72 	;\
ORA $73 	; |
ORA $74 	; |
ORA $75 	; |Cancel the dash under certain conditions
ORA $1470 	; |
ORA $148F 	; |
ORA $187A 	; |
BNE Cancel	;/
LDA !DashTimer	;\Set the dash timer
STA !DashRAM1	;/
LDA !Cooldown	;\Set the cooldown timer
STA !DashRAM2	;/
LDA #$04	;\Play the sound effect
STA $1DFA	;/
BRA End		;Then jump to the end

WallCheck:
LDA $77		;\
AND #$03	; |Check to see if we're touching a wall
BEQ End		;/

Wall:
STZ $7B		;Stop moving
Cancel:
STZ !DashRAM1	;\Zero out the timers
STZ !DashRAM2	;/
STZ $13ED	;\Stop sliding
STZ $13EE	;/

End:
RTL

Ending:

;Done, son
