incsrc BlockDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Health Coin
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: A coin that will increase Yoshi's health by one. It can be
;	grabbed by touching it, throwing eggs or shells at it, or spitting seeds
;	at it.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JMP Main	; Below
JMP Main	; Above
JMP Main	; Side
JMP SpriteCHK	; SpriteV
JMP SpriteCHK	; SpriteH
JMP Return	; Cape
JMP Main	; Fireball
JMP Main	; Corner
JMP Return	; Body
JMP Return	; Head

Main:
	INC !FREERAM27	;   Give Yoshi one health.

	LDA #$01	;\
	STA $1DFC	;/  Play coin SFX.

;====================== Remove Block =======================

	LDA #$02
	STA $9C
	JSL $00BEB0

;===================== Glitter Effect ======================

	LDA $7F                   
        ORA $81                   
        BNE Return
        LDY #$03		
LoopStart:
        LDA $17C0,Y		
        BEQ CreateGlitter	
        DEY                    
        BPL LoopStart          

CreateGlitter:	
	LDA #$05                
        STA $17C0,Y             
        LDA $9A                   
        AND #$F0                
        STA $17C8,Y             
        LDA $98                   
        AND #$F0                
        STA $17C4,Y             
        LDA $1933               
        BEQ ADDR_00FD97           
        LDA $9A                   
        SEC                       
        SBC $26                   
        AND #$F0                
        STA $17C8,Y             
        LDA $98                   
        SEC                       
        SBC $28                   
        AND #$F0                
        STA $17C4,Y             
ADDR_00FD97:
        LDA #$10                
        STA $17CC,Y

Return:
	LDY #$00
	RTL

SpriteCHK:
CheckSprite:
	LDA $7FAB10,x
	AND #$08
	BEQ NotEggH

	LDA $7FAB9E,x
	CMP #!EggSprite_
	BEQ Continue

NotEggH:
	LDA $14C8,x	;\
	CMP #$09	;/ Check if the sprite in contact is carryable.
	BEQ Continue
	CMP #$0A
	BNE Return
Continue:
	LDA $0C
	STA $98
	LDA $0D
	STA $99
	LDA $0A
	STA $9A
	LDA $0B
	STA $9B
	LDA $0F

	JMP Main