incsrc BlockDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Key Door
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: A door that can only be opened if Yoshi has a key. Not the
;	original SMW key, but the custom ones that follow Yoshi around.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JMP MarioBelow
JMP MarioAbove
JMP MarioSide
JMP SpriteV
JMP SpriteH
JMP MarioCape
JMP MarioFireBall
JMP Corner
JMP Body
JMP Head

MarioBelow:
MarioAbove:
MarioSide:
	LDA !FREERAM1	; If Yoshi has no keys...
	BEQ Return	; then return.

	LDA $72
	BNE Return

	LDA $16		; If Yoshi is...
	AND #$08	; not pressing up...
	BEQ Return	; then return.

	LDA #$0F	; Play...
	STA $1DFC	; door SFX.

	DEC !FREERAM1	; Take away one of Yoshi's keys.

	LDA #$06	;\
	STA $71		; |
	STZ $88		; | Teleport Yoshi.
	STZ $89		;/

SpriteV:
SpriteH:
MarioCape:
MarioFireBall:
Corner:
Body:
Head:
Return:
	RTL