incsrc BlockDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; YI POW Block
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: A 16x16 version of the POW block from YI that will turn all
;	sprites on screen into stars.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JMP MarioBelow
JMP MarioAbove
JMP MarioSide
JMP SpriteV
JMP SpriteH
JMP MarioCape
JMP MarioFireBall
JMP Corner
JMP Body
JMP Head

MarioBelow:
	LDA #$09
	STA $1DFC			; Play sound effect

	LDA #$30
	STA $1887			; Shake ground

	LDA #$02
	STA $9C
	JSL $00BEB0			; Erase block

	LDX #$0B
SpriteExistLoop:
	LDA $14C8,x
	CMP #$08
	BCS CheckSilverPOW

	BRA SpriteLoopCall

CheckSilverPOW:
	LDA $190F,x
	AND #$40			; Check "Don't turn into a coin with silver POW" flag
	BEQ SpawnStar

SpriteLoopCall:
	DEX
	BPL SpriteExistLoop

	RTL

SpawnStar:
	LDA #!StarSprite
	STA $7FAB9E,x

	LDA #$01
	STA $14C8,x	; Initialize sprite

	JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
	JSL $0187A7             ;  get table values for custom sprite
	LDA #$88
	STA $7FAB10,x

	DEX
	BPL SpriteExistLoop	; Do this for all other sprite on screen

MarioAbove:
MarioSide:
SpriteV:
SpriteH:
MarioCape:
MarioFireBall:
Corner:
Body:
Head:
Return:
	RTL