incsrc BlockDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; YI Sand Block
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: These act just like the sandblocks from YI; you can shatter
;	it by either hitting it with an egg, hitting it from below, or
;	groundpounding on it from above. You can also throw shells or spit
;	seeds to break it.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JMP MarioBelow
JMP MarioAbove
JMP MarioSide
JMP SpriteV
JMP SpriteH
JMP MarioCape
JMP MarioFireBall
JMP Corner
JMP Body
JMP Head

MarioAbove:
Corner:
	LDA $140D
	BEQ Return
	JSR Shatter
	RTL
SpriteV:
	LDA $7FAB10,x
	AND #$08
	BEQ NotEggV

	LDA $7FAB9E,x
	CMP #!EggSprite_
	BEQ Continue

NotEggV:
	LDA $AA,x
	BPL Return

	LDA $14C8,x
	CMP #$09
	BNE Return

	LDA #$10
	STA $AA,x
	BRA Continue

SpriteH:
	LDA $7FAB10,x
	AND #$08
	BEQ NotEggH

	LDA $7FAB9E,x
	CMP #!EggSprite_
	BEQ Continue

NotEggH:
	LDA $14C8,x
	CMP #$0A
	BNE Return

CarriedSprite:
	LDY #$01	;\
	LDA #$30	; |
	STA $1693	;/  Make block solid.

Continue:
	LDA $0C
	STA $98
	LDA $0D
	STA $99
	LDA $0A
	STA $9A
	LDA $0B
	STA $9B
	LDA $0F
	JSR Shatter
	RTL
MarioFireBall:
	STZ $170B,x	; Destroy fireball (melon seed)
MarioBelow:
	LDY #$01	;\
	LDA #$30	; |
	STA $1693	;/  Make block solid.
	JSR Shatter
MarioSide:
Body:
Head:
Return:
	LDY #$01	;\
	LDA #$30	; |
	STA $1693	;/  Make block solid.
	RTL

MarioCape:
	LDY #$01	;\
	LDA #$30	; |
	STA $1693	;/  Make block solid.
	RTL

Shatter:
	PHY		;preserve map16 high

	PHB		;need to change bank
	LDA #$02
	PHA
	PLB		;to 02
	LDA #$00	;default shatter
	JSL $028663	;shatter block
	PLB		;restore bank

	LDA #$02
	STA $9C
	JSL $00BEB0

	PLY
	RTS