incsrc BlockDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; YI 16x16 Frozen Block
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: A 16x16 version of the frozen block from YI that can only
;	be melted by fire blasts from a red melon.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JMP Return
JMP Return
JMP Return
JMP FIAR
JMP FIAR
JMP Return
JMP Return
JMP Return
JMP Return
JMP Return

FIAR:
		LDA $7FAB9E,x
		CMP #!FIREBLASTSPRITE
		BNE Return

		LDA $0C
		STA $98
		LDA $0D
		STA $99
		LDA $0A
		STA $9A
		LDA $0B
		STA $9B
		LDA $0F

		JSR SUB_SMOKE		; / Show smoke effect

		LDA #$02		;\
		STA $9C			; | Generate blank block
		JSL $00BEB0		;/

		RTL

Return:
		LDY #$01	;\
		LDA #$30	; |
		STA $1693	;/  Make block solid.
		RTL

SUB_SMOKE:	LDY #$03		; \ find a free slot to display effect
FINDFREE:	LDA $17C0,y		;  |
		BEQ FOUNDONE		;  |
		DEY			;  |
		BPL FINDFREE		;  |
		RTS			; / return if no slots open

FOUNDONE:	LDA #$01		; \ set effect to smoke
		STA $17C0,y		; /

		LDA $D8,x		; \ set y pos of smoke
		STA $17C4,y		; /

		LDA $E4,x		; \ set x pos of smoke
		STA $17C8,y		; /

		LDA #$18		; \ set smoke duration
		STA $17CC,y		; /
		RTS