incsrc SpriteTrasmDefines.asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; YI Star
; By Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 	Description: This is the star from YI that will increase Yoshi's health
;	counter. This isn't the actual star sprite, however. The actual star
;	sprite is custom extended sprite $09, and all this sprite does is
;	generate a certain amount of those sprites. The sprites themself will
;	bounce around and disappear after a short while like YI's did.
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL         

                    dcb "MAIN"
                    PHB
                    PHK
                    PLB
                    JSR MainRoutine
                    PLB
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainReturn:
	RTS

MainRoutine:
	LDA $14C8,x
	BEQ MainReturn

	LDA $151C,x	; Get number of stars to generate
StarNumberLoop:
	LDX #$07
GenerateStarLoop:
	LDA $170B,x
	BEQ InitStarGen

	DEX
	BPL GenerateStarLoop

	LDX $15E9
	DEC $151C,x
	LDA $151C,x
	BPL StarNumberLoop

	STZ $14C8,x
	RTS

InitStarGen:
	TXY
	LDX $15E9
	PHX
	LDA #$09	; Custom extended sprite for star
	STA $170B,y
	LDA #$00
	STA $1765,y
	LDA $D8,x
	STA $1715,y
	LDA $E4,x
	STA $171F,y
	LDA $14D4,x
	STA $1729,y
	LDA $14E0,x
	STA $1733,y
	LDA $1632,x
	STA $1779,y
	TYX
	STX $15E9
	LDA #$E0
	STA $173D,x
	LDA $14
	CLC
	ADC $148E
	CLC
	ADC $15E9
	AND #$03
	TAY
	LDA XSPEEDTABLE,y
	STA $1747,x
	LDA INITTIMER,y
	STA $176F,x	; Initialize timer.
	PLX
	STX $15E9

	LDX $15E9
	DEC $151C,x
	LDA $151C,x
	BPL StarNumberLoop

	STZ $14C8,x

	RTS

XSPEEDTABLE
dcb $0C,$08,$F8,$F4

INITTIMER
dcb $FE,$DE,$EE,$CE