!FREESPACE3	=	$178000

org $029B16		; Hijack extended sprite pointer routine.

	LDA $170B,x
	db $F0,$FA

org $02A03E

	JSR CODE_02FFE2

org $029D9D

	JSL ExSprite_StarSetup
	RTS

org $02FFE2

CODE_02FFE2:
	JSL Fix_MelonSeedGFX
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FREESPACE3

db "STAR"					;\
dw ExSpriteEnd-ExSpriteStart-$01		; |Write RATS tag #1 to protect main code
dw ExSpriteEnd-ExSpriteStart-$01^$FFFF		;/

ExSpriteStart:
Custom_ExSprites:
	PHB
	PHK
	PLB
	JSR ExSprites_Main
	PLB
	RTL

ExSprites_Main:
	LDA $170B,x
	JSL $0086E1	; JSL.L ExecutePtr

ExSprites_Pointers:
	dw ExSprite_Star	; 13
	dw ExSprite_StarHurt	; 14

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!GetSpriteClippingA = $03B69F
!CheckForContact = $03B72B
!GivePoints = $02ACE5
!InitSpriteTables = $07F7D2

Fix_MelonSeedGFX:
	PHB
	PHK
	PLB
	JSR CODE_02A1A7
	PLB
	RTL

CODE_02A1A7:
	LDA.w $1747,X
	AND.b #$80
	EOR.b #$80
	LSR
	STA $00
	LDA.w $171F,X
	SEC
	SBC $1A
	STA $01
	LDA.w $1733,X
	SBC $1B
	BNE CODE_02A211
	LDA.w $1715,X
	SEC
	SBC $1C
	STA $02
	LDA.w $1729,X
	SBC $1D
	BNE CODE_02A211
	LDA $02
	CMP.b #$F0
	BCS CODE_02A211
	STA.w $0201,Y
	LDA $01
	STA.w $0200,Y
	LDA.w $1779,X
	STA $01
	LDA $14
	LSR
	LSR
	AND.b #$03
	TAX
	LDA.w FireballTiles,X
	STA.w $0202,Y
	LDA.w DATA_02A15F,X
	EOR $00
	ORA $64
	STA.w $0203,Y
	LDX $01
	BEQ CODE_02A204
	AND.b #$CF
	ORA.b #$10
	STA.w $0203,Y
CODE_02A204:
	TYA
	LSR
	LSR
	TAY
	LDA.b #$00
	STA.w $0420,Y
	LDX.w $15E9
	RTS

CODE_02A211:
	LDA.b #$00
	STA.w $170B,X
	RTS

FireballTiles:
	db $1E,$1E,$1E,$1E

DATA_02A15F:
	db $04,$04,$04,$04

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Star_Tile	=	$EF

ExSprite_StarSetup:
	PHB
	PHK
	PLB
	JSR ExSprite_Star
	PLB
	RTL

ExSprite_StarErase:
	STZ $170B,x
	RTS

ExSprite_Star:
	;RTS

	LDA $1765,x
	BPL ExSprite_CollectibleStar

	JMP ExSprite_StarHurt

ExSprite_CollectibleStar:
	LDA $14
	AND #$01
	BNE ExSprite_StarSkipTimer

	INC $176F,x		; Increase stay on screen timer

	LDA $176F,x
	CMP #$40
	BCC ExSprite_GFXBlink

ExSprite_StarSkipTimer:
	JSR ExSprite_SubGFX

ExSprite_GFXBlink:
	LDA $176F,x
	BEQ ExSprite_StarErase

	JSR ExSprUpdateXPos
	JSR ExSprUpdateYPos	; Update X and Y positions with speed

	LDA $173D,x
	BMI ExSprite_StarGravity
	CMP #$30
	BCS ExSprite_StarMaxSpeed

ExSprite_StarGravity:
	LDA $173D,x
	CLC
	ADC #$04
	STA $173D,x		; Increase Y speed by 4 every frame

ExSprite_StarMaxSpeed:
	JSR ExSprObjContact
	BCC Ex_Sprite_StarPlayerInteract
	INC $1765,X
	LDA $1765,X
	CMP #$02
	BCS Ex_Sprite_StarBounceWalls

	LDA $173D,x
	EOR #$FF
	INC A
	STA $173D,x		; Reverse Y velocity
	BRA ExSprite_NoResetInteraction

Ex_Sprite_StarBounceWalls:
	LDA $1747,x
	EOR #$FF
	INC A
	STA $1747,x		; Reverse X velocity
	BRA ExSprite_NoResetInteraction

Ex_Sprite_StarPlayerInteract:
	STZ $1765,x
ExSprite_NoResetInteraction:
	LDA $13F9
	EOR $1779,x
	BNE ExSprite_StarPlayerInteractReturn
	JSL $03B664

	PHB
	LDA #$02
	PHA
	PLB
	PHK
	PEA.w .jslrtsreturn-1
	PEA $D443 ; value of a RTL minus 1 in the target bank
	JML $02A519 ;location to jump to
.jslrtsreturn
	PLB

	JSL $03B72B
	BCC ExSprite_StarPlayerInteractReturn

	INC !FREERAM27		; Increase Yoshi's health by 1

	LDA #$01
	STA $1DFC		; Play coin SFX

	STZ $170B,x		; Delete sprite

ExSprite_StarPlayerInteractReturn:
	RTS			; Return

ExSprite_SubGFX:
	LDA $1715,x   
	SEC                       
	SBC $1C    
	CMP #$F0                
	BCS CODE_029D5A           
	STA $01                   
	LDA $171F,x   
	CMP $1A   
	LDA $1733,x   
	SBC $1B    
	BNE Return029D5D          
	LDA ExSprite_OAMIndex,x	; Get sprite index to OAM
	TAY
	STY $0F
	LDA $171F,x   
	SEC
	SBC $1A
	STA $00                   
	STA $0200,y
	LDA $01                   
	STA $0201,y 
	LDA #!Star_Tile                
	STA $0202,y
	PHX
	LDA $1779,x      ; Extended sprite goes behind layers flag
	EOR #$01
	ASL #5
	PHA
	LDA $176F,x
	AND #$03
	TAX
	PLA
	ORA ExSprite_StarPalTBL,x
	PLX
	STA $0203,y		; YXPPCCCT

	TYA
	LSR A
	LSR A
	TAY

	LDA #$00                
	STA $0420,y             
	RTS			; Return 

CODE_029D5A:
	STZ $170B,x		; Clear extended sprite 
Return029D5D:
	RTS			; Return 

ExSprite_StarPalTBL:
	db $04,$06,$08,$0A

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ExSprite_StarHurt:
	LDA $1765,x
	AND #$40
	BEQ ExSprite_NoEgg

	JSR ExSprite_Egg
	RTS

ExSprite_NoEgg:
	LDA $14
	LSR A
	STA $176F,x
	JSR ExSprite_SubGFX

	JSL $03B72B

	JSR ExSprUpdateXPos
	JSR ExSprUpdateYPos	; Update X and Y positions with speed

	LDA $173D,x
	BMI ExSprite_StarHurtGravity
	CMP #$30
	BCS ExSprite_StarHurtMaxSpeed

ExSprite_StarHurtGravity:
	LDA $173D,x
	CLC
	ADC #$04
	STA $173D,x		; Increase Y speed by 4 every frame
ExSprite_StarHurtMaxSpeed:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ExSprite_Egg:
	PHX
	JSR ExSprite_EggGFX
	PLX

	JSR ExSprUpdateXPos
	JSR ExSprUpdateYPos	; Update X and Y positions with speed

	LDA $173D,x
	BMI ExSprite_EggGravity
	CMP #$30
	BCS ExSprite_EggMaxSpeed

ExSprite_EggGravity:
	LDA $173D,x
	CLC
	ADC #$04
	STA $173D,x		; Increase Y speed by 4 every frame
ExSprite_EggMaxSpeed:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ExSprite_EggGFX:
	LDA $1715,x   
	SEC                       
	SBC $1C    
	CMP #$F0                
	BCS CODE_029D5A           
	STA $01                   
	LDA $171F,x   
	CMP $1A   
	LDA $1733,x   
	SBC $1B    
	BNE NoReturn029D5D          
	LDA ExSprite_OAMIndex,x	; Get sprite index to OAM
	TAY
	STY $0F
	LDA $171F,x   
	SEC
	SBC $1A
	STA $00                   
	STA $0200,y
	LDA $01                   
	STA $0201,y 
	LDA #!EggTILEGFXTHING
	STA $0202,y
	;LDA $1765,x
	;AND #$BF
	;STA $02
	LDA $1779,x      ; Extended sprite goes behind layers flag
	EOR #$01
	ASL #5
	ORA $1765,x
	STA $0203,y		; YXPPCCCT

	TYA
	LSR A
	LSR A
	TAY

	LDA #$02
	STA $0420,y

NoReturn029D5D:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ExSprite_OAMIndex:
db $90,$94,$98,$9C,$A0,$A4,$A8,$AC

ExSprObjContact:

; $02A56E		;

STZ $0F			;
STZ $0E			;
STZ $0B			;
STZ $1694		;
LDA $140F		;
BNE Code02A5BC	;
LDA $0D9B		;
BPL Code02A5BC	;
AND #$40		;
BEQ Code02A592	;
LDA $0D9B		;
CMP #$C1		;
BEQ Code02A5BC	;
LDA $1715,x		;
CMP #$A8		;
RTS				;

Code02A592:		;
LDA $171F,x		;
CLC				;
ADC #$04		;
STA $14B4		;
LDA $1733,x		;
ADC #$00		;
STA $14B5		;
LDA $1715,x		;
CLC				;
ADC #$08		;
STA $14B6		;
LDA $1729,x		;
ADC #$00		;
STA $14B7		;
JSL $81CC9D		;
LDX $15E9		;
RTS				;

Code02A5BC:		;
JSR Code02A611	;
ROL $0E			;
LDA $1693		;
STA $0C			;
LDA $5B			;
BPL Code02A60C	;
INC $0F			;
LDA $171F,x		;
PHA				;
CLC				;
ADC $26			;
STA $171F,x		;
LDA $1733,x		;
PHA				;
ADC $27			;
STA $1733,x		;
LDA $1715,x		;
PHA				;
CLC				;
ADC $28			;
STA $1715,x		;
LDA $1729,x		;
PHA				;
ADC $29			;
STA $1729,x		;
JSR Code02A611	;
ROL $0E			;
LDA $1693		;
STA $0D			;
PLA				;
STA $1729,x		;
PLA				;
STA $1715,x		;
PLA				;
STA $1733,x		;
PLA				;
STA $171F,x		;
Code02A60C:		;
LDA $0E			;
CMP #$01		;
RTS				;

Code02A611:		;
LDA $0F			;
INC				;
AND $5B			;
BEQ Code02A679	;
LDA $1715,x		;
CLC				;
ADC #$08		;
STA $98			;
AND #$F0		;
STA $00			;
LDA $1729,x		;
ADC #$00		;
CMP $5D			;
BCS Code02A677	;
STA $03			;
STA $99			;
LDA $171F,x		;
CLC				;
ADC #$04		;
STA $01			;
STA $9A			;
LDA $1733,x		;
ADC #$00		;
CMP #$02		;
BCS Code02A677	;
STA $02			;
STA $9B			;
LDA $01			;
LSR #4			;
ORA $00			;
STA $00			;
LDX $03			;
LDA $80BA80,x	;
LDY $0F			;
BEQ Code02A660	;
LDA $80BA8E,x	;
Code02A660:		;
CLC				;
ADC $00			;
STA $05			;
LDA $80BABC,x	;
LDY $0F			;
BEQ Code02A671	;
LDA $80BACA,x	;
Code02A671:		;
ADC $02			;
STA $06			;
BRA Code02A6DB	;

Code02A677:		;
CLC				;
RTS				;

Code02A679:		;
LDA $1715,x		;
CLC				;
ADC #$08		;
STA $98			;
AND #$F0		;
STA $00			;
LDA $1729,x		;
ADC #$00		;
STA $02			;
STA $99			;
LDA $00			;
SEC				;
SBC $1C			;
CMP #$F0		;
BCS Code02A677	;
LDA $171F,x		;
CLC				;
ADC #$04		;
STA $01			;
STA $9A			;
LDA $1733,x		;
ADC #$00		;
CMP $5D			;
BCS Code02A677	;
STA $03			;
STA $9B			;
LDA $01			;
LSR #4			;
ORA $00			;
STA $00			;
LDX $03			;
LDA $80BA60,x	;
LDY $0F			;
BEQ Code02A6C6	;
LDA $80BA70,x	;
Code02A6C6:		;
CLC				;
ADC $00			;
STA $05			;
LDA $80BA9C,x	;
LDY $0F			;
BEQ Code02A6D7	;
LDA $80BAAC,x	;
Code02A6D7:		;
ADC $02			;
STA $06			;

Code02A6DB:		;
LDA #$7E			;
STA $07			;
LDX $15E9		;
LDA [$05]		;
STA $1693		;
INC $07			;
LDA [$05]		;
JSL $80F545		;
CMP #$00		;
BEQ Code02A729	;
LDA $1693		;
CMP #$11		;
BCC Code02A72B	;
CMP #$6E		;
BCC Code02A727	;
CMP #$D8		;
BCS Code02A735	;
LDY $9A			;
STY $0A			;
LDY $98			;
STY $0C			;
JSL $80FA19		;
LDA $00			;
CMP #$0C		;
BCS Code02A718	;
CMP [$05],y		;
BCC Code02A729	;
Code02A718:		;
LDA [$05],y		;
STA $1694		;
PHX				;
LDX $08			;
LDA $80E53D,x	;
PLX				;
STA $0B			;
Code02A727:		;
SEC				;
RTS				;

Code02A729:		;
CLC				;
RTS				;

Code02A72B:		;
LDA $98			;
AND #$0F		;
CMP #$06		;
BCS Code02A729	;
SEC				;
RTS				;

Code02A735:		;
LDA $98			;
AND #$0F		;
CMP #$06		;
BCS Code02A729	;
LDA $1715,x		;
SEC				;
SBC #$02			;
STA $1715,x		;
LDA $1729,x		;
SBC #$00			;
STA $1729,x		;
JMP Code02A611	;

ExSprUpdateXPos:

LDA $1747,x		;
ASL #4			;
CLC				;
ADC $175B,x		;
STA $175B,x		;
PHP				;
LDY #$00			;
LDA $1747,x		;
LSR #4			;
CMP #$08		;
BCC $03			;
ORA #$F0		;
DEY				;
PLP				;
ADC $171F,x		;
STA $171F,x		;
TYA				;
ADC $1733,x		;
STA $1733,x		;
RTS				;

ExSprUpdateYPos:

LDA $173D,x		;
ASL #4			;
CLC				;
ADC $1751,x		;
STA $1751,x		;
PHP				;
LDY #$00			;
LDA $173D,x		;
LSR #4			;
CMP #$08		;
BCC $03			;
ORA #$F0		;
DEY				;
PLP				;
ADC $1715,x		;
STA $1715,x		;
TYA				;
ADC $1729,x		;
STA $1729,x		;
RTS				;

ExSpriteEnd: