; These are the things you may or may not need to edit for the patch.

CursorGFXTILETHING	=	$0E	; Sprite tile for cursor.
EggTILEGFXTHING	=	$26	; Sprite tile for egg.
KeyTile		=	$EC	; Sprite tile for key.
EggSprite_		=	$01	; Sprite value for YIEgg.cfg.
EggSprite_2		=	$02	; Sprite value for YIEgg_Collectable.cfg
FROZENSPRITE		=	$08	; Sprite value for FrozenSprite.cfg (Only applicable if using the ice melon powerup for your hack, otherwise ignore this)
KeySprite		=	$0B	; Sprite value for Yoshikey.cfg
FIREBLASTSPRITE	=	$06	; Sprite value for Fireblast.cfg
ICEBLASTSPRITE		=	$07	; Sprite value for IceBlast.cfg
StarSprite		=	$09	; Sprite value for HealthStar.cfg.
Starbiticon		=	$EF	; Sprite tile for health icon.
X_icon			=	$1D	; Sprite tile for "x" icon in the health menu.
Counter_ExAnimSlot	=	$C2	; ExAnimated sprite tile value for the health counter.

TongueBaseTile_	=	$5A	; \
TongueEndTile_		=	$5B	;  |
TongueTopTile_		=	$0F	;  | Sprite tiles for Yoshi's tongue.
TongueUpTile_		=	$1F	; /

;;;;;;;;;;;;;;;;;;;;;;;;;; FREE RAM DOCUMENTATION (You should probably leave these alone) ;;;;;;;;;;;;;;;;;;;;;;;;;;

;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM1		=	$0DC4		;; 1 byte	;; DESCRIPTION: Number of keys that Yoshi has,    ;;
						;;		;; they will follow Yoshi around and disappear    ;;
						;;		;; whenever they are used.                        ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM2		=	$0DC5		;; 1 byte	;; DESCRIPTION: Number of eggs that Yoshi has,    ;;
						;;		;; they will follow Yoshi around.                 ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM3		=	$63		;; 1 byte	;; DESCRIPTION: "Yoshi is carrying something in   ;;
						;;		;; his mouth" flag. Is also used as a counter for ;;
						;;		;; determining how many times Yoshi can spit      ;;
						;;		;; something out, such as the seeds for the melon ;;
						;;		;; powerup.                                       ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM4		=	$7FB700		;; 6 bytes	;; DESCRIPTION: RAM table for the properties of   ;;
						;;		;; the items that follow Yoshi:                   ;;
						;;		;;	$00 = Green Egg                           ;;
						;;		;;	$01 = Yellow Egg                          ;;
						;;		;;	$02 = Red Egg                             ;;
						;;		;;	$03 = Key                                 ;;
						;;		;; ($7FB706 and $7FB6FF are also temporarily used ;;
						;;		;; while switching through eggs.)                 ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM5		=	$7FB6C0		;; 48 bytes	;; DESCRIPTION: Circular buffer that determines   ;;
						;;		;; whether the items following Yoshi are on the   ;;
						;;		;; ground or not.                                 ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM6		=	$7FB600		;; 192 bytes	;; DESCRIPTION: Circular buffer that determines   ;;
						;;		;; the absolute coordinates of the items that     ;;
						;;		;; follow Yoshi within the level.                 ;;
						;;		;; 4 bytes each: First 2 bytes are the 16-bit X   ;;
						;;		;; coordinate. Last 2 bytes are the 16-bit Y      ;;
						;;		;; coordinate.                                    ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM7		=	$1696		;; 1 byte	;; DESCRIPTION: Holds the consecutive enemy stomp ;;
						;;		;; counter value of the previous frame, to        ;;
						;;		;; determine whether or not Yoshi should flutter  ;;
						;;		;; jump higher when bouncing off an enemy.        ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM8		=	$1864		;; 1 byte	;; DESCRIPTION: "Yoshi can flutter jump higher"   ;;
						;;		;; flag.                                          ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM9		=	$1DFD		;; 2 bytes	;; DESCRIPTION: (16-bit) Egg switching timer.     ;;
						;;		;; Decrements by 4 every fram until it hits 0     ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM10		=	$1869		;; 1 byte	;; DESCRIPTION: Index for the item following      ;;
						;;		;; Yoshi that will be sent to the back when Yoshi ;;
						;;		;; cancels out of an egg throw.                   ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM11		=	$0DDC		;; 1 byte	;; DESCRIPTION: "Yoshi has stuck his tongue out"  ;;
						;;		;; flag:                                          ;;
						;;		;;	$01 = Stuck tongue out sideways.          ;;
						;;		;;	$02 = Stuck tongue out upward.            ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM12		=	$0F3C		;; 1 byte	;; DESCRIPTION: Timer to show swallowing pose.    ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM13		=	$140B		;; 1 byte	;; DESCRIPTION: "Display egg-throw cursor" flag.  ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM14		=	$13C8		;; 1 byte	;; DESCRIPTION: Used to temporarily preserve      ;;
						;;		;; Yoshi's direction while egg-throwing.          ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM15		=	$7C		;; 1 byte	;; DESCRIPTION: Egg cursor position index.        ;;
						;;		;; Increases by 1 each frame. Loops back to $00   ;;
						;;		;; once it reaches $80.                           ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM16		=	$87		;; 1 byte	;; DESCRIPTION: "Egg cursor is locked" flag.      ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM17		=	$0F3A		;; 1 byte	;; DESCRIPTION: Temporary placeholder for the X   ;;
						;;		;; speed of an egg before it's thrown.            ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM18		=	$0F3B		;; 1 byte	;; DESCRIPTION: Temporary placeholder for the Y   ;;
						;;		;; speed of an egg before it's thrown.            ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM19		=	$1923		;; 2 bytes	;; DESCRIPTION: (16-bit) Index for the circular   ;;
						;;		;; buffer for item's coordinates. Increases by 4  ;;
						;;		;; each frame and loops back to $00 once it       ;;
						;;		;; reaches $C0.                                   ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM20		=	$1926		;; 2 bytes	;; DESCRIPTION: (16-bit) Pretty much the same as  ;;
						;;		;; FREERAM19 but divided by 4.                    ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM21		=	$0DD9		;; 1 byte	;; DESCRIPTION: Used to temporarily preserve      ;;
						;;		;; Yoshi's direction while he sticks his tongue   ;;
						;;		;; out.                                           ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM22		=	$0F5E		;; 1 byte	;; DESCRIPTION: Timer for how long Yoshi has his  ;;
						;;		;; tongue stuck out. Increases by 1 every frame:  ;;
						;;		;;	$00 - $0F = Tongue is stretching out.     ;;
						;;		;;	$10 - $1F = Tongue is retracting.         ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM23		=	$0F5F		;; 20 bytes	;; DESCRIPTION: (16-bit) Table that determines    ;;
						;;		;; how much to offset each of the tongue          ;;
						;;		;; segments. $0F5F also holds the length of the   ;;
						;;		;; tongue.                                        ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM24		=	$15E8		;; 1 byte	;; DESCRIPTION: Egg-throw frame timer.            ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM25		=	$1F2D		;; 1 byte	;; DESCRIPTION: "Tongue has grabbed something"    ;;
						;;		;; flag.                                          ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM26		=	$13E6		;; 1 byte	;; DESCRIPTION: Holds the index of the sprite     ;;
						;;		;; Yoshi has grabbed with his tongue.             ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM27		=	$1FFA		;; 1 byte	;; DESCRIPTION: Yoshi's health counter.           ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM28		=	$1FFF		;; 1 byte	;; DESCRIPTION: Determines the amount of health   ;;
						;;		;; that should be taken away from Yoshi when he   ;;
						;;		;; gets hurt.                                     ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM29		=	$0DDB		;; 1 byte	;; DESCRIPTION: "Rapid-firing" flag. Basically,   ;;
						;;		;; when set, Yoshi can spit an item out of his    ;;
						;;		;; mouth continuously when holding X or Y. Used   ;;
						;;		;; for the seeds in the melon powerup.            ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM30		=	$0F47		;; 1 byte	;; DESCRIPTION: "Yoshi is spitting upward" flag.  ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM31		=	$62		;; 1 byte	;; DESCRIPTION: Groundpounding flag.              ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM32		=	$0DC3		;; 1 byte	;; DESCRIPTION: Timer that determines how long    ;;
						;;		;; Yoshi should spin in the air before actually   ;;
						;;		;; groundpounding. When it reaches $10, he'll     ;;
						;;		;; stop spinning.                                 ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM33		=	$0AF5		;; 1 byte	;; DESCRIPTION: Flutter-jumping flag.             ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM34		=	$60		;; 1 byte	;; DESCRIPTION: "Consecutive flutter-jumping in   ;;
						;;		;; air" flag.                                     ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM35		=	$1F48		;; 1 byte	;; DESCRIPTION: Dying flag.                       ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------
						;;		;;						  ;;
FREERAM36		=	$17BB		;; 1 byte	;; DESCRIPTION: Holds the index of the sprite on  ;;
						;;		;; screen that is frozen.                         ;;
						;;		;;						  ;;
;-------------------------------------------------------------------------------------------------------------------