!FREESPACE1	=	$198000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

org $02962C

	JSL TongueInteract_LayerJSR

org $00A2D8

	JSL MAIN_ROUTINES

org $00A5AB

	JSL INIT_ROUTINES

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FREESPACE1		; freespace

db "STAR"				;\
dw YoshiEnd-YoshiStart-$01		; |Write RATS tag #1 to protect main code
dw YoshiEnd-YoshiStart-$01^$FFFF	;/

YoshiStart:
INIT_ROUTINES:
	STZ $1497
	STZ !FREERAM35

CheckCarriedSpriteNotLoop:
	LDX #$0B
CheckCarriedSprite:
	LDA $14C8,x
	CMP #$0B
	BEQ TurnIntoEatenSprite

	DEX
	BPL CheckCarriedSprite
	BRA DontTurnIntoEatenSprite

TurnIntoEatenSprite:
	LDA #$07
	STA $14C8,x
	BRA SkipNotEatenSprite

DontTurnIntoEatenSprite:
	STZ !FREERAM3

SkipNotEatenSprite:

FixEggColors:
	LDX #$05
FixEggColors_Loop:
	LDA !FREERAM4,x
	CMP #$55
	BEQ PaletteIndex00
	CMP #$FF
	BEQ PaletteIndex00

	DEX
	BPL FixEggColors_Loop

	BRA SkipEggColors

PaletteIndex00:
	LDA #$00
	STA !FREERAM4,x

	DEX
	BPL FixEggColors_Loop

SkipEggColors:

InitFollowEggs:
	LDX #$2F
InitFollowEggsLoop:
	LDA #$00
	STA !FREERAM5,x

	DEX
	CPX #$FF
	BNE InitFollowEggsLoop

	LDX #$BC
InitFollowEggsLoop1:
	REP #$20

	LDA $94
	STA !FREERAM6,x
	LDA $96
	CLC
	ADC #$0010
	STA !FREERAM6+$2,x

	SEP #$20

	DEX
	DEX
	DEX
	DEX
	CPX #$FC
	BCC InitFollowEggsLoop1

InitFollowEggsEnd:
	JSL $05809E	; Restore hijacked code
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_ROUTINES:
	PHB
	PHK
	PLB
	JSR Eggthrow
	PLB
	JSL $00E2BD	; Restore hijacked code
	RTL

Eggthrow:
	LDA $9D		; If sprites are locked...
	ORA $1493	; or level is ending...
	BNE SkipSomeOfTheJSRs

	JSR DisableControls
	JSR YoshiMouthPowerStatus
	JSR Flutterjump
	JSR Groundpound
	JSR YoshiEat
	JSR StandStill
	JSR TongueGrab
	JSR Swallowing
	JSR SpitEnemy
	JSR Spitting
	JSR HeathCounter
	JSR StuffInMouth
	JSR TongueBlockInteraction
	JSR FixBerries

	LDA $77
	AND #$04
	BNE ResetFlutterBoost

	LDA !FREERAM7		;
	CMP $1697		; If Yoshi has just bounced off of an enemy...
	BCS NoFlutterBoost	; Set flutter jump boost flag.

	LDA #$01
	STA !FREERAM8		; Free RAM - Flutter jump boost flag.
	BRA NoFlutterBoost

ResetFlutterBoost:
	STZ !FREERAM8

NoFlutterBoost:
	LDA $1697
	STA !FREERAM7	; Store consecutive enemies stomped counter to freeram.

SkipSomeOfTheJSRs:
	JSR HealthStarbit
	JSR HealthFix
	JSR ThrowPose
	JSR FrozenSprite
	JSR CarryThroughPipes
	JSR MidpointFix
	JSR KeyFollow
	JSR NoMoveDucking
	JSR EggFollow
	JSR GoalFix

	REP #$20
	LDA !FREERAM9
	BEQ SkipEggRotate
	LDA !FREERAM9
	SEC
	SBC #$0004
	STA !FREERAM9	; Decrease egg rotating timer until it hits $0000
	BRA DontSkipEggRotate
SkipEggRotate:
	SEP #$20
	STZ !FREERAM10

DontSkipEggRotate:
	SEP #$20
	LDA $9D		; If sprites are locked...
	ORA $1493	; or level is ending...
	BEQ ContinueEggThrow

	RTS

ContinueEggThrow:
	STZ $00
	LDX #$0B
StdLoop:
	LDA $14C8,x
	BNE StdLoop2

	DEX
	BPL StdLoop

	BRA StdLoop5

StdLoop2:
	LDA $7FAB10,x
	AND #$08
	BNE StdLoop3

	DEX
	BPL StdLoop

	BRA StdLoop5

StdLoop3:
	LDA $7FAB9E,x
	CMP #!EggSprite_
	BNE StdLoop4

	INC $00

StdLoop4:
	DEX
	BPL StdLoop

StdLoop5:
	LDA $00
	BEQ Display_Cursor

ReturnStdN:
	JMP FORXENEND

Display_Cursor:
	LDA !FREERAM11	; If eating...
	ORA !FREERAM12	; ...or swallowing
	BNE M3_Return	; ...then return.

	LDA !FREERAM13
	BNE M3_Cursor

	LDA $18
	AND #$80	; If pressing A...
	BEQ M3_Return

	LDA !FREERAM2
	BNE Set_ThrowFlag	; Check if Yoshi has at least one egg

	LDA #$2A
	STA $1DFC	; Play "wrong" sound

	JMP FORXENEND

Set_ThrowFlag:
	LDA #$01
	STA !FREERAM13	; Set egg-throwing flag.

	LDA $76
	STA !FREERAM14	; Store Yoshi's direction to freeram...

	LDA #$40
	STA !FREERAM15	; Initialize cursor position.

M3_Return:
	JMP FORXENEND

M3_Cursor:
	LDA !FREERAM14
	STA $76		; ...store freeram back into Yoshi's direction to prevent him from turning around.

	LDA $16
	AND #$04
	BNE M3_EggRE

	LDA $74
	BNE M3_EggRE

	JMP M3_IfPressA

M3_EggRE:
	STZ !FREERAM13	; Reset cursor flag.
	STZ !FREERAM16	; Reset lock flag.

	LDX #$00
M3_ShiftEggLoop:
	LDA !FREERAM4,x
	STA !FREERAM4-$1,x
	INX
	CPX !FREERAM2
	BNE M3_ShiftEggLoop

	LDA !FREERAM2
	DEC A
	TAX
	LDA !FREERAM4-$1
	STA !FREERAM4,x	; Shift ram table

	LDA !FREERAM2
	STA !FREERAM10	; Which egg following Yoshi should be sent to the back.
	DEC A
	ASL A
	TAX

	REP #$20
	LDA EggRotate_TBL,x
	STA !FREERAM9	; Set egg switching timer.
	SEP #$20

	JMP FORXENEND

M3_IfPressA:
	LDA $18
	AND #$80
	BEQ M3_SoundEffect

	STZ !FREERAM13	; Reset cursor flag.
	STZ !FREERAM16	; Reset lock flag.
	JSR ThrowEgg	; Jump to the egg-throwing routine.
	JMP FORXENEND

M3_SoundEffect:
	LDA $14
	AND #$03
	BNE M3_Cursor_1

	LDA #$01	; 13
	STA $1DFC	; 1df9

M3_Cursor_1:
	LDX $13E0
	LDA YoshiFrame_TBL,x
	STA $13E0

GetFrAMQS:
	LDA $80
	CLC
	ADC #$0C
	STA $0325

	LDA #!EggTILEGFXTHING
	STA $0326

	LDA !FREERAM4
	TAX
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	ORA EggPaletteTBL,x
	STA $0327

	LDA #$02
	STA $0469

	LDA $76
	BEQ GetFrAMQS_1

	LDA $7E
	SEC
	SBC #$08
	STA $0324
	BRA GetFrAMQS_2

GetFrAMQS_1:
	LDA $7E
	CLC
	ADC #$08
	STA $0324

GetFrAMQS_2:
	LDA !FREERAM16
	BNE LOCKCHK

	LDA $15
	AND #$08	; If holding up...
	BEQ LOCKCHK

	LDA !FREERAM15
	AND #$7F
	BEQ PauseCursor

	LDA !FREERAM15
	AND #$7F
	CMP #$40
	BCS Costum_Timer

	DEC !FREERAM15
	DEC !FREERAM15	; Make cursor go back to up position.
	BRA Costum_Timer

LOCKCHK:
	LDA $18
	AND #$10	; If pressing R...
	BEQ Costum_Timer

	LDA !FREERAM16
	EOR #$01
	STA !FREERAM16	; Flip lock flag.

Costum_Timer:
	LDA !FREERAM16	; Check lock flag.
	BNE PauseCursor

	INC !FREERAM15	; Increase cursor position.

PauseCursor:
	LDA !FREERAM15	; RAM timer for cursor position.
	AND #$7F
	TAX

	LDA M3_CursorY_TBL,x
	CLC
	ADC #$29	; #$29
	STA $02

	LDA M3_CursorY_TBL,x
	EOR #$FF
	INC A
	BMI Y_Angle_Negative

	ASL A
	STA !FREERAM18
	BRA X_Angle

Y_Angle_Negative:
	EOR #$FF
	INC A
	ASL A
	EOR #$FF
	INC A
	STA !FREERAM18

X_Angle:
	LDA $76
	BNE X_Angle_Right

	LDA M3_CursorX_TBL,x
	EOR #$FF
	INC A
	BRA X_Angle_Left

X_Angle_Right:
	LDA M3_CursorX_TBL,x
X_Angle_Left:
	BMI X_Angle_Negative

	ASL A
	STA !FREERAM17
	BRA Y_Angle

X_Angle_Negative:
	EOR #$FF
	INC A
	ASL A
	EOR #$FF
	INC A
	STA !FREERAM17

Y_Angle:
	LDA $76
	BEQ EggCursorL_Jump

	JMP EggCursor_R

EggCursorL_Jump:
	JMP EggCursor_L

CallLoop_R:
	LDX $01
	DEX
	BPL EggCursor_R_Loop

	JMP FORXENEND

EggCursor_R:
	LDX #$04
EggCursor_R_Loop:
	STX $01

	TXA
	ASL A
	ASL A
	STA $00

	STZ $0430,x	; 8x8 tile

	LDA !FREERAM15	; RAM timer for cursor position.
	AND #$7F
	TAX
	LDA $7E
	CLC
	ADC M3_CursorX_TBL,x
	LDX $00
	STA $0240,x
	LDA $7F
	ADC #$00
	STA $0241,x
	LDA $0240,x
	LDX $01
	CLC
	ADC CursorXOffset,x
	LDX $00
	STA $0240,x
	LDA $0241,x
	ADC #$00
	STA $0241,x

	LDA $0241,x
	BEQ Skip_EggCursor_OffScreenX

	JSR EggCursor_OffScreenX

Skip_EggCursor_OffScreenX:
	LDX $00
	LDA $80
	SEC
	SBC $02
	STA $0241,x
	LDA $81
	SBC #$00
	STA $0242,x
	LDA $0241,x
	CLC
	ADC #$39	; #$29
	STA $0241,x
	LDA $0242,x
	ADC #$00
	STA $0242,x
	LDA $0241,x
	LDX $01
	CLC
	ADC CursorYOffset,x
	LDX $00
	STA $0241,x
	LDA $0242,x
	ADC #$00
	STA $0242,x

	REP #$20
	LDA $0241,x
	CLC
	ADC #$0010
	CMP #$0100
	SEP #$20
	BCC SkipEggCursor_OffScreenY

	JSR EggCursor_OffScreenY

SkipEggCursor_OffScreenY:
	LDA #!CursorGFXTILETHING
	STA $0242,x
	LDA $14
	LSR A
	AND #$01
	TAX
	LDA CursorProperties,x
	LDX $01
	ORA CursorProperties2,x
	LDX $00
	STA $0243,x

	JMP CallLoop_R

CallLoop_L:
	LDX $01
	DEX
	BPL EggCursor_L_Loop

	JMP FORXENEND

EggCursor_L:
	LDX #$04
EggCursor_L_Loop:
	STX $01

	TXA
	ASL A
	ASL A
	STA $00

	STZ $0430,x	; 8x8 tile

	LDA !FREERAM15	; RAM timer for cursor position.
	AND #$7F
	TAX
	LDA $7E
	SEC
	SBC M3_CursorX_TBL,x
	LDX $00
	STA $0240,x
	LDA $7F
	SBC #$00
	STA $0241,x
	LDA $0240,x
	LDX $01
	CLC
	ADC CursorXOffset,x
	LDX $00
	STA $0240,x
	LDA $0241,x
	ADC #$00
	STA $0241,x

	LDA $0241,x
	BEQ Skip_EggCursor_L_OffScreenX

	JSR EggCursor_OffScreenX

Skip_EggCursor_L_OffScreenX:
	LDX $00
	LDA $80
	SEC
	SBC $02
	STA $0241,x
	LDA $81
	SBC #$00
	STA $0242,x
	LDA $0241,x
	CLC
	ADC #$29
	STA $0241,x
	LDA $0242,x
	ADC #$00
	STA $0242,x
	LDA $0241,x
	LDX $01
	CLC
	ADC CursorYOffset,x
	LDX $00
	STA $0241,x
	LDA $0242,x
	ADC #$00
	STA $0242,x

	REP #$20
	LDA $0241,x
	CLC
	ADC #$0010
	CMP #$0100
	SEP #$20
	BCC SkipEggCursor_L_OffScreenY

	JSR EggCursor_OffScreenY

SkipEggCursor_L_OffScreenY:
	LDA #!CursorGFXTILETHING
	STA $0242,x
	LDA $14
	LSR A
	AND #$01
	TAX
	LDA CursorProperties,x
	LDX $01
	ORA CursorProperties2,x
	LDX $00
	STA $0243,x

	JMP CallLoop_L

EggCursor_OffScreenY:
	LDA #$F0
	STA $0241,x
	RTS

EggCursor_OffScreenX:
	LDX $01
	LDA #$01
	STA $0430,x	; High X byte
	RTS

	JMP FORXENEND

CursorProperties:
	db $34,$38
CursorXOffset:
	db $00,$08,$00,$08
CursorYOffset:
	db $00,$00,$08,$08
CursorProperties2:
	db $00,$40,$80,$C0

M3_CursorX_TBL:
db $00,$02,$05,$07,$09,$0B,$0D,$10,$12,$14,$16,$19,$1B,$1D,$1F,$21
db $22,$24,$26,$28,$2A,$2B,$2D,$2E,$30,$31,$33,$34,$35,$36,$37,$38
db $39,$3A,$3B,$3C,$3C,$3D,$3D,$3D,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3D
db $3D,$3C,$3C,$3B,$3A,$3A,$39,$38,$37,$36,$34,$33,$32,$30,$2F,$2D
db $2D,$2F,$30,$32,$33,$34,$36,$37,$38,$39,$3A,$3A,$3B,$3C,$3C,$3D
db $3D,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3D,$3D,$3D,$3C,$3C,$3B,$3A,$39
db $38,$37,$36,$35,$34,$33,$31,$30,$2E,$2D,$2B,$2A,$28,$26,$24,$22
db $21,$1F,$1D,$1B,$19,$16,$14,$12,$10,$0D,$0B,$09,$07,$05,$02,$00

M3_CursorY_TBL:
db $3E,$3E,$3E,$3E,$3D,$3D,$3C,$3C,$3B,$3A,$3A,$39,$38,$37,$36,$34
db $33,$32,$30,$2F,$2D,$2B,$2A,$28,$26,$24,$22,$21,$1F,$1D,$1B,$19
db $16,$14,$12,$10,$0D,$0B,$09,$07,$05,$02,$00,$00,$FE,$FB,$F9,$F7
db $F5,$F3,$F0,$EE,$EC,$EA,$E7,$E5,$E3,$E1,$DF,$DE,$DC,$DA,$D9,$D7
db $D7,$D9,$DA,$DC,$DE,$DF,$E1,$E3,$E5,$E7,$EA,$EC,$EE,$F0,$F3,$F5
db $F7,$F9,$FB,$FE,$00,$00,$02,$05,$07,$09,$0B,$0D,$10,$12,$14,$16
db $19,$1B,$1D,$1F,$21,$22,$24,$26,$28,$2A,$2B,$2D,$2E,$30,$31,$33
db $34,$36,$37,$38,$39,$3A,$3A,$3B,$3C,$3C,$3D,$3D,$3E,$3E,$3E,$3E

M3_AngleIndex_TBL:
db $00,$02,$03,$05,$06,$08,$09,$0B,$0C,$0E,$0F,$11,$12,$14,$15,$17
db $18,$1A,$1B,$1D,$1E,$20,$21,$23,$24,$26,$27,$29,$2A,$2C,$2D,$2F
db $30,$32,$33,$35,$36,$38,$39,$3B,$3C,$3E,$40,$41,$43,$44,$46,$47
db $49,$4B,$4C,$4E,$4F,$51,$52,$54,$55,$57,$58,$5A,$5B,$5D,$5E,$60
db $60,$5E,$5D,$5B,$5A,$58,$57,$55,$54,$52,$51,$4F,$4E,$4C,$4B,$49
db $47,$46,$44,$43,$41,$40,$3E,$3C,$3B,$39,$38,$36,$35,$33,$32,$30
db $2F,$2D,$2C,$2A,$29,$27,$26,$24,$23,$21,$20,$1E,$1D,$1B,$1A,$18
db $17,$15,$14,$12,$11,$0F,$0E,$0C,$0B,$09,$08,$06,$05,$03,$02,$00

YoshiFrame_TBL:
db $35,$36,$35,$35,$36,$35,$36,$35,$36,$35,$35,$36,$36,$35,$35,$35
db $35,$35,$35,$35,$35,$35,$35,$35,$36,$35,$36,$35,$35,$35,$35,$35
db $35,$35,$35,$35,$36,$35,$35,$35,$35,$35,$35,$35,$35,$35,$35,$35
db $35,$35,$36,$35,$35,$35,$36,$36,$35,$35,$36,$35,$35,$35,$35,$35

EggRotate_TBL:
dw $0018,$0038,$0058,$0078,$0098,$00B8

FORXENEND:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ThrowEgg:
	LDX #$0B
EggThrow_Loop:
	LDA #$10
	STA !FREERAM24	; Timer for showing Yoshi's egg-throwing pose.

	LDA $14C8,x
	BEQ Generate_Egg

	DEX
	BPL EggThrow_Loop

	RTS

Generate_Egg:
	LDA #!EggSprite_
	STA $7FAB9E,x	; Store sprite number for egg

	LDA $94
	STA $E4,x
	LDA $95
	STA $14E0,x
	LDA $96
	CLC
	ADC #$0C
	STA $D8,x
	LDA $97
	ADC #$00
	STA $14D4,x	; Generate from Yoshi's position

	LDA #$08
	STA $14C8,x	; Make the sprite actually exist

	JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
	JSL $0187A7             ;  get table values for custom sprite
	LDA #$88
	STA $7FAB10,x

	PHX
	LDA !FREERAM15
	AND #$7F
	TAX
	LDA M3_AngleIndex_TBL,x
	PLX
	STA $1594,x

	LDA $76
	BEQ M3_AddAngle

	LDA $1594,x
	EOR #$FF
	INC A
	STA $1594,x

M3_AddAngle:
	LDA $1594,x
	CLC
	ADC #$40
	STA $1594,x	; Store angle index to misc sprite table

	STZ $1510,x

	LDA $13F9	; Player is behind layers flag
	STA $1632,x	; Sprite is behind layers flag

	LDA !FREERAM17
	STA $B6,x
	LDA !FREERAM18
	STA $AA,x	; Get angle of egg

	LDA !FREERAM4
	STA $C2,x	; Get initial egg color

	LDX #$00
Generate_Egg_ShiftEggLoop:
	LDA !FREERAM4,x
	STA !FREERAM4-$1,x
	INX
	CPX !FREERAM2
	BNE Generate_Egg_ShiftEggLoop

	LDA !FREERAM2
	DEC A
	TAX
	LDA !FREERAM4-$1
	STA !FREERAM4,x	; Shift ram table

	DEC !FREERAM2	; Decrease the amount of eggs Yoshi has

EggThrow_Return:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

EggFollow:
Draw_Egg:
	LDA !FREERAM2	; Get # of Yoshi eggs.
	CLC
	ADC !FREERAM1	; ...plus # of keys.
	BNE Draw_EggLoop111

Draw_EggRet:
	JSR EggRAM_Cycle
	RTS

Draw_EggLoop111:
	STZ $05		; Reset temp egg on ground counter
	LDA !FREERAM2
	CLC
	ADC !FREERAM1	; Number of eggs + keys
	TAX
	DEX

Draw_EggLoop:
	STX $04
	LDA #$02
	STA $0469,x

	LDA $04
	ASL A
	TAX

	LDA !FREERAM10
	BEQ Draw_EggRotateAll
	DEC A
	CMP $04
	BEQ Draw_EggRotateAll

	REP #$20
	LDA #$0000
	BRA Draw_EggNoRotate

Draw_EggRotateAll:
	REP #$20

	LDA !FREERAM9	; Egg rotate timer.
Draw_EggNoRotate:
	CLC
	ADC table,x
	CLC
	ADC !FREERAM19	; Index offset
	CMP #$00C0
	BCC Draw_EggStoreIndex
	SEC
	SBC #$00C0
Draw_EggStoreIndex:
	TAX
	;PHX

	LDA !FREERAM6,x
	SEC
	SBC $1462
	STA $00
	SEP #$20

	;PLX
	JSR BounceTheEgg

	REP #$20
	LDA $02
	CLC
	ADC #$0010
	CMP #$0100
	BCS EraseSprite

	SEP #$20
	
	LDX $04

	TXA
	ASL A
	ASL A
	TAX
	
	LDA $02
	STA $0325,x
	
	LDA $00
	STA $0324,x
	
	PHX
	LDX $04
	LDA !FREERAM4,x
	TAX
	LDA EggTileTBL,x
	PLX
	STA $0326,x

	PHX
	LDX $04
	LDA !FREERAM4,x
	TAX
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	ORA EggPaletteTBL,x
	PLX
	STA $0327,x
	BRA Draw_Egg_DontEraseSprite

EraseSprite:
	SEP #$20

	LDX $04

	TXA
	ASL A
	ASL A
	TAX

	LDA #$F0
	STA $0325,x
	BRA DrawEgg_CallLoopCall

Draw_Egg_DontEraseSprite:
	LDA $01
	BEQ DrawEgg_CallLoopCall

	LDX $04
	LDA #$03
	STA $0469,x

DrawEgg_CallLoopCall:
	LDX $04
	DEX
	BMI EggRAM_Cycle
	JMP Draw_EggLoop

EggRAM_Cycle:
	REP #$20

	LDA !FREERAM19	; Index offset
	SEC
	SBC #$0004
	CLC
	ADC #$00BC
	CMP #$00C0
	BCC EggRAM_TransferAX3
	SEC
	SBC #$00C0
EggRAM_TransferAX3:
	TAX

	LDA $94
	CMP !FREERAM6,x
	SEP #$20
	BNE EggRAM_Cycle2

	REP #$20
	LDA $96
	CLC
	ADC #$0010
	CMP !FREERAM6+$2,x
	SEP #$20
	BNE EggRAM_Cycle2

	LDA $05			; If the number of follow items on the ground...
	SEC			; ...
	SBC !FREERAM2		; Is not equal to the number of eggs...
	SEC			; ...
	SBC !FREERAM1		; And the number of keys Yoshi has...
	BNE EggRAM_Cycle2	; Make items continue to follow Yoshi...

	RTS			; Otherwise, stop them in their path.

EggRAM_Cycle2:
	REP #$20
	LDA !FREERAM19	; Index offset
	CLC
	ADC #$00BC
	CMP #$00C0
	BCC EggRAM_TransferAX
	SEC
	SBC #$00C0
EggRAM_TransferAX:
	TAX

	LDA $94
	STA !FREERAM6,x

	LDA $96
	CLC
	ADC #$0010
	STA !FREERAM6+$2,x

EggOnGround_LoopCall:
	LDA !FREERAM20
	TAX
	SEP #$20

	LDA $77
	AND #$04
	LSR A
	LSR A		; If blocked from bottom, set #$01 to !FREERAM5,x.
	STA !FREERAM5,x

	REP #$20
	LDA !FREERAM19
	CLC
	ADC #$0004	; Shift RAM table.
	CMP #$00C0
	BNE EggOnGround_FixIndex
	LDA #$0000
EggOnGround_FixIndex:
	STA !FREERAM19
	LSR A
	LSR A		; Divide by 4
	STA !FREERAM20	; Bounce index table.
	SEP #$20

	RTS

BounceTheEgg:
	PHX

	TXA
	LSR A
	LSR A
	TAX

	LDA !FREERAM5,x
	BNE EggIsOnGround

EggIsNotOnGround:
	PLX

	REP #$20
	LDA !FREERAM6+$2,x
	SEC
	SBC $1464
	STA $02
	SEP #$20
	RTS

EggIsOnGround:
	INC $05		; Temp counter for how many eggs are on ground.

	LDX $04
	LDA !FREERAM4,x
	CMP #$03		; If egg is actually a key...
	BEQ EggIsNotOnGround	; Don't bounce.

	PLX

	REP #$20
	LDA !FREERAM6+$2,x
	SEC
	SBC $1464
	PHA
	SEP #$20

	LDA $04
	PHA

	LDA $04
	AND #$01
	ASL A
	ASL A
	STA $04

	LDA $14
	LSR A
	CLC
	ADC $04
	AND #$07
	ASL A
	TAX

	PLA
	STA $04

	REP #$20
	PLA
	SEC
	SBC EggBounceTBL,x
	STA $02
	SEP #$20
	RTS

EggPaletteTBL:
db $0A,$04,$08,$04
EggTileTBL:
db !EggTILEGFXTHING,!EggTILEGFXTHING,!EggTILEGFXTHING,!KeyTile
EggBounceTBL:
dw $0000,$0001,$0003,$0004,$0004,$0003,$0001,$0000
table:
dw $00A0,$0080,$0060,$0040,$0020,$0000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

YoshiEat:
	LDA !FREERAM13	; Check if holding an egg...
	ORA $140D	; ...or groundpounding
	ORA !FREERAM12	; ...or swallowing
	BNE TongueReturn
	LDA $71
	CMP #$0B
	BEQ Canceltongue1
	LDA !FREERAM3	; ...or has something in his mouth
	ORA $74		; ...or is climbing
	BNE Canceltongue1

	LDA !FREERAM11	; Yoshi stuck his tongue out "flag" - $01 = stuck tongue out sideways, $02 = stuck tongue out upward.
	BNE Tongue_Frame

Tongue_CTRL:
	LDA $16
	AND #$40	; If pressing X or Y...
	BEQ TongueReturn

	LDA #$21
	STA $1DFC	; Play sound effect

	LDA $76
	STA !FREERAM21

	LDA $15
	AND #$08	; If holding up...
	BNE LickUpward

	INC !FREERAM11	; Set licking flag
	RTS

LickUpward:
	LDA #$02
	STA !FREERAM11
	RTS

TongueReturn:
	RTS

Canceltongue:
	LDA #$01
	STA $19
Canceltongue1:
	STZ !FREERAM11
	STZ !FREERAM22
	RTS

Tongue_Frame:
	STZ $74

	LDA !FREERAM21
	STA $76

	LDA !FREERAM22
	CMP #$20
	BEQ Canceltongue

	STZ $19		; Make Yoshi small so it can display eating frame properly.

TongueGFX1:
	LDA !FREERAM22	; RAM timer for Yoshi's tongue segment positions.
	ASL A
	TAX

	REP #$20
	LDA TonguePos_TBL,x
	STA !FREERAM23	; Length of Yoshi's tongue.
	LDA TonguePos_TBL2,x
	STA !FREERAM23+$2
	LDA TonguePos_TBL3,x
	STA !FREERAM23+$4
	LDA TonguePos_TBL4,x
	STA !FREERAM23+$6
	LDA TonguePos_TBL5,x
	STA !FREERAM23+$8
	LDA TonguePos_TBL6,x
	STA !FREERAM23+$A
	LDA TonguePos_TBL7,x
	STA !FREERAM23+$C
	LDA TonguePos_TBL8,x
	STA !FREERAM23+$E
	LDA TonguePos_TBL9,x
	STA !FREERAM23+$10
	LDA TonguePos_TBLA,x
	STA !FREERAM23+$12
	SEP #$20

	LDA !FREERAM11
	ASL A
	TAX
	JSR (TongueDirection,x)

	INC !FREERAM22

	LDA $76
	STA !FREERAM21

	RTS

TongueDirection:
	dw $0000
	dw Tongue_Horz
	dw Tongue_Vert

Tongue_Horz:
	LDX $13E0
	LDA SpittingFrame2,x
	STA $13E0	; Show Yoshi's eating frame.

	LDA #$01
	JSR YoshiFrame_EatSpit

	LDX #$00
	LDA $76
	BEQ TongueLeft

TongueHorz:
	STZ $04
	PHX
	TXA
	ASL A
	TAX
	ASL A
	TAY
	REP #$20
	LDA $7E
	CLC
	ADC !FREERAM23,x
	CLC
	ADC #$0004
	STA $00
	CMP #$0100
	BCC YesDrawTongue
	SEP #$20
	LDA #$01
	STA $04
YesDrawTongue:
	REP #$20
	LDA $80
	CLC
	ADC #$000D
	STA $02
	CLC
	ADC #$0010
	CMP #$0100
	BCC YesDrawTongueV
	SEP #$20
	LDA #$F0
	STA $02
YesDrawTongueV:
	SEP #$20
	JSR UpdateTongueOAMs
	LDA TongeOAMTileTable,y
	STA $0202,y
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	STA $0203,y

	PLX
	LDA $04
	STA $0420,x

	INX
	CPX #$0A
	BCC TongueHorz
	RTS

TongueLeft:
TongueLeftLoop:
	STZ $04
	PHX
	TXA
	ASL A
	TAX
	ASL A
	TAY
	REP #$20
	LDA $7E
	SEC
	SBC !FREERAM23,x
	CLC
	ADC #$0004
	STA $00
	CMP #$0100
	BCC YesDrawTongue1
	SEP #$20
	LDA #$01
	STA $04
YesDrawTongue1:
	REP #$20
	LDA $80
	CLC
	ADC #$000D
	STA $02
	CLC
	ADC #$0010
	CMP #$0100
	BCC YesDrawTongue1V
	SEP #$20
	LDA #$F0
	STA $02
YesDrawTongue1V:
	SEP #$20
	JSR UpdateTongueOAMs
	LDA TongeOAMTileTable,y
	STA $0202,y
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	ORA #$40	; X-flip
	STA $0203,y

	PLX
	LDA $04
	STA $0420,x

	INX
	CPX #$0A
	BCC TongueLeftLoop
	RTS

Tongue_Vert:
	LDX #$00
	PHX
	LDX $13E0
	LDA SpittingFrame3,x
	STA $13E0	; Looking up while eating frame.
	PLX

Tongue_VertLoop:
	STZ $04
	PHX
	TXA
	ASL A
	TAX
	ASL A
	TAY
	REP #$20
	LDA $80
	SEC
	SBC !FREERAM23,x
	CLC
	ADC #$000E
	STA $02
	CLC
	ADC #$0010
	CMP #$0100
	BCC YesDrawTongue2
	SEP #$20
	LDA #$F0
	STA $02
YesDrawTongue2:
	PHX
	LDA $76
	ASL A
	TAX
	REP #$20
	LDA $7E
	CLC
	ADC TongueUpOffsetTBL,x
	STA $00
	CMP #$0100
	BCC YesDrawTongue2V
	SEP #$20
	LDA #$01
	STA $04
YesDrawTongue2V:
	SEP #$20
	PLX
	JSR UpdateTongueOAMs
	LDA TongeOAMTileVert,y
	STA $0202,y
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	STA $0203,y

	PLX
	LDA $04
	STA $0420,x

	INX
	CPX #$0A
	BCC Tongue_VertLoop
	RTS

UpdateTongueOAMs:
	LDA $00
	STA $0200,y
	LDA $02
	STA $0201,y
	RTS

TongueUpOffsetTBL:
dw $0001,$0007

TonguePos_TBL:
dw $0008,$000C,$0010,$0014,$0018,$001C,$0020,$0024,$0028,$002C,$0030,$0034,$0038,$003C,$0040,$0044
dw $0044,$0040,$003C,$0038,$0034,$0030,$002C,$0028,$0024,$0020,$001C,$0018,$0014,$0010,$000C,$0008
TonguePos_TBL2:
dw $8000,$8000,$0008,$000C,$0010,$0014,$0018,$001C,$0020,$0024,$0028,$002C,$0030,$0034,$0038,$003C
dw $003C,$0038,$0034,$0030,$002C,$0028,$0024,$0020,$001C,$0018,$0014,$0010,$000C,$0008,$0008,$0008
TonguePos_TBL3:
dw $8000,$8000,$0008,$0008,$0008,$000C,$0010,$0014,$0018,$001C,$0020,$0024,$0028,$002C,$0030,$0034
dw $0034,$0030,$002C,$0028,$0024,$0020,$001C,$0018,$0014,$0010,$000C,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL4:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$000C,$0010,$0014,$0018,$001C,$0020,$0024,$0028,$002C
dw $002C,$0028,$0024,$0020,$001C,$0018,$0014,$0010,$000C,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL5:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$000C,$0010,$0014,$0018,$001C,$0020,$0024
dw $0024,$0020,$001C,$0018,$0014,$0010,$000C,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL6:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$000C,$0010,$0014,$0018,$001C
dw $001C,$0018,$0014,$0010,$000C,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL7:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$000C,$0010,$0014
dw $0014,$0010,$000C,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL8:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$000C
dw $000C,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBL9:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
dw $0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
TonguePos_TBLA:
dw $8000,$8000,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008
dw $0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008,$0008

TongeOAMTileTable:
	db !TongueEndTile_,!TongueEndTile_,!TongueEndTile_,!TongueEndTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_
	db !TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_,!TongueBaseTile_

TongeOAMTileVert:
	db !TongueTopTile_,!TongueTopTile_,!TongueTopTile_,!TongueTopTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_
	db !TongueUpTile_,!TongueUpTile_,!TongueUpTile_,!TongueUpTile_

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

StandStill:
	LDA !FREERAM3	; Flag used to determine if Yoshi is holding something in his mouth
	ORA !FREERAM11
	ORA !FREERAM12
	BNE StandReturn1

	LDA !FREERAM13
	ORA $73
	ORA !FREERAM24
	ORA $74
	BNE StandReturn

	LDA $7B
	BNE StandReturn

	LDA $77
	AND #$04
	BEQ StandReturn

	LDA $15
	AND #$08
	BNE StandReturn

	STZ $19

	LDA $14
	LSR A
	LSR A
	AND #$3F
	TAX
	LDA StandTBL,x
	STA $13E0

StandReturn1:
	RTS

StandReturn:
	LDA #$01
	STA $19
	RTS

StandTBL:
db $46,$46,$46,$46,$46,$46,$46,$17,$46,$46,$46,$46,$46,$46,$46,$46
db $46,$46,$46,$22,$22,$23,$23,$27,$27,$23,$23,$27,$27,$23,$23,$27
db $27,$22,$22,$46,$46,$46,$46,$17,$46,$46,$46,$46,$46,$46,$46,$46
db $46,$46,$46,$46,$19,$1B,$21,$21,$21,$21,$21,$21,$21,$21,$1B,$19

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TongueGrab:
	LDA !FREERAM22
	BNE Tongue_Grab7

TongueGrabReturn:
	RTS

Tongue_Grab7:
	LDA !FREERAM12
	BNE TongueGrabReturn
	JMP Tongue_Grab

TongueGrab_LEFT:
	LDA !FREERAM25
	ASL A
	TAX
	JSR (TOriefg_TABLe2,x)
	RTS

TOriefg_TABLe2:
dw EnemyNotGrabbed2
dw EnemyGrabbed2

EnemyNotGrabbed2:
	REP #$20
	LDA $94		; Yoshi's X position.
	SEC
	SBC !FREERAM23	; Length of Yoshi's tongue.
	CLC
	ADC #$0008
	STA $13E9	; Cape X

	LDA $96
	CLC
	ADC #$0010	;$0018
	STA $13EB	; Cape Y
	SEP #$20

	JSR GrabExist
	RTS

EnemyGrabbed2:
	LDA !FREERAM22
	CMP #$20
	BEQ EraseGrabbed2
	CMP #$10
	BCS No_XOR2

	LDA !FREERAM22
	EOR #$1F
	STA !FREERAM22	; Retract Yoshi's tongue on contact.

No_XOR2:
	LDX !FREERAM26

	REP #$20
	LDA $94		; Yoshi's X position.
	SEC
	SBC !FREERAM23	; Length of Yoshi's tongue.
	CLC
	ADC #$0008
	STA $13E9	; Cape X

	LDA $96
	CLC
	ADC #$0010
	STA $13EB	; Cape Y
	SEP #$20

	LDA $13E9
	STA $E4,x

	LDA $13EA
	STA $14E0,x

	LDA $13EB
	SEC
	SBC #$08
	STA $D8,x

	LDA $13EC
	SBC #$00
	STA $14D4,x	; Snap sprite position to Yoshi's tongue position.

	JSR Egg_Grab

	LDA $167A,x
	BMI Tongue_NotDefaultInteraction2

	LDA #$03
	STA $154C,x	; Make sprite not interact with Yoshi

	RTS

Tongue_NotDefaultInteraction2:
	LDA #$03
	STA $1497
	RTS

EraseGrabbed2:
	JMP EraseGrabbed

Tongue_Grab:
	LDA !FREERAM11
	CMP #$02
	BEQ TongueGrab_UP

	LDA $76
	ASL A
	TAX
	JMP (TongueGrab_DIR,x)

TongueGrab_DIR1:
	LDA !FREERAM25
	ASL A
	TAX
	JSR (TOriefg_TABLe1,x)
	RTS

TOriefg_TABLe1:
dw EnemyNotGrabbed1
dw EnemyGrabbed1

TongueGrab_DIR:
dw TongueGrab_LEFT
dw TongueGrab_DIR1

TongueGrab_UP:
	LDA !FREERAM25
	ASL A
	TAX
	JSR (TOriefg_TABLe3,x)
	RTS

TOriefg_TABLe3:
dw EnemyNotGrabbed3
dw EnemyGrabbed3

EnemyNotGrabbed3:
	REP #$20
	LDA $96		; Yoshi's Y position.
	SEC
	SBC !FREERAM23	; Length of Yoshi's tongue.
	CLC
	ADC #$0008
	STA $13EB	; Cape Y

	LDA $94
	STA $13E9	; Cape X
	SEP #$20

	JSR GrabExist
	RTS

EnemyGrabbed3:
	LDA !FREERAM22
	CMP #$20
	BEQ EraseGrabbed3
	CMP #$10
	BCS No_XOR3

	LDA !FREERAM22
	EOR #$1F
	STA !FREERAM22	; Retract Yoshi's tongue on contact.

No_XOR3:
	LDX !FREERAM26

	REP #$20
	LDA $96		; Yoshi's X position.
	SEC
	SBC !FREERAM23	; Length of Yoshi's tongue.
	CLC
	ADC #$0008
	STA $13EB	; Cape Y

	LDA $94
	STA $13E9	; Cape X
	SEP #$20

	LDA $13E9
	STA $E4,x

	LDA $13EA
	STA $14E0,x

	LDA $13EB
	CLC
	ADC #$08
	STA $D8,x

	LDA $13EC
	ADC #$00
	STA $14D4,x	; Snap sprite position to Yoshi's tongue position.

	JSR Egg_Grab

	LDA $167A,x
	BMI Tongue_NotDefaultInteraction3

	LDA #$03
	STA $154C,x	; Make sprite not interact with Yoshi

	RTS

Tongue_NotDefaultInteraction3:
	LDA #$03
	STA $1497
	RTS

EraseGrabbed3:
	JMP EraseGrabbed

EnemyNotGrabbed1:
	REP #$20
	LDA $94		; Yoshi's X position.
	CLC
	ADC !FREERAM23	; Length of Yoshi's tongue.
	SEC
	SBC #$0008
	STA $13E9	; Cape X

	LDA $96
	CLC
	ADC #$0010	;$0018
	STA $13EB	; Cape Y
	SEP #$20

GrabExist:
	LDX #$0B
GrabExist1:
	LDA $14C8,x
	CMP #$08
	BCS GrabLoop_Hi1

	DEX
	BPL GrabExist1

	RTS

GrabLoop_Hi1:
	LDA $E4,x
	SEC
	SBC $13E9
	STA $00
	LDA $14E0,x
	SBC $13EA
	STA $01
	LDA $D8,x
	SEC
	SBC $13EB
	STA $02
	LDA $14D4,x
	SBC $13EC
	STA $03

	REP #$20
	LDA $00
	BPL Pos_InteractX

	EOR #$FFFF
	INC A

Pos_InteractX:
	CMP #$0010
	BCS GrabExist_LoopCall

	LDA $02
	BPL Pos_InteractY

	EOR #$FFFF
	INC A

Pos_InteractY:
	CMP #$0010
	BCC EdibleCheck

GrabExist_LoopCall:
	SEP #$20
	DEX
	BPL GrabExist1

	RTS

EdibleCheck:
	SEP #$20
	LDA $1686,x	; Check Tweaker bits.
	AND #$01	; Check "inedible" flag.
	BNE GrabReturn1

	LDA $13F9	; Player is behind layers flag
	CMP $1632,x	; Sprite is behind layers flag
	BNE GrabReturn1	; If the two are not equal, return.

	LDA #$01
	STA !FREERAM25	; Set tongue grab flag.

	STX !FREERAM26	; Store current X register to empty RAM.

GrabReturn1:
	RTS

EnemyGrabbed1:
	LDA !FREERAM22
	CMP #$20
	BEQ EraseGrabbed
	CMP #$10
	BCS No_XOR

	LDA !FREERAM22
	EOR #$1F
	STA !FREERAM22	; Retract Yoshi's tongue on contact.

No_XOR:
	LDX !FREERAM26

	REP #$20
	LDA $94		; Yoshi's X position.
	CLC
	ADC !FREERAM23	; Length of Yoshi's tongue.
	SEC
	SBC #$0008
	STA $13E9	; Cape X

	LDA $96
	CLC
	ADC #$0010
	STA $13EB	; Cape Y
	SEP #$20

	LDA $13E9
	STA $E4,x

	LDA $13EA
	STA $14E0,x

	LDA $13EB
	SEC
	SBC #$08
	STA $D8,x

	LDA $13EC
	SBC #$00
	STA $14D4,x	; Snap sprite position to Yoshi's tongue position.

	JSR Egg_Grab

	LDA $167A,x
	BMI Tongue_NotDefaultInteraction4

	LDA #$03
	STA $154C,x	; Make sprite not interact with Yoshi

	RTS

Tongue_NotDefaultInteraction4:
	LDA #$03
	STA $1497
	RTS

EraseGrabbed:
	LDX !FREERAM26

	LDA $1686,x	; Check Tweaker bits.
	AND #$02	; Check "Stay in Yoshi's mouth" flag.
	BEQ NOTStayInMouth

	JMP StayInMouth

NOTStayInMouth:
	LDA $167A,x	; Check Tweaker bits.
	AND #$40	; Check "Gives power-up when eaten by Yoshi" flag.
	BNE NoAddEgg2
	LDA $9E,x
	CMP #$74	; If sprite is a berry...
	BEQ NoAddEgg3	; don't make an egg.

	PHX
	LDA #$05
	SEC
	SBC !FREERAM1
	TAX
	LDA !FREERAM4,x
	TAX
	LDA EggPaletteTBL,x
	STA $00
	PLX

	LDA !FREERAM4+$4
	STA !FREERAM4+$5
	LDA !FREERAM4+$3
	STA !FREERAM4+$4
	LDA !FREERAM4+$2
	STA !FREERAM4+$3
	LDA !FREERAM4+$1
	STA !FREERAM4+$2
	LDA !FREERAM4
	STA !FREERAM4+$1
	LDA #$00
	STA !FREERAM4	; Shift ram table

	LDA !FREERAM2
	CLC
	ADC !FREERAM1	; Eggs plus keys
	CMP #$06
	BEQ NoAddEgg
	INC !FREERAM2	; Give Yoshi an egg.
	BRA NoAddEgg4

NoAddEgg:
	PHX
	JSR NoAddEgg5
	PLX
NoAddEgg4:
	REP #$20
	LDA #$0018
	STA !FREERAM9	; Egg rotating timer.
	SEP #$20

	LDA #$19
	STA $1DFC	; Play egg laying sound effect.

	STZ $14C8,x	; Erase sprite.

NoAddEgg2:
	LDA #$10
	STA !FREERAM12	; Timer to show swallowing pose.

	LDA #$06
	STA $1DF9	; Play swallowing sound effect.

	STZ !FREERAM25
	RTS

NoAddEgg3:
	LDA $160E,x	; Check if sprite is a berry
	BEQ NoAddEgg2

	STZ $14C8,x	; Erase sprite
	STZ !FREERAM25

	LDA #$01
	STA $1DFC	; Play coin SFX

	INC $13CC	; Give Yoshi a coin
	INC !FREERAM27	; Increase Yoshi's health
	BRA NoAddEgg2

StayInMouth:
	STZ !FREERAM25

	LDA #$07
	STA $14C8,x	; Set sprite state to "inside Yoshi's mouth".

	STZ $1540,x	; Fix that weird fucking paratroopa glitch.

	LDA $167A,x	; Check Tweaker bits.
	AND #$40	; Check "Gives power-up when eaten by Yoshi" flag.
	BNE TimerProp

	LDA #$01
	STA !FREERAM3

	RTS

TimerProp:
	LDA $1510,x	; Unused sprite table.
	STA !FREERAM3
	RTS

NoAddEgg5:
	LDY #$07
GenerateEggLoop:
	LDA $170B,y
	BEQ InitEggGen

	DEY
	BPL GenerateEggLoop

InitEggGenReturn:
	RTS

InitEggGen:
	LDA !FREERAM1
	CMP #$06
	BEQ InitEggGenReturn
	LDA $00
	ORA #$C0
	STA $1765,y	; Egg properties + egg sprite flag.
	LDA #$09
	STA $170B,y	; Egg sprite number.
	LDX $76
	LDA Egg_XSpeed,x
	STA $1747,y
	LDA #$D0
	STA $173D,y
	LDA #$00
	STA $176F,y

	LDA #$05
	SEC
	SBC !FREERAM1
	ASL A
	TAX

	REP #$20
	LDA table,x
	CLC
	ADC !FREERAM19	; Index offset
	CMP #$00C0
	BCC GetEggCoordIndex
	SEC
	SBC #$00C0
GetEggCoordIndex:
	TAX
	SEP #$20

	LDA !FREERAM6,x		;\
	STA $171F,y		; |
	LDA !FREERAM6+$1,x	; |
	STA $1733,y		; |
	LDA !FREERAM6+$2,x	; | Generate egg at the proper coordinates.
	STA $1715,y		; |
	LDA !FREERAM6+$3,x	; |
	STA $1729,y		;/
	RTS

Egg_XSpeed:
	db $10,$F0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Egg_Grab:
	LDA $7FAB10,x
	AND #$08
	BEQ DontMakeEggJump

	LDA $7FAB9E,x
	CMP #!EggSprite_
	BEQ MakeEggJump
	CMP #!EggSprite_2
	BEQ MakeEggJump
	CMP #!KeySprite
	BEQ MakeKeyJump

	RTS

MakeEggJump:
	LDA #!EggSprite_2
	STA $7FAB9E,x	; Make egg collectable

MakeKeyJump:
	;JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
	;JSL $0187A7             ;  get table values for custom sprite
	LDA #$88
	STA $7FAB10,x
	LDA #$01
	STA $7FAB28,x

	PHX
	LDX $76
	LDA EggXSpeedTBL,x
	PLX
	STA $B6,x

	STZ $151C,x	; Egg has gravity

	LDA #$C8
	STA $AA,x

	STZ !FREERAM25	; Erase grabbed flag

	LDA #$20
	STA $1528,x	; Inedible timer

DontMakeEggJump:
	RTS

EggXSpeedTBL:
db $10,$F0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Swallowing:
	LDA !FREERAM3
	BNE SwallowReturn

	LDA !FREERAM12	; Timer to show swallowing pose.
	BEQ SwallowReturn

	STZ $19

	LDX !FREERAM12
	LDA SwallowFrame,x
	STA $13E0

	DEC !FREERAM12
	RTS

SwallowReturn:
	RTS

SwallowFrame:
db $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$00,$00,$00,$00,$00,$00,$00,$00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpitEnemy:
	LDA !FREERAM3
	BEQ SpitReturn
	LDA !FREERAM12
	BNE SpitReturn
	LDA $71
	CMP #$05
	BEQ SpitReturn
	CMP #$06
	BEQ SpitReturn
	CMP #$0B
	BEQ SpitReturn

	LDA $16
	AND #$40
	BNE SpitNotReturn

	LDA $14
	AND #$07
	BNE SpitReturn

	LDA !FREERAM29	; Rapidfiring flag.
	EOR #$01
	TAX

	LDA $15,x
	AND #$40
	BEQ SpitReturn

	STZ $74		; No climbing allowed.

SpitNotReturn:
	LDX #$0B
SpitLoop1:
	LDA $14C8,x
	CMP #$07		; Check for the sprite inside Yoshi's mouth.
	BEQ GenSpitSprite	; Look for a free sprite slot.

	DEX
	BPL SpitLoop1
SpitReturn:
	RTS

GenSpitSprite:
	LDA $167A,x	; Check Tweaker bits.
	AND #$40	; Check "Gives power-up when eaten by Yoshi" flag.
	BNE SkipSpitSFX

	LDA #$54
	STA $1DFC	; Play Yoshi spitting sound effect.

SkipSpitSFX:
	LDA $15
	AND #$08	; If holding up...
	BNE SpitUpward

	STZ !FREERAM30

	LDA #$0A
	STA $14C8,x	; Sprite status = kicked.

	LDA $167A,x
	AND #$40	; Gives powerup when eaten
	BEQ ObjectInteract

	LDA $1686,x
	AND #$02	; Stay in Yoshi's mouth
	BEQ ObjectInteract

	LDA $1686,x
	ORA #$80
	STA $1686,x	; Don't interact with objects

ObjectInteract:
	PHX
	LDX $76		; Yoshi's direction.
	LDA KickSpeedTBL,x
	PLX

	STA $B6,x	; Sprite X speed
	STZ $AA,x	; Sprite Y speed

	LDA #$08
	STA !FREERAM12	; Timer to show spitting pose.

	RTS

SpitUpward:
	LDA #$01
	STA !FREERAM30	; Yoshi is spitting upward flag

	LDA #$09
	STA $14C8,x	; Sprite status = stunned.

	LDA $167A,x
	AND #$40	; Gives powerup when eaten
	BEQ ObjectInteractUp

	LDA $1686,x
	AND #$02	; Stay in Yoshi's mouth
	BEQ ObjectInteractUp

	LDA $1686,x
	ORA #$80
	STA $1686,x	; Don't interact with objects

ObjectInteractUp:
	PHX
	LDX $76		; Yoshi's direction.
	LDA KickSpeedTBL2,x
	PLX

	STA $B6,x	; Sprite X speed
	LDA #$BF
	STA $AA,x	; Sprite Y speed

	LDA #$08
	STA !FREERAM12	; Timer to show spitting pose.

	RTS

KickSpeedTBL:
db $BE,$42
KickSpeedTBL2:
db $E6,$19

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Spitting:
	LDA !FREERAM3
	BEQ SpittingReturn

	LDA !FREERAM12	; Timer to show swallowing pose.
	BEQ SpittingReturn2
	CMP #$01
	BEQ SpittingReturn1

	STZ $74		; No climbing allowed.

	LDA !FREERAM3
	CMP #$02
	BCC ShowNormalSpitFrame

	LDA !FREERAM30
	ASL A
	ASL A
	ASL A
	ASL A
	ASL A
	ASL A
	CLC
	ADC $13E0
	TAX
	LDA SpittingFrame2,x
	STA $13E0
	CMP #$20
	BEQ ShowAlternateSpitFrame
	CMP #$0A
	BEQ ShowAlternateSpitFrame
	CMP #$31
	BEQ ShowAlternateSpitFrame
	BRA DecrementSpitTimer

ShowNormalSpitFrame:
	LDA !FREERAM30
	ASL A
	ASL A
	ASL A
	ASL A
	ASL A
	ASL A
	CLC
	ADC $13E0
	TAX
	LDA SpittingFrame,x
	STA $13E0

DecrementSpitTimer:
	DEC !FREERAM12
	RTS

SpittingReturn1:
	DEC !FREERAM12
	DEC !FREERAM3
SpittingReturn2:
	RTS

SpittingReturn:
	STZ !FREERAM29	; Reset rapidfire flag.
	RTS

ShowAlternateSpitFrame:
	LDA #$00
	JSR YoshiFrame_EatSpit
	DEC !FREERAM12
	RTS

YoshiFrame_EatSpit:
	STA $7FC0AA
	STA $7FC0AB
	STA $7FC0AC
	STA $7FC0AD
	STA $7FC0AE
	STA $7FC0AF
	STA $7FC0B0
	STA $7FC0B1
	STA $7FC0B2
	STA $7FC0B3
	STA $7FC0B4
	STA $7FC0B5
	STA $7FC0B6
	STA $7FC0B7
	STA $7FC0B8
	STA $7FC0B9	; Store to exanimation slots.

	STZ $04
	LDA $76
	ASL A
	TAX
	REP #$20
	LDA $7E
	CLC
	ADC YoshiHeadOffset,x
	STA $00
	CMP #$0100
	BCC YoshEat_OffScreenX
	SEP #$20
	LDA #$01
	STA $04
YoshEat_OffScreenX:
	REP #$20
	LDA $80
	CLC
	ADC #$0004
	STA $02
	CLC
	ADC #$0010
	CMP #$0100
	BCC YoshEat_OffScreenY
	SEP #$20
	LDA #$F0
	STA $02
YoshEat_OffScreenY:
	SEP #$20
	LDA #$80
	STA $0282
	LDX $76
	LDA $13F9	; Player goes behind layers flag
	EOR #$01
	ASL #5
	ORA YoshiHeadFlipProp,x
	STA $0283
	LDA #$02
	ORA $04
	STA $0440
	LDA $00
	STA $0280
	LDA $02
	STA $0281
	RTS

SpittingFrame:
db $1E,$38,$39,$1E,$1E,$38,$39,$1E,$38,$39,$1E,$39,$39,$1E,$1E,$1E
db $1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$38,$1E,$39,$1E,$1E,$1E,$1E,$1E
db $1E,$1E,$1E,$1E,$39,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E
db $38,$1E,$39,$1E,$1E,$1E,$39,$39,$38,$39,$39,$1E,$1E,$1E,$1E,$1E
SpittingFrame3:
db $26,$33,$34,$26,$26,$33,$34,$26,$33,$34,$26,$34,$34,$26,$26,$26
db $26,$26,$26,$26,$26,$26,$26,$26,$33,$26,$34,$26,$26,$26,$26,$26
db $26,$26,$26,$26,$34,$26,$26,$26,$26,$26,$26,$26,$26,$26,$26,$26
db $33,$26,$34,$33,$34,$26,$34,$34,$33,$34,$34,$26,$26,$26,$26,$26
SpittingFrame2:
db $20,$0A,$31,$20,$20,$0A,$31,$20,$0A,$31,$0A,$31,$31,$20,$20,$20
db $20,$20,$20,$20,$20,$20,$20,$20,$0A,$20,$31,$20,$20,$20,$20,$20
db $20,$20,$20,$20,$31,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
db $0A,$31,$31,$31,$20,$20,$31,$31,$0A,$31,$31,$20,$20,$20,$20,$20

db $3B,$14,$28,$3B,$3B,$14,$28,$3B,$14,$28,$3B,$28,$28,$3B,$3B,$3B
db $3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$14,$3B,$28,$3B,$3B,$3B,$3B,$3B
db $3B,$3B,$3B,$3B,$28,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B
db $14,$3B,$28,$14,$28,$3B,$28,$28,$14,$28,$28,$3B,$3B,$3B,$3B,$3B

YoshiHeadOffset:
dw $FFFC,$0004
YoshiHeadFlipProp:
db $00,$40

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HeathCounter:
	LDA #!Starbiticon
	STA $033E
	LDA #$04
	STA $033C
	LDA #$D0
	STA $033D
	LDA #$34
	STA $033F	; Draw starbit icon.

	LDA #!X_icon
	STA $0342
	LDA #$10
	STA $0340
	LDA #$D4
	STA $0341	; Draw "x" icon.
	LDA #$34
	STA $0343	; Draw "x" icon.

	LDA #!Counter_ExAnimSlot
	STA $0346
	LDA #$20
	STA $0344
	LDA #$CC
	STA $0345
	LDX !FREERAM27
	LDA HealthPropertiesTBL,x
	STA $0347	; Draw counter.

	STZ $046F	; 8x8 tile
	STZ $0470	; 8x8 tile
	LDA #$02
	STA $0471	; 16x16 tile

	LDA $14
	LSR A
	LSR A
	LSR A
	AND #$03
	TAX
	LDA Animate_HealthTBL,x
	CLC
	ADC !FREERAM27	; Yoshi's health.
	TAX
	LDA HealthIconTBL1,x
	DEC A
	STA $7FC0A1
	STA $7FC0A9	; Store to exanimation slots.
	LDA HealthIconTBL2,x
	DEC A
	STA $7FC0A0
	STA $7FC0A8	; Store to exanimation slots.

	RTS

Animate_HealthTBL:
db $00,$20,$40,$20

HealthIconTBL1:
db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$00,$01,$02,$03,$04,$05
db $06,$07,$08,$09,$00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$00,$0A	; Frame 1.
db $0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$0B,$0C,$0D,$0E,$0F,$10
db $11,$12,$13,$14,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$0B,$15	; Frame 2.
db $16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$16,$17,$18,$19,$1A,$1B
db $1C,$1D,$1E,$1F,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$16  	; Frame 3.
HealthIconTBL2:
db $0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$01,$01,$01,$01,$01,$01
db $01,$01,$01,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$03,$0A	; Frame 1.
db $0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0C,$0C,$0C,$0C,$0C,$0C
db $0C,$0C,$0C,$0C,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0E,$0A	; Frame 2.
db $0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$17,$17,$17,$17,$17,$17
db $17,$17,$17,$17,$18,$18,$18,$18,$18,$18,$18,$18,$18,$18,$19  	; Frame 3.
HealthPropertiesTBL:
db $38,$38,$38,$38,$38,$38,$34,$34,$34,$34,$34,$3A,$3A,$3A,$3A,$3A
db $3A,$3A,$3A,$3A,$3A,$36,$36,$36,$36,$36,$36,$36,$36,$36,$36

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

StuffInMouth:
	LDX #$0B
YoshiCoordloop:
	LDA $14C8,x
	CMP #$07		; Check for the sprite inside Yoshi's mouth.
	BEQ SnapToYoshiCoords	; Look for a free sprite slot.

	DEX
	BPL YoshiCoordloop

	RTS

SnapToYoshiCoords:
	LDA !FREERAM3
	BEQ RemoveEatenSpriteCompletely

	LDA $94
	STA $E4,x
	LDA $96
	STA $D8,x
	LDA $95
	STA $14E0,x
	LDA $97
	STA $14D4,x

	LDA #$18
	STA $154C,x	; Make sprite temporarily not interact with Yoshi

StuffInMouth_Return:
	RTS

RemoveEatenSpriteCompletely:
	STZ $14C8,x
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TongueInteract_Layer2NotReturn:
	LDA $149E	; Punching Net timer
	BEQ TongueInteract_Layer2Return

	PHB
	LDA #$02
	PHA
	PLB
	PHK
	PEA.w .jslrtsreturn-1
	PEA $D443 ; value of a RTL minus 1 in the target bank
	JML $0293AE ;location to jump to 02950B
.jslrtsreturn
	PLB

TongueInteract_Layer2Return:
	RTS

TongueBlockInteraction:
	LDA !FREERAM22
	BEQ TongueInteract_Layer2NotReturn

	LDA #$01
	STA $13E8

	PHB
	LDA #$02
	PHA
	PLB
	PHK
	PEA.w .jslrtsreturn-1
	PEA $D443 ; value of a RTL minus 1 in the target bank
	JML $0294F5 ;location to jump to 02950B
.jslrtsreturn
	PLB

	STZ $13E8
	RTS

TongueInteract_LayerJSR:
	JSL $00F160	; Restore hijack
	JSR TongueInteract_Layer
	RTL

TongueInteract_Layer:
	CPY $1693
	BEQ TongueBlockBerryCheck

	LDX $1693
	LDA SolidBlocks,x			; $00 = Block is not solid. $01 = Block is solid.
	BEQ TongueBlockInteraction_Return	; If block is not solid, return.

	LDA !FREERAM22
	CMP #$10
	BCS TongueBlockInteraction_CancelTongue

	LDA !FREERAM22
	EOR #$1F
	INC A
	INC A
	AND #$1F
	STA !FREERAM22				; Retract tongue if coming into contact with solid block.
	RTS

TongueBlockInteraction_CancelTongue:
	LDA #$1F
	STA !FREERAM22

TongueBlockInteraction_Return:
TongueBlockBerryCheck:
	RTS

SolidBlocks:
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 100 - 10F
db $00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01	; Tiles 110 - 11F
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01	; Tiles 120 - 12F
db $01,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01	; Tiles 130 - 13F
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01	; Tiles 140 - 14F
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00	; Tiles 150 - 15F
db $00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00	; Tiles 160 - 16F
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 170 - 17F
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 180 - 18F
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 190 - 19F
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 1A0 - 1AF
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 1B0 - 1BF
db $00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$00,$00,$00,$00,$00,$00	; Tiles 1C0 - 1CF
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 1D0 - 1DF
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01	; Tiles 1E0 - 1EF
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; Tiles 1F0 - 1FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FixBerries:
	LDA !FREERAM25	; Grab something with tongue flag
	BNE FixBerriesEnd

	LDX #$0B
IfBerryOnScreen:
	LDA $9E,x
	CMP #$74
	BEQ CheckIfMushroomIsBerry

	BRA LoopCallBerry

CheckIfMushroomIsBerry:
	LDA $160E,x
	BEQ LoopCallBerry

	LDA $14C8,x
	BEQ LoopCallBerry

	STZ $14C8,x	; Delete sprite.
FixBerriesEnd:
	RTS

LoopCallBerry:
	DEX
	BPL IfBerryOnScreen
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MidpointFix:
	LDX $13BF	; Get overworld level number.
	LDA $13CE
	BEQ MidpointFix_Return

	LDA $1EA2,x
	ORA #$40
	STA $1EA2,x	; Set midpoint flag to level table.

MidpointFix_Return:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

M1_Return__:
	STZ $140D
	STZ !FREERAM31
	STZ !FREERAM32			; Groundpound timer
	RTS

Groundpound:
	LDA !FREERAM11
	BNE M1_Return__

	LDA $74
	BNE M1_Return__

	LDA $75
	BNE M1_Return__

	LDA !FREERAM31
	BNE M1_Frame_2

	LDA $77
	AND #$04			; If not touching ground
	BNE M1_Return__

	LDA $16
	AND #$04			; If pressing down
	BEQ M1_Return

	LDA #$01
	STA !FREERAM31			; Set spin jump flag
	LDA #$01
	STA $140D			; Set spin jump flag

	LDA #$0F
	STA $1DF9			; Play sound effect

M1_Frame_2:
	JSR M1_CenterCamera

	LDA !FREERAM32			; Groundpound timer
	CMP #$10
	BEQ M1_Frame

	STZ $7B
	STZ $7D

	STZ !FREERAM13			; No egg-throwing allowed.

	LDA !FREERAM32
	LSR A
	LSR A
	AND #$03
	TAX
	LDA GroundPoundFrameTBL,x
	STA $13E0

	LDA !FREERAM32
	AND #$03
	BNE M1_INCTimer

	LDA $76
	EOR XFlipTBL,x
	STA $76

M1_INCTimer:
	INC !FREERAM32

	RTS

M1_Frame:
	LDA #$1C
	STA $13E0			; Set groundpound frame

	LDA $0D9B
	BMI No_Show_GP_Sparkles		; Don't show sparkles if in a mode 7 boss room.

	LDA #$02
	STA $18D3			; Make sparkles follow Yoshi

No_Show_GP_Sparkles:
	LDA #$6F
	STA $7D				; Push player down quickly

	STZ $7B				; Player can't move horizontally

	LDA $77
	AND #$04			; If touching ground
	BEQ M1_Return

	LDA #$30
	STA $1887

	LDA #$09
	STA $1DFC

	JMP M1_Return__

M1_Return:
	RTS

M1_CenterCamera:
	LDA $1412
	BEQ M1_Return

	LDA $5B
	AND #$03
	BEQ M1_NotVerticalCamera

	JMP M1_VerticalCamera

M1_NotVerticalCamera:
	REP #$20
	LDA $1464
	BMI M1_NoMoveCameraH2
	CMP #$00C0
	BCS M1_NoMoveCameraH

M1_MoveCamera:
	LDA $80
	SEC
	SBC #$8070
	BMI M1_CameraDown

	LDA #$0070
	SEC
	SBC $80
	STA $00
	CMP #$0003
	BCC M1_CameraUp2

	LDA $1464
	SEC 
	SBC #$0003
	STA $1464
	SEP #$20
	RTS

M1_CameraUp2:
	LDA $1464
	SEC 
	SBC $00
	STA $1464
	SEP #$20
	RTS

M1_CameraDown:
	LDA $80
	SEC
	SBC #$0070
	STA $00
	CMP #$0003
	BCC M1_CameraDown2

	LDA $1464
	CLC 
	ADC #$0003
	STA $1464
	SEP #$20
	RTS

M1_CameraDown2:
	LDA $1464
	CLC 
	ADC $00
	STA $1464
	SEP #$20
	RTS

M1_NoMoveCameraH:
	LDA #$00C0
	STA $1464
	SEP #$20
	RTS

M1_NoMoveCameraH2:
	STZ $1464
	SEP #$20
	RTS

M1_VerticalCamera:
	LDA $1465
	BMI M1_NoMoveCameraV2
	CMP $5D
	BCS M1_NoMoveCameraV

	REP #$20
	BRA M1_MoveCamera

M1_NoMoveCameraV:
	STZ $1464
	LDA $5D
	STA $1465
	RTS

M1_NoMoveCameraV2:
	STZ $1464
	STZ $1465
	RTS

GroundPoundFrameTBL:
	db $0F,$00,$25,$06,$06,$06,$06,$06
XFlipTBL:
	db $01,$00,$01,$00,$00,$00,$00,$00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;!FREERAM33		; Flutter jumping flag.

Flutterjump:
	LDA $74
	BNE M2T_Return

	LDA $75
	BNE M2T_Return

	LDA !FREERAM8		;
	BEQ NoFlutterBoost2	; Set flutter jump boost flag.

	LDA #$01
	STA !FREERAM34		; Set the alternate flutter jumping flag

NoFlutterBoost2:
	LDA !FREERAM33
	BNE M2_IfFlutterJump

	LDA $16
	AND #$80	; If pressing B.
	BNE M2_AltFlutterFlag

	LDA !FREERAM34
	BEQ M2T_Return

	LDA $7D
	BMI M2T_Return

	LDA $7D
	CMP #$24
	BCC M2T_Return

	LDA $15
	AND #$80	; If holding B.
	BEQ M2T_Return
	LDA $17		; Check for A button
	BMI M2T_Return

	LDA #$01
	STA !FREERAM33	; Set the flutter jumping flag

	RTS

M2_AltFlutterFlag:
	LDA #$01
	STA !FREERAM34	; Set alternate flag
M2T_Return:
	RTS

M2_IfFlutterJump:
	LDA $77
	AND #$04
	BNE M2_CancelFlutter

	LDA $15
	AND #$80	; If holding B.
	BEQ M2_CancelFlutter
	LDA $17		; Check for A button
	BMI M2_CancelFlutter

	LDA $7D
	BPL M2_SkipFlutterSpeedCheck

	LDX !FREERAM8
	LDA $7D
	CMP FlutterBoost_TBL,x
	BCC M2_CancelFlutter

M2_SkipFlutterSpeedCheck:
	LDA $14
	LSR A
	LSR A
	AND #$01
	TAX

	LDA YoshiFrame_TBLTBL,x
	STA $13E0

	LDA $7B
	SEC
	SBC #$18
	CMP #$D0
	BCS M2_SkipSlowDown

	LDA $7B
	BMI M2_SlowDownLeft

	LDA #$18
	STA $7B		; Max X speed right
	BRA M2_SkipSlowDown

M2_SlowDownLeft:
	LDA #$E8
	STA $7B		; Max X speed left

M2_SkipSlowDown:
	LDA $14
	AND #$01
	TAX
	LDA $7D
	SEC
	SBC Acceleration_FrameTBL,x
	STA $7D		; Accelerate upwards.

	LDA $77
	AND #$08
	BEQ DoNotBounceFromCeiling

	LDA #$46
	STA $7D

DoNotBounceFromCeiling:
	RTS

M2_CancelFlutter:
	STZ !FREERAM8
	STZ !FREERAM34
	STZ !FREERAM33
	RTS

YoshiFrame_TBLTBL:
	db $30,$37
Acceleration_FrameTBL:
	db $04,$05
FlutterBoost_TBL:
	db $E6,$D4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ThrowPose:
	LDA !FREERAM24	; Load timer for throwing frame.
	BEQ M4_Return	; If equal to zero...return.

	LDA #$3F
	STA $13E0	; Load throwing frame.

	DEC !FREERAM24	; Decrease timer.

M4_Return:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FrozenSprite:
	LDX #$0B
FrozenSprite_CheckSprite:
	LDA $7FAB9E,x
	CMP #!FROZENSPRITE
	BEQ FrozenSprite_CheckCustom
	BRA FrozenSprite_CallLoop

FrozenSprite_CheckCustom:
	LDA $7FAB10,x
	AND #$08
	BNE FrozenSprite_CheckExist
	BRA FrozenSprite_CallLoop

FrozenSprite_CheckExist:
	LDA $14C8,x
	BNE FrozenSprite_Routine

FrozenSprite_CallLoop:
	DEX
	BPL FrozenSprite_CheckSprite
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FrozenSprite_Routine:
	LDA $1504,x
	PHX
	TAX
	TXY		; Load frozen sprite index into Y.
	PLX

	LDA #$00
	STA $1504,y

	LDA $C2,x
	STA $00C2,y

	LDA $1510,x
	STA $1510,y

	LDA $151C,x
	STA $151C,y

	LDA $1528,x
	STA $1528,y

	LDA $1534,x
	STA $1534,y

	LDA $1540,x
	STA $1540,y

	LDA $154C,x
	STA $154C,y

	LDA $1558,x
	STA $1558,y

	LDA $1564,x
	STA $1564,y

	LDA $1570,x
	STA $1570,y

	LDA $157C,x
	STA $157C,y

	LDA $1602,x
	STA $1588,y

	LDA $1594,x
	STA $1594,y

	LDA $160E,x
	STA $160E,y

	LDA $163E,x
	STA $163E,y

	LDA #$03
	STA $154C,y	; Sprite can't hurt the player.

	LDA $15F6,y
	AND #$F1
	ORA #$0E
	STA $15F6,y	; Load palette F.

	LDA #$00
	STA $00B6,y	; Sprite can't move horizontally.
	STA $00AA,y	; Or vertically.

	LDA $1656,y	;\
	AND #$0F	; |
	ORA #$30	; |
	STA $1656,y	;/ Dies when jumped on.

	LDA $166E,y	;\
	AND #$01	; |
	ORA #$3E	; |
	STA $166E,y	;/ Disable cape and fireball killing.

	LDA $167A,y	;\
	AND #$08	; |
	ORA #$12	; |
	STA $167A,y	;/ Don't use default player interaction.

	LDA #$39	;\
	STA $1686,y	;/ Interaction with objects, and inedible.

	LDA #$46	;\
	STA $190F,y	;/ Don't be killed with silver POW or sliding or goal.

	LDA $E4,x
	STA $00E4,y
	LDA $D8,x
	STA $00D8,y
	LDA $14E0,x
	STA $14E0,y
	LDA $14D4,x
	STA $14D4,y

	LDA $15AC,x
	BNE FrozenSpriteRoutineReturn

	LDA #$07
	STA $1DF9	; Play SFX

	;STZ $14C8,x	; Kill sprite with spin-jump.

	PHY
	LDA #$21	;\
	STA $9E,x	; |
	LDA #$01	; |
	STA $14C8,x	; |
	LDA #$00	; |
	STA $7FAB10,x	; |
	STA $7FAB9E,x	; |
	JSL $07F7D2	;/ Generate coin where sprite was.
	PLY

	LDA #$20
	STA $1540,y	; Set spin jump timer.
	LDA #$04
	STA $14C8,y
	TYX
	STX $15E9
	JSL $07FC3B

FrozenSpriteRoutineReturn:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CarryThroughPipes:
	LDA $89
	CMP #$04
	BCS CarryThroughPipes_Return	; Return if player is exiting from a pipe.

	LDA $71
	CMP #$05
	BEQ FindEatenSprite
	CMP #$06
	BEQ FindEatenSprite

CarryThroughPipes_Return:
	JSR CarrySpringFix
	RTS

FindEatenSprite:
	LDX #$0B
FindEatenSpriteLoop:
	LDA $14C8,x
	CMP #$07
	BEQ TurnIntoCarriedSprite

	DEX
	BPL FindEatenSpriteLoop
	RTS

TurnIntoCarriedSprite:
	LDA $7FAB10,x
	AND #$08
	BNE CarryThroughPipes_DeleteSprite	; If sprite is custom, don't carry through pipe.

	LDA #$0B
	STA $14C8,x

	LDA #$01
	STA $1470	; Set carried flag.

	RTS

CarryThroughPipes_DeleteSprite:
	STZ $14C8,x
	STZ !FREERAM3
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HealthStarbit:
	LDA !FREERAM35
	BNE HurtFrame

	LDA !FREERAM28	; How much to decrement from Yoshi's health.
	BEQ HealthStuff

	LDA $14
	AND #$07
	BNE HealthStuff
	DEC !FREERAM27
	DEC !FREERAM28
	LDA #$01
	STA $1DFC	; Play starbit sound effect.

NextSlotExt1:
	LDA !FREERAM27	; Yoshi's health.
	BMI HurtYoshi

	JSR HurtGenerateStars

HealthStuff:
	LDA $1497
	CMP #$30
	BCC HealthReturn
HurtFrame:
	LDA $9D
	BEQ DontDec_SprLockTimer
	CMP #$03
	BCC BackToOW

	DEC $9D

DontDec_SprLockTimer:
	LDA #$14
	STA $13E0	; Display "hurt" frame.
	STZ $15
	STZ $16
	STZ $17
	STZ $18		; Disable controls.
	LDA #$01
	STA $19
	RTS

BackToOW:
	JSL $00D0D8
	STZ !FREERAM35	; Reset death flag.
	STZ !FREERAM2	; Reset egg counter.
	RTS
HurtYoshi:
	STZ !FREERAM27
	STZ !FREERAM28
	JSL $00F606
HealthReturn:
	RTS

HurtGenerateStars:
	LDX #$07
GenerateStarLoop:
	LDA $170B,x
	BEQ InitStarGen

	DEX
	BPL GenerateStarLoop

	RTS

InitStarGen:
	LDA #$09	; Custom extended sprite for star
	STA $170B,x
	LDA #$80
	STA $1765,x	; Misc RAM that determines whether or not star should be collectible. It's set to $80, which means it doesn't interact with anything.
	LDA $96
	STA $1715,x
	LDA $94
	STA $171F,x
	LDA $97
	STA $1729,x
	LDA $95
	STA $1733,x
	LDA #$C0
	STA $173D,x
	LDA !FREERAM28
	AND #$07
	TAY
	LDA XSPEEDTABLE,y
	STA $1747,x
	RTS

XSPEEDTABLE:
db $00,$08,$F8,$10,$F0,$00,$08,$F8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HealthFix:
	LDA !FREERAM27
	CMP #$1F
	BCC HealthFixReturn

	LDA #$1E
	STA !FREERAM27	; Health cannot go above 30.

HealthFixReturn:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

KeyFollow:
	LDA #$06	; If the max # of eggs Yoshi can have...
	SEC		; ...
	SBC !FREERAM1	; minus the number of keys...
	CMP !FREERAM2	; is less than the number of eggs Yoshi actually does have...
	BCS DontStoreToEgg

	STA !FREERAM2	; store the amount to Yoshi's egg count.

DontStoreToEgg:
	LDA !FREERAM1
	BEQ KeyReturn

	CMP #$07
	BCC KeyTableProp

	LDA #$06
	STA !FREERAM1	; Store 6 to the number of keys if Yoshi has more than that amount

KeyTableProp:
	CLC
	ADC !FREERAM2	; Yoshi's eggs + keys
	TAX
	DEX		; Minus 1
	LDY #$00
KeyTable_Loop:
	LDA #$03
	STA !FREERAM4,x
	DEX
	INY
	CPY !FREERAM1
	BNE KeyTable_Loop

KeyReturn:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CarrySpringFix:
	LDX #$0B
CarrySpringLoop:
	LDA $14C8,x
	CMP #$0B
	BEQ UnCarrySpring

	DEX
	BPL CarrySpringLoop

CarrySpringReturn:
	RTS

UnCarrySpring:
	LDA #$08
	STA $14C8,x
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NoMoveDucking:
	LDA $77
	AND #$04
	BEQ DisableDucking

NoMoveDucking1:
	LDA $73		; Ducking flag
	BEQ Ducking_Return

	STZ $7B		; Freeze X speed to prevent player from being able to slide under small tunnels.

Ducking_Return:
	RTS

DisableDucking:
	LDA $1471
	BNE NoMoveDucking1

	STZ $73		; Disable ducking if player is in air.
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

YoshiMouthPowerStatus:
	LDA !FREERAM3
	CMP #$01
	BCS SmallMarioHealth

	LDA !FREERAM3
	EOR #$01
	STA $19
	BRA NotSmallMarioHealth

SmallMarioHealth:
	STZ $19

NotSmallMarioHealth:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DisableControls:
	LDA $1497
	CMP #$30
	BCC DisableControlsReturn

	STZ $15
	STZ $16
	STZ $17
	STZ $18

DisableControlsReturn:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GoalFix:
	LDA $1493
	BEQ GoalFixReturn

	LDA #$01
	STA $19

GoalFixReturn:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

YoshiEnd: