;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Awesome Air Meter Patch by 1024
;; Demonstration Video:
;; http://www.smwcentral.net/?p=thread&pid=69229
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mandatory Adjustments here
;;
;; Find freespace 600+ bytes
;;
;;Adjust:
;;
!freespace = $148000
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Optional Value Adjustments
;; Note: $28 cycles per second are on timer counter
;;
!airstat = $0670 ;Free RAM walue ($0660 to $06FF)
!decfrmram = $0671 ;""
!incfrmram = $0672 ;""
!branchinfo = $0673 ;""
!decfrmmax = #$48 ;Cycles per lowering air-- 1 is really fast FF is really slow
!incfrmmax = #$12 ; "" increasing air ""
!maxair = #$06 ;Maximium air points plus 1 (#$01 to #$10)
!length = #$05 ;How many tiles wide (#$00 to #$0F)
!sfxchannel = $1DFC ;Where the sfx byte table is stored
!pos = $0F0B ;Where on the Status bar tilemar the gfx starts ($0EF9 to $0F2E)
!death = $00F606 ;Subroutine for 0 air
;; Look below in code for useful tables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Install code at
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $8E81
JSL routine

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org !freespace
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
db "STAR" ; RATS tag used to protect data from other programs
dw Endcode-Startcode
dw Endcode-Startcode^#$FFFF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Startcode:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Dont use rtl here because it's below

routine:
LDA !airstat
BNE noupdatechk
LDA !maxair
STA !airstat
noupdatechk:
LDA.w $1493
ORA $9D
BEQ cont
STZ !airstat
RTL
cont:
LDA $75
BEQ dry
LDA !branchinfo
CMP #$01
BEQ dframeld
LDA #$01
STA !branchinfo
LDA !decfrmmax
STA !decfrmram
dframeld:
LDA !decfrmram
BNE decram
DEC !airstat
LDA !decfrmmax
STA !decfrmram
BRA decactions
decram:
DEC !decfrmram
BRL gfxcalc
decactions:
LDX !airstat
DEX
LDA decsound,x
STA !sfxchannel
LDA !airstat
CMP #$01
BNE cont2
JSL !death
cont2:
BRL gfxcalc

; SFX for decrementing air points Empty to Full
decsound:
db $00,$2A,$2A,$2A,$2A,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15

dry:
LDA !branchinfo
CMP #$02
BNE cont3
BRL gfxcalc
cont3:
LDA !branchinfo
BEQ iframeld
STZ !branchinfo
LDA !incfrmmax
STA !incfrmram
iframeld:
LDA !incfrmram
CMP !incfrmmax
BNE incram
LDA !airstat
CMP !maxair
BNE cont4
LDA #$02
STA !branchinfo
BRL gfxcalc
cont4:
INC !airstat
STZ !incfrmram
BRA incactions
incram:
INC !incfrmram
BRL gfxcalc
incactions:
LDX !airstat
DEX
LDA incsound,x
STA !sfxchannel
BRA gfxcalc

; SFX for incrementing air points Empty to Full
incsound:
db $00,$00,$00,$00,$00,$29,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15

; Extended settings
db $41,$69,$72,$4D,$74,$72,$62,$79,$31,$30,$32,$34,$28,$32,$5E,$31,$30,$29
; Do not adjust unless you like a crashed ROM

gfxcalc:
LDA !length
recalc:
BEQ jump
PHA
LDA !airstat
SEC
SBC #$01
ASL
ASL
ASL
ASL
STA $0674
PLA
SEC
SBC #$01
PHA
CLC
ADC $0674
TAX
PLA
TAY
PHY
LDA gfxtable,x
TYX
STA !pos,x
PLA
BRA recalc
jump:
BRL end

; Gfx 2bbp tile numbers Left to Right
; Vertically starts at air empty and goes up
gfxtable:
db $41,$40,$40,$40,$42,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;Empty 3 7 B/11 F/15
db $7A,$40,$40,$40,$42,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 1 air 3 7 B/11 F/15
db $7A,$3B,$40,$40,$42,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 2 air 3 7 B/11 F/15
db $7A,$3B,$3B,$40,$42,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 air 3 7 B/11 F/15


db $7A,$3B,$3B,$3B,$42,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $43,$79,$79,$79,$44,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 7 air 3 7 B/11 F/15

db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; B/11 air 3 7 B/11 F/15

db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; 3 7 B/11 F/15
db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
; F/15 air 3 7 B/11 F/15


end:
;You can put your own timers here instead

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LDX #$10 ; restore damaged code
LDY #$00
RTL ;End

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Endcode:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;