;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  SMW Boss Property Patch  ;
;       by Luigi-San        ;
;                           ;
;  This patch changes many  ;
;   different properties    ;
; related to SMW's original ;
;  boss battles, including  ;
; palettes, sprites thrown, ;
; hits needed to win, etc.  ;
;                           ;
;   No freespace required.  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


header
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;         Defines           ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!MortonRoyLudwigHP = $05 ; |Amount of hits needed to beat Morton, Roy, and Ludwig.
!MortonRoyLudwigFireballHP = $0C ; |Amount of fireballs needed to beat Morton, Roy, and Ludwig.
!LemmyWendyHP = $05 ; |Amount of hits needed to beat Lemmy and Wendy.
!LemmyWendySprites = $03 ; |Amount of hits (MINUS ONE) on Lemmy/Wendy before all other sprites in the room vanish.
!LemmyWendyPoints = $03 ; |Amount of points damaging Wendy/Lemmy and their decoys are worth.
!IggyLarrySprite = $02 ; |Sprite thrown by Iggy and Larry. SOME SPRITES MAY CRASH THE GAME.
!BowserFallingSprite = $05 ; |Sprite spawned by between-phases falling sprite generator.
!BowserPhase2Sprite = $10 ; |Sprite thrown by Bowser in Phase 2 (normally the bowling ball).
!BowserPhase1HP = $03 ; |Bowser's HP in the first phase.
!BowserPhase2and3HP = $05 ; |Bowser's HP in the second and third phases.
!PeachSprite = $75 ; |Sprite thrown by Princess Peach in between phases.
!AllPhaseSprite = $09 ; |Sprite thrown by Bowser in all 3 phases (normally Mechakoopas).
!ReznorSprite = $04 ; |Sprite spawned by Reznors. SOME SPRITES MAY CRASH THE GAME.
!ReznorBridge = $03 ; |Number of Reznors that need to be killed before the bridge begins to break.
!BigBooSecretExit = $BC ; |Level number that triggers secret exit upon defeat of Big Boo.
!BigBooHP = $05 ; |Big Boo's HP.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   General data            ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $048E2E ; |Prevents music from disappearing after beating a boss.
db $80

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    Morton/Roy/Ludwig data ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $03DD6E     ; |Changes Morton, Roy, and Ludwig's palettes to match their official artwork.
db $84,$CC,$A4

org $03DD73     ; |Same as above.
db $B3,$B3,$B2

org $01CFCD
db !MortonRoyLudwigHP 

org $01D3FF
db !MortonRoyLudwigFireballHP

org $01D3F8
;db $EA,$EA,$EA  ; |Remove the first semicolon to make Morton, Roy, and Ludwig immune to fireballs

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    Lemmy/Wendy data       ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $03D22E ; |Changes Lemmy's palette to match his official artwork.
db $0B,$4B,$0B,$4B,$0B,$00,$0B,$4B,$0B,$4B,$0B,$00,$0B,$0B,$0B,$00,$00,$00,$0B,$0B,$0B,$4B,$00,$00,$0B,$4B,$0B,$0B,$4B,$00,$0B,$4B,$0B,$00,$00,$00,$0B,$0B,$0B,$00,$00,$00,$0B,$0B,$0B,$00,$00,$00,$0B,$4B,$0B,$0B,$00,$00,$0B,$4B,$4B,$4B,$00,$00,$0B,$4B,$0B,$0B,$0B,$4B,$0B,$4B,$4B,$0B,$4B,$00,$0B,$4B,$00,$00,$00,$00,$0B,$4B,$00,$00,$00,$00,$0B,$4B,$4B,$0B,$4B,$00,$0B,$4B,$0B,$0B,$4B,$00,$0B,$4B,$0B,$00,$00,$00,$0B,$4B,$0B,$00,$00,$00,$0B,$4B,$0B,$00

org $03D2A0 ; |And his decoys, for consistency.
db $0B,$4B,$0B,$0B,$4B,$00,$0B,$4B,$0B,$00,$00,$00,$0B,$4B,$0B,$00,$00,$00,$0B,$4B,$0B

org $03D2B8 ; |Changes Wendy's palette to match her official artwork.
db $0F,$4F,$0F,$4F,$0F,$00,$0F,$4F,$0F,$4F,$0F,$00,$0F,$0F,$0F,$00,$00,$00,$0F,$0F,$0F,$4F,$00,$00,$0F,$4F,$0F,$0F,$4F,$00,$0F,$4F,$0F,$00,$00,$00,$0F,$0F,$0F,$00,$00,$00,$0F,$0F,$0F,$00,$00,$00,$0F,$4F,$0F,$0F,$0F,$00,$0F,$4F,$4F,$4F,$4F,$00,$0F,$4F,$0F,$0F,$0F,$4F,$0F,$4F,$4F,$0F,$4F,$00,$0F,$4F,$00,$00,$00,$00,$0F,$4F,$00,$00,$00,$00,$0F,$4F,$4F,$0F,$4F,$00,$0F,$4F,$0F,$0F,$4F,$00,$0F,$4F,$0F,$00,$00,$00,$0F,$4F,$0F,$00,$00,$00,$0F,$4F,$0F

org $03D32A ; |And her decoys, for consistency.
db $0F,$4F,$0F,$0F,$4F,$00,$0F,$4F,$0F,$00,$00,$00,$0F,$4F,$0F,$00,$00,$00,$0F,$4F,$0F

org $03CE1A
db !LemmyWendyHP

org $03CED4
db !LemmyWendySprites           

org $03CEB8    
db !LemmyWendyPoints            

org $03CFAF     ; |This and following three addresses fix Wendy's bow
db $08 

org $03CFB5
db $08

org $03D1D7
db $1F,$1E

org $03D1DD
db $1E,$1F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      Iggy/Larry data      ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $01FEBA     ; |Changes Iggy's palette to match his official artwork.
db $3B

org $01FEBB     ; |Changes Larry's palette to match his official artwork.
db $37

org $01FDBD     
db !IggyLarrySprite

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Bowser data         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $03A801    
db !BowserFallingSprite

org $03A623    
db !BowserPhase2Sprite

org $03A10B
db !BowserPhase1HP

org $03A683
db !BowserPhase2and3HP

org $03A8EE    
db !PeachSprite

org $03B031
db !AllPhaseSprite

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        Reznor data        ; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $03D71B    
db !ReznorBridge

org $039B09
db !ReznorSprite

org $03989F
;db $EA,$EA,$EA,$EA  ; |Remove the first semicolon to prevent Reznor's bridge from breaking

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      Big Boo Boss data    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $00CA0C    
db !BigBooSecretExit

org $0381A2
db !BigBooHP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   Mario's status in the   ;
;  credits. Uncomment the   ; 
;   one you want to use.    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $0C9FF8
;db $A5,$19 ; |Makes Mario keep his current powerup status during the credits

org $0C9FF8
;db $A9,$00 ; |Makes Mario small during the credits

org $0C9FF8
;db $A9,$01 ; |Makes Mario big during the credits

org $0C9FF8
;db $A9,$03 ; |Makes Mario fiery during the credits

org $0C9FF8
;db $A9,$02 ; |Makes Mario caped during the credits