header
lorom

;Custom OW Border Palettes v1.0 by lolcats439
;Enables custom palettes for colors 8-F of palettes 0 and 1 on the Overworld
;on a per-submap and if-special-world-passed basis


;how to use it
;edit the custom palettes below the SubmapPtr table
;make the color you want in LM'S palette editor, then use the SNES RGB value it gives you
;after patching, use Terra Stripe - http://bin.smwcentral.net/5814/Terra%20Stripe%201.1.zip
;to edit the OW Border and fill in the space where Mario was


;Note: This patch is incompatible with the OW Mario border sprite, so this removes it.
;The background tiles displayed behind Mario are also a sprite, and it uses palette B color 7
;the same color as the OW Luigi (not border) sprite's skin. Changing it would mess up Luigi's
;OW sprite. Changing the palette of those tiles won't work, since color 7 of palette 8 and 9 are
;used, and color 7 of palettes C - F are transparent colors. So, it's better to just remove Mario
;from the OW border to make it look right.


!FREESPACE = $168000; change to freespace
!DefaultBorderPal = $00B5EC ; ROM address of the default Layer 3 OW border palette (colors 8-F of palettes 0-1)


org $00AD8C               ;\ Hijack code and JSL to custom code
JSL !FREESPACE            ;|
NOP #19                   ;/


org $0485CF               ;\ remove Mario from the OW border
NOP #4                    ;/


org !FREESPACE
SEP #$30                  
LDY $0DB3                 ;\ get current player 
LDA $1F11,y               ;| index to current player's submap
ASL A                     ;| multiply submap index by 3
CLC                       ;| 
ADC $1F11,y               ;/
TAX
LDA $1EEB                 ;\ Only run if special world is passed - Note: the special world level must be 125 for this to work
BPL SpecialWorldNotPassed ;/ 
TXA                       ;\ If special world is passed
CLC                       ;| add 15 to the submap number in A
ADC #$15                  ;|
TAX                       ;/
SpecialWorldNotPassed:
LDA SubmapPtr+2,x         ;\ Store bank byte into $02
STA $02                   ;|
REP #$30                  ;/
LDA SubmapPtr,x           ;\ Store custom palette address into $00
STA $00                   ;/
LDA.w #$0010              ;\ restore old code
STA $04                   ;|
LDA.w #$0007              ;|
STA $06                   ;|
LDA.w #$0001              ;|
STA $08                   ;/

JSR LoadCustColors
RTL


; Almost identical to LoadColors rom all.log, copied here so it is in the same bank as the custom palettes
LoadCustColors:
LDX $04                   ; load byte offset (first color number * 2) into X
LDY $06                   ; load number of colors into Y
NextColor:
LDA [$00]                 ; load 24-bit pointer to colors into A
STA.w $0703,X             ; Store color into RAM
INC $00                   ; \ add 2 to $00, to get next color to load
INC $00                   ; /
INX                       ; \ add 2 to X, to offset the RAM address
INX                       ; /
DEY                       ; \ subtract 1 from Y, to decrease remaining color count
BPL NextColor             ; / if Y is still positive, branch up to load next color
LDA $04                   ; after all colors loaded into this row, load RAM offset into A
CLC                       ; \ add 20 to it to move the RAM offset hex 10 colors forward
ADC.w #$0020              ; /
STA $04                   ; store offset to $04 again
DEC $08                   ; \ decrease number of rows to load
BPL LoadCustColors        ; / if $08 is still positive, branch to LoadColors to load colors into the next row
RTS                       ; Return 




;Submap pointer
;1st row is for each submap before special world is passed, 2nd row is after
;The order is MainOW, YoshisIsland, VanillaDome, ForestOfIllution, ValleyOfBowser, SpecialWorld, StarWorld
;Replace "!DefaultBorderPal" with the label of the custom palette that you want for that submap
SubmapPtr:
dl !DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal
dl !DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal,!DefaultBorderPal


MainOW:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
YoshisIsland:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
VanillaDome:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
ForestOfIllusion:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
ValleyOfBowser:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
SpecialWorld:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
StarWorld:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C

MainOWSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
YoshisIslandSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
VanillaDomeSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
ForestOfIllusionSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
ValleyOfBowserSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
SpecialWorldSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C
StarWorldSWP:
dw $7393,$0000,$03FF,$573B,$7393,$3E75,$3212,$25AF
dw $7393,$573B,$7FFF,$0000,$7393,$0000,$573B,$7E6C

