lorom
header

!True = 1
!False = 0

;----------------------------------------------------------------------------------;

; If you want the time up screen to use different values than the game over one, set this to !True
!AltTimeUp = !True

; If you want to specify frames directly for a specific screen, just set either of those to !False
!UseSecondsGO = !True		; GO = Game Over
!UseSecondsTU = !False		; TU = Time Up

; How much time the game over and timeup screens will last.
; If !UseSeconds(GO and/or TU) is !True, use !Seconds(GO and/or TU), else use !Frames(GO and/or TU) instead.
; Note1: the game over values are used for the time up screen too if !AltTimeUp = !False
; Note2: the timer will start counting after the GAME and OVER (or TIME and UP) words join (about 3 seconds)
; Note3: the original game waits for $FF frames, which is about 4 seconds
!SecondsGO = 11			; GO = Game Over
!SecondsTU = 4			; TU = Time Up

!FramesGO = $01FF		; Use 16-bit values!
!FramesTU = $0100		; Same as above!

; If for some reason you don't want to enable Start to skip the death screens, set this to !False
!PressStartToEnd = !True	; !True is reccomended in most cases

; 16-bit counter for the game over and time up screen. Must be 2 bytes!
!FreeRAM = $18CB

;----------------------------------------------------------------------------------;

if !UseSecondsGO
	assert !SecondsGO <= 1092, "Error: too long time. Doubt you'll want something that long anyway."
	!FramesGO = (!SecondsGO*60)&$FFFF
else
	assert !FramesGO <= $010000, "Error: invalid number of frames, be sure to use a 16-bit value."
endif

if !UseSecondsTU && !AltTimeUp
	assert !SecondsTU <= 1092, "Error: too long time. Doubt you'll want something that long anyway."
	!FramesTU = (!SecondsTU*60)&$FFFF
else
	assert !FramesTU <= $010000, "Error: invalid number of frames, be sure to use a 16-bit value."
endif

if !AltTimeUp
	print "Frames to wait during GAME OVER screen: $", hex(!FramesGO)
	print "Frames to wait during TIME UP screen: $", hex(!FramesTU)
else
	print "Frames to wait during both GAME OVER and TIME UP screen: $", hex(!FramesGO)
endif

;----------------------------------------------------------------------------------;
	
org $009760
	autoclean JML DecTimer
	NOP

org $00D0FD
	autoclean JML StoreTimer
	NOP

freecode

DecTimer:
	BNE .nope			; Branch away if the words haven't joined toghether
if !PressStartToEnd			; (only assembled when pressing start is enabled)
	LDA $16				;\ End the whole thing prematurely if player presses start
	AND #$10			; |
	BNE .end			;/
endif
	REP #$20			;\ Decrease 16-bit timer accordingly
	DEC !FreeRAM			; |
	SEP #$20			;/
	JML $009765			; Return
.nope
	JML $00978B			; Return somewhere else
	
if !PressStartToEnd
.end
	LDA #$FF			;\ Fade out music
	STA $1DFB			;/
	JML $009767			; Jump there to prematurely end the scene
endif

StoreTimer:
	REP #$20			; 16-bit A
	LDA.w #!FramesGO		; Load frames to wait during the game over screen
if !AltTimeUp == !True			; (only assembled if using alternate values for time up)
	LDX $143B			;\ If not time up, branch away
	CPX #$1D			; |
	BNE .not_time_up		;/
	LDA.w #!FramesTU		; Else, load frames to wait during the time up screen..
.not_time_up
endif		
	STA !FreeRAM			; Store frames
	SEP #$20			; 8-bit A
.return
	JML $00D102			; Return
