;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Goal Point Sprite Reward Fix
; by Ragey (29/06/2014)
;
; When you hit the goal tape nearby a lot of sprites, garbage tiles appear. This
; patch fixes that.  In addition, it allows you to control how many sprites need
; to be  nearby when cutting  the goal tape,  before Mario gets  1UPs  for them.
; The default settings will give a  1UP for each enemy beyond the fourth; reduce
; the value of  !FIRST_SPRITE_WORTH  to increase the amount of sprites required.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!FREE_RAM = $13D8            ; must be cleared on overworld or level load
!FIRST_SPRITE_WORTH = $09    ; default = 1000 points. Can be between $01 - $0D
!HIGHEST_SPRITE_WORTH = $0D  ; default = 1UP.         Can be between $01 - $0D

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $00FC0E
  autoclean JSL.L NewGivePoints

freecode
NewGivePoints:
  PHX
  INC !FREE_RAM
  LDA !FREE_RAM
  CMP #!FIRST_SPRITE_WORTH
  BCC .set9
  CMP #!HIGHEST_SPRITE_WORTH+$1
  BCS .setD
  JSL.L $02acef
  PLX
  RTL
.set9
  LDA #!FIRST_SPRITE_WORTH
  STA !FREE_RAM
  JSL.L $02acef
  PLX
  RTL
.setD
  LDA #!HIGHEST_SPRITE_WORTH
  STA !FREE_RAM
  JSL.L $02acef
  PLX
  RTL