; -------------------------------------------
; Koyukillo's amazing smb2/dokidokipanic holding patch!
; -------------------------------------------

HEADER
LOROM 

; -------------------------------------------
; Patches
; -------------------------------------------
org $01AA58
	JML HoldGrab1
org $81E6CE
	JML HoldGrab2
org $01A00D
	JML HoldRelease
org $01A0F6
	JML HoldOffset
org $019F77 ; Held item always in front 
	BRA $0A
org $01A685
	JML KickHit
org $00D062
	JML CheckAttack
; -------------------------------------------

; -------------------------------------------
; RATS tag
; -------------------------------------------

; -------------------------------------------
!blockaddress = $0FFC01		; FREE SPACE PLS!
org !blockaddress		; address to put code
; -------------------------------------------
db "STAR"		; Write RATS tag
dw block_end-block_start-1
dw block_end-block_start-1^$FFFF
; -------------------------------------------
block_start:		; code starts here
; -------------------------------------------

; -------------------------------------------
; Defines
; -------------------------------------------

!RAM_SpriteNum = $9E 
!RAM_SpriteSpeedY = $AA 
!RAM_SpriteSpeedX = $B6 
!RAM_SpriteState = $C2
!RAM_SpriteDir = $157C
!RAM_SprObjStatus = $1588
!RAM_SprIndexInLvl = $161A
!RAM_SprBehindScrn = $1632 

; -------------------------------------------
; Code
; -------------------------------------------

;Koyuki update
NoDuckOffsets:
dw $0002, 0-$06, 0-$06, 0-$06
DuckOffsets:
dw $000A, $0004, $0004, $0004


HoldGrab1:
	LDA $15
;	EOR $17
	AND #$40
	BNE .Hold
	.NoHold
	JML $81AA74
	.Hold
	;LDA #$10
	;STA $0F46
	LDA $148F
	BNE .NoHold
	LDA #$01
	STA $148F
	JML $01AA5E
	
HoldGrab2:
	LDA $15
;	EOR $17
	AND #$40
	BNE .Hold
	.NoHold
	JML $01E6E2
	.Hold
	LDA $1470
	ORA $148F
	ORA $187A
	BNE .NoHold
	;LDA #$10
	;STA $0F46
	LDA #$01
	STA $1470	; This was never set in the orginal for this, hence the double pickup bug
	STA $148F
	JML $01E6DA
	
HoldRelease:
	LDA #$01	;\ Koyuki update
	STA $148F	;| This fixes ICB's SMB2 Blocks and Mikeyk's SMB2 sprites bug when pressing Y
	STA $1470	;/ Try removing this and test ICB smb2 blocks/mikeyk's smb2 sprites to see what happens 
	LDA $1498 	; Can't let go until animation is over
	BNE .Hold
	LDA $16
;	AND $18
	AND #$40
	BNE .NoHold
	.Hold
	STZ $74 ; Forbid climbing if your carrying something. 
		; You can still catch items while climbing but it forces you to drop. 
	JML $01A011
	.NoHold
	STZ $0F46
	JML $01A015

HoldOffset:
	REP #$20
	LDA $00
	SEP #$20
	STA $E4,x
	XBA
	STA $14E0,x
		
	PHX		; Koyuki update
	LDA $19
	ASL
	TAX
	LDA $73
	CMP #$04
	REP #$20
	CLC
	BEQ .Ducking	;Koyuki update
	{
		.Noduck
		LDA NoDuckOffsets,x
		ADC $02
		;STA $02
		BRA .Skip
	}
	.Ducking
	{
		LDA DuckOffsets,x
		ADC $02
		;STA $02
	}
	.Skip
	PLX
	SEP #$20
	CLC
	ADC $1498
	STA $D8,x
	XBA
	ADC #$00
	STA $14D4,x
	LDA $76
	EOR #$01
	STA $157C,x	
	PLY
	LDA $1470
	JML $01A128

KickHit:
{
	PHX
	PHY	
	
	; for some reason the sprites are switched sometimes
	LDA $14C8,y
	CMP #$08 : BNE .else
	{
		TXA : TYX : TAY	; if so switch x and y
		BRA .endif	; skip next block
	}
	.else
	{	
		; Branch if not stunned
		LDA $14C8,x
		CMP #$09 : BNE .endif
		{
			; Branch if not on ground
			LDA.w !RAM_SprObjStatus,x
			AND.b #$04
			BNE .endif
			{
				; Branch if not goomba
				LDA.w !RAM_SpriteNum,x
				CMP #$0F : BNE .endif
				{
					TXA : TYX : TAY	; Switch x and y
					BRA .isgoomba	; Skip to start, we know it's a goomba
				}
			}
		}
	}
	.endif
		
	; Branch if not goomba or a custom sprite that acts like one
	LDA.w !RAM_SpriteNum,y	
	CMP #$0F : BNE .normal
	.isgoomba
	; Branch if flying question blocks
	LDA !RAM_SpriteNum,x
	CMP.b #$83 : BEQ .normal
	CMP.b #$84 : BEQ .normal
	{
		LDA.b #$02	; kill other sprite
		STA.w $14C8,x	
		LDA.b #$0A	; Set kick status
		STA $14C8,y
		LDA $1686,y	; Turn off object interaction
		ORA #$80
		STA $1686,y
		LDA $167A,y	; Turn off player interaction
		ORA #$80
		STA $167A,y
		LDA #$FF	; Permanently erase sprite
		STA !RAM_SprIndexInLvl,y
		JSL $81AB72

		LDA $1626,y
		INC
		CMP #$08 : BCS .skip
		{ STA $1626,y }
		.skip

		PHX
		TAX
		LDA $01A61D,x
		STA $1DF9
		TXA
		PLX

		JSL $02ACE5

		STA $7FFFFF
		LDA.w !RAM_SpriteSpeedX,y
		CMP #$80	; Set carry if negitive
		ROR		; Rotate bits right, moving carry into highest bit if set
		CMP #$80
		ROR
		STA $00
		LDA.w !RAM_SpriteSpeedX,y
		SEC
		SBC $00
		STA !RAM_SpriteSpeedX,x 
		STA.w !RAM_SpriteSpeedX,y
		LDA.b #$0-$20
		STA !RAM_SpriteSpeedY,x 
		STA.w !RAM_SpriteSpeedY,y

		; Jump to RTS
		PLY
		PLX
		JML $01A6D6

	}
	.normal		; non goombas end up here
	{
		PLY
		PLX
		LDA !RAM_SpriteNum,x	; restore code
		CMP.b #$83
		JML $01A689
	}
}

; This makes sure the player is not holding an object before he can shoot fireballs or use a cape
CheckAttack:
	LDA $148F
	BNE .holding
	{
		LDA $19
		CMP.b #$02 
		JML $00D066
	}
	.holding
	{
		JML $00D080
	}

; -------------------------------------------
block_end:		; code ends here	
; -------------------------------------------