
;0x3CE

!Freespace = 	$149942	; Freespace.
!NeedARam = 	$7C	; Free RAM (1 byte).
!Idle = 	$08	; How many seconds it takes to be idle/sleepy.
!Pose =		$24	; Pose to use for sleeping/idling frame.

Header
LoROM

org $028DD7
	db $DF	; Remap RVF tiles. Change these to whatever free tile in SP1/SP2 you have.
	db $DE
	db $CF
	db $CE

org $028E44
	db $02	; Make it use the first graphics page (these are the properties).

org $8F89
JSL Hacks
org !Freespace

;===========================;
org !Freespace		    ;
!CodeSize = Ending-Routine  ;	
db "STAR"		    ;		
dw !CodeSize-$01            ;
dw !CodeSize-$01^$FFFF      ;
Routine:		    ;
;===========================;

LolStop:
	STZ !NeedARam		; RAM = 0.
	LDA #$0F		;\
	STA $0DAE		;/ Restore brightness.
EndCode:
	RTL
Hacks:
	STZ $00
	STZ $01
	LDA $0DB0		; End the code if it's running as the level starts, to get rid of the mosaic/pixelation.
	ORA $1493		; Also end if you're ending the level.
	ORA $1490		; Or if you have a star..
	ORA $74			; ZzZ while climbing?
	ORA $71			; Bunch of actions.
	BNE EndCode
	LDA $16			;\
	ORA $15			; |
	ORA $17			; | If you're pressing a button, disable the timer and revert the brightness.
	ORA $18			; |
	BNE LolStop		;/
	LDA !NeedARam		;\
	CMP #!Idle		; | If you've been idle..
	BCS ++			;/ Execute idle code.
	LDA $13
	AND #$3F
	BNE +			; Increment the timer every 1 second.
	INC !NeedARam
+	RTL

++	LDA #$0A		; Brightness, configurable.
	STA $0DAE
	LDA #!Pose		; Pose.
	STA $13E0
	PHX
	PHY	
	JSL ZzZ			; ZzZ tiles.
	PLX
	PLY
	RTL

ZzZ:	LDA #$06
	TAY
	LDA $15A0,x
	ORA $186C,x
	BNE Return
	TYA
	DEC $1528,x
	BPL Return
	PHA
	LDA #$28
	STA $1528,x
	LDY #$0B
Loop:
	LDA $17F0,y
	BEQ FreeSlotFound
	DEY
	BPL Loop
	DEC $185D
	BPL EndLoop
	LDA #$0B
	STA $185D
EndLoop:
	LDY $185D
FreeSlotFound:
	PLA
	STA $17F0,y
	LDA $94
	CLC
	ADC #$06
	STA $1808,y
	LDA $96
	CLC
	ADC #$00
	STA $17FC,y
	LDA #$7F
	STA $1850,y
	LDA #$FA 
	STA $182C,y
Return:            
	RTL  

Ending: