;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Iggy Hair Fix, by Mattrizzle, 
; Thanks to mikeyk for the full disassembly
; 
; This xkas patch gives Iggy's hair its correct graphics,
; instead of reusing Larry's hair.
;
; As far as I can tell, this is bug-free, but let me know if
; you find any problems.
;
; The blank space at the end of bank 01 is used by this. Beware
; of overwritten data! 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

lorom
header

org $01FA9A
                    jsr ADDR_01FF98

org $01FC5E
                    jsr SHELL_SPIN

org $01FE9C
                    db $FC                  ; replace duplicate hair tile in turning frame with a blank tile

org $01FF14
                    bne NOT_IGGY           
                    cmp #$05                
                    bcs NOT_IGGY           
                    lsr                       
                    tax                       
                    lda.w $01FEB3,X       
                    sta $0302,Y             

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Start of modified data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    lda $02FE,Y
                    cmp #$0C                ;  If tile 0C... (Larry's hair)
                    bne HAIR_TILE2
                    lda #$1A                ;  Replace with tile 1A (Iggy's hair)
                    bra STORE_TILE
HAIR_TILE2:         cmp #$1C                ;  If tile 1C... (Larry's Hair while turning)
                    bne NOT_IGGY
                    lda #$1B                ;  Replace with tile 1B (Iggy's hair while turning)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; End of modified data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STORE_TILE:         sta $02FE,Y       
NOT_IGGY:           lda $0302,Y             
                    cmp #$4A                
                    lda $0D                   
                    bcc ADDR_01FF2D           
                    lda #$35                ;  Iggy ball palette 
ADDR_01FF2D:        ora $02                   
                    sta $0303,Y             
                    pla                       
                    and #$03                
                    tax                       
                    phy                       
                    tya                       
                    lsr                       
                    lsr                       
                    tay                       
                    lda.w $01FEB6,X       
                    sta $0460,Y             
                    ply                       
                    iny                       
                    iny                       
                    iny                       
                    iny                       
                    plx                       
                    dex                       
                    bpl BACK
                    plx                       
                    ldy #$FF                
                    lda #$03                
                    jsr.w $01B7BB         
                    rts                       ; Return 

BACK:               jmp.w $01FEDE

DATA_01FF53:        db $2C,$2E,$2C,$2E

DATA_01FF57:        db $00,$00,$40,$00

SHELL_SPIN:         phx                       
                    ldy $C2,X                 
                    lda.w $1FEB7,Y       
                    sta $0D                   
                    ldy #$70                
                    lda $14B8               
                    sec                       
                    sbc #$08                
                    sta $0300,Y             
                    lda $14BA               
                    clc                       
                    adc #$60                
                    sta $0301,Y             
                    lda $14                   
                    lsr                       
                    and #$03                
                    tax                       
                    lda.w DATA_01FF53,X       
                    sta $0302,Y             
                    lda #$30                
                    ora.w DATA_01FF57,X       
                    ora $0D                   
                    sta $0303,Y             
                    tya                       
                    lsr                       
                    lsr                       
                    tay                       
                    lda #$02                
                    sta $0460,Y             
                    plx                       
                    rts                       ; Return 

ADDR_01FF98:        lda $E4,X                 
                    clc                       
                    adc #$08                
                    sta $14B4               
                    lda $14E0,X             
                    adc #$00                
                    sta $14B5               
                    lda $D8,X                 
                    clc                       
                    adc #$0F                
                    sta $14B6               
                    lda $14D4,X             
                    adc #$00                
                    sta $14B7               
                    phx                       
                    jsl $01CC9D         
                    plx                       
                    rts                       ; Return 

                    ;padbyte $FF : pad $028000 ; You can remove the ";" from the beginning of this line if you're not using the Classic Piranha Plant Fix patch