;Instant Item Box v1.3
;
;Base Code: imamelia
;Bugfixes: W4mp3/ShUriK KiD, AxemJinx
;Swap Code: AxemJinx
;
;v1.1
;Prevents players from activating the item box during the death animation.
;v1.2
;Fixes the star not working. Now it works by using the standard star routine.
;v1.3
;Swaps powerups properly and prevents players from ativating powerups they already have.
;Also extends v1.1's fix to include all special player actions/animations.

header
lorom

!Freespace = $1FFFF7	;CHANGE THIS APPROPRIATELY!

org $00F5F8		; x77F8 (disable item auto-falling when Mario gets hurt)
db $EA,$EA,$EA,$EA	; 22 08 80 02

org $028008
JML NewItemDrop

org !Freespace
db "STAR"
dw EndCode-StartCode-$01
dw EndCode-StartCode-$01^$FFFF

StartCode:

NewItemDrop:

LDA $71		;\ Only drop an item if the player can move freely and no special action/animation is running.
BNE NoItemDrop	;/ Forbids activating the item box while obtaining powerups, getting hit, dying, etc.



LDA $0DC2	;\
CMP #$02	;|
BEQ DropFlower	;|
CMP #$04	;|
BEQ DropFeather	;| Check current item box status to determine which powerup to drop.
CMP #$01	;|
BEQ DropMushroom;|
CMP #$03	;|
BEQ DropStar	;/
RTL

DropFlower:
LDA $19		;\
CMP #$03	;|
BEQ NoItemDrop	;|
CMP #$02	;| If player already has flower, don't drop.
BNE NoCapeSwap	;| Otherwise, swap first. (small status = empty box)
LDA #$04	;|
NoCapeSwap:	;|
STA $0DC2	;/
LDA #$20	;\
STA $149B	;| Time to change palettes and lock sprites/animation.
STA $9D		;/
LDA #$03
STA $19		; Set player status to fire Mario.
LDA #$04
STA $71		; Activate "get fire flower" animation.
LDA #$0A
STA $1DF9	; Play "get powerup" sound effect.
RTL

DropFeather:
LDA $19		;\
CMP #$02	;|
BEQ NoItemDrop	;|
CMP #$03	;| If player already has cape, don't drop.
BNE NoFireSwap	;| Otherwise, swap first. (small status = empty box)
LDA #$02	;|
NoFireSwap:	;|
STA $0DC2	;/
LDA #$02
STA $19		; Set player status to cape Mario.
LDA #$0D
STA $1DF9	; Play "get cape" sound effect.
JSL $01C5AE	; Probably an alternative to activating the "get cape" animation through $71 and $1496.
RTL

DropMushroom:
LDA $19		;\ Only drop mushroom if player is small.
BNE NoItemDrop	;/
LDA #$2F	;\
STA $1496	;| Time to run through "get mushroom" animation (and lock all other sprites/animation).
STA $9D		;/
STZ $0DC2	; Erase mushroom from item box.
LDA #$02
STA $71		; Activate "get mushroom" animation.
LDA #$0A
STA $1DF9	; Play "get powerup" sound effect.
RTL

DropStar:
JSL $01C580	; Star routine.
STZ $0DC2	; Erase star from item box.

NoItemDrop:
RTL

EndCode: