;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;LevelNames v2.0 by Ice Man
;Original Code by BMF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom						;\ ROM is LoRom
	header						;/ and has a header.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Definitions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	!CodeLocation = $1BFCF8		;\ Main code location
	!TableLocation = $1C8000	;| Table location
	!TableStart = $1BFFF8		;/ Table starting location (RATS tag included)
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Jumps
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org $8DE1					;\ Hijack routine
	JSL StartCode				;| and jump to our code.
	NOP							;/ No Operation

	org $8C88					;\ Fixes the 10th letter
	db $38						;/ not to be flipped.
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;LevelNames Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org !CodeLocation
	
%RATS_start(0)	
StartCode:
	LDA #$02					;\ Restore old code
	STA $420B					;/ from previous code.
	
	LDA $7FFF0F					;\ Load levelnames table
	REP #$30					;| Set processor to 16 bit
	BNE Start					;| If not equal, jump to start.
	LDA $010B					;| Check level number.
	ASL A						;| x2
	ASL A						;| x4
	ASL A						;| x6
	ASL A						;| x8
	ASL A						;| x10
	TAX 						;| Transfer A to X
	LDY #$0000					;/ Load 0000 to Y
	
Loop:	
	LDA !TableLocation,x		;\ Load table location
	PHX 						;| Push X register
	TYX 						;| Transfer Y to X
	STA $7FFF00,x				;| Store in levelnames address
	PLX 						;| Pull X register
	INY 						;| Increase Y
	INY 						;| Increase Y
	INX 						;| Increase X
	INX 						;| Increase X
	CPY #$0020					;| Compare Y with 0020 bytes
	BNE Loop					;/ If not equal, loop the code.
	
Start:	
	LDA #$5020					;\ Starting address of the
	STA $2116					;/ levelnames text.
	
	LDA #$1800					;\ Parameters for DMA 
	STA $4310					;/ transfer.
	
	LDA #$FF00					;\ A Address
	STA $4312					;/ Low Byte 
	
	LDA #$207F					;\ A Address
	STA $4314					;/ Bank
	
	SEP #$30					;\ Set processor to 8 bit
	STZ $2115					;| No VRAM increment
	STZ $4316					;/ Zero bytes to transfer
	
	LDA #$02					;\ Transfer data
	STA $420B					;| 
	RTL							;/ Return
%RATS_end(0)	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Include Table File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	org !TableStart
	
%RATS_start(1)	
	incsrc table.tbl
%RATS_end(1)