header
lorom

;Free ROM (can be in banks 40+):
!Freespace = $1FFFF7

;Free RAM:
!HP    = $0F3A;Two bytes
!MP    = $0F3C;One byte
!Lv    = $0F3D;One byte
!XP    = $0F3E;Two bytes
!MaxHP = $0DC4;Two bytes
!MaxMP = $0DC6;One byte
;I haven't seen the ones used as default used anywhere, but if they're used, try $0DDB or $0F42.

!Temp  = $142C;Two bytes. Can be cleared whenever you want (as long as you don't stick your codes inside this patch).

!StatusBarLoc  = $0A75;64 bytes. Note that the defaults will mess up the Iggy and Larry battles.
!StatusBarProp = $0AB5;64 bytes. (It'll also mess up the overworld animations and credits, but my codes doesn't run on the OW.)

!HpOff        =    6
!MaxHpOff     =    10
!MpOff        = 32+6
!MaxMpOff     = 32+9
!XpOff        =    27
!XpNextOff    = 32+27
!LvOff        = 32+1
!LvTextOff    =    1
!YoshiCoinOff =    14
!TimeOff      = 32+20
!RandomBlank  = 0;Point this one to any blank tile. "Blank" means "FC". This will be used as freeram, nobody'll notice it.

!HpPos        = !StatusBarLoc+!HpOff
!MaxHpPos     = !StatusBarLoc+!MaxHpOff
!MpPos        = !StatusBarLoc+!MpOff
!MaxMpPos     = !StatusBarLoc+!MaxMpOff
!XpPos        = !StatusBarLoc+!XpOff
!XpNextPos    = !StatusBarLoc+!XpNextOff
!LvPos        = !StatusBarLoc+!LvOff
!YoshiCoinPos = !StatusBarLoc+!YoshiCoinOff
!TimePos      = !StatusBarLoc+!TimeOff

!FlashTimer   = !StatusBarProp+!RandomBlank

!c_green  = #$28
!c_red    = #$2C
!c_white  = #$38
!c_yellow = #$3C

org $00AF4B;Fade fix patch
LDX #$00FE
LDA #$01
org $00AF6A
CMP #$003E
BEQ Fadefix1
CMP #$001E
BNE Fadefix2
Fadefix1:
SEC
SBC #$0010
Fadefix2:
TAX
BPL $D3
BRA Fadefix3
NOP #11
Fadefix3:

org $05CBFF
RTL;Disable level end scorecard
org $07F1CA
RTL;Disable bonus stars showing up too

org $00F614
JSL Youredead

org $00F5C6
JML YougothitLOSER

org $008E6F
JSL Main;muck up the status bar
RTS

org $009E65
JML GameInit

org $00CF43
BCC $03
org $00D066
BCC $19
org $00D806
BCC $09
org $00D8E2
BCS $01
org $00D8EB;These gives Fire Mario a cape,
BCC $3B
org $00E3FF
BCC $57
org $00EFA7
BCC $04
org $00F5DB
BCC $16

org $00D06A
BVC .R
;org $00D074;and these gives Fire Mario his fireballs back.
;BVC .R
org $00D07D
JSL CodeD07D
.R

org $008650
JSL Control1;I need one action for X and one for Y, so I need the More Control patch.
NOP
org $008678
JSL Control2
NOP

org $00A5E8
JSL Init

org $00CF3D;disable cape spin turning you
BRA $00;I'd put LDA $76 here, but that shows up on my breakpoints. I think it's done, but I might be wrong.
org $00E399
JSL DirectionHijack1;but make it look like you're still turning
NOP
org $00E3CD
JSL DirectionHijack2
NOP
org $00E435
PHA
JML DirectionHijack3
org $00FEC9
JSL DirectionHijack4
NOP
org $00CE4C
JSL DirectionHijack5

org $00A08A
JML End

org $01C478
BRA $04;this disables star y movement
org $01C3BD
BEQ $06;and this kills its x movement

org $008DAC;muck up status bar DMA
STZ $2115
REP #$20
LDA #$5020
STA $2116
LDA #$1800
STA $4310
LDA.w #!StatusBarLoc
STA $4312
LDX.b #!StatusBarLoc/65536
STX $4314
LDA #$0040
STA $4315
LDX #$02
STX $420B

LDX #$80
STX $2115
LDA #$5020
STA $2116
LDA #$1900
STA $4310
LDA.w #!StatusBarProp
STA $4312
LDX.b #!StatusBarProp/65536
STX $4314
JSL DrawStatusBar
RTS
warnpc $008DF5

org $008CFF
LDA #$28
STA $0F30;kill default status bar DMAing
RTS

org $01C538
GetPowerup:
SEC
SBC #$74
ASL
TAX
LDA #$0A
STA $1DF9
JMP (PowerupTable,x)

PowerupTable:
dw .Mushroom,.Flower,.Star,.Feather,.Life

.Mushroom
LDA.b #60
BRA .GiveHp

.Flower
LDA.b #100
BRA .GiveHp

.Feather
LDA.b #140
.GiveHp
JSL GiveHp
LDX $15E9;I have NO idea why the value in X seems to be used like that...
RTS

.Life
LDA !MaxHP
STA !HP
LDA !MaxHP+1
STA !HP+1
JSL EditPowerupL
.Star
LDA !MaxMP
STA !MP
LDX $15E9
RTS
warnpc $01C5AE

org $009D24
JSL OnePlayer

org $00D08C
JML CheckFireButton

org $00FEB5
JML ThrowFireball

org $00D8ED
JML CapeFloat

org $00D8F3
JSL TornadoJump
NOP

org $00D076
JML CapeSpin

org $029649
JSL CheckIfExSpriteDies
NOP

org $00D869
JML StartFlight

org $00D638
JSL Spinjumping

org $05B34A
JML ManaOrb

org $02A129
LDA #$02
STA $14C8,x;classic fireball patch (+give EXP when killing anything with a fireball)
JSL GiveXP
BRA $02
org $01AB64
JSL GiveXP;Jump/spinjump kill
org $029457
JSL GiveXP;Cape ground pound
org $01A667
JSL GiveXP;Thrown item
org $01A6C1
JSL GiveXP;Carried item
org $01C4CF
;JSL GiveXP;Eaten with Yoshi
org $01F0D3
JSL EatEnemy
NOP

;special cases for Rex:
org $0395A0
BRA $01
org $0395BD
JMP KillRex;jumping
org $039628
KillRex:
STA $1558,x
JSL GiveXP
RTS
KillRex2:
STA $1DF9
JSL GiveXP
RTS
EatEnemy:
LDA #$06
STA $1DF9
JML GiveXP
warnpc $03964C

org $0395EE
JMP KillRex2

org $039612;star
JSL GiveXP


org $00E2E0
LDA $1490;make star power last forever

org $00F2E0
JSL Midway
BRA $02



;This is the SRAM expand patch, slightly altered.
!SRAMSize = #$02	; SRAM Size amount of bytes = 2048*decimal value (game default: #$01)


org $FFD8
	db !SRAMSize

org $9BCC		; Save Game Routine
	JSL SaveGame
	NOP #2
	;LDX $010A	; replaced opcodes
	;LDA $9CCB,x

org $9E5C		; Load Game Routine (executed when 1 or 2 player is chosen)
	JSL LoadGame
	NOP #2
	;STZ $0DD5      ; replaced opcodes
	;STZ $0DB3

org !Freespace
db "STAR"
dw Ratstagsdoesnothingexceptwasteromspace-Somestupidlabel-$01
dw Ratstagsdoesnothingexceptwasteromspace-Somestupidlabel-$01^$FFFF
Somestupidlabel:
base $000000;stupid xkas stop 24biting my freeram

CodeStart:
SaveGame:	PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		SEP #$40			; a set overflow flag means we are saving
		BRA SRAMMain

LoadGame: 	STZ $0DD5                	;\ replaced opcodes from the LoadGame jump
		STZ $0DB3     			;/
		PHA				;\
		PHX				;| this makes sure the game goes on without problems
		PHY				;|
		PHP				;/
		REP #$40
		LDA $0109			;\ NewGame?
		CMP #$E9			;/
		BNE SRAMMain			; no
		JMP NewGame			; yes

		;<< SaveGame & LoadGame code start here >>

SRAMMain:		REP #$30			; let A,X and Y go 16 bit, since we deal with large numbers > FF
		LDA $010A			; load current save file # (use LDA #$04 to access fourth part of the expanded SRAM)
		AND #$00FF			; mask high bits to take care of the garbage
		ASL #!SRAMSize-1+8		; since we have got 3 files, we give every file a fourth of the expanded SRAM leaving another fourth free
		TAX				; transfer the offset to X
		SEP #$20			; let A go back to 8 bit
		LDY #$0000			; store 0 into the index for our loop

Loop:		PHX
		TYX
		LDA.l Table,x			; load the RAM pointer from the table (low byte)
		STA $00				; store it to a temp RAM
		INX
		LDA.l Table,x			; load the RAM pointer from the table (high byte)
		STA $01				; store it to a temp RAM
		TXY
		PLX
		BVC Loading			; if carry is clear -> Loading

Saving:		LDA ($00)			; load the RAM content from the table
		STA $700800,x			; and save it
		BRA GoOn

Loading:	LDA $700800,x			; load the RAM from the SRAM
		STA ($00)			; store it to the pointer of the temp RAM

GoOn:		INX				; next RAM
		INY				; increase index of the loop
		CPY.w #Tablev-Table		; have we reached the end of our table?
		BNE Loop			; loop if we haven't

		;<< SaveGame & LoadGame code end here >>

Return:		BVC GetBack			; if we are loading, we mustn't to execute the replaced opcodes
		PLP
		PLY
		PLX
		PLA
		LDX $010A			;\ replaced opcodes from the SaveGame jump
		LDA $9CCB,x			;/
		RTL

GetBack:	SEP #$30
		LDA $0DB6			;\ get Mario's coins
		STA $0DBF			;/ 
		LDA $0DB4			;\ get Mario's lives
		STA $0DBE			;/ 
		LDA $0DB8			;\ get Mario's powerup
		STA $19				;/ 
		LDA $0DBA			;\ 
		STA $0DC1			;| get Mario's Yoshi color
		STA $13C7			;| 
		STA $187A			;/ 
		LDA $0DBC			;\ get Mario's reserved item
		STA $0DC2			;/ 
		PLP
		PLY
		PLX
		PLA
		RTL

NewGame:	REP #$30			; let A,X and Y go 16 bit, since we deal with large numbers > FF
		LDA $010A			; load current save file # (use LDA #$04 to access fourth part of the expanded SRAM)
		AND #$00FF			; mask high bits to take care of the garbage
		ASL #!SRAMSize-1+8		; since we have got 3 files, we give every file a fourth of the expanded SRAM leaving another fourth free
		TAX				; transfer the offset to X
		SEP #$20			; let A go back to 8 bit
		LDY #$0000			; store 0 into the index for our loop

Loop2:		PHX
		TYX
		LDA.l Tablev,x			; load the starting value from Tablev
		INX
		TXY
		PLX
		STA $700800,x			; save it to SRAM
		INX
		CPY.w #CodeEnd-Tablev		; have we reached the end of our table?
		BNE Loop2			; loop if we haven't
		REP #$40			;\
		JMP SRAMMain			;/ --> loading


; >>>>>>>>> here you can define which RAM addresses should be saved <<<<<<<<<

Table:
dw !Lv
dw !XP,!XP+1


; >>>>>>>>> Here you can define the values for a new game.                                      <<<<<<<<<
; >>>>>>>>> MAKE SURE THEY ARE IN THE SAME ORDER!                                               <<<<<<<<<
; >>>>>>>>> The first value (Tablev) loads into the first RAM address from the first "Table".   <<<<<<<<<
; >>>>>>>>> The second value loads into the second RAM address from the first "Table" etc.      <<<<<<<<<

Tablev:
db $01
db $00,$00
	
CodeEnd:

GameInit:
JSR UpdateMaxMpHp
STZ $1DF9
LDY #$0B
JML $009C8B

Init:
SEP #$10
REP #$20
LDA.w #!StatusBarLoc
STA $2181
LDY.b #!StatusBarLoc/65536
STY $2183
LDA.w #$8000
STA $4300
LDA.w #.DefStBar
STA $4302
LDY.b #.DefStBar/65536;copy over the status bar
STY $4304
LDA.w #$0040
STA $4305
LDY #$01
STY $420B

LDA.w #!StatusBarProp
STA $2181
LDY.b #!StatusBarProp/65536
STY $2183
LDA.w #$8000
STA $4310
LDA.w #.StBarProp
STA $4312
LDX.b #.StBarProp/65536;copy the status bar properties
STX $4314
LDA #$0040
STA $4315
SEP #$20
LDA #$02
STA $420B

LDX $0701
STX $0903
JMP Main

.DefStBar
table ascii-28.tbl
db " LV HP~~~*~~~ ~~~~~  EXP~~~~ ";the  here is the TIME text
db " ~~ MP~~*~~         ~~~ TNL~~~~ "

.StBarProp
table palettes.tbl
;R=red, Y=yellow, G=green, W=white
;b " LV HP~~~*~~~ ~~~~~  EXP~~~~ "
db " WW YYWWWYWWW YYYYY YYY WWWWWWW "

;b " ~~ MP~~*~~         ~~~ TNL~~~~ "
db " WW YYWWYWW         YYY WWWWWWW "
cleartable

Main:
;LDA $15
;AND #$20
;BEQ .DEBUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUG
;STA $1F2E
;JSL GiveXP
;.DEBUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUG
;when time ticks...
LDA $0F30
BNE .TimeDidntTick
LDA $1407
BEQ .NotFlying
LDA #$01
JSR TakeMP
BCS .NotFlying
LDA #$7F
STA $1497
LDA #$0F
STA $1DF9
LDA #$01
STA $140D
STZ $1407
.NotFlying

LDA $1490
BEQ .NotStar
LDA #$01
JSR TakeMP
BCS .NotStar
STZ $1490
.NotStar

LDA $77;if on ground,
AND #$04
ORA $1407;flying,
BNE .NotFloating
LDA $15;not holding B,
BPL .NotFloating
LDA $7D;moving upwards,
BMI .NotFloating
LDA $19;or not holding a cape, don't tick the MP
CMP #$02
BCC .NotFloating
LDA #$01
JSR TakeMP
.NotFloating
.TimeDidntTick

;check for star switch
LDA $16
AND #$20
BEQ .NoStarSwitch
LDA !Lv
CMP #$1E
BCC .NoStarSwitch
LDA #$01
JSR TakeMP;you can't save MP by turning this off when the timer ticks
BCC .NoStarSwitch
LDA $1490
EOR #$FF
STA $1490
.NoStarSwitch

;print timer
LDA $0F33
STA !TimePos+2
LDA $0F32
STA !TimePos+1
LDA $0F31
STA !TimePos
BNE .DoneEditingTimer
LDX #$FC
STX !TimePos
LDA $0F32
BNE .DoneEditingTimer
LDX #$FC
STX !TimePos+1
.DoneEditingTimer

;print mp
LDA !MP
JSR HexDec8to21
STA !MpPos
STX !MpPos+1

;print max mp
LDA !MaxMP
JSR HexDec8to21
STA !MaxMpPos
STX !MaxMpPos+1

;print hp
REP #$20
LDA !HP
JSR HexDec16to311
SEP #$20
STA !HpPos
STY !HpPos+1
STX !HpPos+2

;print max hp
REP #$20
LDA !MaxHP
JSR HexDec16to311
SEP #$20
STA !MaxHpPos
STY !MaxHpPos+1
STX !MaxHpPos+2

;print level
LDA !Lv
JSR HexDec8to21
STA !LvPos
STX !LvPos+1

;print yoshi coins
LDA #$2E
LDX #$00
LDY $1422
.YoshiCoinLoop;random note: my code is smaller than nintendos (20 vs 33)
DEY
BPL .OneMore
LDA #$FC
.OneMore
STA.w !YoshiCoinPos,x;six of those saved bytes are since I don't kill the coins when I've got all five,
INX
CPX #$05
BNE .YoshiCoinLoop;the remaining seven is nintendo being stupid as usual

;flash XP bar
LDA !FlashTimer
BEQ .DontFlashEXP
CLC
ADC #$04;the lowest two bits may not be used, so tick it down four steps at the time
STA !FlashTimer
LSR #2

TAX
LDA .XpColors,x
STA !StatusBarProp+!LvTextOff
STA !StatusBarProp+!LvTextOff+1
.DontFlashEXP

;variable color on hp
LDY !c_white
REP #$20
LDA !MaxHP
LSR
CMP !HP
BCC .ThisColor
LDY !c_yellow
LSR
CMP !HP
BCC .ThisColor
LDY !c_red
.ThisColor
STY !StatusBarProp+!HpOff
STY !StatusBarProp+!HpOff+1
STY !StatusBarProp+!HpOff+2

;check for max level
LDX !Lv
CPX #30
BEQ .LvMAX

;print exp
LDA !XP
JSR HexDec16to311
STX !XpPos+3
STY !XpPos+2
SEP #$20
JSR HexDec8to21
STX !XpPos+1
STA !XpPos

;print exp to next
LDA !Lv
ASL
TAX
REP #$20
LDA.l XpTable,x
JSR HexDec16to311
STX !XpNextPos+3
STY !XpNextPos+2
SEP #$20
JSR HexDec8to21
STX !XpNextPos+1
STA !XpNextPos

RTL

.LvMAX
SEP #$20
LDX #$03
.Next
LDA.l .LvMAXtbl1,x
STA !XpPos,x
LDA.l .LvMAXtbl2,x
STA !XpNextPos,x
DEX
BPL .Next
RTL

table palettes.tbl
.XpColors
db "W";this is what happens when the timer runs out. SET IT TO THE SAME AS IN THE DEFAULT STATUS BAR
db "YYYYYYYYYYYYYYYYWWWWWWWWWWWWWWWWYYYYYYYYYYYYYYYYWWWWWWWWWWWWWWW"
cleartable

table ascii-28.tbl
.LvMAXtbl1
db " MAX"
.LvMAXtbl2
db " MAX"
cleartable

End:;This runs at the end of a level. It also runs when a new game starts.
LDA !HP
ORA !HP+1
BNE .DontRefill
LDA !MaxHP
STA !HP
LDA !MaxHP+1
STA !HP+1
STZ !MP
.DontRefill
LDA !MaxHP+1
BNE .Fire
LDA !HP
CMP #$64
BCS .Cape

CMP #$3C
BCS .Big
LDA #$00
BRA .Store

.Big
LDA #$01
BRA .Store

.Cape
CMP #$8C
BCS .Fire
LDA #$02
BRA .Store

.Fire
LDA #$03
.Store
STA $19
.Return
LDA $1B9C;this seems to check if Mario (and Luigi) should be put at their start places...?
BEQ .NoJSL;Whatever, I don't need to know what it is to hijack it.
JML $00A08F
.NoJSL
JML $00A093

Youredead:
LDA #$09
STA $71
STZ !HP
STZ !HP+1
RTL

YougothitLOSER:
LDA $1F2E
INC A
LSR
;first I had JML here, but then I figured out we were in the same bank, so I considered JMP,
;and then BRA and then I figured out I don't need anything.

TakeHp:
STA !Temp
STZ !Temp+1
REP #$20
LDA !HP
SEC
SBC !Temp
BEQ .Dead
BMI .Dead
STA !HP
SEP #$20
LDA #$7F
STA $1497
LDA #$04
STA $1DF9
;LDA $19
;CMP #$02
;BCC .NotCapeFlying
LDA $1407
BEQ .NotCapeFlying;end cape flight if you get hit
LDA #$0F
STA $1DF9
LDA #$01
STA $140D
STZ $1407
.NotCapeFlying
JSR EditPowerup
RTL

.Dead
SEP #$20
JML $00F606

ManaOrb:
LDA #$0E
STA $1DF9
LDA !MP
CMP !MaxMP
BEQ .MaxMP
INC !MP
.MaxMP
LDA !Lv
CMP #$1A
BCC GiveHpRTL
LDA #$01
;I like sticking routines after each other like this. It saves space.

GiveHp:
STA !Temp
STZ !Temp+1
REP #$20
LDA !HP
CLC
ADC !Temp
CMP !MaxHP
BCC .Store
LDA !MaxHP
.Store
STA !HP
SEP #$20
JSR EditPowerup
GiveHpRTL:
RTL

TakeMP:
STA !Temp
LDA !MP
CMP !Temp
BCC .NotEnough
LDA !MP
SEC
SBC !Temp
STA !MP
SEC
RTS

.NotEnough
CLC
RTS

GiveXP:
PHX
LDA !Lv
CMP.b #30
BEQ .Return
ASL A
TAX
LDA $1F2E
INC A
INC A;make division round up, not down
STA $4204
STZ $4205
LDA #$03
STA $4206
JSR Waste24Cycles
REP #$20
LDA $4214
CLC
ADC !XP
STA !XP
CMP.w #7008
BCC .NotFull
LDA.w #7008
.NotFull
CMP.l XpTable,x
BCC .Return
SEP #$20
INC !Lv
JSR UpdateMaxMpHp
JSL $02858F
JSL $02858F
JSL $02858F;send some sparkles around mario when he levels up
JSL $02858F
JSL $02858F
JSL $02858F
LDA #$04
STA !FlashTimer
.Return
SEP #$20
PLX
RTL

UpdateMaxMpHp:
LDA #$00
XBA
LDA !Lv
ASL A
STA !MP
STA !MaxMP
STA !Temp
STZ !Temp+1
REP #$20
ASL A
ASL A
CLC
ADC !Temp
STA !HP
STA !MaxHP
SEP #$20
JSR EditPowerup
RTS

EditPowerupL:
JSR EditPowerup
RTL

EditPowerup:
LDA !HP+1
BNE .Fire
LDA !HP
CMP #$64
BCS .Cape
CMP #$3C
BCS .Big
LDA $19
BEQ .Return
LDA #$04
STA $1DF9
JSL $00F5FC
RTS

.Big
LDA $19
CMP #$01
BEQ .Return
CMP #$00
BEQ .SmallToBig
LDA #$01
STA $19
RTS

.SmallToBig
LDA #$02
STA $71
LDA #$2F
STA $1496
STA $9D
LDA #$0A
STA $1DF9
RTS

.Cape
CMP #$8C
BCS .Fire
LDA $19
CMP #$02
BEQ .Return
CMP #$03
BEQ .FireToCape
LDA #$02
STA $19
LDA #$0D
STA $1DF9
JSL $01C5B4;This is the code used by the original SMW when Mario gets a cape. It ends with RTL, which allows me to steal it.
.Return
RTS

.FireToCape
LDA #$02
STA $19
RTS

.Fire
LDA $19
CMP #$03
BEQ .Return
LDA #$20
STA $149B
STA $9D
LDA #$04
STA $71
DEC A
STA $19
LDA #$0A
STA $1DF9
RTS

;MaxHP=level*10
;MaxMP=level*2
;Level 3 learns spin jump, costs 2MP.
;60 HP learns big.
;100 HP learns cape. Can't fly, only float. Float costs 1MP per timer tick, cape spin costs 1MP.
;140HP learns fire cape. Fireball costs 1MP.
;Level 18 learns flight. Costs 1MP per timer tick.
;Level 22 learns super flame (Yoshi fireball) when hitting X. Costs 2MP.
;Level 26 gets 1HP per coin, in addition to the 1MP.
;Level 30 learns star power. Costs 1MP per timer tick, hit Select to toggle.

;enemy damage= 1 x( * divided by 2)
;Exp per kill= 1 x( * divided by 3)
;*=level exits found.

;I would like 2 exp counters. 1 would be current exp, and the other would display the exp total for the next level
;(for example it would say 16 till mario reaches Lv 2, and 48 till he reaches Lv 3).
;mushrooms heal 60 hp
;feathers heal 100 hp
;flowers heal 140 hp
;1-up mushrooms heal 300 hp and 60 mp
;coins (AKA mana orbs) restore 1 mp
;when a coin is collected, it should make the swim sound
;the bonus game is disabled.
;bonus stars become exp.
;marios hp and mp should be restored when he levels up.

Waste24Cycles:
;Six cycles to JSR to here, six to JSR to .Return, and six each for two RTSs.
;While 16 would usually be enough, many users put their patches in fastrom,
;and the division registers are one of the things that fastrom doesn't boost.
JSR .Return;
.Return
RTS

HexDec16to311:
;This one takes an 16bit number from A, puts the ones digit in X, the tens in Y and the rest (divided by 100) in A.
;A must be 16bit, XY must be 8bit. Register sizes won't change.
STA $4204
LDY #$0A
STY $4206
JSR Waste24Cycles
LDX $4216
LDA $4214

STA $4204
LDY #$0A
STY $4206
JSR Waste24Cycles
LDY $4216
LDA $4214
RTS

HexDec8to21:
;This one takes an 8bit number from A, puts the ones digit in X and the rest (divided by 10) in A.
;AXY must be 8bit. Register sizes won't change.
STA $4204
STZ $4205
LDY #$0A
STY $4206
JSR Waste24Cycles
LDX $4216
LDA $4214
RTS

XpTable:
dw 0;This is since levels starts at 1, not 0.
dw   16,  48,  96, 160, 240, 336
dw  448, 576, 720, 880,1056,1248
dw 1456,1680,1920,2176,2448,2736
dw 3040,3360,3696,4048,4416,4800
dw 5200,5616,6064,6528,7008,30000;This 30000 is some sort of padding. Don't ask.

Control1:
LDX #$00
BRA CtrlMain
Control2:
LDX #$02

CtrlMain:
LDA $4219,x
LSR #4
ORA $4218,x
RTL

CodeD07D:
STA $1DFC
LDA $19
RTL

OnePlayer:
INC $0100
LDA $0100
CMP #$0A
BNE .Return
INC $0100
PEA $8074
PEA $9E64
PEA $9E12
JMP $00A195
.Return
RTL


DrawStatusBar:
LDA #$0040
STA $4315
SEP #$20
LDA #$02
STA $420B
RTL


GetDirection:
LDA $140D
ORA $14A6
BNE .Spin
LDA $76
RTS

.Spin
LDA $14
LSR #2
AND #$01
RTS

DirectionHijack1:
JSR GetDirection
ORA $DCEC,x
RTL

DirectionHijack2:
PHA
JSR GetDirection
TAX
PLA
ORA $E18C,x
RTL

DirectionHijack3:
JSR GetDirection
STA $05
PLA
ORA $05;how ugly
TAY
LDA $E21A,y
JML $00E43B

DirectionHijack4:
LDA $140D
BEQ .NotSpinjump
LDA $13E2
AND #$10
LSR #4
TAY
.Store
LDA $FE94,y
RTL
.NotSpinjump
LDY $76
BRA .Store

DirectionHijack5:
JSR GetDirection
LDX #$00
RTL


ThrowFireball:
LDA #$01
JSR TakeMP
BCC .Nope
LDA #$06
STA $1DFC
JML $00FEBA

.Nope
JML $00FEB4


CheckFireButton:
LDA $18
AND #$04
BNE .Yes
LDA $18
AND #$40
BNE BigFireball
JML $00D090
.Yes
JML $00D0AA


BigFireball:
LDA !Lv
CMP #$16
BCC .Nope
LDA #$02
JSR TakeMP
BCC .Nope
LDY #$07
.FindSlotLoop
LDA $170B,y
BEQ .FoundSlot
DEY
BPL .FindSlotLoop
DEC $18FC
BPL .DontRolloverSlot
LDA #$07
STA $18FC
.DontRolloverSlot
LDY $18FC
.FoundSlot
LDA #$11
STA $170B,y
LDA $96
CLC
ADC #$08
STA $1715,y
LDA $97
ADC #$00
STA $1729,y
LDA $94
STA $171F,y
LDA $95
STA $1733,y
LDA #$00
STA $1779,y
LDA $76
LSR A
LDA #$28
BCS .DontFlip
LDA #$D8
.DontFlip
STA $1747,y
LDA #$00
STA $173D,y
LDA #$A0
STA $176F,y
.Nope
JML $00D090


StartFlight:
CLC
ADC $D7CF,x
LDY !Lv
CPY #$12
BCS .Ok
LDA #$00
.Ok
JML $00D86D

CapeFloat:
LDA !MP
BEQ .Nope
LDA $72
CMP #$0C
JML $00D8F1
.Nope
JML $00D928

TornadoJump:
;This also blocks LV<18 from tornado jumping.
LDA !Lv
CMP #$12
BCC .NoU
LDA $149F
CMP #$50
BNE .AlreadyTaken
LDA #$03
JSR TakeMP
.AlreadyTaken
LDA !MP
CMP #$03
BCC .NoU

LDY #$01
CPY $149F
RTL

.NoU
CLC
RTL

Spinjumping:
LSR A
AND #$FE
TAX
LDA $18
BPL .NotSpinjump
LDA $148F
BNE .NotSpinjump
LDA !Lv
CMP #$03
BCC .BlockSpinjump
LDA #$02
JSR TakeMP
BCS .NotSpinjump
.BlockSpinjump
LDA #$80
TRB $18
.NotSpinjump
RTL

CapeSpin:
LDA #$01
JSR TakeMP
BCC .Nope
LDA #$12                
STA $14A6
JML $00D07B
.Nope
LDA $19
JML $00D081

CheckIfExSpriteDies:
PHX
LDA $170B,x
TAX
LDA.l ExSpritesKilled,x
PLX
CMP #$00
RTL

Midway:
LDA !HP+1
BNE .Return
LDA !HP
CMP #$3C
BCS .Return
LDA #$0A
JSL GiveHp
LDA !HP
CMP #$3C
BCC .Return
LDA #$3C
STA !HP
.Return
RTL

ExSpritesKilled:
db $00;Nothing
db $00;Puff of smoke with various objects
db $01;reznor fireball
db $01;flame left by hopping flame
db $01;hammer
db $00;mario fireball
db $01;bone
db $01;Lava Splash (doesn't hurt, parabolic down)
db $00;Torpedo Ted shooter's arm
db $01;Red thing that flickers from 16x16 to 8x8
db $00;coin from cloud game
db $01;piranha fireball
db $01;lava lotus fire
db $01;baseball
db $00;Flower of Wiggler
db $00;Trail of smoke
db $00;Spin Jump star
db $00;yoshi fireballs
db $00;Water bubble
rep 128 : db $01;in case someone uses some exspritetool or something


Ratstagsdoesnothingexceptwasteromspace:

















