;$0F13-$0F2F should be unused, use them for more counters or w/e

!statusloc = $0EF9	;do not change
!bgcolor = $0000	;status bar background color (default=black)

;below = location of counters in status bar
!playerVRAM	= 5001
!livesVRAM	= 5007
!bonusVRAM	= 500C
!itemboxVRAM	= 5010
!yicoinsVRAM	= 5014
!timeVRAM	= 501C
!coinsVRAM	= 5403
!scoreVRAM	= 5418

;DO NOT EDIT THESE. EDIT THE ABOVE ONES INSTEAD
!player = !statusloc
!lives = !statusloc+$5
!bonus = !statusloc+$7
!itembox = !statusloc+$9
!yicoins = !statusloc+$A
!time = !statusloc+$F
!coins = !statusloc+$12
!score = !statusloc+$14

macro vramwrite(a, b, vram, loc, bank, byte)
LDX <a> : STX $2115
LDA #$<vram> : STA $2116
LDA <b> : STA $4310
LDA.w #<loc> : STA $4312
LDX.b #<bank> : STX $4314
LDA <byte> : STA $4315
STY $420B
endmacro

header : lorom

org $008292
LDY #$09		;top status bar scanline length

org $0082A4
autoclean JML NMI
NOP #2

org $00838F
autoclean JML IRQ
NOP

org $008CFF
autoclean JML StatusHijack
NOP

org $008DAC
autoclean JML DrawStatusHijack
NOP

org $028052
db $78			;item box X drop ($78)

org $028060
db $09			;item box Y drop ($0F)

org $008E6F		;Time hijack
LDA $0F31
STA !time
LDA $0F32
STA !time+$1
LDA $0F33
STA !time+$2
LDX #$00
org $008E8C
STA !time,x

org $008F55		;Lives hijack
STX !lives
STA !lives+$1

org $008F7E		;Coins hijack
STA !coins+$1
STX !coins

org $008EE0		;Score hijacks
org $008EE0
LDA !score,x
org $008F0E
LDA !score,x
org $008EE7
STA !score,x
org $008F15
STA !score,x
org $008ED7
LDX #$00
org $008F05
LDX #$00
org $009014
STZ !score,x
org $009034
INC !score,x

org $008F86
autoclean JML MiscCounters
NOP


freecode

NMI:			;top status bar
LDA $0D9B
BNE +
LDA $0100
CMP #$0B
BCC +
LDA #$00 : STA $2111
LDA #$00 : STA $2111
LDA #$FF : STA $2112
LDA #$01 : STA $2112
LDA #$04 : STA $212C	;layer 3 on main+sub
STZ $212D
STZ $212E
STZ $2130
STZ $2131
STZ $2121
LDA.b #!bgcolor : STA $2122
LDA.b #!bgcolor>>8 : STA $2122
LDA #$09 : STA $2105	;gfx mode 1 + layer 3 priority
JML $0082B0
+
STZ $2111
STZ $2111
STZ $2112
STZ $2112
JML $0082B0

IRQ:
LDA $11
BNE +			;regular screen (IRQ #1)
LDY #$D7
STY $4209
LDA #$A1 : STA $4200
INC $11
BIT $4212 : BVC $FB	;wait for h-blank
LDA #$80 : STA $2100	;f-blank the scanline
LDA $22 : STA $2111	;static layer 3
LDA $23 : STA $2111
LDA $24 : STA $2112
LDA $25 : STA $2112
LDA $3E : STA $2105
LDA $0D9D : STA $212C	;main screen
STA $212E
LDA $0D9E : STA $212D	;sub screen
STA $212F
LDA $40 : STA $2131	;color math
LDA $44 : STA $2130
STZ $2121
STZ $2122 : STZ $2122	;color 0 back to black
-
BIT $4212 : BVC $FB	;wait for h-blank again
LDA $0DAE : STA $2100	;restore brightness
JML $0083B2

+			;bottom status bar (IRQ #2)
BIT $4212 : BVC $FB	;wait for h-blank
LDA #$80 : STA $2100	;f-blank the scanline
LDA #$00 : STA $2111
LDA #$01 : STA $2111
LDA #$27 : STA $2112
LDA #$01 : STA $2112
LDA #$04 : STA $212C	;layer 3 on main+sub
STZ $212E
STZ $2130
STZ $2131
STZ $2121
LDA.b #!bgcolor : STA $2122
LDA.b #!bgcolor>>8 : STA $2122
LDA #$09 : STA $2105	;gfx mode 1 + layer 3 priority
BRA -


MiscCounters:
PHB : PHK : PLB

LDX $0DC2		;Item Box Item
LDA .statuspowerup,x
STA !itembox

LDY $0DB3 : TYA
BEQ +
LDA #$10
+
STA $00
LDX #$04
-
LDA .playertable,x	;Current Player
CLC : ADC $00
STA !player,x
DEX : BPL -

TYX
LDA $0F48,x		;Bonus Stars
PHK
PEA.w .jslrtsreturn-1
PEA.w $0084CF-1
JML $009045
.jslrtsreturn
TXY : BNE +
LDX #$FC
+
STX !bonus
STA !bonus+$1

LDX #$00		;Yoshi Coins
LDA $1422
DEC A : STA $00
-
LDA #$2E		;full yoshi coin tile
LDY $00 : BPL +
LDA #$FC		;blank yoshi coin tile
+
STA !yicoins,x
DEC $00 : INX
CPX #$05 : BCC -	;# of yoshi coins needed to stop display

PLB : JML $008FF9

.statuspowerup
db $FC,$95,$97,$96,$28
;none, mushroom, flower, star, feather

.playertable
db $30,$31,$32,$33,$34
;$10 is added for luigi's tiles


;Status Bar upload routine

StatusHijack:		;initialize status bar
REP #$20
LDY #$02
%vramwrite(#$00, #$1800, 5000, TopTiles, TopTiles>>16, #$0020)
%vramwrite(#$80, #$1900, 5000, TopPal, TopPal>>16, #$0020)
%vramwrite(#$00, #$1800, 5400, BottomTiles, BottomTiles>>16, #$0020)
%vramwrite(#$80, #$1900, 5400, BottomPal, BottomPal>>16, #$0020)
SEP #$20
JML $008D8A

DrawStatusHijack:	;draw counters onto status bar
REP #$20
LDY #$02
%vramwrite(#$00, #$1800, !playerVRAM, !player, $7E, #$0005)
%vramwrite(#$00, #$1800, !livesVRAM, !lives, $7E, #$0002)
%vramwrite(#$00, #$1800, !bonusVRAM, !bonus, $7E, #$0002)
%vramwrite(#$00, #$1800, !itemboxVRAM, !itembox, $7E, #$0001)
%vramwrite(#$00, #$1800, !yicoinsVRAM, !yicoins, $7E, #$0005)
%vramwrite(#$00, #$1800, !timeVRAM, !time, $7E, #$0003)
%vramwrite(#$00, #$1800, !coinsVRAM, !coins, $7E, #$0002)
%vramwrite(#$00, #$1800, !scoreVRAM, !score, $7E, #$0006)
SEP #$20
JML $008DE6

;_MARIOx--_*x--_[_]__OOOOO_T=---_	<-- TOP VISUAL. _ is $FC

;_@x--````_______________SSSSSSS_	<-- BOTTOM VISUAL. _ is $FC

TopTiles:
db $FC,$30,$31,$32,$33,$34,$26,$27
db $27,$FC,$64,$26,$27,$27,$FC,$5B
db $FC,$5C,$FC,$FC,$FC,$FC,$FC,$FC
db $FC,$FC,$76,$77,$27,$27,$27,$FC

TopPal:
db $38,$28,$28,$28,$28,$28,$38,$38
db $38,$38,$28,$38,$38,$38,$38,$39
db $28,$39,$38,$38,$3C,$3C,$3C,$3C
db $3C,$38,$38,$38,$3C,$3C,$3C,$38

BottomTiles:
db $FC,$2E,$26,$27,$27,$FC,$FC,$FC
db $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC
db $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC
db $00,$00,$00,$00,$00,$00,$00,$FC

BottomPal:
db $38,$3C,$38,$38,$38,$38,$38,$38
db $38,$38,$38,$38,$38,$38,$38,$38
db $38,$38,$38,$38,$38,$38,$38,$38
db $38,$38,$38,$38,$38,$38,$38,$38