;p-switch ticking sound by GreenHammerBro.
;This patch will create a ticking sound when the blue or silver p-switch is on.
;Similar to A super Mario Thing, but there is something even better, if the p-switch
;timer is less than a specific value, the frequency speeds up, giving a clue that the
;p-switch is low in time. Similar to Super mario.. 64, Galaxy 1 and 2.

org $C500		;rom map to overwrite
autoclean JML main_code	;get to main code
freecode		;find freespace


!free_ram_timer_freq	= $0D9C		;>free ram for frequency (make sure that this
					;ram is unused by other patches!!)
!sound_freq		= #$1E		;>how many frames between each sound (60 fps)
!sound_freq_fast	= #$0F		;>similar to above but will play when
					;below a specific time.
!sound_ram		= $1DFC		;>What ram address i/o port
!sound_num		= #$23		;>what sound (#$23 is the beep sound moving on OW)
!when_to_tick_fast	= #$3C		;>if switch timer is less than that point,
					;will tick faster (higher value = earlier
					;time to make a fast tick).
					;Also p-switch timer #$1E is where the "running out"
					;sound effect plays, (also note that the timer decrement
					;every 4th frame (15 steps = a second).
!dir_coin_almost	= #$1E		;>when the "p-switch running out" plays when directional
					;coins are almost up.
!sound_ram1		= $1DFC		;\sfx for the directional coins timer
!sound_num1		= #$24		;/
;------------------------------------------;
; Do not change anything below here.       ;
;------------------------------------------;
main_code:
	LDA $190C			;\if directional coins timer hits a
	CMP !dir_coin_almost		;|specific value, then play sfx
	BNE no_dir_sound		;/
	LDA !sound_num1			;\play sfx
	STA !sound_ram1			;/
no_dir_sound:
	LDA $14AD			;\If blue p-switch is off..
	BEQ check_silver		;/then check silver switch
	JMP make_repeating_sound	;>otherwise make occasional sounds
check_silver:
	LDA $14AE			;\If both switches timer is 00
	BEQ check_directional_coins	;/then silent
	JMP make_repeating_sound	;>otherwise make occasional sounds
check_directional_coins:
	LDA $190C
	BEQ silent
	JMP make_repeating_sound
silent:
	LDA #$01			;\silent when 3 timers
	STA !free_ram_timer_freq	;|are off and set occasional timer so
					;/they don't keep running when off.
	BRA dont_do_anything

make_repeating_sound:
	CMP !when_to_tick_fast		;\if timer is greater or equal than specific time
	BCS tick_slow			;/then tick slowly
;fast tick:				;\otherwise tick faster
	LDA !free_ram_timer_freq	;|
	BNE timer			;|
	LDA !sound_freq_fast		;|
	BRA timer			;/
tick_slow:
	LDA !free_ram_timer_freq	;\tick slowly
	BNE timer			;|
	LDA !sound_freq			;/
timer:
	STA !free_ram_timer_freq	;>set timer
	LDA $9D				;\If both the freeze flags (pause and lock)
	ORA $13D4			;|are 0 (normal motion), then don't do anything
	BNE dont_do_anything		;/
	DEC !free_ram_timer_freq	;>subtract timer
	LDA !free_ram_timer_freq
	BNE dont_do_anything
	LDA !sound_num			;\set sound
	STA !sound_ram			;/
dont_do_anything:
	LDA $9D				;\this is the branch we hijacked
	BNE +				;|(this restores smw's code)
	JML $00C504			;|
+	JML $00C569			;/
	RTL