;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mario knockback
; By Smallhacker, revised by ICB
; 
; Knocks Mario up/backwards when hurt.
; This version also does a SMB3 style powerdown (because it looks better with the knockback)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $139E00

;Speed to be knocked back with
;(Second value is the same, but negative)
!knockSpeed1 = $40
!knockSpeed2 = $C0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Hijack the hurt routine
org $00F5D5
    JML NewRoutine

;Hack the hurt animation routine
;and force it to bypass the shrink code
org $00D129
	db $EA,$EA,$EA,$80
;Disable zeroing status in powerdown routine
;but leave the rest alone so that cape glide functions
;and layer 2 handling (Wherever that is) are intact.
;we handle powerdown below.
org $00F600
	db $EA,$EA

org !freeSpace
%RATS_start(0)

NewRoutine:
    LDA $19		;if small and hit
    BEQ Die		;die, Mario, die!
    
    LDA #!knockSpeed2
    STA $7D
    
    LDA $76
    BNE Other
    
    LDA #!knockSpeed1
    STA $7B
    BRA End
    
Other:
    LDA #!knockSpeed2
    STA $7B
End:
LDA $19			;If status is big
CMP #$01		;then make small
BEQ makesmall		
LDA #$01		;Otherwise
STA $19			;Power down to big
BRA jumpback		;and jump back to original routine
makesmall:
STZ $19			;if big, now small!
jumpback:
    JML $00F5DD

Die:
    JML $00F606
    


%RATS_end(0)