lorom
header
fastrom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ~~ Enable hijacks ~~
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Normal = !True		;Set this to !True to enable separate normal jump sfx, otherwise set it to !False
!Spin = !True		;Set this to !True to enable separate spin jump sfx, otherwise set it to !False
;Protip: you can change idea and repatch this again.
;Setting both to !False will completely remove the patch from your ROM.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ~~ SFX Defines ~~
;
; It's highly reccomended that you edit those
;
; More info about SFX ports can be found here -> http://www.smwcentral.net/?p=viewthread&t=6665 <-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Normal Jump
!SmallSFX = $13
!SmallBNK = $1DF9
!BigSFX = $01
!BigBNK = $1DFA
!CapedSFX = $08
!CapedBNK = $1DFC
!FireSFX = $20
!FireBNK = $1DF9

;Spin jump
!SmallSpinSFX = $09
!SmallSpinBNK = $1DF9
!BigSpinSFX = $04
!BigSpinBNK = $1DFC
!CapedSpinSFX = $09
!CapedSpinBNK = $1DFC
!FireSpinSFX = $06
!FireSpinBNK = $1DF9

;Default sfx originally used by SMW
!defsfxNormal = $01
!defbnkNormal = $1DFA
!defsfxSpin = $04
!defbnkSpin = $1DFC

;No need to touch those
!True = 1
!False = 0

macro hijack(addr,type)
org $<addr>
if !<type> != 0
autoclean JSL SomeLabel
NOP
else
LDA #!defsfx<type>
STA !defbnk<type>
endif
endmacro

%hijack(00D65E,Normal)

%hijack(00DBA5,Normal)

%hijack(00D649,Spin)

%hijack(00EA8D,Spin)

freecode

SomeLabel:
 PHX			;push X onto the stack
 PHB			;push data bank register onto the stack
 PHK			;push program bank register onto the stack
 PLB			;pull data bank register from the stack
 
 LDX $19		;load powerup status into X
 LDA $140D		;Load Spin-Jump Flag into A
 BEQ ASDFLabel		;if not spinjumping branch
 INX			;otherwise increase X index four times
 INX
 INX
 INX
ASDFLabel:
 LDA JumpSFXTable,x	;load value from table, indexed by X (powerup status), to the accumulator
 PHA			;push accumulator (SFX to play) onto the stack
 TXA			;transfer Y register to the accumulaor
 ASL			;multiply accumulator by 2
 TAX			;transfer accumulator to the X register
 REP #$20		;accumulator goes in 16-bit mode
 LDA JumpBankTable,x	;load value from table, indexed by X (powerup status), to the accumulator
 STA $00		;store the 16-bit value in A to scratch RAM
 SEP #$20		;accumulator returns in 8-bit mode
 PLA			;pull A from the stack
 STA ($00)		;store A (SFX to play) to the absolute RAM address stored in $7E0000 (SFX bank)
 PLB			;pull data bank register from the stack
 PLX			;pull X from the stack
 
 RTL			;return

JumpSFXTable:
    db !SmallSFX,!BigSFX,!CapedSFX,!FireSFX
SpinSFXTable:
    db !SmallSpinSFX,!BigSpinSFX,!CapedSpinSFX,!FireSpinSFX
    
JumpBankTable:
    dw !SmallBNK,!BigBNK,!CapedBNK,!FireBNK
SpinBankTable:
    dw !SmallSpinBNK,!BigSpinBNK,!CapedSpinBNK,!FireSpinBNK