;----------------------------------------------------------------------------------------
;
; sma2 overworld status menu
;
; by Ladida
;
;----------------------------------------------------------------------------------------

!gfxfile = $0FFF	;ExGFX file that has the status screen GFX. CHANGE THIS!!!!!!!!!!!!!!
!gfxfile2 = $0FFE	;ExGFX file that has the sprite GFX. CHANGE THIS!!!!!!!!!!!!!!!!!!!!!

!statussong = $09	;song that should play on the status screen. default is special world
			;change it to whatever you insert the included song as

!CURRENTSONG = $1DFF 	;change to $7FB000 or whatever !CurrentSong is in AMK (if you're using amk)
			;basically holds current song playing

!exitcounter = 96	;# of exits needed before peach stops crying, the timer
			;stops, and you can WARP!!! (also, icon on title screen)
			;in decimal; add a $ if youre gonna use a hex value
			;i wouldve calculated this manually, but it's much easier if you
			;count your own exits :>
			;note that the patch also edits address $009D6D for you

!east_timor = $700824	;9 bytes. holds digits for timer (should be same as in SRAMExpand)
			;by default its in SRAM, its best like that (you can move it elsewhere,
			;just make sure the address is never cleared)

;----------------------------------------------------------------------------------------

;below are RAM addresses. dont change them (only if you -have- to)
;they are located in the later half of the map16 low byte table,
;which is pretty much unused during the OW.
;other patches, maybe even LM, might use the area, but it'd prolly only be during levels
;so conflict should be fine (on my end anyways). i will do writes before any reads


!EXGFXBUFFER = $7EE800	;where the exgfx files defined above are uploaded to.
			;layer 3 needs 2kb and sprites need 2.5kb
!GFX2BBACKUP = $7EE000	;where whatever is in lyr3 slot 4 is backed up. needs 2kb
!SP2BBACKUP = $7EF600	;where whatever is in sp2 is backed up. needs 2.5kb
!NMBRBACKUP = $7EF560	;where some numbers are backed up to

!lvlsworld = $7EE800	;stores level names that need to be loaded (when scrolling, etc)
			;may need to be reserved up to 512 bytes

!lvllmstore = $7EEA00	;3 bytes. contains address where level names
			;are located in a hacked ROM (dont worry, my
			;code will find the address)

!worldname = $7EEA06	;stores letters for current world. 7 bytes ($7F8606 - $7F860C)

!levellist = $7EEA0D	;stores level numbers from current world. can use up to 21 bytes.
			;so $7F860D - $7F8621 is reserved

!levelzeroindex = $7EEA22	;stores level 0's index. used for flashing.

!levelonscreen = $7EEA23	;if current level is on list, set this to 1. else its 0
!levelonscreenindex = $7EEA24	;stores where on list the current level is at, if above is 1

!levelyicoin = $7EEA25	;stores yi coin flag for levels in current world. can use up to 21 bytes.
			;so $7F8625 - $7F8639 is reserved

!levelcleared = $7EEA3A	;stores level clear for levels in current world. can use up to 21 bytes.
			;so $7F863A - $7F864E is reserved

!levelsecret = $7EEA4F	;stores whether levels in current world have secret exits. can use up to
			;21 bytes, so $7F864F - $7F8653 is reserved

!lvlnm = $7EECE0	;$7F88E0 - $7F88F2 used. tilemap of current level name

!currentlevel = $7EF200	;stores current level number

!scrlltbl = $7EF201	;layer 3 X position HDMA table. 7 bytes ($7F8C01 - $7F8C07)

!imamusic = $7EF208	;backup of overworld music

!scrollflag = $7EF209	;whether you're scrolling the list or not
!scrollside = $7EF20A	;which side of the layer 3 tilemap needs to be updated
!scrollindex = $7EF20B	;holds level in list to update

!freeram1 = $7EF20C	;pointer to different submodes for ow<->status screen
!freeram2 = $7EF20D	;timer
!currentworld = $7EF20E	;current world you're in
			;used to determine what to show on the status screen

!levelscmplt = $7EF20F	;if no levels in the world are unlocked, this is 0. else, it's nonzero

!cursorpos = $7EF210	;position of cursor

!bgcolor = $7EF211	;has bg color to DMA. 2 bytes

!yicointhing = $7EF213	;flag whether youve collected all the yoshi coins in the game

!worldsavail = $7EF214	;table that holds a flag per world.

!levelwarp = $7EF230	;holds level number to warp to

!levellevelindex = $7EF27F	;stores... some index, forgot what
!leveltiletable = $7EF300	;stores layer 1 map16 tile for levels
!levelleveltable = $7EF280	;stores level numbers or something

!numbermux = $7EE800	;temp space

!somelvlindex = $14	;originally $0C. Max # of levels to show. Don't change.

;----------------------------------------------------------------------------------------

;each of the below are 152 ($98) bytes
;they mainly store level name GFX so we can mux them with the background ala VWF
;and display the result at the very top of the menu (header)
;only really used on menu load, free country afterwards

!lvlgfxrawline1 = $7EE800	;level name, top 4 pixels
!lvlgfxrawline2 = $7EE898	;level name, bottom 4 pixels

!sttsdefgfxline1 = $7EE930	;\ the background tile
!sttsdefgfxline2 = $7EE938	;| graphics are stored
!sttsdefgfxline3 = $7EE940	;| here. consists of
!sttsdefgfxline4 = $7EE948	;/ 2 8x8 tiles.

!lvlgfxoraline1 = $7EE950	;\ top 4 pixels of background tile are stored here
!lvlgfxoraline2 = $7EE9E8	;| level name is muxed with background tile, top 4 pixels
!lvlgfxoraline3 = $7EEA80	;| level name is muxed with background tile, bottom 4 pixels
!lvlgfxoraline4 = $7EEB18	;/ bottom 4 pixels of background tile are stored here

!lvlgfxrawline3 = $7EEBB0	;level name, top 4 pixels, and shifted down 1 pixel (shadow)
!lvlgfxrawline4 = $7EEC48	;level name, bottom 4 pixels, and shifted down 1 pixel (shadow)

;----------------------------------------------------------------------------------------
; from here on out lies unoptimized, uncommented goodness
; i bet in a few weeks/months i'll have no idea what most of the code does, lol
; oh well, i hate commenting anyways
; unless it's useless block comments like this
; that don't get in the way of code
;----------------------------------------------------------------------------------------

header : lorom

incsrc dmamacros.txt

org $0084D6
autoclean dl newlyr3	;$04A400 - Old address of overworld border

org $008222		;this is the NMI portion of the code
autoclean JSL OWYICOIN
NOP

org $00827C
JML LYR3SCROLLFIX	;this will fix not being able to move layer 3 on the overworld
NOP

org $00A1C7
JSL OWHIJACK		;this is the MAIN portion of the code


org $008184		;fixes $1DFF being overwritten
BRA $09			;i think amk hijacks around here though, fml
;BNE $09

org $0081C1		;timer needs to run pretty much every frame of the game
JML Timer		;LDA $44
NOP			;STA $2130

org $009D6D
db !exitcounter

;----------------------------------------------------------------------------------------

freecode

LYR3SCROLLFIX:
LDY $13C6
CPY #$08
BNE +
JML $008283
+
LDY $0100
CPY #$0E
BNE +
STA $4200
JML $0082B0
+
JML $0082A1

OWYICOIN:
PHB : PHK : PLB
PHP : SEP #$30
LDA $0100
CMP #$0D
BNE +
LDA #$00
STA !freeram1		;\ clear free ram
STA !freeram2		;| just in case
STA !currentworld	;| it isnt already
STA !scrollflag		;|
STA !scrollside		;|
STA !scrollindex	;| (hint: it's not)
STA !levelonscreen	;/
BRA ++
+
CMP #$0E
BNE ++
JSR OWStatus		;let's a-go
++
PLP : PLB
LDA $13D9		;restore hijack
CMP #$0A
RTL


OWStatus:
LDA !freeram1		;generic pointer
ASL : TAX
JMP (.ptrs,x)
.ptrs
dw Default		;regular overworld
dw Default		;fading to status screen
dw NMIStuffStatus	;magic
dw Default		;fading, showing status screen
dw Status		;regular status screen
dw Default		;fading to overworld
dw NMIStuffOW		;more magic
dw Default		;fading, showing regular overworld
dw Default		;fading, after you picked a level
dw NMIStuffOW		;same magic
dw Default		;warp

Default:
RTS

db $00			;don't touch this
NMIStuffStatus:
LDA !freeram2
BNE +
RTS
+
%vramread(#$80, #$3981, 4C00, !GFX2BBACKUP&$FFFF, !GFX2BBACKUP>>16, #$0800)	;back up whatever is in GFX2B
%vramread(#$80, #$3981, 6800, !SP2BBACKUP&$FFFF, !SP2BBACKUP>>16, #$0A00)	;back up whatever is in SP2
%vramread(#$80, #$3981, 4910, !NMBRBACKUP&$FFFF, !NMBRBACKUP>>16, #$00A0)	;back up some numbers in GFX2A
LDA.b #!EXGFXBUFFER&$FF : STA $00
LDA.b #!EXGFXBUFFER>>8&$FF : STA $01
LDA.b #!EXGFXBUFFER>>16 : STA $02
REP #$30
LDA #!gfxfile		;decompress status GFX to free ram
JSL $0FF900		;jump to decompression routine
SEP #$30
%vramwrite(#$80, #$1801, 4C00, !EXGFXBUFFER&$FFFF, !EXGFXBUFFER>>16, #$0800)	;write status GFX to VRAM
REP #$30
LDA #!gfxfile2		;decompress status sprite GFX to free ram
JSL $0FF900		;jump to decompression routine
LDA $0701		;back up background color
STA $0903
SEP #$30
%vramwrite(#$80, #$1801, 6800, !EXGFXBUFFER&$FFFF, !EXGFXBUFFER>>16, #$0A00)	;write status GFX to VRAM

%cgramread(#$00, $0703, $7E, #$0040)			;back up 1st 2 palettes
%cgramread(#$E0, $E0*2+$0703, $7E, #$0040)		;also last 2 palettes

%cgramwrite(#$00, OWPal, OWPal>>16, #$0040)		;write status palette
%cgramwrite(#$E0, OWPal+$40, OWPal>>16, #$0040)		;write status sprite palettes

LDX.b #.endtable2-.table2-1
-
LDA .table2,x			;prepare HDMA table in RAM
STA !scrlltbl,x
DEX : BPL -

JSR TransitionSpeedup			;loading was slow as hell before i put this
JSR CurrentLevelToStatusDynamic		;more like JSR Hell, no joke
JSR HUDDMA				;load score, lives, coins, etc
JSR InitStatusMenu			;prepares some stuff, reads LM hijack
LDA #$00 : STA !levelscmplt
JSR MainKindaStatusMenu			;update menu when done fading

LDX #!somelvlindex	;place cursor on current level
-
LDA !levellist,x
BEQ +
CMP $0F
BEQ ++
+
DEX : BPL -
INX
++
TXA : STA !cursorpos
+

LDA #$00 : STA !scrollside
JSR WorldNameUpdatePre			;initialize update world name
JSR WorldNameUpdate			;update world name

JSR PreDrawYoshiCoin

LDA #$04		;only layer 3
STA $212C
LDA #$10		;and sprites are visible
STA $212D
STZ $0701		;\ set background color
STZ $0702		;/ to black
INC $25			;increase layer 3 Y position
LDA $24 : STA $2112	;\
LDA $25 : STA $2112	;/ actually update position
RTS

.table2
db $2B : dw $0000
db $01 : dw $0000
db $00
.endtable2


Status:
JSR SideArrows		;side arrow flash

LDA !scrollflag		;if scrolling
BNE .scrolling		;update level and world names

JSR CURSOR_FINALLY_LAST_PART_I_NEED_TO_CODE_BEFORE_IM_DONE

LDA $16
BIT #$30		;if start or select is not pressed
BEQ .end		;gtfo
LDA !freeram1		;else, exit menu
INC A
STA !freeram1
BRA .end
.scrolling
LDA !scrollindex
CMP #!somelvlindex	;world name and yoshi coins/exits completed should update first
BCC +
JSR WorldNameUpdate	;since they appear first when you scroll
LDA !scrollindex
DEC A
STA !scrollindex
BRA .end
+
LDA !scrollindex
BMI .end
JSR LevelScrollUpdate	;update level names
.end
RTS


NMIStuffOW:
LDA !freeram2
CMP #$01
BEQ +
RTS
+
LDA #$FD : STA $00
%vramwrite(#$01, #$1808, 5CC4, $0000, $7E, #$0014)
%vramwrite(#$01, #$1808, 58C4, $0000, $7E, #$0014)
%vramwrite(#$80, #$1801, 4C00, !GFX2BBACKUP&$FFFF, !GFX2BBACKUP>>16, #$0800)	;restore GFX2B
%vramwrite(#$80, #$1801, 6800, !SP2BBACKUP&$FFFF, !SP2BBACKUP>>16, #$0A00)	;restore SP2
%vramwrite(#$80, #$1801, 4910, !NMBRBACKUP&$FFFF, !NMBRBACKUP>>16, #$00A0)	;restore numbers
LDA.b #%00010101		;Layer 1, Layer 3, Sprites on main screen
STA $212C
LDA.b #%00000010		;Layer 2 on sub screen
STA $212D
LDA $0903			;restore background color
STA $0701
LDA $0904			;high byte
STA $0702
LDA #$08			;disable HDMA
TRB $0D9F
%cgramwrite(#$00, $0703, $7E, #$0040)		;restore palette
%cgramwrite(#$F0, $F0*2+$0703, $7E, #$0020)	;also last palette
DEC $25				;move layer 3 Y back to normal
LDA $24 : STA $2112
LDA $25 : STA $2112
STZ $2111 : STZ $2111
RTS




CurrentLevel:		;\ this code is copyright Ladida
LDY $0DD6		;get current player*4
LDA $1F17,y		;ow player X position low
LSR #4
STA $00
LDA $1F19,y		;ow player y position low
AND #$F0
ORA $00
STA $00
LDA $1F1A,y		;ow player y position high
ASL
ORA $1F18,y		;ow player x position high
LDY $0DB3		;get current player
LDX $1F11,y		;get current map
BEQ +
CLC : ADC #$04		;if on submap, add $0400
+
STA $01

REP #$10
LDX $00
LDA $7ED000,x		;load layer 1 tilemap, and thus current translevel number
STA $0F			;CURRENT LEVEL IS NOW IN $0F FOR NOW
SEP #$10
RTS			;/ just kidding, but i did work hard on it




;you ready for this?
;
;WELCOME TO DIE:

CurrentLevelToStatusDynamic:
%vramread(#$80, #$3981, 4C10, !sttsdefgfxline1&$FFFF, !sttsdefgfxline1>>16, #$0008)	;\just
%vramread(#$80, #$3981, 4C14, !sttsdefgfxline2&$FFFF, !sttsdefgfxline2>>16, #$0008)	;|reads
%vramread(#$80, #$3981, 4C90, !sttsdefgfxline3&$FFFF, !sttsdefgfxline1>>16, #$0008)	;|bg
%vramread(#$80, #$3981, 4C94, !sttsdefgfxline4&$FFFF, !sttsdefgfxline2>>16, #$0008)	;/tile
%vramread(#$00, #$3980, 508B, !lvlnm&$FFFF, !lvlnm>>16, #$0013)		;read level name
REP #$20
LDX #$00
.loop
LDA !lvlnm,x		;get tilemap of current letter
AND #$00FF		;since we're in 16bit, get rid of upper byte
ASL #3			;\ multiply by 8...
ORA #$4800		;| and OR $4800
STA $00			;/ to get GFX location of letter
TXA			; get current index
ASL #3			;multiply by 8
AND #$00FF		;clear higher byte
STA $02			;this is our index for the letter GFX in RAM

LDY #$80 : STY $2115
LDA $00 : STA $2116
LDA $2139
LDA #$3981 : STA $4310
LDA.w #!lvlgfxrawline1&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxrawline1>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

PHX : LDX $02
LDA #$00FF
STA !lvlgfxrawline3,x
PLX

LDY #$80 : STY $2115
LDA $00 : STA $2116
LDA $2139
LDA #$3981 : STA $4310
LDA.w #!lvlgfxrawline3&$FFFF : CLC : ADC $02 : ADC #$0002 : STA $4312
LDY.b #!lvlgfxrawline3>>16 : STY $4314
LDA #$0006 : STA $4315
LDY #$02 : STY $420B

LDA $00 : CLC : ADC #$0004 : STA $00
DEC A : STA $04

LDY #$80 : STY $2115
LDA $00 : STA $2116
LDA $2139
LDA #$3981 : STA $4310
LDA.w #!lvlgfxrawline2&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxrawline2>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA $04 : STA $2116
LDA $2139
LDA #$3981 : STA $4310
LDA.w #!lvlgfxrawline4&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxrawline4>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

JSR TileFusionShadow		;this renders the shadow of the text (just text-1pixel)
JSR TileFusionMain		;this renders the text itself

CPX #$0B
BCC +
TXA
SEC : SBC #$000B
ASL #3
AND #$00FF
STA $04
JSR DMABottom
BRA ++
+
JSR DMATop
++

INX : CPX #$13 : BCS +
JMP .loop
+
SEP #$20
RTS



TileFusionShadow:	;renders text shadow onto image
PHX : PHP
REP #$10 : SEP #$20
LDX $02
LDY #$0000
-
PHX : TYX
LDA !sttsdefgfxline1,x
PLX
STA !lvlgfxoraline1,x
PHX : TYX
LDA !sttsdefgfxline4,x
PLX
STA !lvlgfxoraline4,x

INX
LDA !lvlgfxrawline3,x
DEX
PHX : TYX
ORA !sttsdefgfxline2,x
PLX
STA !lvlgfxoraline2,x

INX
LDA !lvlgfxrawline4,x
DEX
PHX : TYX
ORA !sttsdefgfxline3,x
PLX
STA !lvlgfxoraline3,x

INX : INY

PHX : TYX
LDA !sttsdefgfxline1,x
PLX
STA !lvlgfxoraline1,x
PHX : TYX
LDA !sttsdefgfxline4,x
PLX
STA !lvlgfxoraline4,x

LDA !lvlgfxrawline3,x
PHX : TYX
ORA !sttsdefgfxline2,x
PLX
STA !lvlgfxoraline2,x

LDA !lvlgfxrawline4,x
PHX : TYX
ORA !sttsdefgfxline3,x
PLX
STA !lvlgfxoraline3,x

INX : INY
CPY #$0008 : BNE -
PLP : PLX
RTS


TileFusionMain:		;renders main text onto image & shadow
PHX : PHP
REP #$10 : SEP #$20
LDX $02
LDY #$0000
-
INX
LDA !lvlgfxrawline1,x
DEX
EOR #$FF
AND !lvlgfxoraline2,x
STA !lvlgfxoraline2,x

INX
LDA !lvlgfxrawline2,x
DEX
EOR #$FF
AND !lvlgfxoraline3,x
STA !lvlgfxoraline3,x

INX : INY

LDA !lvlgfxrawline1,x
EOR #$FF
AND !lvlgfxoraline2,x
STA !lvlgfxoraline2,x

LDA !lvlgfxrawline2,x
EOR #$FF
AND !lvlgfxoraline3,x
STA !lvlgfxoraline3,x

INX : INY
CPY #$0008 : BNE -
PLP : PLX
RTS


DMATop:
LDY #$80 : STY $2115
LDA #$4C28 : CLC : ADC $02 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline1&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline1>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4C2C : CLC : ADC $02 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline2&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline2>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4CA8 : CLC : ADC $02 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline3&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline3>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4CAC : CLC : ADC $02 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline4&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline4>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B
RTS

DMABottom:
LDY #$80 : STY $2115
LDA #$4D28 : CLC : ADC $04 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline1&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline1>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4D2C : CLC : ADC $04 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline2&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline2>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4DA8 : CLC : ADC $04 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline3&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline3>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B

LDY #$80 : STY $2115
LDA #$4DAC : CLC : ADC $04 : STA $2116
LDA #$1801 : STA $4310
LDA.w #!lvlgfxoraline4&$FFFF : CLC : ADC $02 : STA $4312
LDY.b #!lvlgfxoraline4>>16 : STY $4314
LDA #$0008 : STA $4315
LDY #$02 : STY $420B
RTS				;You are now leaving DIE. have a n0ice day
;(I could probably optimize the whole gfx muxing code above,
; but who cares; it runs during f-blank anyways)



InitStatusMenu:
JSR CurrentLevel	;current level will be in $0F
LDX #$00
LDA $0F
STA !currentlevel
BEQ +
-
TXA : ASL : TAY
LDA worldptrs,y
STA $00
INY
LDA worldptrs,y
STA $01
LDY worldptrs2,x
--
LDA ($00),y
CMP $0F
BEQ +
DEY : BPL --
INX : CPX.b #endworldptrs2-worldptrs2 : BCC -
LDX #$00
+
TXA : STA !currentworld		;world

REP #$20
LDA $048E82		;LM puts a JSL here, to unused space
CLC : ADC #$0037	;so we're getting the address + $0037
STA $00			;because at that point
SEP #$20		;a table is loaded/indexed from freespace
LDA $048E84		;this table contains level names
STA $02			;yay

LDY #$00
LDA [$00],y
STA !lvllmstore : INY
LDA [$00],y
STA !lvllmstore+$1 : INY
LDA [$00],y
STA !lvllmstore+$2	;the location of the level name table is now at !lvllmstore
RTS


MainKindaStatusMenu:
JSR WorldChecker		;check which worlds have been completed
JSR InitStatusNotReally		;fffffff
JSR BackgroundColor		;change bg color according to world completeness

LDY #!somelvlindex-1
-
STY $211B
STZ $211B
LDA #$13
STA $211C
REP #$20
LDA $2134
STA $00
TYA
AND #$00FF
ASL #5
CLC : ADC #$58C5

LDX #$00 : STX $2115
STA $2116
LDA #$1800 : STA $4310
LDA.w #!lvlsworld&$FFFF : CLC : ADC $00 : STA $4312
LDX.b #!lvlsworld>>16 : STX $4314
LDA #$0013 : STA $4315
LDX #$02 : STX $420B
SEP #$20
DEY : BPL -
RTS


incsrc levelnames.txt		;doesnt actually have level names anymore, lol


SpriteDraw:
JSL $7F8000		;make sure SMW's OW sprites don't show up

LDX #$0F : LDY #$FC
-
LDA .spritetablex,x
STA $0200,y
LDA #$27
STA $0201,y
LDA .spritetablet,x
STA $0202,y
LDA #$0E
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX
DEY #4 : DEX : BPL -

LDX #$01
-
LDA .sidetablex,x
STA $0200,y
LDA .sidetabley,x
STA $0201,y
LDA #$80
STA $0202,y
LDA .sidetablep,x
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$00 : STA $0420,x
PLX
DEY #4 : DEX : BPL -
LDX #$01
-
LDA .sidetablex+2,x
STA $0200,y
LDA .sidetabley+2,x
STA $0201,y
LDA #$80
STA $0202,y
LDA .sidetablep+2,x
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX
DEY #4 : DEX : BPL -

LDX #$03
-
LDA .playertablex,x
STA $0200,y
LDA #$1F
STA $0201,y
PHX : LDX $0DB3
LDA .playertablet,x
STA $0202,y
PLX
LDA #$0E
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$00 : STA $0420,x
PLX
DEY #4 : DEX : BPL -

JSR DrawPeach
JSR DrawYoshiCoin

LDA #$2F : STA $00
LDX #$13
-
LDA !scrlltbl+$4
EOR #$FF
INC A
CLC : ADC #$E8
STA $0200,y
LDA $00
STA $0201,y
LDA #$C8
STA $0202,y
LDA #$0E
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$00 : STA $0420,x
PLX
LDA $00 : CLC : ADC #$08 : STA $00
DEY #4 : DEX : BPL -

JSR ScrollSprites

RTS

.spritetablex
db $00,$10,$20,$30,$40,$50,$60,$70
db $80,$90,$A0,$B0,$C0,$D0,$E0,$F0
.spritetablet
db $81,$83,$83,$83,$83,$83,$83,$83
db $83,$83,$83,$83,$83,$83,$83,$85

.sidetablex
db $00,$F8,$00,$F0
.sidetabley
db $1F,$1F,$0F,$0F
.sidetablep
db $0E,$4E,$0E,$4E

.playertablex
db $48,$50,$58,$60
.playertablet
db $87,$97



OWHIJACK:
JSL $048241		;restore hijack
PHB : PHK : PLB
LDA $0100
CMP #$0E		;only run code when on the overworld (no fading)
BNE ++
LDA $13D9
CMP #$03		;and only when standing still
BNE ++
JSR NonNMIPointer
++
PLB : RTL


NonNMIPointer:
LDA !freeram1		;generic pointer
ASL : TAX
JMP (.ptrs,x)
.ptrs
dw lol			;on OW
dw fademusic		;fade to status screen
dw updatemaybe		;NMI stuff
dw dunno		;fade in
dw statusyay		;status screen
dw unfademusic		;fade back to ow
dw deupdatemaybe	;NMI stuff
dw dunno2		;fade in
dw unfademusic		;fade to OW after choosing level
dw newupdatemaybe	;stuff
dw lol2			;this one sux, i hate it. anyways, it actually warps you

lol:
LDA $1B87		;if save/continue or lives transfer
BNE +			;then dont activate status screen
LDA $13D4		;if scrolling on ow
BNE +			;then dont activate status screen
LDA $16			;you have to
AND #$20		;press select
BEQ +			;to access status screen
LDA !freeram1
INC A
STA !freeram1
+
RTS

lol2:
REP #$10
LDX #$07FF		;lol, checking 2,048 values
-			;this should lag a bit
LDA $7ED000,x		;anyways, check level # at current index
CMP !levelwarp		;if it's the same as the one you chose to warp to
BEQ +			;then warp
DEX : BPL -		;otherwise, change index and check again
+
STA $13BF		;store to translevel # (not sure if necessary)
REP #$20
LDA $0DB3
AND #$00FF
ASL : TAY
SEP #$20
LDA #$02		;face screen when you warp
STA $1F13,y
LDA $7EC800,x		;store layer 1 tile of destination level
STA $13C1		;to current layer 1 tile
CMP #$80		;if you're on tile 80
BEQ ++
CMP #$6A		;or a tile from 6A
BCC +
CMP #$6E		;to 6D
BCS +
++
LDA #$0A		;then be in water, facing screen
STA $1F13,y
+
STX $00			;store index to scratch ram, this is important
SEP #$10

LDY $0DD6		;current player*4 to Y
LDX $0DB3		;current player to X

LDA $00
AND #$F0
CLC : ADC #$08
STA $1F19,y
LSR #4
STA $1F21,y
LDA $00
AND #$0F
ASL #4
CLC : ADC #$08
STA $1F17,y
LSR #4
STA $1F1F,y

STZ $1F11,x		;checking
LDA $01			;destination
BIT #$04		;submap
BEQ +			;is
SEC : SBC #$04		;the
STA $01			;worst
REP #$20		;i mean
LDA $00			;look at these lulzy checks
CMP #$00A0		;it's looks like lolcode
BCC .yi
CMP #$0100
BCC .va
CMP #$01A0
BCC .vb
CMP #$0200
BCC .sp
CMP #$0250
BCC .va
CMP #$0300
BCC .fi
CMP #$0350
BCC .sp
.sw
SEP #$20
LDA #$06
STA $1F11,x
BRA +
.yi
SEP #$20
LDA #$01
STA $1F11,x
BRA +
.va
SEP #$20
LDA #$02
STA $1F11,x
BRA +
.fi
SEP #$20
LDA #$03
STA $1F11,x
BRA +
.vb
SEP #$20
LDA #$04
STA $1F11,x
BRA +
.sp
SEP #$20
LDA #$05
STA $1F11,x
+
LDA $01
LSR
STA $1F1A,y
ASL #4
ORA $1F21,y
STA $1F21,y
LDA $01
AND #$01
STA $1F18,y
ASL #4
ORA $1F1F,y
STA $1F1F,y		;yay, done with that. now we are at destination

LDA #$00
STA !freeram1		;\ clear free ram
STA !freeram2		;| just in case
STA !currentworld	;| it isnt already
STA !scrollflag		;|
STA !scrollside		;|
STA !scrollindex	;|
STA !levelonscreen	;| (wait, i said that somewhere before...)
STA !cursorpos		;/
STA $1DFB		;let the game load the music
LDA #$0C		;game mode = OW load
STA $0100
LDA #$00		;?_?
STA $0DAF		;fade related i guess
RTS

newupdatemaybe:
LDA #$FF
STA $0DAA		;disable button input
STA $0DAB
STA $0DAC
STA $0DAD
LDA #$00
STA $1DFB
LDA !freeram2
BEQ +
DEC A
STA !freeram2
RTS
+
LDA !freeram1
INC A
STA !freeram1
STZ $0DAE
RTS

fademusic:
LDA !CURRENTSONG
STA !imamusic
LDA #$FF
STA $0DAA		;disable button input
STA $0DAB
STA $0DAC
STA $0DAD
LDA $0DAE
DEC A
STA $0DAE
BNE +
LDA !freeram1
INC A
STA !freeram1
LDA #$01
STA !freeram2
LDA #$80		;set F-blank
STA $0DAE
LDA #$80
STA $1DFB
+
RTS

updatemaybe:
LDA #$01
STA $13D4		;set map scroll, so player wont move on OW
REP #$20
LDA #$FFFF
STA $0DAA		;disable button input
STA $0DAC
LDA $1A
STA $1DF0
LDA $1C
STA $1DF2
SEP #$20
LDA #$FF
STA $1FFC
LDA !freeram2
BEQ +
DEC A
STA !freeram2
RTS
+
STZ $0DAE		;disable F-blank, brightness=0
LDA !freeram1
INC A
STA !freeram1
LDA #!statussong
STA $1DFB
RTS

dunno:
JSR SpriteDraw
LDA #$FF
STA $0DAA		;disable button input
STA $0DAB
STA $0DAC
STA $0DAD
LDA #$FF
STA $1FFC
LDA $0DAE
INC A
STA $0DAE
CMP #$0F
BNE +
LDA !freeram1
INC A
STA !freeram1
+
RTS

unfademusic:
JSR SpriteDraw
LDA #$80
STA $1DFB
LDA #$02
STA $13D4		;disable map scroll, so we can move again
REP #$20
LDA #$FFFF		;disable button input
STA $0DAA
STA $0DAC
LDA $1DF0
STA $1A
STA $1E
LDA $1DF2
STA $1C
STA $20
SEP #$20
LDA #$FF
STA $1FFC
LDA $0DAE
DEC A
STA $0DAE
BNE +
LDA !freeram1
INC A
STA !freeram1
LDX #$07
CMP #$08
BCC ++
LDX #$01
++
TXA
STA !freeram2
LDA #$80		;set F-blank
STA $0DAE
+
RTS

deupdatemaybe:
LDA !imamusic
STA $1DFB
LDA #$FF
STA $0DAA		;disable button input
STA $0DAB
STA $0DAC
STA $0DAD
LDA !freeram2
BEQ +
DEC A
STA !freeram2
RTS
+
LDA !freeram1
INC A
STA !freeram1
STZ $0DAE
RTS

dunno2:
LDA #$FF
STA $0DAA		;disable button input
STA $0DAB
STA $0DAC
STA $0DAD
LDA $0DAE
INC A
STA $0DAE
CMP #$0F
BNE +
LDA #$00
STA !freeram1
+
RTS

statusyay:
LDA #$FF
STA $1FFC		;make sure lightning flash sound on VoB never happens

LDA !scrollflag
CMP #$01
BEQ .goingright
CMP #$02
BEQ .goingleft

JSR CursorMov

LDA $16
BIT #$01
BNE .right
BIT #$02
BNE ++
LDA $18
BIT #$10
BNE .right
BIT #$20
BEQ +
++
JMP .left
+
JMP .neither

.goingright
REP #$20
LDA !scrlltbl+$4
CLC : ADC #$0008
STA !scrlltbl+$4
SEP #$20
LDA !scrlltbl+$4
BNE +
LDA #$00
STA !scrollflag
+
JMP .neither

.goingleft
REP #$20
LDA !scrlltbl+$4
SEC : SBC #$0008
STA !scrlltbl+$4
SEP #$20
LDA !scrlltbl+$4
BNE +
LDA #$00
STA !scrollflag
+
JMP .neither

.right
LDX #$00
LDA !currentworld
BEQ +
LDX #$01
+
STA $00
STX $01
TAX
-
TXA
INC A
CMP $00
BEQ ++
CMP.b #endworldptrs2-worldptrs2
BCC +
LDA $01
BEQ ++
LDA #$00
+
TAX
LDA !worldsavail,x
BEQ -
TXA
STA !currentworld
LDA #$01
STA $1DFC
LDA !scrollside
EOR #$01
STA !scrollside
LDA #$01
STA !scrollflag
LDA #!somelvlindex
STA !scrollindex
LDA #$00
STA !levelonscreen
LDA #$00 : STA !levelscmplt
JSR InitStatusNotReally
JSR WorldNameUpdatePre
JSR BackgroundColor
++
JMP .neither


.left
STA $7FFFFF
LDX #$00
LDA !currentworld
CMP.b #endworldptrs2-worldptrs2-1
BEQ +
LDX #$01
+
STA $00
STX $01
TAX
-
TXA
DEC A
CMP $00
BEQ .neither
TAX : TXA
BPL +
LDA $01
BEQ .neither
LDA.b #endworldptrs2-worldptrs2-1
+
TAX
LDA !worldsavail,x
BEQ -
TXA
STA !currentworld
LDA #$01
STA $1DFC
LDA !scrollside
EOR #$01
STA !scrollside
LDA #$02
STA !scrollflag
LDA #!somelvlindex
STA !scrollindex
LDA #$00
STA !levelonscreen
LDA #$00 : STA !levelscmplt
JSR InitStatusNotReally
JSR WorldNameUpdatePre
JSR BackgroundColor

.neither

LDA !cursorpos
TAX
-
LDA !levellist,x
BNE +
DEX : BPL -
+
TXA
STA !cursorpos

JSR SpriteDraw
STZ $1B87

REP #$20
LDA #$1106 : STA $4330
LDA #!scrlltbl&$FFFF : STA $4332
LDY.b #!scrlltbl>>16 : STY $4334
SEP #$20
LDA #$08
TSB $0D9F

RTS

db $FD
InitStatusNotReally:	;the main meat of the patch. this is what arranges the level names
			;and icons, and prepares them for DMA
LDX #$13
-
LDA #$FD
STA !levelyicoin,x
STA !levelsecret,x
STA !levelcleared,x
LDA #$00
STA !levellist,x
DEX : BPL -


%wramwrite(!lvlsworld&$FFFF, !lvlsworld>>16, #$8008, InitStatusNotReally-1&$FFFF, InitStatusNotReally-1>>16, #$00E4)

LDA !currentworld : TAX
LDY worldptrs2,x : INY : STY $08
ASL : TAX
REP #$20
LDA worldptrs,x
STA $00
STZ $06
SEP #$20
LDY #$00

.loop
LDA ($00),y : PHY	;get translevel
TYX
STA !levellist,x	;store level to list
STA $0E
STY $0A

PHX
LDY.b #endnocompleted-nocompleted-1
-
CMP nocompleted,y
BEQ .cantbeat
DEY : BPL -
BRA +
.cantbeat
BRL .cantbeatt
+

LDY.b #endsecretexit-secretexit-1
-
CMP secretexit,y
BEQ .hassecretexit
DEY : BPL -

LDA #$FD
STA !levelsecret,x
BRA .skip

.hassecretexit
TAX
LDA $05D608,x
INC A
STA $4204
STZ $4205
LDA #$08
STA $4206
NOP #8
LDX $4216
LDY $4214
LDA $1F02,y
AND .andtable,x
BEQ .notbeatsecret
LDA !levelscmplt : INC A : STA !levelscmplt
LDA #$AF		;show icon
BRA ++
.notbeatsecret
LDA #$DB		;show empty icon
++
PLX
STA !levelsecret,x	;/ end level complete check
PHX
.skip
LDA $0E
TAX
LDA $05D608,x
STA $4204
STZ $4205
LDA #$08
STA $4206
NOP #8
LDX $4216
LDY $4214
LDA $1F02,y
AND .andtable,x
BEQ .notbeat
LDA !levelscmplt : INC A : STA !levelscmplt
LDA #$AF		;show icon
BRA ++
.notbeat
LDA #$DB		;show empty icon
BRA ++
.cantbeatt
PLX
LDA #$FD		;show nothing
STA !levelsecret,x	;/ end level complete check
PHX
++
PLX
STA !levelcleared,x	;/ end level complete check

PHX			;\ start yoshi coins collected check
LDY.b #endnoyoshicoins-noyoshicoins-1
-
LDA $0E
CMP noyoshicoins,y
BEQ +
DEY : BPL -
LSR #3
TAY
LDA $0E
AND #$07
TAX
LDA $1F2F,y
AND $05B35B,x
BEQ +++
LDA #$84		;show icon
BRA ++
+
LDA #$FD		;show nothing
BRA ++
+++
LDA #$94		;show empty icon
++
PLX
STA !levelyicoin,x	;/ end yoshi coins collected check

LDA $0E
CMP !currentlevel
BNE +
PHA
LDA #$01
STA !levelonscreen
TXA
STA !levelonscreenindex
PLA
+

LDY.b #endspeciallevel-speciallevel-4
-
LDA $0E
CMP speciallevel,y
BEQ .starsw
DEY #4 : CPY.b #endspeciallevel-speciallevel-1 : BCC -

LDA !levellevelindex : TAX
LDA $0E
-
CMP !levelleveltable,x
BEQ .nextpart
DEX : BPL -
BRL .enddisabler
.nextpart
LDA !leveltiletable,x
LDX #$15
-
CMP $04DA1D,x
BEQ +++
DEX : BPL -
BRL .enddisabler

.starsw
LDX #$02 : INY
-
LDA speciallevel,y
BEQ .enddisabler
STA $4204
STZ $4205
LDA #$08
STA $4206
NOP #5
PHX : PHY
LDX $4216
LDY $4214
LDA $1F02,y
AND .andtable,x
BNE .enddisablerpre
PLY : PLX
INY : DEX : BPL -
+++
LDX $0A
LDA #$FD
STA !levelsecret,x
STA !levelcleared,x
STA !levelyicoin,x
REP #$10
LDY #$0000
BRA .jugemujugemugokounosurikirekaijarisuigyonosuigyoumatsu
.enddisablerpre
PLY : PLX

.enddisabler
LDA $0E
STA $211B		;multiply the translevel
STZ $211B
LDY #$13		;by $13, to get index to level name table
STY $211C
REP #$10
LDY $2134		;Y now has index
.jugemujugemugokounosurikirekaijarisuigyonosuigyoumatsu
LDA !lvllmstore
STA $03
LDA !lvllmstore+$1
STA $04
LDA !lvllmstore+$2
STA $05
LDX #$0012
-
LDA [$03],y		;load table, now with correct level index
PHX : LDX $06
STA !lvlsworld,x	;store temporarily to free ram, so we can DMA
INX : STX $06
PLX
INY
DEX : BPL -
SEP #$10
PLY
INY
CPY $08 : BCS + : BRL .loop
+

STY $0C
--
PHY
REP #$10
LDY #$0000 : LDX #$0012
-
LDA [$03],y
PHX : LDX $06
STA !lvlsworld,x
INX : STX $06
PLX : INY : DEX : BPL -
SEP #$10
PLY
TYX
LDA #$00
STA !levellist,x
INY : CPY #!somelvlindex+2 : BCC --
DEY
TYA
STA !levelzeroindex
BRA +
-
BRL .nothing
+

LDA !levelscmplt
BEQ -
STA $03
LDA !currentworld
TAX
LDY worldptrs2,x : INY : STY $02 : STY $04
ASL : TAX
REP #$20
LDA worldptrs,x : STA $00
SEP #$20

LDY #$00
--
LDA ($00),y
LDX.b #endnocompleted-nocompleted-1
-
CMP nocompleted,x
BEQ +
DEX : BPL -
BRA ++
+
DEC $04
++
INY : CPY $02 : BCC --

LDY #$00
--
LDA ($00),y
LDX.b #endsecretexit-secretexit-1
-
CMP secretexit,x
BEQ +
DEX : BPL -
BRA ++
+
INC $04
++
INY : CPY $02 : BCC --

INC $0C

LDA $03
CMP $04
BCC .nothing

REP #$10
LDA #$00 : XBA
LDA.b #!somelvlindex+1
REP #$20
TAY
LDA $06 : SEC : SBC #$0013 : SBC #$0013 : STA $06
SEP #$30
-
REP #$10
LDX $06
LDA #$DA
STA !lvlsworld+7,x
STA !lvlsworld+8,x
REP #$20
TXA : SEC : SBC #$0013 : TAX : STX $06
SEP #$30
DEY : CPY $0C : BCS -

.nothing
RTS

.andtable
db $80,$40,$20,$10,$08,$04,$02,$01



LevelScrollUpdate:
LDX #$02
-
PHX
LDA !scrollindex
TAY
STA $211B
STZ $211B
LDA #$13
STA $211C
REP #$20
LDA $2134
STA $00
TYA
AND #$00FF
ASL #5
CLC : ADC #$58C5
STA $02
LDA !scrollside
AND #$00FF
BEQ +
LDA $02
CLC : ADC #$0400
BRA ++
+
LDA $02
++
LDX #$00 : STX $2115
STA $2116
LDA #$1800 : STA $4310
LDA.w #!lvlsworld&$FFFF : CLC : ADC $00 : STA $4312
LDX.b #!lvlsworld>>16 : STX $4314
LDA #$0013 : STA $4315
LDX #$02 : STX $420B
SEP #$20
LDA !scrollindex
DEC A
STA !scrollindex
PLX : DEX : BPL -
RTS


WorldNameUpdatePre:
LDA !currentworld
TAY
LDX #$00
LDA worldnumbervert1,y
STA !worldname,x
INX
LDA worldnumbervert2,y
STA !worldname,x
INX
LDA worldnumbervert3,y
STA !worldname,x
INX
LDA worldnumbervert4,y
STA !worldname,x
INX
LDA worldnumbervert5,y
STA !worldname,x
INX
LDA worldnumbervert6,y
STA !worldname,x
INX
LDA worldnumbervert7,y
STA !worldname,x
RTS

WorldNameUpdate:
REP #$30
LDX #$5982
LDA #$0000 : STA $00
LDA !scrollside
AND #$00FF
BEQ +
PHX : PHP
SEP #$30
LDY #$03
STY $2121
LDA !bgcolor
STA $2122
LDA !bgcolor+$1
STA $2122
LDY #$11
STY $2121
LDA !bgcolor
STA $2122
LDA !bgcolor+$1
STA $2122
PLP : PLX
LDA #$0400 : STA $00
TXA : CLC : ADC #$0400 : TAX
BRA ++
+
PHX : PHP
SEP #$30
LDY #$07
STY $2121
LDA !bgcolor
STA $2122
LDA !bgcolor+$1
STA $2122
LDY #$1D
STY $2121
LDA !bgcolor
STA $2122
LDA !bgcolor+$1
STA $2122
PLP : PLX
++
TXA
SEP #$10
LDX #$01 : STX $2115
STA $2116
LDA #$1800 : STA $4310
LDA.w #!worldname&$FFFF : STA $4312
LDX.b #!worldname>>16 : STX $4314
LDA #$0007 : STA $4315
SEP #$20
LDA #$02
STA $420B

%vramwrite(#$01, #$1800, "58D9 : CLC : ADC $00", !levelcleared&$FFFF, !levelcleared>>16, #$0014)
%vramwrite(#$01, #$1800, "58DB : CLC : ADC $00", !levelsecret&$FFFF, !levelsecret>>16, #$0014)
%vramwrite(#$01, #$1800, "58DD : CLC : ADC $00", !levelyicoin&$FFFF, !levelyicoin>>16, #$0014)

RTS


SideArrows:
REP #$10
LDA !scrollflag
BNE .scrolling

LDY #$0000
LDX.w #endworldptrs2-worldptrs2-1
-
LDA !worldsavail,x
BEQ +
INY
+
DEX : BPL -
TYA
CMP #$01
BEQ .scrolling

LDX #$D6C6
LDA $13
LSR #4
AND #$01
BEQ +
BRA ++
.scrolling
LDA !scrollindex
CMP #!somelvlindex
BEQ ++
BRL +++
++
LDX #$FEFE
+
STX $00
SEP #$10
%vramwrite(#$01, #$1800, 59C0, $0000, $7E, #$0002)
%vramwrite(#$01, #$1800, 59DF, $0000, $7E, #$0002)
%vramwrite(#$01, #$1800, 5DC0, $0000, $7E, #$0002)
%vramwrite(#$01, #$1800, 5DDF, $0000, $7E, #$0002)
+++
SEP #$10

LDA !scrollflag
BEQ +
BRL .skip
+
LDA !levelonscreen
BNE .noskip
BRL .skip
.noskip

LDA #$FD
STA $04 : STA $05 : STA $06 : STA $07 : STA $08

LDA !levelonscreenindex
TAX
LDA !levelzeroindex
TAY
LDA $13
LSR #5
AND #$01
BEQ +
LDA !levelcleared,x
STA $04
LDA !levelsecret,x
STA $06
LDA !levelyicoin,x
STA $08
TXY
+
TYA
STA $211B
STZ $211B
LDA #$13
STA $211C
REP #$20
LDA $2134
STA $00

TXA
AND #$00FF
ASL #5
CLC : ADC #$58C5
STA $02
LDA !scrollside
AND #$00FF
BEQ +
LDA $02
CLC : ADC #$0400
STA $02
+
LDA $02

LDX #$00 : STX $2115
STA $2116
LDA #$1800 : STA $4310
LDA.w #!lvlsworld&$FFFF : CLC : ADC $00 : STA $4312
LDX.b #!lvlsworld>>16 : STX $4314
LDA #$0013 : STA $4315
LDX #$02 : STX $420B

LDX #$00 : STX $2115
LDA $02
CLC : ADC #$0014
STA $2116
LDA #$1800 : STA $4310
LDA #$0004 : STA $4312
LDX #$7E : STX $4314
LDA #$0005 : STA $4315
LDX #$02 : STX $420B
SEP #$20

.skip
RTS



HUDDMA:
%vramread(#$80, #$3981, 4910, !numbermux&$FFFF, !numbermux>>16, #$00A0)
LDX #$9E : STX $00
-
LDA !numbermux,x
EOR #$FF
STA !numbermux,x
TXA
SEC : SBC #$10
TAX : CPX $00 : BCC -
SEP #$20
%vramwrite(#$80, #$1801, 4910, !numbermux&$FFFF, !numbermux>>16, #$00A0)

incsrc counters.asm



DrawPeach:
LDX #$01
-
LDA .xpos,x
STA $0200,y
LDA .ypos2,x
STA $0201,y
LDA $1F2E
CMP #!exitcounter
BCC .nolettersyet
LDA $13
LSR #4
AND #$01
BEQ +
LDA .letters3,x
BRA ++
+
LDA .letters4,x
++
STA $0202,y
BRA .pal
.nolettersyet
LDA $13
LSR #3
AND #$01
BEQ +
LDA .letters1,x
BRA ++
+
LDA .letters2,x
++
STA $0202,y
.pal
LDA #$3C
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX
DEY #4 : DEX : BPL -

LDX #$01
-
LDA .xpos,x
STA $0200,y
LDA .ypos1,x
STA $0201,y
LDA $1F2E
CMP #!exitcounter
BCC .nopeachyet
LDA $13
LSR #4
AND #$0F
BEQ +
LDA .peach3,x
BRA ++
+
LDA .peach4,x
++
STA $0202,y
BRA .ntsc
.nopeachyet
LDA $13
LSR #3
AND #$01
BEQ +
LDA .peach1,x
BRA ++
+
LDA .peach2,x
++
STA $0202,y
.ntsc
LDA #$3C
STA $0203,y
PHX : TYA
LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX
DEY #4 : DEX : BPL -
RTS
.xpos
db $20,$28
.ypos1
db $17,$17
.ypos2
db $0F,$0F
.peach1
db $88,$89
.peach2
db $8B,$8C
.peach3
db $A8,$A9
.peach4
db $AB,$AC
.letters1
db $A2,$A3
.letters2
db $A5,$A6
.letters3
db $B2,$B3
.letters4
db $B5,$B6

PreDrawYoshiCoin:
STZ $00
LDX #$0B
-
LDA $1F2F,x
LDY #$00
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
LSR : BCC $01 : INY
TYA
CLC : ADC $00
STA $00
DEX : BPL -
LDA.b #endlevels-startlevels-1
SEC : SBC.b #endnoyoshicoins-noyoshicoins-1
STA $01
LDA $00
CMP $01
BCC +
LDA #$01
STA !yicointhing
+
LDA #$00
STA !yicointhing
RTS

DrawYoshiCoin:
LDA !yicointhing
BEQ .norender

LDX #$01
-
LDA #$E0
STA $0200,y
LDA .yoshiy,x
STA $0201,y
LDA .yoshitile,x
STA $0202,y
LDA #$0E
STA $0203,y
PHX : TYA : LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX : DEY #4 : DEX : BPL -
RTS

.yoshiy
db $0F,$17
.yoshitile
db $8E,$9E

.norender
LDX #$01
-
LDA #$E0
STA $0200,y
LDA .yoshiy,x
STA $0201,y
LDA #$BE
STA $0202,y
LDA #$0E
STA $0203,y
PHX : TYA : LSR #2 : TAX
LDA #$02 : STA $0420,x
PLX : DEY #4 : DEX : BPL -
RTS


ScrollSprites:
LDY #$FC
LDA #$F0 : STA $00
LDX #$1F
-
LDA $00
STA $0300,y
SEC : SBC #$08
STA $00
LDA #$CF
STA $0301,y
LDA #$C7
STA $0302,y
LDA #$0E
STA $0303,y
PHX : TYA : LSR #2 : TAX
LDA #$00 : STA $0460,x
PLX : DEY #4 : DEX : BPL -

LDA #$F0 : STA $00
LDX #$0F
-
LDA $00
STA $0300,y
SEC : SBC #$10
STA $00
LDA #$D7
STA $0301,y
LDA .mushtable,x
STA $0302,y
LDA #$0E
STA $0303,y
PHX : TYA : LSR #2 : TAX
LDA #$02 : STA $0460,x
PLX : DEY #4 : DEX : BPL -

JSR HUDLines

RTS

.mushtable
db $C1,$C0,$C3,$C0,$C5,$C0,$C1,$C0
db $C3,$C0,$C5,$C0,$C1,$C0,$C3,$C0


BackgroundColor:
LDA !levelscmplt
BEQ .nothing
STA $03
LDA !currentworld
TAX
LDY worldptrs2,x : INY : STY $02 : STY $04
ASL : TAX
REP #$20
LDA worldptrs,x : STA $00
SEP #$20

LDY #$00
--
LDA ($00),y
LDX.b #endnocompleted-nocompleted-1
-
CMP nocompleted,x
BEQ +
DEX : BPL -
BRA ++
+
DEC $04
++
INY : CPY $02 : BCC --

LDY #$00
--
LDA ($00),y
LDX.b #endsecretexit-secretexit-1
-
CMP secretexit,x
BEQ +
DEX : BPL -
BRA ++
+
INC $04
++
INY : CPY $02 : BCC --

LDA $03
CMP $04
BCC +
LDA !currentworld
TAX
LDA #$02
STA !worldsavail,x
LDA OWPal+$E
STA !bgcolor
LDA OWPal+$F
STA !bgcolor+$1
RTS
+
.nothing
LDA OWPal+$6
STA !bgcolor
LDA OWPal+$7
STA !bgcolor+$1
RTS

TransitionSpeedup:
REP #$10
LDX #$07FF : LDY #$0000
-
LDA $7ED000,x
BEQ +
PHX : TYX
STA !levelleveltable,x
PLX
LDA $7EC800,x
PHX : TYX
STA !leveltiletable,x
PLX
INY
+
DEX : BPL -
SEP #$10
TYA
STA !levellevelindex
RTS


HUDLines:
LDX #$0A
-
LDA .timerbglinesx,x : STA $0300,y
LDA .timerbglinesy,x : STA $0301,y
LDA #$A0 : STA $0302,y
LDA #$0E : STA $0303,y
PHX : TYA : LSR #2 : TAX
LDA #$02 : STA $0460,x
PLX : DEY #4 : DEX : BPL -
LDA #$C8 : STA $0300,y
LDA #$1F : STA $0301,y
LDA #$A0 : STA $0302,y
LDA #$0E : STA $0303,y
TYA : LSR #2 : TAX
LDA #$00 : STA $0460,x
DEY #4
LDA #$D0 : STA $0300,y
LDA #$1F : STA $0301,y
LDA #$A0 : STA $0302,y
LDA #$0E : STA $0303,y
TYA : LSR #2 : TAX
LDA #$00 : STA $0460,x

DEY #4
LDA #$68 : STA $0300,y
LDA #$0F : STA $0301,y
LDA #$A0 : STA $0302,y
LDA #$0E : STA $0303,y
TYA : LSR #2 : TAX
LDA #$00 : STA $0460,x
RTS

.timerbglinesx
db $48,$58,$68,$78,$98,$A8,$B8,$C8,$98,$A8,$B8
.timerbglinesy
db $0F,$0F,$17,$1F,$0F,$0F,$0F,$0F,$17,$17,$17


WorldChecker:
PHP
SEP #$30
LDX #$00
LDA !currentworld
BEQ +
LDX #$01
+
STX $02
TAX : PHA
LDA #$01
STA !worldsavail,x
STZ $03
.backtotheloop
TXA
INC A
TAX
CMP $01,s
BNE +
JMP .FATALITY
+
CMP.b #endworldptrs2-worldptrs2
BCC +
LDA $02
BNE ++
JMP .FATALITY
++
LDX #$00
+
PHX
LDY worldptrs2,x : INY : STY $08
ASL : TAX
REP #$20
LDA worldptrs,x : STA $00
STZ $06
SEP #$20
LDY #$00
.loop
LDA ($00),y : PHY	;get translevel
STA $0E
STY $0A

LDY.b #endspeciallevel-speciallevel-4
--
CMP speciallevel,y
BEQ .starsw
DEY #4 : CPY.b #endspeciallevel-speciallevel-1 : BCC --

LDA !levellevelindex : TAX
LDA $0E
-
CMP !levelleveltable,x
BEQ .nextpart
DEX : BPL -
BRL .enddisabler
.nextpart
LDA !leveltiletable,x
LDX #$15
-
CMP $04DA1D,x
BEQ .jugemujugemugokounosurikirekaijarisuigyonosuigyoumatsu
DEX : BPL -
BRL .enddisabler

.starsw
LDX #$02 : INY
-
LDA speciallevel,y
BEQ .enddisabler
STA $4204
STZ $4205
LDA #$08
STA $4206
NOP #5
PHX : PHY
LDX $4216
LDY $4214
LDA $1F02,y
AND .andtable,x
BNE .enddisablerpre
PLY : PLX
INY : DEX : BPL -
BRA .jugemujugemugokounosurikirekaijarisuigyonosuigyoumatsu
.enddisablerpre
PLY : PLX
.enddisabler
INC $03
.jugemujugemugokounosurikirekaijarisuigyonosuigyoumatsu
PLY : INY : CPY $08 : BCS + : BRL .loop
+
PLX
LDA $03
BEQ .zerolevels
LDA #$01
.zerolevels
STA !worldsavail,x
STZ $03
JMP .backtotheloop
.FATALITY
PLA : PLP : RTS

.andtable
db $80,$40,$20,$10,$08,$04,$02,$01


Timer:
LDA $44
STA $2130
PHB : PHK : PLB : PHP : SEP #$30

LDX #$00
-
LDA !east_timor,x
CMP .timortabol,x
BNE +
INX : CPX #$08 : BCC -
LDA #$01
STA !east_timor+$8
+

LDA $0100
CMP #$08
BCC +
CMP #$18
BCS +++
BRA ++
.timortabol
db $09,$05,$09,$05,$03,$02,$09,$09
+
LDA #$00
STA !east_timor
STA !east_timor+$1
STA !east_timor+$2
STA !east_timor+$3
STA !east_timor+$4
STA !east_timor+$5
STA !east_timor+$6
STA !east_timor+$7
STA !east_timor+$8
-
+++
JMP .finnish
++

LDA $1F2E
CMP #!exitcounter
BCS -

LDA !east_timor+$8
BNE -

LDA $13
AND #$3F
BNE -

;seconds
LDA !east_timor
INC A
CMP #10
BCS +
STA !east_timor
JMP .finnish
+
LDA #$00
STA !east_timor
LDA !east_timor+$1
INC A
CMP #6
BCS +

STA !east_timor+$1
JMP .finnish
+
LDA #$00
STA !east_timor+$1

;minutes
LDA !east_timor+$2
INC A
CMP #10
BCS +
STA !east_timor+$2
JMP .finnish
+
LDA #$00
STA !east_timor+$2
LDA !east_timor+$3
INC A
CMP #6
BCS +
STA !east_timor+$3
JMP .finnish
+
LDA #$00
STA !east_timor+$3
BRA +++

-
LDA !east_timor+$5
CMP #2
BCC ++
LDA #$00
STA !east_timor+$5
STA !east_timor+$4
BRA ++++

;hours
+++
LDA !east_timor+$4
INC A
STA $00
CMP #4
BEQ -
++
LDA $00
CMP #10
BCS +
STA !east_timor+$4
JMP .finnish
+
LDA #$00
STA !east_timor+$4
LDA !east_timor+$5
INC A
STA !east_timor+$5
JMP .finnish

;days
++++
LDA !east_timor+$6
INC A
CMP #10
BCS +
STA !east_timor+$6
JMP .finnish
+
LDA #$00
STA !east_timor+$6
LDA !east_timor+$7
INC A
CMP #10
BCS +
JMP .finnish
+
LDA #$09
STA !east_timor+$7


.finnish
PLP : PLB
JML $0081C6



CURSOR_FINALLY_LAST_PART_I_NEED_TO_CODE_BEFORE_IM_DONE:
;well, this was a great (not really) 2 weeks of coding
;i learned alot (like how nmi is a delicate fsck)
;after this im gonna have to test a the whole smw x_x
;then i'll prolly watch some puchimasu if there's a new ep
;oh, i was also processing some images to use for my
;random avatar, have to finish that too
;
;jimmy is a pedo

LDA $1F2E
CMP #!exitcounter
BCS +
JMP .nodone
+

LDA $16
BIT #$80
BEQ +
LDA !cursorpos
TAX
LDA !levellist,x
STA !levelwarp
LDA #$08
STA !freeram1
PLA : PLA : RTS
+

LDA #$FD : STA $00
%vramwrite(#$01, #$1808, 5CC4, $0000, $7E, #$0014)
%vramwrite(#$01, #$1808, 58C4, $0000, $7E, #$0014)

LDA #$D0 : STA $04

REP #$20
LDA !cursorpos
AND #$00FF
ASL #5
STA $02
LDA !scrollside
AND #$00FF
BEQ +
LDA $02
CLC : ADC #$0400
STA $02
+
SEP #$30
%vramwrite(#$01, #$1808, "58C4 : CLC : ADC $02", $0004, $7E, #$0001)

.nodone
RTS

CursorMov:
LDA $1F2E
CMP #!exitcounter
BCS +
JMP .dragonofnoone
+

LDA $16
BIT #$04
BNE .down
BIT #$08
BNE .up
JMP .dragonofnoone

.down
LDA !cursorpos
INC A
TAX
LDA !levellist,x
BNE +
LDX #$00
+
TXA
STA !cursorpos
LDA #$06
STA $1DFC

JMP .dragonofnoone

.up
LDA !cursorpos
DEC A
BPL +
TAX
-
INX
LDA !levellist,x
BNE -
TXA
+
STA !cursorpos
LDA #$06
STA $1DFC

.dragonofnoone
RTS



;----------------------------------------------------------------------------------------
; the stuff below isnt really huge, i just felt like putting them in banks $40+
; since they're all data
;----------------------------------------------------------------------------------------

freedata
newlyr3:
incbin owlyr3.stim

OWPal:
incbin statuspal.mw3