;--------------------------------------------------------------------------------------------------
; "Star Music Fix Patch" by Lui37 (user ID 16989 at SMWCentral)   
; To be assembled with Asar
;
; Description:
; This patch hijacks part of the star powerup code so it checks if star music
; is already playing in order to prevent it from restarting if you get another star.
;
; Notes:
; Tested both with Addmusi4.05 and AddmusicM.
;--------------------------------------------------------------------------------------------------

lorom
header

org $01C580

autoclean JSL SomeLabel
NOP #13
RTL

freecode

SomeLabel:
LDA #$FF                ; \ Set star timer:
STA $1490               ; / 256 frames or 16 seconds
LDA $0DDA               ; \
CMP #$80                ; |  if player hasn't star powerup yet...
BCS EvilLabel           ; /
LDA #$0D                ; \
STA $1DFB               ; / ...change music to star music
EvilLabel:
ASL $0DDA               ; shift music value left 1 bit...
SEC                     ; set carry flag...
ROR $0DDA               ; ...and rotate music byte right 1 bit, causing the music value to remain the same it was before except that bit 7 has now been set (?)
RTL                     ; Return