;;;;;;;;;;;;;;;;;;;;;;;;;
;; Framal Controller   ;;
;;     by 	       ;;
;;  wiiqwertyuiop      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;
;;

!FreeRam = $58		; Free ram for the controller
!FreeRam2 = $60		; Free ram for counter
!FramesTillClear = $7F	; Number of frames to wait to clear it
!FreeSpace = $128000	; free rom

;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Hijack		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

org $0086C1
NOP
JML MeCode

;;;;;;;;;;;;;;;;;;;;;;;;;;
;; RATS tag + freesapce	;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FreeSpace
db "STAR"
dw End-MeCode-$01
dw End-MeCode-$01^$FFFF

;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Code below		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

MeCode:
LDA $15			
BEQ Clear	
LDA !FreeRam
BNE Skip
LDA !FreeRam2
BNE NoPress
LDA $15
STA !FreeRam
Skip:
LDA !FreeRam2
CMP #!FramesTillClear
BCC Ok
BRA NoPress
Clear:
STZ !FreeRam2
NoPress:
STZ !FreeRam
BRA Return
Ok:
LDA $13
AND #$03
BEQ Return
INC !FreeRam2
Return:
LDA $0DA8,x
STA $18
JML $0086C6

End:

